/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/buffer","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/strings","vs/base/common/uuid","fs","os","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/policy/common/policy","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/objects","child_process","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ee=function(q){for(var e=[],w=0,t=q.length;w<t;w++)e[w]=Z[q[w]];return e};define(Z[120],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function w(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=w;function t(k,R="Unreachable"){throw new Error(R)}e.assertNever=t}),define(Z[121],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function w(D){return D?D.replace(/\$\((.*?)\)/g,(y,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=w;class t{constructor(y,h,m){this.id=y,this.definition=h,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.terminalDecorationSuccess=new t("terminal-decoration-success",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.terminalDecorationIncomplete=new t("terminal-decoration-incomplete",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.terminalDecorationMark=new t("terminal-decoration-mark",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.terminalDecorationError=new t("terminal-decoration-error",t.errorSmall.definition),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,y){const h=["codicon","codicon-"+D];return y&&h.push("codicon-modifier-"+y),h}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function h(C){if(C instanceof t)return["codicon","codicon-"+C.id];const S=y.exec(C.id);if(!S)return h(t.error);const[,g,d]=S,E=["codicon","codicon-"+g];return d&&E.push("codicon-modifier-"+d.substr(1)),E}D.asClassNameArray=h;function m(C){return h(C).join(" ")}D.asClassName=m;function I(C){return"."+h(C).join(".")}D.asCSSSelector=I})(R=e.CSSIcon||(e.CSSIcon={}))}),define(Z[122],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function w(y,h){const m=Math.pow(10,h);return Math.round(y*m)/m}class t{constructor(h,m,I,C=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,I))|0,this.a=w(Math.max(Math.min(1,C),0),3)}static equals(h,m){return h.r===m.r&&h.g===m.g&&h.b===m.b&&h.a===m.a}}e.RGBA=t;class k{constructor(h,m,I,C){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.l=w(Math.max(Math.min(1,I),0),3),this.a=w(Math.max(Math.min(1,C),0),3)}static equals(h,m){return h.h===m.h&&h.s===m.s&&h.l===m.l&&h.a===m.a}static fromRGBA(h){const m=h.r/255,I=h.g/255,C=h.b/255,S=h.a,g=Math.max(m,I,C),d=Math.min(m,I,C);let E=0,b=0;const p=(d+g)/2,v=g-d;if(v>0){switch(b=Math.min(p<=.5?v/(2*p):v/(2-2*p),1),g){case m:E=(I-C)/v+(I<C?6:0);break;case I:E=(C-m)/v+2;break;case C:E=(m-I)/v+4;break}E*=60,E=Math.round(E)}return new k(E,b,p,S)}static _hue2rgb(h,m,I){return I<0&&(I+=1),I>1&&(I-=1),I<1/6?h+(m-h)*6*I:I<1/2?m:I<2/3?h+(m-h)*(2/3-I)*6:h}static toRGBA(h){const m=h.h/360,{s:I,l:C,a:S}=h;let g,d,E;if(I===0)g=d=E=C;else{const b=C<.5?C*(1+I):C+I-C*I,p=2*C-b;g=k._hue2rgb(p,b,m+1/3),d=k._hue2rgb(p,b,m),E=k._hue2rgb(p,b,m-1/3)}return new t(Math.round(g*255),Math.round(d*255),Math.round(E*255),S)}}e.HSLA=k;class R{constructor(h,m,I,C){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.v=w(Math.max(Math.min(1,I),0),3),this.a=w(Math.max(Math.min(1,C),0),3)}static equals(h,m){return h.h===m.h&&h.s===m.s&&h.v===m.v&&h.a===m.a}static fromRGBA(h){const m=h.r/255,I=h.g/255,C=h.b/255,S=Math.max(m,I,C),g=Math.min(m,I,C),d=S-g,E=S===0?0:d/S;let b;return d===0?b=0:S===m?b=((I-C)/d%6+6)%6:S===I?b=(C-m)/d+2:b=(m-I)/d+4,new R(Math.round(b*60),E,S,h.a)}static toRGBA(h){const{h:m,s:I,v:C,a:S}=h,g=C*I,d=g*(1-Math.abs(m/60%2-1)),E=C-g;let[b,p,v]=[0,0,0];return m<60?(b=g,p=d):m<120?(b=d,p=g):m<180?(p=g,v=d):m<240?(p=d,v=g):m<300?(b=d,v=g):m<=360&&(b=g,v=d),b=Math.round((b+E)*255),p=Math.round((p+E)*255),v=Math.round((v+E)*255),new t(b,p,v,S)}}e.HSVA=R;class D{constructor(h){if(h)if(h instanceof t)this.rgba=h;else if(h instanceof k)this._hsla=h,this.rgba=k.toRGBA(h);else if(h instanceof R)this._hsva=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(h){return D.Format.CSS.parseHex(h)||D.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(h){return!!h&&t.equals(this.rgba,h.rgba)&&k.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=D._relativeLuminanceForComponent(this.rgba.r),m=D._relativeLuminanceForComponent(this.rgba.g),I=D._relativeLuminanceForComponent(this.rgba.b),C=.2126*h+.7152*m+.0722*I;return w(C,4)}static _relativeLuminanceForComponent(h){const m=h/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(h){const m=this.getRelativeLuminance(),I=h.getRelativeLuminance();return m>I?(m+.05)/(I+.05):(I+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const m=this.getRelativeLuminance(),I=h.getRelativeLuminance();return m>I}isDarkerThan(h){const m=this.getRelativeLuminance(),I=h.getRelativeLuminance();return m<I}lighten(h){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:m,g:I,b:C,a:S}=this.rgba;return new D(new t(m,I,C,S*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const m=h.rgba,I=this.rgba.a,C=m.a,S=I+C*(1-I);if(S<1e-6)return D.transparent;const g=this.rgba.r*I/S+m.r*C*(1-I)/S,d=this.rgba.g*I/S+m.g*C*(1-I)/S,E=this.rgba.b*I/S+m.b*C*(1-I)/S;return new D(new t(g,d,E,S))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:m,g:I,b:C,a:S}=this.rgba;return new D(new t(h.rgba.r-S*(h.rgba.r-m),h.rgba.g-S*(h.rgba.g-I),h.rgba.b-S*(h.rgba.b-C),1))}flatten(...h){const m=h.reduceRight((I,C)=>D._flatten(C,I));return D._flatten(this,m)}static _flatten(h,m){const I=1-h.rgba.a;return new D(new t(I*m.rgba.r+h.rgba.a*h.rgba.r,I*m.rgba.g+h.rgba.a*h.rgba.g,I*m.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(h,m,I){if(h.isLighterThan(m))return h;I=I||.5;const C=h.getRelativeLuminance(),S=m.getRelativeLuminance();return I=I*(S-C)/S,h.lighten(I)}static getDarkerColor(h,m,I){if(h.isDarkerThan(m))return h;I=I||.5;const C=h.getRelativeLuminance(),S=m.getRelativeLuminance();return I=I*(C-S)/C,h.darken(I)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(y){let h;(function(m){let I;(function(C){function S(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:y.Format.CSS.formatRGBA(s)}C.formatRGB=S;function g(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}C.formatRGBA=g;function d(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(s)}C.formatHSL=d;function E(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}C.formatHSLA=E;function b(s){const r=s.toString(16);return r.length!==2?"0"+r:r}function p(s){return`#${b(s.rgba.r)}${b(s.rgba.g)}${b(s.rgba.b)}`}C.formatHex=p;function v(s,r=!1){return r&&s.rgba.a===1?y.Format.CSS.formatHex(s):`#${b(s.rgba.r)}${b(s.rgba.g)}${b(s.rgba.b)}${b(Math.round(s.rgba.a*255))}`}C.formatHexA=v;function f(s){return s.isOpaque()?y.Format.CSS.formatHex(s):y.Format.CSS.formatRGBA(s)}C.format=f;function u(s){const r=s.length;if(r===0||s.charCodeAt(0)!==35)return null;if(r===7){const i=16*c(s.charCodeAt(1))+c(s.charCodeAt(2)),n=16*c(s.charCodeAt(3))+c(s.charCodeAt(4)),o=16*c(s.charCodeAt(5))+c(s.charCodeAt(6));return new y(new t(i,n,o,1))}if(r===9){const i=16*c(s.charCodeAt(1))+c(s.charCodeAt(2)),n=16*c(s.charCodeAt(3))+c(s.charCodeAt(4)),o=16*c(s.charCodeAt(5))+c(s.charCodeAt(6)),a=16*c(s.charCodeAt(7))+c(s.charCodeAt(8));return new y(new t(i,n,o,a/255))}if(r===4){const i=c(s.charCodeAt(1)),n=c(s.charCodeAt(2)),o=c(s.charCodeAt(3));return new y(new t(16*i+i,16*n+n,16*o+o))}if(r===5){const i=c(s.charCodeAt(1)),n=c(s.charCodeAt(2)),o=c(s.charCodeAt(3)),a=c(s.charCodeAt(4));return new y(new t(16*i+i,16*n+n,16*o+o,(16*a+a)/255))}return null}C.parseHex=u;function c(s){switch(s){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(I=m.CSS||(m.CSS={}))})(h=y.Format||(y.Format={}))}(D=e.Color||(e.Color={}))}),define(Z[52],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(D){return(y,h,m)=>{let I=null,C=null;if(typeof m.value=="function"?(I="value",C=m.value):typeof m.get=="function"&&(I="get",C=m.get),!C)throw new Error("not supported");m[I]=D(C,h)}}e.createDecorator=w;function t(D,y,h){let m=null,I=null;if(typeof h.value=="function"?(m="value",I=h.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(m="get",I=h.get),!I)throw new Error("not supported");const C=`$memoize$${y}`;h[m]=function(...S){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,S)}),this[C]}}e.memoize=t;function k(D,y,h){return w((m,I)=>{const C=`$debounce$${I}`,S=`$debounce$result$${I}`;return function(...g){this[S]||(this[S]=h?h():void 0),clearTimeout(this[C]),y&&(this[S]=y(this[S],...g),g=[this[S]]),this[C]=setTimeout(()=>{m.apply(this,g),this[S]=h?h():void 0},D)}})}e.debounce=k;function R(D,y,h){return w((m,I)=>{const C=`$throttle$timer$${I}`,S=`$throttle$result$${I}`,g=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...E){if(this[S]||(this[S]=h?h():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),y&&(this[S]=y(this[S],...E)),this[d])return;const b=this[g]+D;b<=Date.now()?(this[g]=Date.now(),m.apply(this,[this[S]]),this[S]=h?h():void 0):(this[d]=!0,this[C]=setTimeout(()=>{this[d]=!1,this[g]=Date.now(),m.apply(this,[this[S]]),this[S]=h?h():void 0},b-Date.now()))}})}e.throttle=R}),define(Z[18],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?f.isErrorNoTelemetry(s)?new f(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(r=>{r(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=w,e.errorHandler=new w;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){h(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){h(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:s,message:r}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:s,message:r,stack:i,noTelemetry:f.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const y="Canceled";function h(c){return c instanceof m?!0:c instanceof Error&&c.name===y&&c.message===y}e.isCancellationError=h;class m extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=m;function I(){const c=new Error(y);return c.name=c.message,c}e.canceled=I;function C(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=C;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=S;function g(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function d(c){const s=new Error(`${c} has been disposed`);return s.name="DISPOSED",s}e.disposed=d;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=E;class b extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=b;class p extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=p;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;class f extends Error{constructor(s){super(s);this.name="CodeExpectedError"}static fromError(s){if(s instanceof f)return s;const r=new f;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class u extends Error{constructor(s){super(s||"An unexpected bug occurred.");Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(Z[24],ee([0,1,18]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(H,te=0){return H[H.length-(1+te)]}e.tail=t;function k(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=k;function R(H,te,ie=(ce,de)=>ce===de){if(H===te)return!0;if(!H||!te||H.length!==te.length)return!1;for(let ce=0,de=H.length;ce<de;ce++)if(!ie(H[ce],te[ce]))return!1;return!0}e.equals=R;function D(H,te){const ie=H.length-1;te<ie&&(H[te]=H[ie]),H.pop()}e.removeFastWithoutKeepingOrder=D;function y(H,te,ie){return h(H.length,ce=>ie(H[ce],te))}e.binarySearch=y;function h(H,te){let ie=0,ce=H-1;for(;ie<=ce;){const de=(ie+ce)/2|0,ke=te(de);if(ke<0)ie=de+1;else if(ke>0)ce=de-1;else return de}return-(ie+1)}e.binarySearch2=h;function m(H,te){let ie=0,ce=H.length;if(ce===0)return 0;for(;ie<ce;){const de=Math.floor((ie+ce)/2);te(H[de])?ce=de:ie=de+1}return ie}e.findFirstInSorted=m;function I(H,te,ie){if(H=H|0,H>=te.length)throw new TypeError("invalid index");const ce=te[Math.floor(te.length*Math.random())],de=[],ke=[],Le=[];for(const Me of te){const Ae=ie(Me,ce);Ae<0?de.push(Me):Ae>0?ke.push(Me):Le.push(Me)}return H<de.length?I(H,de,ie):H<de.length+Le.length?Le[0]:I(H-(de.length+Le.length),ke,ie)}e.quickSelect=I;function C(H,te){const ie=[];let ce;for(const de of H.slice(0).sort(te))!ce||te(ce[0],de)!==0?(ce=[de],ie.push(ce)):ce.push(de);return ie}e.groupBy=C;function S(H,te,ie){const ce=[];function de(Me,Ae,Ve){if(Ae===0&&Ve.length===0)return;const ge=ce[ce.length-1];ge&&ge.start+ge.deleteCount===Me?(ge.deleteCount+=Ae,ge.toInsert.push(...Ve)):ce.push({start:Me,deleteCount:Ae,toInsert:Ve})}let ke=0,Le=0;for(;;){if(ke===H.length){de(ke,0,te.slice(Le));break}if(Le===te.length){de(ke,H.length-ke,[]);break}const Me=H[ke],Ae=te[Le],Ve=ie(Me,Ae);Ve===0?(ke+=1,Le+=1):Ve<0?(de(ke,1,[]),ke+=1):Ve>0&&(de(ke,0,[Ae]),Le+=1)}return ce}e.sortedDiff=S;function g(H,te,ie){const ce=S(H,te,ie),de=[],ke=[];for(const Le of ce)de.push(...H.slice(Le.start,Le.start+Le.deleteCount)),ke.push(...Le.toInsert);return{removed:de,added:ke}}e.delta=g;function d(H,te,ie){if(ie===0)return[];const ce=H.slice(0,ie).sort(te);return b(H,te,ce,ie,H.length),ce}e.top=d;function E(H,te,ie,ce,de){return ie===0?Promise.resolve([]):new Promise((ke,Le)=>{(async()=>{const Me=H.length,Ae=H.slice(0,ie).sort(te);for(let Ve=ie,ge=Math.min(ie+ce,Me);Ve<Me;Ve=ge,ge=Math.min(ge+ce,Me)){if(Ve>ie&&await new Promise(pe=>setTimeout(pe)),de&&de.isCancellationRequested)throw new w.CancellationError;b(H,te,Ae,Ve,ge)}return Ae})().then(ke,Le)})}e.topAsync=E;function b(H,te,ie,ce,de){for(const ke=ie.length;ce<de;ce++){const Le=H[ce];if(te(Le,ie[ke-1])<0){ie.pop();const Me=m(ie,Ae=>te(Le,Ae)<0);ie.splice(Me,0,Le)}}}function p(H){return H.filter(te=>!!te)}e.coalesce=p;function v(H){let te=0;for(let ie=0;ie<H.length;ie++)H[ie]&&(H[te]=H[ie],te+=1);H.length=te}e.coalesceInPlace=v;function f(H,te,ie){H.splice(ie,0,H.splice(te,1)[0])}e.move=f;function u(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=u;function c(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=c;function s(H,te=ie=>ie){const ie=new Set;return H.filter(ce=>{const de=te(ce);return ie.has(de)?!1:(ie.add(de),!0)})}e.distinct=s;function r(H){const te=new Set;return ie=>{const ce=H(ie);return te.has(ce)?!1:(te.add(ce),!0)}}e.uniqueFilter=r;function i(H,te){const ie=n(H,te);if(ie!==-1)return H[ie]}e.findLast=i;function n(H,te){for(let ie=H.length-1;ie>=0;ie--){const ce=H[ie];if(te(ce))return ie}return-1}e.lastIndex=n;function o(H,te){return H.length>0?H[0]:te}e.firstOrDefault=o;function a(H,te){return H.length>0?H[H.length-1]:te}e.lastOrDefault=a;function l(H,te,ie=(ce,de)=>ce===de){let ce=0;for(let de=0,ke=Math.min(H.length,te.length);de<ke&&ie(H[de],te[de]);de++)ce++;return ce}e.commonPrefixLength=l;function P(H){return[].concat(...H)}e.flatten=P;function M(H,te){let ie=typeof te=="number"?H:0;typeof te=="number"?ie=H:(ie=0,te=H);const ce=[];if(ie<=te)for(let de=ie;de<te;de++)ce.push(de);else for(let de=ie;de>te;de--)ce.push(de);return ce}e.range=M;function T(H,te,ie){return H.reduce((ce,de)=>(ce[te(de)]=ie?ie(de):de,ce),Object.create(null))}e.index=T;function O(H,te){return H.push(te),()=>U(H,te)}e.insert=O;function U(H,te){const ie=H.indexOf(te);if(ie>-1)return H.splice(ie,1),te}e.remove=U;function Q(H,te,ie){const ce=H.slice(0,te),de=H.slice(te);return ce.concat(ie,de)}e.arrayInsert=Q;function re(H,te){let ie;if(typeof te=="number"){let ce=te;ie=()=>{const de=Math.sin(ce++)*179426549;return de-Math.floor(de)}}else ie=Math.random;for(let ce=H.length-1;ce>0;ce-=1){const de=Math.floor(ie()*(ce+1)),ke=H[ce];H[ce]=H[de],H[de]=ke}}e.shuffle=re;function le(H,te){const ie=H.indexOf(te);ie>-1&&(H.splice(ie,1),H.unshift(te))}e.pushToStart=le;function fe(H,te){const ie=H.indexOf(te);ie>-1&&(H.splice(ie,1),H.push(te))}e.pushToEnd=fe;function se(H,te){for(const ie of te)H.push(ie)}e.pushMany=se;function ue(H,te){return Array.isArray(H)?H.map(te):te(H)}e.mapArrayOrNot=ue;function K(H){return Array.isArray(H)?H:[H]}e.asArray=K;function N(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=N;function _(H,te){for(const ie of H){const ce=te(ie);if(ce!==void 0)return ce}}e.mapFind=_;function A(H,te,ie){const ce=$(H,te),de=H.length,ke=ie.length;H.length=de+ke;for(let Le=de-1;Le>=ce;Le--)H[Le+ke]=H[Le];for(let Le=0;Le<ke;Le++)H[Le+ce]=ie[Le]}e.insertInto=A;function W(H,te,ie,ce){const de=$(H,te),ke=H.splice(de,ie);return A(H,de,ce),ke}e.splice=W;function $(H,te){return te<0?Math.max(te+H.length,0):Math.min(te,H.length)}var Y;(function(H){function te(de){return de<0}H.isLessThan=te;function ie(de){return de>0}H.isGreaterThan=ie;function ce(de){return de===0}H.isNeitherLessOrGreaterThan=ce,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function z(H,te){return(ie,ce)=>te(H(ie),H(ce))}e.compareBy=z;function j(...H){return(te,ie)=>{for(const ce of H){const de=ce(te,ie);if(!Y.isNeitherLessOrGreaterThan(de))return de}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=j;const L=(H,te)=>H-te;e.numberComparator=L;function F(H,te){if(H.length===0)return;let ie=H[0];for(let ce=1;ce<H.length;ce++){const de=H[ce];te(de,ie)>0&&(ie=de)}return ie}e.findMaxBy=F;function B(H,te){if(H.length===0)return;let ie=H[0];for(let ce=1;ce<H.length;ce++){const de=H[ce];te(de,ie)>=0&&(ie=de)}return ie}e.findLastMaxBy=B;function V(H,te){return F(H,(ie,ce)=>-te(ie,ce))}e.findMinBy=V;class x{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ie=this.firstIdx;for(;ie<this.items.length&&te(this.items[ie]);)ie++;const ce=ie===this.firstIdx?null:this.items.slice(this.firstIdx,ie);return this.firstIdx=ie,ce}takeFromEndWhile(te){let ie=this.lastIdx;for(;ie>=0&&te(this.items[ie]);)ie--;const ce=ie===this.lastIdx?null:this.items.slice(ie+1,this.lastIdx+1);return this.lastIdx=ie,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ie=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ie}}e.ArrayQueue=x;class ne{constructor(te){this.iterate=te}forEach(te){this.iterate(ie=>(te(ie),!0))}toArray(){const te=[];return this.iterate(ie=>(te.push(ie),!0)),te}filter(te){return new ne(ie=>this.iterate(ce=>te(ce)?ie(ce):!0))}map(te){return new ne(ie=>this.iterate(ce=>ie(te(ce))))}some(te){let ie=!1;return this.iterate(ce=>(ie=te(ce),!ie)),ie}findFirst(te){let ie;return this.iterate(ce=>te(ce)?(ie=ce,!1):!0),ie}findLast(te){let ie;return this.iterate(ce=>(te(ce)&&(ie=ce),!0)),ie}findLastMaxBy(te){let ie,ce=!0;return this.iterate(de=>((ce||Y.isGreaterThan(te(de,ie)))&&(ce=!1,ie=de),!0)),ie}}e.CallbackIterable=ne,ne.empty=new ne(H=>{})}),define(Z[48],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=w}),define(Z[57],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(t){function k(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*y(r){yield r}t.single=y;function h(r){return r||R}t.from=h;function m(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=m;function I(r){return r[Symbol.iterator]().next().value}t.first=I;function C(r,i){for(const n of r)if(i(n))return!0;return!1}t.some=C;function S(r,i){for(const n of r)if(i(n))return n}t.find=S;function*g(r,i){for(const n of r)i(n)&&(yield n)}t.filter=g;function*d(r,i){let n=0;for(const o of r)yield i(o,n++)}t.map=d;function*E(...r){for(const i of r)for(const n of i)yield n}t.concat=E;function*b(r){for(const i of r)for(const n of i)yield n}t.concatNested=b;function p(r,i,n){let o=n;for(const a of r)o=i(o,a);return o}t.reduce=p;function v(r,i){let n=0;for(const o of r)i(o,n++)}t.forEach=v;function*f(r,i,n=r.length){for(i<0&&(i+=r.length),n<0?n+=r.length:n>r.length&&(n=r.length);i<n;i++)yield r[i]}t.slice=f;function u(r,i=Number.POSITIVE_INFINITY){const n=[];if(i===0)return[n,r];const o=r[Symbol.iterator]();for(let a=0;a<i;a++){const l=o.next();if(l.done)return[n,t.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return o}}]}t.consume=u;function c(r){return u(r)[0]}t.collect=c;function s(r,i,n=(o,a)=>o===a){const o=r[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const l=o.next(),P=a.next();if(l.done!==P.done)return!1;if(l.done)return!0;if(!n(l.value,P.value))return!1}}t.equals=s})(w=e.Iterable||(e.Iterable={}))}),define(Z[42],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(s){s.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(s,r=!1){let i=0;const n=s.length;let o="",a=0,l=16,P=0;function M(fe){let se=0,ue=0;for(;se<fe;){const K=s.charCodeAt(i);if(K>=48&&K<=57)ue=ue*16+K-48;else if(K>=65&&K<=70)ue=ue*16+K-65+10;else if(K>=97&&K<=102)ue=ue*16+K-97+10;else break;i++,se++}return se<fe&&(ue=-1),ue}function T(fe){i=fe,o="",a=0,l=16,P=0}function O(){const fe=i;if(s.charCodeAt(i)===48)i++;else for(i++;i<s.length&&m(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===46)if(i++,i<s.length&&m(s.charCodeAt(i)))for(i++;i<s.length&&m(s.charCodeAt(i));)i++;else return P=3,s.substring(fe,i);let se=i;if(i<s.length&&(s.charCodeAt(i)===69||s.charCodeAt(i)===101))if(i++,(i<s.length&&s.charCodeAt(i)===43||s.charCodeAt(i)===45)&&i++,i<s.length&&m(s.charCodeAt(i))){for(i++;i<s.length&&m(s.charCodeAt(i));)i++;se=i}else P=3;return s.substring(fe,se)}function U(){let fe="",se=i;for(;;){if(i>=n){fe+=s.substring(se,i),P=2;break}const ue=s.charCodeAt(i);if(ue===34){fe+=s.substring(se,i),i++;break}if(ue===92){if(fe+=s.substring(se,i),i++,i>=n){P=2;break}switch(s.charCodeAt(i++)){case 34:fe+='"';break;case 92:fe+="\\";break;case 47:fe+="/";break;case 98:fe+="\b";break;case 102:fe+="\f";break;case 110:fe+=`
`;break;case 114:fe+="\r";break;case 116:fe+="	";break;case 117:{const N=M(4);N>=0?fe+=String.fromCharCode(N):P=4;break}default:P=5}se=i;continue}if(ue>=0&&ue<=31)if(h(ue)){fe+=s.substring(se,i),P=2;break}else P=6;i++}return fe}function Q(){if(o="",P=0,a=i,i>=n)return a=n,l=17;let fe=s.charCodeAt(i);if(y(fe)){do i++,o+=String.fromCharCode(fe),fe=s.charCodeAt(i);while(y(fe));return l=15}if(h(fe))return i++,o+=String.fromCharCode(fe),fe===13&&s.charCodeAt(i)===10&&(i++,o+=`
`),l=14;switch(fe){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,o=U(),l=10;case 47:{const se=i-1;if(s.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(s.charCodeAt(i));)i++;return o=s.substring(se,i),l=12}if(s.charCodeAt(i+1)===42){i+=2;const ue=n-1;let K=!1;for(;i<ue;){if(s.charCodeAt(i)===42&&s.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,P=1),o=s.substring(se,i),l=13}return o+=String.fromCharCode(fe),i++,l=16}case 45:if(o+=String.fromCharCode(fe),i++,i===n||!m(s.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),l=11;default:for(;i<n&&re(fe);)i++,fe=s.charCodeAt(i);if(a!==i){switch(o=s.substring(a,i),o){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return o+=String.fromCharCode(fe),i++,l=16}}function re(fe){if(y(fe)||h(fe))return!1;switch(fe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let fe;do fe=Q();while(fe>=12&&fe<=15);return fe}return{setPosition:T,getPosition:()=>i,scan:r?le:Q,getToken:()=>l,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>P}}e.createScanner=D;function y(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function m(s){return s>=48&&s<=57}var I;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(I||(I={}));function C(s,r){const i=[],n=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(M,T,O,U){a.value=M,a.offset=T,a.length=O,a.type=U,a.colonOffset=void 0,o=a}try{f(s,{onObjectBegin:(M,T)=>{if(r<=M)throw n;o=void 0,l=r>M,i.push("")},onObjectProperty:(M,T,O)=>{if(r<T||(P(M,T,O,"property"),i[i.length-1]=M,r<=T+O))throw n},onObjectEnd:(M,T)=>{if(r<=M)throw n;o=void 0,i.pop()},onArrayBegin:(M,T)=>{if(r<=M)throw n;o=void 0,i.push(0)},onArrayEnd:(M,T)=>{if(r<=M)throw n;o=void 0,i.pop()},onLiteralValue:(M,T,O)=>{if(r<T||(P(M,T,O,c(M)),r<=T+O))throw n},onSeparator:(M,T,O)=>{if(r<=T)throw n;if(M===":"&&o&&o.type==="property")o.colonOffset=T,l=!1,o=void 0;else if(M===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(l=!0,i[i.length-1]=""),o=void 0}}})}catch(M){if(M!==n)throw M}return{path:i,previousNode:o,isAtPropertyKey:l,matches:M=>{let T=0;for(let O=0;T<M.length&&O<i.length;O++)if(M[T]===i[O]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=C;function S(s,r=[],i=R.DEFAULT){let n=null,o=[];const a=[];function l(M){Array.isArray(o)?o.push(M):n!==null&&(o[n]=M)}return f(s,{onObjectBegin:()=>{const M={};l(M),a.push(o),o=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const M=[];l(M),a.push(o),o=M,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:l,onError:(M,T,O)=>{r.push({error:M,offset:T,length:O})}},i),o[0]}e.parse=S;function g(s,r=[],i=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(M){n.type==="property"&&(n.length=M-n.offset,n=n.parent)}function a(M){return n.children.push(M),M}f(s,{onObjectBegin:M=>{n=a({type:"object",offset:M,length:-1,parent:n,children:[]})},onObjectProperty:(M,T,O)=>{n=a({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:M,offset:T,length:O,parent:n})},onObjectEnd:(M,T)=>{n.length=M+T-n.offset,n=n.parent,o(M+T)},onArrayBegin:(M,T)=>{n=a({type:"array",offset:M,length:-1,parent:n,children:[]})},onArrayEnd:(M,T)=>{n.length=M+T-n.offset,n=n.parent,o(M+T)},onLiteralValue:(M,T,O)=>{a({type:c(M),offset:T,length:O,parent:n,value:M}),o(T+O)},onSeparator:(M,T,O)=>{n.type==="property"&&(M===":"?n.colonOffset=T:M===","&&o(T))},onError:(M,T,O)=>{r.push({error:M,offset:T,length:O})}},i);const P=n.children[0];return P&&delete P.parent,P}e.parseTree=g;function d(s,r){if(!s)return;let i=s;for(const n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=d;function E(s){if(!s.parent||!s.parent.children)return[];const r=E(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;r.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&r.push(i)}return r}e.getNodePath=E;function b(s){switch(s.type){case"array":return s.children.map(b);case"object":{const r=Object.create(null);for(const i of s.children){const n=i.children[1];n&&(r[i.children[0].value]=b(n))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=b;function p(s,r,i=!1){return r>=s.offset&&r<s.offset+s.length||i&&r===s.offset+s.length}e.contains=p;function v(s,r,i=!1){if(p(s,r,i)){const n=s.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const a=v(n[o],r,i);if(a)return a}return s}}e.findNodeAtOffset=v;function f(s,r,i=R.DEFAULT){const n=D(s,!1);function o(z){return z?()=>z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(z){return z?j=>z(j,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=o(r.onObjectBegin),P=a(r.onObjectProperty),M=o(r.onObjectEnd),T=o(r.onArrayBegin),O=o(r.onArrayEnd),U=a(r.onLiteralValue),Q=a(r.onSeparator),re=o(r.onComment),le=a(r.onError),fe=i&&i.disallowComments,se=i&&i.allowTrailingComma;function ue(){for(;;){const z=n.scan();switch(n.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:fe||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(z){case 12:case 13:fe?K(10):re();break;case 16:K(1);break;case 15:case 14:break;default:return z}}}function K(z,j=[],L=[]){if(le(z),j.length+L.length>0){let F=n.getToken();for(;F!==17;){if(j.indexOf(F)!==-1){ue();break}else if(L.indexOf(F)!==-1)break;F=ue()}}}function N(z){const j=n.getTokenValue();return z?U(j):P(j),ue(),!0}function _(){switch(n.getToken()){case 11:{let z=0;try{z=JSON.parse(n.getTokenValue()),typeof z!="number"&&(K(2),z=0)}catch{K(2)}U(z);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return ue(),!0}function A(){return n.getToken()!==10?(K(3,[],[2,5]),!1):(N(!1),n.getToken()===6?(Q(":"),ue(),Y()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function W(){l(),ue();let z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(z||K(4,[],[]),Q(","),ue(),n.getToken()===2&&se)break}else z&&K(6,[],[]);A()||K(4,[],[2,5]),z=!0}return M(),n.getToken()!==2?K(7,[2],[]):ue(),!0}function $(){T(),ue();let z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(z||K(4,[],[]),Q(","),ue(),n.getToken()===4&&se)break}else z&&K(6,[],[]);Y()||K(4,[],[4,5]),z=!0}return O(),n.getToken()!==4?K(8,[4],[]):ue(),!0}function Y(){switch(n.getToken()){case 3:return $();case 1:return W();case 10:return N(!0);default:return _()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):Y()?(n.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=f;function u(s,r){const i=D(s),n=[];let o,a=0,l;do switch(l=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:a!==l&&n.push(s.substring(a,l)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),a=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=u;function c(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[123],ee([0,1,42]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,I,C){let S,g,d,E,b;if(I){for(E=I.offset,b=E+I.length,d=E;d>0&&!h(m,d-1);)d--;let l=b;for(;l<m.length&&!h(m,l);)l++;g=m.substring(d,l),S=D(g,C)}else g=m,S=0,d=0,E=0,b=m.length;const p=y(C,m);let v=!1,f=0,u;C.insertSpaces?u=R(" ",C.tabSize||4):u="	";const c=(0,w.createScanner)(g,!1);let s=!1;function r(){return p+R(u,S+f)}function i(){let l=c.scan();for(v=!1;l===15||l===14;)v=v||l===14,l=c.scan();return s=l===16||c.getTokenError()!==0,l}const n=[];function o(l,P,M){!s&&P<b&&M>E&&m.substring(P,M)!==l&&n.push({offset:P,length:M-P,content:l})}let a=i();if(a!==17){const l=c.getTokenOffset()+d,P=R(u,S);o(P,d,l)}for(;a!==17;){let l=c.getTokenOffset()+c.getTokenLength()+d,P=i(),M="";for(;!v&&(P===12||P===13);){const O=c.getTokenOffset()+d;o(" ",l,O),l=c.getTokenOffset()+c.getTokenLength()+d,M=P===12?r():"",P=i()}if(P===2)a!==1&&(f--,M=r());else if(P===4)a!==3&&(f--,M=r());else{switch(a){case 3:case 1:f++,M=r();break;case 5:case 12:M=r();break;case 13:v?M=r():M=" ";break;case 6:M=" ";break;case 10:if(P===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?M=" ":P!==5&&P!==17&&(s=!0);break;case 16:s=!0;break}v&&(P===12||P===13)&&(M=r())}const T=c.getTokenOffset()+d;o(M,l,T),a=P}return n}e.format=t;function k(m,I){const C=JSON.stringify(m,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?C.replace(/\r\n|\r|\n/g,I.eol):C}e.toFormattedString=k;function R(m,I){let C="";for(let S=0;S<I;S++)C+=m;return C}function D(m,I){let C=0,S=0;const g=I.tabSize||4;for(;C<m.length;){const d=m.charAt(C);if(d===" ")S++;else if(d==="	")S+=g;else break;C++}return Math.floor(S/g)}function y(m,I){for(let C=0;C<I.length;C++){const S=I.charAt(C);if(S==="\r")return C+1<I.length&&I.charAt(C+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=y;function h(m,I){return`\r
`.indexOf(m.charAt(I))!==-1}e.isEOL=h}),define(Z[124],ee([0,1,42,123]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,I,C){return R(m,I,void 0,C)}e.removeProperty=k;function R(m,I,C,S,g){const d=I.slice(),E=[],b=(0,w.parseTree)(m,E);let p,v;for(;d.length>0&&(v=d.pop(),p=(0,w.findNodeAtLocation)(b,d),p===void 0&&C!==void 0);)typeof v=="string"?C={[v]:C}:C=[C];if(p)if(p.type==="object"&&typeof v=="string"&&Array.isArray(p.children)){const f=(0,w.findNodeAtLocation)(p,[v]);if(f!==void 0)if(C===void 0){if(!f.parent)throw new Error("Malformed AST");const u=p.children.indexOf(f.parent);let c,s=f.parent.offset+f.parent.length;if(u>0){const r=p.children[u-1];c=r.offset+r.length}else c=p.offset+1,p.children.length>1&&(s=p.children[1].offset);return D(m,{offset:c,length:s-c,content:""},S)}else return D(m,{offset:f.offset,length:f.length,content:JSON.stringify(C)},S);else{if(C===void 0)return[];const u=`${JSON.stringify(v)}: ${JSON.stringify(C)}`,c=g?g(p.children.map(r=>r.children[0].value)):p.children.length;let s;if(c>0){const r=p.children[c-1];s={offset:r.offset+r.length,length:0,content:","+u}}else p.children.length===0?s={offset:p.offset+1,length:0,content:u}:s={offset:p.offset+1,length:0,content:u+","};return D(m,s,S)}}else if(p.type==="array"&&typeof v=="number"&&Array.isArray(p.children))if(C!==void 0){const f=`${JSON.stringify(C)}`;let u;if(p.children.length===0||v===0)u={offset:p.offset+1,length:0,content:p.children.length===0?f:f+","};else{const c=v===-1||v>p.children.length?p.children.length:v,s=p.children[c-1];u={offset:s.offset+s.length,length:0,content:","+f}}return D(m,u,S)}else{const f=v,u=p.children[f];let c;if(p.children.length===1)c={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===f){const s=p.children[f-1],r=s.offset+s.length,i=p.offset+p.length;c={offset:r,length:i-2-r,content:""}}else c={offset:u.offset,length:p.children[f+1].offset-u.offset,content:""};return D(m,c,S)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${p.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(m,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(C)},S)}}e.setProperty=R;function D(m,I,C){let S=y(m,I),g=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;g>0&&!(0,t.isEOL)(S,g-1);)g--;for(;d<S.length&&!(0,t.isEOL)(S,d);)d++}const E=(0,t.format)(S,{offset:g,length:d-g},C);for(let p=E.length-1;p>=0;p--){const v=E[p];S=y(S,v),g=Math.min(g,v.offset),d=Math.max(d,v.offset+v.length),d+=v.content.length-v.length}const b=m.length-(S.length-d)-g;return[{offset:g,length:b,content:S.substring(g,d)}]}e.withFormatting=D;function y(m,I){return m.substring(0,I.offset)+I.content+m.substring(I.offset+I.length)}e.applyEdit=y;function h(m,I){const C=I.slice(0).sort((g,d)=>{const E=g.offset-d.offset;return E===0?g.length-d.length:E});let S=m.length;for(let g=C.length-1;g>=0;g--){const d=C[g];if(d.offset+d.length<=S)m=y(m,d);else throw new Error("Overlapping edit");S=d.offset}return m}e.applyEdits=h}),define(Z[125],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new w(()=>k(this.getValue()))}}e.Lazy=w}),define(Z[2],ee([0,1,48,57]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(a){R=a}if(e.setDisposableTracker=D,k){const a="__is_disposable_tracked__";D(new class{trackDisposable(l){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[a]||console.log(P)},3e3)}setParent(l,P){if(l&&l!==f.None)try{l[a]=!0}catch{}}markAsDisposed(l){if(l&&l!==f.None)try{l[a]=!0}catch{}}markAsSingleton(l){}})}function y(a){return R?.trackDisposable(a),a}function h(a){R?.markAsDisposed(a)}function m(a,l){R?.setParent(a,l)}function I(a,l){if(!!R)for(const P of a)R.setParent(P,l)}function C(a){return R?.markAsSingleton(a),a}e.markAsSingleton=C;class S extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=S;function g(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=g;function d(a){if(t.Iterable.is(a)){const l=[];for(const P of a)if(P)try{P.dispose()}catch(M){l.push(M)}if(l.length===1)throw l[0];if(l.length>1)throw new S(l);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=d;function E(a){for(const l of a)g(l)&&l.dispose();return[]}e.disposeIfDisposable=E;function b(...a){const l=p(()=>d(a));return I(a,l),l}e.combinedDisposable=b;function p(a){const l=y({dispose:(0,w.once)(()=>{h(l),a()})});return l}e.toDisposable=p;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return m(l,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new v,y(this),m(this._store,this)}dispose(){h(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&m(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&m(l,null),l}}e.MutableDisposable=u;class c{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(l){let P=l;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,h(this))},this}}e.SafeDisposable=s;class r{constructor(){this.references=new Map}acquire(l,...P){let M=this.references.get(l);M||(M={counter:0,object:this.createReferencedObject(l,...P)},this.references.set(l,M));const{object:T}=M,O=(0,w.once)(()=>{--M.counter==0&&(this.destroyReferencedObject(l,M.object),this.references.delete(l))});return M.counter++,{object:T,dispose:O}}}e.ReferenceCollection=r;class i{constructor(l){this.referenceCollection=l}async acquire(l,...P){const M=this.referenceCollection.acquire(l,...P);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.AsyncReferenceCollection=i;class n{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=n;function o(a){const l=new v;try{a(l)}finally{l.dispose()}}e.disposeOnReturn=o}),define(Z[126],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(R){this.element=R,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class t{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let R=this._first;for(;R!==w.Undefined;){const D=R.next;R.prev=w.Undefined,R.next=w.Undefined,R=D}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const y=new w(R);if(this._first===w.Undefined)this._first=y,this._last=y;else if(D){const m=this._last;this._last=y,y.prev=m,m.next=y}else{const m=this._first;this._first=y,y.next=m,m.prev=y}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(y))}}shift(){if(this._first!==w.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==w.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==w.Undefined&&R.next!==w.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===w.Undefined&&R.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):R.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):R.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==w.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function q(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(h){R.push(h,Date.now())}function y(){const h=[];for(let m=0;m<R.length;m+=2)h.push({name:R[m],startTime:R[m+1]});return h}return{mark:D,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=w(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var t in w)(typeof exports=="object"?exports:q)[t]=w[t]}}(typeof self!="undefined"?self:this,function(){return function(q){var e={};function w(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return q[t].call(k.exports,k,k.exports,w),k.l=!0,k.exports}return w.m=q,w.c=e,w.d=function(t,k,R){w.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},w.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},w.t=function(t,k){if(1&k&&(t=w(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(w.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)w.d(R,D,function(y){return t[y]}.bind(null,D));return R},w.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return w.d(k,"a",k),k},w.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},w.p="",w(w.s=0)}([function(q,e,w){(function(t){var k;e=q.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],h=e.src=[],m=0,I=m++;h[I]="0|[1-9]\\d*";var C=m++;h[C]="[0-9]+";var S=m++;h[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=m++;h[g]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var d=m++;h[d]="("+h[C]+")\\.("+h[C]+")\\.("+h[C]+")";var E=m++;h[E]="(?:"+h[I]+"|"+h[S]+")";var b=m++;h[b]="(?:"+h[C]+"|"+h[S]+")";var p=m++;h[p]="(?:-("+h[E]+"(?:\\."+h[E]+")*))";var v=m++;h[v]="(?:-?("+h[b]+"(?:\\."+h[b]+")*))";var f=m++;h[f]="[0-9A-Za-z-]+";var u=m++;h[u]="(?:\\+("+h[f]+"(?:\\."+h[f]+")*))";var c=m++,s="v?"+h[g]+h[p]+"?"+h[u]+"?";h[c]="^"+s+"$";var r="[v=\\s]*"+h[d]+h[v]+"?"+h[u]+"?",i=m++;h[i]="^"+r+"$";var n=m++;h[n]="((?:<|>)?=?)";var o=m++;h[o]=h[C]+"|x|X|\\*";var a=m++;h[a]=h[I]+"|x|X|\\*";var l=m++;h[l]="[v=\\s]*("+h[a]+")(?:\\.("+h[a]+")(?:\\.("+h[a]+")(?:"+h[p]+")?"+h[u]+"?)?)?";var P=m++;h[P]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[v]+")?"+h[u]+"?)?)?";var M=m++;h[M]="^"+h[n]+"\\s*"+h[l]+"$";var T=m++;h[T]="^"+h[n]+"\\s*"+h[P]+"$";var O=m++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=m++;h[U]="(?:~>?)";var Q=m++;h[Q]="(\\s*)"+h[U]+"\\s+",y[Q]=new RegExp(h[Q],"g");var re=m++;h[re]="^"+h[U]+h[l]+"$";var le=m++;h[le]="^"+h[U]+h[P]+"$";var fe=m++;h[fe]="(?:\\^)";var se=m++;h[se]="(\\s*)"+h[fe]+"\\s+",y[se]=new RegExp(h[se],"g");var ue=m++;h[ue]="^"+h[fe]+h[l]+"$";var K=m++;h[K]="^"+h[fe]+h[P]+"$";var N=m++;h[N]="^"+h[n]+"\\s*("+r+")$|^$";var _=m++;h[_]="^"+h[n]+"\\s*("+s+")$|^$";var A=m++;h[A]="(\\s*)"+h[n]+"\\s*("+r+"|"+h[l]+")",y[A]=new RegExp(h[A],"g");var W=m++;h[W]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var $=m++;h[$]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var Y=m++;h[Y]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)k(z,h[z]),y[z]||(y[z]=new RegExp(h[z]));function j(X,oe){if(X instanceof L)return X;if(typeof X!="string"||X.length>R||!(oe?y[i]:y[c]).test(X))return null;try{return new L(X,oe)}catch{return null}}function L(X,oe){if(X instanceof L){if(X.loose===oe)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(X,oe);k("SemVer",X,oe),this.loose=oe;var he=X.trim().match(oe?y[i]:y[c]);if(!he)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ce=+ye;if(Ce>=0&&Ce<D)return Ce}return ye}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=j,e.valid=function(X,oe){var he=j(X,oe);return he?he.version:null},e.clean=function(X,oe){var he=j(X.trim().replace(/^[=v]+/,""),oe);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(X){return k("SemVer.compare",this.version,this.loose,X),X instanceof L||(X=new L(X,this.loose)),this.compareMain(X)||this.comparePre(X)},L.prototype.compareMain=function(X){return X instanceof L||(X=new L(X,this.loose)),B(this.major,X.major)||B(this.minor,X.minor)||B(this.patch,X.patch)},L.prototype.comparePre=function(X){if(X instanceof L||(X=new L(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var oe=0;do{var he=this.prerelease[oe],ye=X.prerelease[oe];if(k("prerelease compare",oe,he,ye),he===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(he===void 0)return-1;if(he!==ye)return B(he,ye)}while(++oe)},L.prototype.inc=function(X,oe){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,oe,he,ye){typeof he=="string"&&(ye=he,he=void 0);try{return new L(X,he).inc(oe,ye).version}catch{return null}},e.diff=function(X,oe){if(H(X,oe))return null;var he=j(X),ye=j(oe);if(he.prerelease.length||ye.prerelease.length){for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==ye[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==ye[Ce])return Ce},e.compareIdentifiers=B;var F=/^[0-9]+$/;function B(X,oe){var he=F.test(X),ye=F.test(oe);return he&&ye&&(X=+X,oe=+oe),he&&!ye?-1:ye&&!he?1:X<oe?-1:X>oe?1:0}function V(X,oe,he){return new L(X,he).compare(new L(oe,he))}function x(X,oe,he){return V(X,oe,he)>0}function ne(X,oe,he){return V(X,oe,he)<0}function H(X,oe,he){return V(X,oe,he)===0}function te(X,oe,he){return V(X,oe,he)!==0}function ie(X,oe,he){return V(X,oe,he)>=0}function ce(X,oe,he){return V(X,oe,he)<=0}function de(X,oe,he,ye){var Ce;switch(oe){case"===":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ce=X===he;break;case"!==":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ce=X!==he;break;case"":case"=":case"==":Ce=H(X,he,ye);break;case"!=":Ce=te(X,he,ye);break;case">":Ce=x(X,he,ye);break;case">=":Ce=ie(X,he,ye);break;case"<":Ce=ne(X,he,ye);break;case"<=":Ce=ce(X,he,ye);break;default:throw new TypeError("Invalid operator: "+oe)}return Ce}function ke(X,oe){if(X instanceof ke){if(X.loose===oe)return X;X=X.value}if(!(this instanceof ke))return new ke(X,oe);k("comparator",X,oe),this.loose=oe,this.parse(X),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(X,oe){return B(oe,X)},e.major=function(X,oe){return new L(X,oe).major},e.minor=function(X,oe){return new L(X,oe).minor},e.patch=function(X,oe){return new L(X,oe).patch},e.compare=V,e.compareLoose=function(X,oe){return V(X,oe,!0)},e.rcompare=function(X,oe,he){return V(oe,X,he)},e.sort=function(X,oe){return X.sort(function(he,ye){return e.compare(he,ye,oe)})},e.rsort=function(X,oe){return X.sort(function(he,ye){return e.rcompare(he,ye,oe)})},e.gt=x,e.lt=ne,e.eq=H,e.neq=te,e.gte=ie,e.lte=ce,e.cmp=de,e.Comparator=ke;var Le={};function Me(X,oe){if(X instanceof Me)return X.loose===oe?X:new Me(X.raw,oe);if(X instanceof ke)return new Me(X.value,oe);if(!(this instanceof Me))return new Me(X,oe);if(this.loose=oe,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ve(X,oe,he,ye,Ce,Te,Fe,Be,ze,_e,je,G,ae){return((oe=Ae(he)?"":Ae(ye)?">="+he+".0.0":Ae(Ce)?">="+he+"."+ye+".0":">="+oe)+" "+(Be=Ae(ze)?"":Ae(_e)?"<"+(+ze+1)+".0.0":Ae(je)?"<"+ze+"."+(+_e+1)+".0":G?"<="+ze+"."+_e+"."+je+"-"+G:"<="+Be)).trim()}function ge(X,oe){for(var he=0;he<X.length;he++)if(!X[he].test(oe))return!1;if(oe.prerelease.length){for(he=0;he<X.length;he++)if(k(X[he].semver),X[he].semver!==Le&&X[he].semver.prerelease.length>0){var ye=X[he].semver;if(ye.major===oe.major&&ye.minor===oe.minor&&ye.patch===oe.patch)return!0}return!1}return!0}function pe(X,oe,he){try{oe=new Me(oe,he)}catch{return!1}return oe.test(X)}function be(X,oe,he,ye){var Ce,Te,Fe,Be,ze;switch(X=new L(X,ye),oe=new Me(oe,ye),he){case">":Ce=x,Te=ce,Fe=ne,Be=">",ze=">=";break;case"<":Ce=ne,Te=ie,Fe=x,Be="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(X,oe,ye))return!1;for(var _e=0;_e<oe.set.length;++_e){var je=oe.set[_e],G=null,ae=null;if(je.forEach(function(me){me.semver===Le&&(me=new ke(">=0.0.0")),G=G||me,ae=ae||me,Ce(me.semver,G.semver,ye)?G=me:Fe(me.semver,ae.semver,ye)&&(ae=me)}),G.operator===Be||G.operator===ze||(!ae.operator||ae.operator===Be)&&Te(X,ae.semver)||ae.operator===ze&&Fe(X,ae.semver))return!1}return!0}ke.prototype.parse=function(X){var oe=this.loose?y[N]:y[_],he=X.match(oe);if(!he)throw new TypeError("Invalid comparator: "+X);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=Le},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return k("Comparator.test",X,this.loose),this.semver===Le||(typeof X=="string"&&(X=new L(X,this.loose)),de(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,oe){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Me(X.value,oe),pe(this.value,he,oe);if(X.operator==="")return he=new Me(this.value,oe),pe(X.semver,he,oe);var ye=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Te=this.semver.version===X.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Be=de(this.semver,"<",X.semver,oe)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),ze=de(this.semver,">",X.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return ye||Ce||Te&&Fe||Be||ze},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(X){var oe=this.loose;X=X.trim(),k("range",X,oe);var he=oe?y[$]:y[W];X=X.replace(he,Ve),k("hyphen replace",X),X=X.replace(y[A],"$1$2$3"),k("comparator trim",X,y[A]),X=(X=(X=X.replace(y[Q],"$1~")).replace(y[se],"$1^")).split(/\s+/).join(" ");var ye=oe?y[N]:y[_],Ce=X.split(" ").map(function(Te){return function(Fe,Be){return k("comp",Fe),Fe=function(ze,_e){return ze.trim().split(/\s+/).map(function(je){return function(G,ae){k("caret",G,ae);var me=ae?y[K]:y[ue];return G.replace(me,function(Se,we,Ie,Oe,$e){var Ke;return k("caret",G,Se,we,Ie,Oe,$e),Ae(we)?Ke="":Ae(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Ae(Oe)?Ke=we==="0"?">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+".0 <"+(+we+1)+".0.0":$e?(k("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+Oe+$e+" <"+we+"."+Ie+"."+(+Oe+1):">="+we+"."+Ie+"."+Oe+$e+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+Oe+$e+" <"+(+we+1)+".0.0"):(k("no pr"),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+Oe+" <"+we+"."+Ie+"."+(+Oe+1):">="+we+"."+Ie+"."+Oe+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+Oe+" <"+(+we+1)+".0.0"),k("caret return",Ke),Ke})}(je,_e)}).join(" ")}(Fe,Be),k("caret",Fe),Fe=function(ze,_e){return ze.trim().split(/\s+/).map(function(je){return function(G,ae){var me=ae?y[le]:y[re];return G.replace(me,function(Se,we,Ie,Oe,$e){var Ke;return k("tilde",G,Se,we,Ie,Oe,$e),Ae(we)?Ke="":Ae(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Ae(Oe)?Ke=">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":$e?(k("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Ke=">="+we+"."+Ie+"."+Oe+$e+" <"+we+"."+(+Ie+1)+".0"):Ke=">="+we+"."+Ie+"."+Oe+" <"+we+"."+(+Ie+1)+".0",k("tilde return",Ke),Ke})}(je,_e)}).join(" ")}(Fe,Be),k("tildes",Fe),Fe=function(ze,_e){return k("replaceXRanges",ze,_e),ze.split(/\s+/).map(function(je){return function(G,ae){G=G.trim();var me=ae?y[T]:y[M];return G.replace(me,function(Se,we,Ie,Oe,$e,Ke){k("xRange",G,Se,we,Ie,Oe,$e,Ke);var xe=Ae(Ie),Ye=xe||Ae(Oe),et=Ye||Ae($e);return we==="="&&et&&(we=""),xe?Se=we===">"||we==="<"?"<0.0.0":"*":we&&et?(Ye&&(Oe=0),et&&($e=0),we===">"?(we=">=",Ye?(Ie=+Ie+1,Oe=0,$e=0):et&&(Oe=+Oe+1,$e=0)):we==="<="&&(we="<",Ye?Ie=+Ie+1:Oe=+Oe+1),Se=we+Ie+"."+Oe+"."+$e):Ye?Se=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":et&&(Se=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),k("xRange return",Se),Se})}(je,_e)}).join(" ")}(Fe,Be),k("xrange",Fe),Fe=function(ze,_e){return k("replaceStars",ze,_e),ze.trim().replace(y[Y],"")}(Fe,Be),k("stars",Fe),Fe}(Te,oe)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Te){return!!Te.match(ye)})),Ce=Ce.map(function(Te){return new ke(Te,oe)})},Me.prototype.intersects=function(X,oe){if(!(X instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(ye){return X.set.some(function(Ce){return Ce.every(function(Te){return ye.intersects(Te,oe)})})})})},e.toComparators=function(X,oe){return new Me(X,oe).set.map(function(he){return he.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new L(X,this.loose));for(var oe=0;oe<this.set.length;oe++)if(ge(this.set[oe],X))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(X,oe,he){var ye=null,Ce=null;try{var Te=new Me(oe,he)}catch{return null}return X.forEach(function(Fe){Te.test(Fe)&&(ye&&Ce.compare(Fe)!==-1||(Ce=new L(ye=Fe,he)))}),ye},e.minSatisfying=function(X,oe,he){var ye=null,Ce=null;try{var Te=new Me(oe,he)}catch{return null}return X.forEach(function(Fe){Te.test(Fe)&&(ye&&Ce.compare(Fe)!==1||(Ce=new L(ye=Fe,he)))}),ye},e.validRange=function(X,oe){try{return new Me(X,oe).range||"*"}catch{return null}},e.ltr=function(X,oe,he){return be(X,oe,"<",he)},e.gtr=function(X,oe,he){return be(X,oe,">",he)},e.outside=be,e.prerelease=function(X,oe){var he=j(X,oe);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(X,oe,he){return X=new Me(X,he),oe=new Me(oe,he),X.intersects(oe)},e.coerce=function(X){if(X instanceof L)return X;if(typeof X!="string")return null;var oe=X.match(y[O]);return oe==null?null:j((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,w(1))},function(q,e){var w,t,k=q.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function y(b){if(w===setTimeout)return setTimeout(b,0);if((w===R||!w)&&setTimeout)return w=setTimeout,setTimeout(b,0);try{return w(b,0)}catch{try{return w.call(null,b,0)}catch{return w.call(this,b,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:R}catch{w=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var h,m=[],I=!1,C=-1;function S(){I&&h&&(I=!1,h.length?m=h.concat(m):C=-1,m.length&&g())}function g(){if(!I){var b=y(S);I=!0;for(var p=m.length;p;){for(h=m,m=[];++C<p;)h&&h[C].run();C=-1,p=m.length}h=null,I=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(b)}}function d(b,p){this.fun=b,this.array=p}function E(){}k.nextTick=function(b){var p=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)p[v-1]=arguments[v];m.push(new d(b,p)),m.length!==1||I||y(g)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=E,k.addListener=E,k.once=E,k.off=E,k.removeListener=E,k.removeAllListeners=E,k.emit=E,k.prependListener=E,k.prependOnceListener=E,k.listeners=function(b){return[]},k.binding=function(b){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(b){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[127],ee([0,1]),function(q,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(y,h,m){this.level=y,this.key=h,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(y,h=2**16){this.comparator=y,this[w]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(y){return Boolean(R._search(this,y,this.comparator))}get(y){return R._search(this,y,this.comparator)?.value}set(y,h){return R._insert(this,y,h,this.comparator)&&(this._size+=1),this}delete(y){const h=R._delete(this,y,this.comparator);return h&&(this._size-=1),h}forEach(y,h){let m=this._header.forward[0];for(;m;)y.call(h,m.value,m.key,this),m=m.forward[0]}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this._header.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this._header.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this._header.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",h=this._header.forward[0];for(;h;)y+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return y}static _search(y,h,m){let I=y._header;for(let C=y._level-1;C>=0;C--)for(;I.forward[C]&&m(I.forward[C].key,h)<0;)I=I.forward[C];if(I=I.forward[0],I&&m(I.key,h)===0)return I}static _insert(y,h,m,I){const C=[];let S=y._header;for(let g=y._level-1;g>=0;g--){for(;S.forward[g]&&I(S.forward[g].key,h)<0;)S=S.forward[g];C[g]=S}if(S=S.forward[0],S&&I(S.key,h)===0)return S.value=m,!1;{const g=R._randomLevel(y);if(g>y._level){for(let d=y._level;d<g;d++)C[d]=y._header;y._level=g}S=new t(g,h,m);for(let d=0;d<g;d++)S.forward[d]=C[d].forward[d],C[d].forward[d]=S;return!0}}static _randomLevel(y,h=.5){let m=1;for(;Math.random()<h&&m<y._maxLevel;)m+=1;return m}static _delete(y,h,m){const I=[];let C=y._header;for(let S=y._level-1;S>=0;S--){for(;C.forward[S]&&m(C.forward[S].key,h)<0;)C=C.forward[S];I[S]=C}if(C=C.forward[0],!C||m(C.key,h)!==0)return!1;for(let S=0;S<y._level&&I[S].forward[S]===C;S++)I[S].forward[S]=C.forward[S];for(;y._level>0&&y._header.forward[y._level-1]===k;)y._level-=1;return!0}}e.SkipList=R}),define(Z[58],ee([0,1,18,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=k;function R(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=R;function D(u){const c=u;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function y(u,c){return new h(u,c)}e.newWriteableStream=y;class h{constructor(c,s){this.reducer=c,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(s=>s(c))}emitError(c){this.listeners.error.length===0?(0,w.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(s=>s(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,s){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(c,s){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(s);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(u,c){const s=[];let r;for(;(r=u.read())!==null;)s.push(r);return c(s)}e.consumeReadable=m;function I(u,c,s){const r=[];let i;for(;(i=u.read())!==null&&r.length<s;)r.push(i);return i===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return u.read()}}}e.peekReadable=I;function C(u,c){return new Promise((s,r)=>{const i=[];S(u,{onData:n=>{c&&i.push(n)},onError:n=>{c?r(n):s(void 0)},onEnd:()=>{s(c?c(i):void 0)}})})}e.consumeStream=C;function S(u,c){let s=!1;return u.on("error",r=>{s||c.onError(r)}),u.on("end",()=>{s||c.onEnd()}),u.on("data",r=>{s||c.onData(r)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=S;function g(u,c){return new Promise((s,r)=>{const i=new t.DisposableStore,n=[],o=P=>{if(n.push(P),n.length>c)return i.dispose(),u.pause(),s({stream:u,buffer:n,ended:!1})},a=P=>r(P),l=()=>s({stream:u,buffer:n,ended:!0});i.add((0,t.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),i.add((0,t.toDisposable)(()=>u.removeListener("end",l))),u.on("end",l),i.add((0,t.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=g;function d(u,c){const s=y(c);return s.end(u),s}e.toStream=d;function E(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=E;function b(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=b;function p(u,c,s){const r=y(s);return S(u,{onData:i=>r.write(c.data(i)),onError:i=>r.error(c.error?c.error(i):i),onEnd:()=>r.end()}),r}e.transform=p;function v(u,c,s){let r=!1;return{read:()=>{const i=c.read();return r?i:(r=!0,i!==null?s([u,i]):u)}}}e.prefixedReadable=v;function f(u,c,s){let r=!1;const i=y(s);return S(c,{onData:n=>r?i.write(n):(r=!0,i.write(s([u,n]))),onError:n=>i.error(n),onEnd:()=>{r||(r=!0,i.write(u)),i.end()}}),i}e.prefixedStream=f}),define(Z[17],ee([0,1,58]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let k,R;class D{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return t?new D(Buffer.allocUnsafe(P)):new D(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new D(P)}static fromString(P,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(P)):(k||(k=new TextEncoder),new D(k.encode(P)))}static fromByteArray(P){const M=D.alloc(P.length);for(let T=0,O=P.length;T<O;T++)M.buffer[T]=P[T];return M}static concat(P,M){if(typeof M=="undefined"){M=0;for(let U=0,Q=P.length;U<Q;U++)M+=P[U].byteLength}const T=D.alloc(M);let O=0;for(let U=0,Q=P.length;U<Q;U++){const re=P[U];T.set(re,O),O+=re.byteLength}return T}clone(){const P=D.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,M){return new D(this.buffer.subarray(P,M))}set(P,M){if(P instanceof D)this.buffer.set(P.buffer,M);else if(P instanceof Uint8Array)this.buffer.set(P,M);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),M);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return m(this.buffer,P)}writeUInt32BE(P,M){I(this.buffer,P,M)}readUInt32LE(P){return C(this.buffer,P)}writeUInt32LE(P,M){S(this.buffer,P,M)}readUInt8(P){return g(this.buffer,P)}writeUInt8(P,M){d(this.buffer,P,M)}}e.VSBuffer=D;function y(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0}e.readUInt16LE=y;function h(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255}e.writeUInt16LE=h;function m(l,P){return l[P]*2**24+l[P+1]*2**16+l[P+2]*2**8+l[P+3]}e.readUInt32BE=m;function I(l,P,M){l[M+3]=P,P=P>>>8,l[M+2]=P,P=P>>>8,l[M+1]=P,P=P>>>8,l[M]=P}e.writeUInt32BE=I;function C(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0|l[P+2]<<16>>>0|l[P+3]<<24>>>0}e.readUInt32LE=C;function S(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255,P=P>>>8,l[M+2]=P&255,P=P>>>8,l[M+3]=P&255}e.writeUInt32LE=S;function g(l,P){return l[P]}e.readUInt8=g;function d(l,P,M){l[M]=P}e.writeUInt8=d;function E(l){return w.consumeReadable(l,P=>D.concat(P))}e.readableToBuffer=E;function b(l){return w.toReadable(l)}e.bufferToReadable=b;function p(l){return w.consumeStream(l,P=>D.concat(P))}e.streamToBuffer=p;async function v(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await p(l.stream)])}e.bufferedStreamToBuffer=v;function f(l){return w.toStream(l,P=>D.concat(P))}e.bufferToStream=f;function u(l){return w.transform(l,{data:P=>typeof P=="string"?D.fromString(P):D.wrap(P)},P=>D.concat(P))}e.streamToBufferReadableStream=u;function c(l){return w.newWriteableStream(P=>D.concat(P),l)}e.newWriteableBufferStream=c;function s(l,P){return w.prefixedReadable(l,P,M=>D.concat(M))}e.prefixedBufferReadable=s;function r(l,P){return w.prefixedStream(l,P,M=>D.concat(M))}e.prefixedBufferStream=r;function i(l){let P=0,M=0,T=0;const O=new Uint8Array(Math.floor(l.length/4*3)),U=re=>{switch(M){case 3:O[T++]=P|re,M=0;break;case 2:O[T++]=P|re>>>2,P=re<<6,M=3;break;case 1:O[T++]=P|re>>>4,P=re<<4,M=2;break;default:P=re<<2,M=1}};for(let re=0;re<l.length;re++){const le=l.charCodeAt(re);if(le>=65&&le<=90)U(le-65);else if(le>=97&&le<=122)U(le-97+26);else if(le>=48&&le<=57)U(le-48+52);else if(le===43||le===45)U(62);else if(le===47||le===95)U(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${l[re]}`)}}const Q=T;for(;M>0;)U(0);return D.wrap(O).slice(0,Q)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:l},P=!0,M=!1){const T=M?o:n;let O="";const U=l.byteLength%3;let Q=0;for(;Q<l.byteLength-U;Q+=3){const re=l[Q+0],le=l[Q+1],fe=l[Q+2];O+=T[re>>>2],O+=T[(re<<4|le>>>4)&63],O+=T[(le<<2|fe>>>6)&63],O+=T[fe&63]}if(U===1){const re=l[Q+0];O+=T[re>>>2],O+=T[re<<4&63],P&&(O+="==")}else if(U===2){const re=l[Q+0],le=l[Q+1];O+=T[re>>>2],O+=T[(re<<4|le>>>4)&63],O+=T[le<<2&63],P&&(O+="=")}return O}e.encodeBase64=a}),define(Z[12],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function w(r){return typeof r=="string"}e.isString=w;function t(r){return Array.isArray(r)&&r.every(i=>w(i))}e.isStringArray=t;function k(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=k;function R(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=R;function D(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=D;function y(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=y;function h(r){return r===!0||r===!1}e.isBoolean=h;function m(r){return typeof r=="undefined"}e.isUndefined=m;function I(r){return!C(r)}e.isDefined=I;function C(r){return m(r)||r===null}e.isUndefinedOrNull=C;function S(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=S;function g(r){if(C(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=g;function d(...r){const i=[];for(let n=0;n<r.length;n++){const o=r[n];if(C(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(o)}return i}e.assertAllDefined=d;const E=Object.prototype.hasOwnProperty;function b(r){if(!k(r))return!1;for(const i in r)if(E.call(r,i))return!1;return!0}e.isEmptyObject=b;function p(r){return typeof r=="function"}e.isFunction=p;function v(...r){return r.length>0&&r.every(p)}e.areFunctions=v;function f(r,i){const n=Math.min(r.length,i.length);for(let o=0;o<n;o++)u(r[o],i[o])}e.validateConstraints=f;function u(r,i){if(w(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(p(i)){try{if(r instanceof i)return}catch{}if(!C(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function c(r){return r===null?void 0:r}e.withNullAsUndefined=c;function s(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=s}),define(Z[49],ee([0,1,12]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const v=Array.isArray(p)?[]:{};return Object.keys(p).forEach(f=>{p[f]&&typeof p[f]=="object"?v[f]=t(p[f]):v[f]=p[f]}),v}e.deepClone=t;function k(p){if(!p||typeof p!="object")return p;const v=[p];for(;v.length>0;){const f=v.shift();Object.freeze(f);for(const u in f)if(R.call(f,u)){const c=f[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,w.isTypedArray)(c)&&v.push(c)}}return p}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(p,v){return y(p,v,new Set)}e.cloneAndChange=D;function y(p,v,f){if((0,w.isUndefinedOrNull)(p))return p;const u=v(p);if(typeof u!="undefined")return u;if(Array.isArray(p)){const c=[];for(const s of p)c.push(y(s,v,f));return c}if((0,w.isObject)(p)){if(f.has(p))throw new Error("Cannot clone recursive data-structure");f.add(p);const c={};for(const s in p)R.call(p,s)&&(c[s]=y(p[s],v,f));return f.delete(p),c}return p}function h(p,v,f=!0){return(0,w.isObject)(p)?((0,w.isObject)(v)&&Object.keys(v).forEach(u=>{u in p?f&&((0,w.isObject)(p[u])&&(0,w.isObject)(v[u])?h(p[u],v[u],f):p[u]=v[u]):p[u]=v[u]}),p):v}e.mixin=h;function m(p,v){if(p===v)return!0;if(p==null||v===null||v===void 0||typeof p!=typeof v||typeof p!="object"||Array.isArray(p)!==Array.isArray(v))return!1;let f,u;if(Array.isArray(p)){if(p.length!==v.length)return!1;for(f=0;f<p.length;f++)if(!m(p[f],v[f]))return!1}else{const c=[];for(u in p)c.push(u);c.sort();const s=[];for(u in v)s.push(u);if(s.sort(),!m(c,s))return!1;for(f=0;f<c.length;f++)if(!m(p[c[f]],v[c[f]]))return!1}return!0}e.equals=m;function I(p){const v=new Set;return JSON.stringify(p,(f,u)=>{if((0,w.isObject)(u)||Array.isArray(u)){if(v.has(u))return"[Circular]";v.add(u)}return u})}e.safeStringify=I;function C(p,v){const f=Object.create(null);return!p||!v||Object.keys(v).forEach(c=>{const s=p[c],r=v[c];m(s,r)||(f[c]=r)}),f}e.distinct=C;function S(p,v){const f=v.toLowerCase(),u=Object.keys(p).find(c=>c.toLowerCase()===f);return u?p[u]:p[v]}e.getCaseInsensitive=S;function g(p,v){const f=Object.create(null);for(const[u,c]of Object.entries(p))v(u,c)&&(f[u]=c);return f}e.filter=g;function d(p){let v=[],f=Object.getPrototypeOf(p);for(;Object.prototype!==f;)v=v.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return v}e.getAllPropertyNames=d;function E(p){const v=[];for(const f of d(p))typeof p[f]=="function"&&v.push(f);return v}e.getAllMethodNames=E;function b(p,v){const f=c=>function(){const s=Array.prototype.slice.call(arguments,0);return v(c,s)},u={};for(const c of p)u[c]=f(c);return u}e.createProxyObject=b}),define(Z[28],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return w.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(y){for(let h=0;h<y.length;h++)y[h]=Math.floor(Math.random()*256);return y};const R=new Uint8Array(16),D=[];for(let y=0;y<256;y++)D.push(y.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,m="";return m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+="-",m+=D[R[h++]],m+=D[R[h++]],m+="-",m+=D[R[h++]],m+=D[R[h++]],m+="-",m+=D[R[h++]],m+=D[R[h++]],m+="-",m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m}}()}),define(Z[128],ee([0,1,76,29,48]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,y){if(await new Promise((I,C)=>{const S=t.createReadStream(D),g=w.createHash("sha1");S.pipe(g);const d=(0,k.once)((E,b)=>{S.removeAllListeners(),g.removeAllListeners(),E?C(E):I(b)});S.once("error",d),S.once("end",d),g.once("error",d),g.once("data",E=>d(void 0,E.toString("hex")))})!==y)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[129],ee([0,1,30]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const y=D.replace(/\-/g,":").toLowerCase();return!t.has(y)}function R(){const D=(0,w.networkInterfaces)();for(const y in D){const h=D[y];if(h){for(const{mac:m}of h)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[92],ee([0,1,77]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(y,h,m,I=1){let C=!1;return new Promise(S=>{const g=setTimeout(()=>{if(!C)return C=!0,S(0)},m);k(y,h,I,d=>{if(!C)return C=!0,clearTimeout(g),S(d)})})}e.findFreePort=t;function k(y,h,m,I){if(h===0)return I(0);const C=new w.Socket;C.once("connect",()=>(D(C),k(y+m,h-1,m,I))),C.once("data",()=>{}),C.once("error",S=>(D(C),S.code!=="ECONNREFUSED"?k(y+m,h-1,m,I):I(y))),C.connect(y,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(y,h,m){let I=!1,C,S=1;const g=w.createServer({pauseOnConnect:!0});function d(E,b){I||(I=!0,g.removeAllListeners(),g.close(),C&&clearTimeout(C),b(E))}return new Promise(E=>{C=setTimeout(()=>{d(0,E)},m),g.on("listening",()=>{d(y,E)}),g.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&S<h?(y++,S++,g.listen(y,"127.0.0.1")):d(0,E)}),g.on("close",()=>{d(0,E)}),g.listen(y,"127.0.0.1")})}e.findFreePortFaster=R;function D(y){try{y.removeAllListeners("connect"),y.removeAllListeners("error"),y.end(),y.destroy(),y.unref()}catch(h){console.error(h)}}}),define(Z[130],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[131],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(Z[40],ee([0,1,15,18]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,y){const h=(m,...I)=>{this.validateEvent(D,m)&&y(m,...I)};return this.mapListenerToWrapper.set(y,h),w.ipcMain.on(D,h),this}once(D,y){return w.ipcMain.once(D,(h,...m)=>{this.validateEvent(D,h)&&y(h,...m)}),this}handle(D,y){return w.ipcMain.handle(D,(h,...m)=>this.validateEvent(D,h)?y(h,...m):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return w.ipcMain.removeHandler(D),this}removeListener(D,y){const h=this.mapListenerToWrapper.get(y);return h&&(w.ipcMain.removeListener(D,h),this.mapListenerToWrapper.delete(y)),this}validateEvent(D,y){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const h=y.senderFrame,m=h.url;if(!m)return!0;let I="unknown";try{I=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${m}'.`),!1}return I!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${I}'.`),!1):h.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${I}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(Z[132],ee([0,1,15,40,12,130]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(h,m,I,C,S)=>{const g=y(h,C,I);g.popup({window:(0,k.withNullAsUndefined)(w.BrowserWindow.fromWebContents(h.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{g&&h.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=D;function y(h,m,I){const C=new w.Menu;return I.forEach(S=>{let g;S.type==="separator"?g=new w.MenuItem({type:S.type}):Array.isArray(S.submenu)?g=new w.MenuItem({submenu:y(h,m,S.submenu),label:S.label}):g=new w.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(d,E,b)=>h.sender.send(m,S.id,b)}),C.append(g)}),C}}),define(Z[133],ee([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(Z[134],ee([0,1,133]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,y=R*30,h=R*365;function m(C,S,g){typeof C!="number"&&(C=C.getTime());const d=Math.round((new Date().getTime()-C)/1e3);if(d<-30)return(0,w.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(d<30)return(0,w.localize)(1,null);let E;return d<t?(E=d,S?E===1?g?(0,w.localize)(2,null,E):(0,w.localize)(3,null,E):g?(0,w.localize)(4,null,E):(0,w.localize)(5,null,E):E===1?g?(0,w.localize)(6,null,E):(0,w.localize)(7,null,E):g?(0,w.localize)(8,null,E):(0,w.localize)(9,null,E)):d<k?(E=Math.floor(d/t),S?E===1?g?(0,w.localize)(10,null,E):(0,w.localize)(11,null,E):g?(0,w.localize)(12,null,E):(0,w.localize)(13,null,E):E===1?g?(0,w.localize)(14,null,E):(0,w.localize)(15,null,E):g?(0,w.localize)(16,null,E):(0,w.localize)(17,null,E)):d<R?(E=Math.floor(d/k),S?E===1?g?(0,w.localize)(18,null,E):(0,w.localize)(19,null,E):g?(0,w.localize)(20,null,E):(0,w.localize)(21,null,E):E===1?g?(0,w.localize)(22,null,E):(0,w.localize)(23,null,E):g?(0,w.localize)(24,null,E):(0,w.localize)(25,null,E)):d<D?(E=Math.floor(d/R),S?E===1?(0,w.localize)(26,null,E):(0,w.localize)(27,null,E):E===1?(0,w.localize)(28,null,E):(0,w.localize)(29,null,E)):d<y?(E=Math.floor(d/D),S?E===1?g?(0,w.localize)(30,null,E):(0,w.localize)(31,null,E):g?(0,w.localize)(32,null,E):(0,w.localize)(33,null,E):E===1?g?(0,w.localize)(34,null,E):(0,w.localize)(35,null,E):g?(0,w.localize)(36,null,E):(0,w.localize)(37,null,E)):d<h?(E=Math.floor(d/y),S?E===1?g?(0,w.localize)(38,null,E):(0,w.localize)(39,null,E):g?(0,w.localize)(40,null,E):(0,w.localize)(41,null,E):E===1?g?(0,w.localize)(42,null,E):(0,w.localize)(43,null,E):g?(0,w.localize)(44,null,E):(0,w.localize)(45,null,E)):(E=Math.floor(d/h),S?E===1?g?(0,w.localize)(46,null,E):(0,w.localize)(47,null,E):g?(0,w.localize)(48,null,E):(0,w.localize)(49,null,E):E===1?g?(0,w.localize)(50,null,E):(0,w.localize)(51,null,E):g?(0,w.localize)(52,null,E):(0,w.localize)(53,null,E))}e.fromNow=m;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Z[135],ee([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,24,12,135]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(C,S){return S&&(C.stack||C.stacktrace)?k.localize(0,null,y(C),D(C.stack)||D(C.stacktrace)):y(C)}function D(C){return Array.isArray(C)?C.join(`
`):C}function y(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?k.localize(1,null,C.message):C.message||k.localize(2,null)}function h(C=null,S=!1){if(!C)return k.localize(3,null);if(Array.isArray(C)){const g=w.coalesce(C),d=h(g[0],S);return g.length>1?k.localize(4,null,d,g.length):d}if(t.isString(C))return C;if(C.detail){const g=C.detail;if(g.error)return R(g.error,S);if(g.exception)return R(g.exception,S)}return C.stack?R(C,S):C.message?C.message:k.localize(5,null)}e.toErrorMessage=h;function m(C){const S=C;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=m;function I(C,S){let g;return typeof C=="string"?g=new Error(C):g=C,g.actions=S,g}e.createErrorWithActions=I}),define(Z[136],ee([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(Z[137],ee([0,1,136]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,w.localize)(0,null);case 2:return(0,w.localize)(1,null);case 3:return(0,w.localize)(2,null);case 4:return(0,w.localize)(3,null);case 5:return(0,w.localize)(4,null);case 6:return(0,w.localize)(5,null);case 7:return(0,w.localize)(6,null);case 8:return(0,w.localize)(7,null);case 9:return(0,w.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(Z[138],ee([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,138]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,D=!1,y=!1,h=!1,m=!1,I=!1,C=!1,S=!1,g,d=t,E,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const v=typeof p?.versions?.electron=="string",f=v&&p?.type==="renderer";if(typeof navigator=="object"&&!f)b=navigator.userAgent,k=b.indexOf("Windows")>=0,R=b.indexOf("Macintosh")>=0,C=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=b.indexOf("Linux")>=0,m=!0,g=w.getConfiguredDefaultLocale(w.localize(0,null))||t,d=g;else if(typeof p=="object"){k=p.platform==="win32",R=p.platform==="darwin",D=p.platform==="linux",y=D&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,I=v,S=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t,d=t;const l=p.env.VSCODE_NLS_CONFIG;if(l)try{const P=JSON.parse(l),M=P.availableLanguages["*"];g=P.locale,d=M||t,E=P._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var u;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function c(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let s=0;R?s=1:k?s=3:D&&(s=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=D,e.isLinuxSnap=y,e.isNative=h,e.isElectron=I,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isCI=S,e.platform=s,e.userAgent=b,e.language=d;var r;(function(l){function P(){return e.language}l.value=P;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=M;function T(){return e.language==="en"}l.isDefault=T})(r=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,O=l.length;T<O;T++){const U=l[T];if(U.id===M.data.vscodeScheduleAsyncWork){l.splice(T,1),U.callback();return}}});let P=0;return M=>{const T=++P;l.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return l=>setTimeout(l)})();var i;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||C?2:k?1:3;let n=!0,o=!1;function a(){if(!o){o=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,n=new Uint16Array(l.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[34],ee([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const k=w.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Z[9],ee([0,1,34]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,y=46,h=47,m=92,I=58,C=63;class S extends Error{constructor(u,c,s){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=u.indexOf(".")!==-1?"property":"argument";let n=`The "${u}" ${i} ${r} of type ${c}`;n+=`. Received type ${typeof s}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function g(f,u){if(typeof f!="string")throw new S(u,"string",f)}function d(f){return f===h||f===m}function E(f){return f===h}function b(f){return f>=t&&f<=R||f>=k&&f<=D}function p(f,u,c,s){let r="",i=0,n=-1,o=0,a=0;for(let l=0;l<=f.length;++l){if(l<f.length)a=f.charCodeAt(l);else{if(s(a))break;a=h}if(s(a)){if(!(n===l-1||o===1))if(o===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const P=r.lastIndexOf(c);P===-1?(r="",i=0):(r=r.slice(0,P),i=r.length-1-r.lastIndexOf(c)),n=l,o=0;continue}else if(r.length!==0){r="",i=0,n=l,o=0;continue}}u&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${f.slice(n+1,l)}`:r=f.slice(n+1,l),i=l-n-1;n=l,o=0}else a===y&&o!==-1?++o:o=-1}return r}function v(f,u){if(u===null||typeof u!="object")throw new S("pathObject","Object",u);const c=u.dir||u.root,s=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${s}`:`${c}${f}${s}`:s}e.win32={resolve(...f){let u="",c="",s=!1;for(let r=f.length-1;r>=-1;r--){let i;if(r>=0){if(i=f[r],g(i,"path"),i.length===0)continue}else u.length===0?i=w.cwd():(i=w.env[`=${u}`]||w.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==u.toLowerCase()&&i.charCodeAt(2)===m)&&(i=`${u}\\`));const n=i.length;let o=0,a="",l=!1;const P=i.charCodeAt(0);if(n===1)d(P)&&(o=1,l=!0);else if(d(P))if(l=!0,d(i.charCodeAt(1))){let M=2,T=M;for(;M<n&&!d(i.charCodeAt(M));)M++;if(M<n&&M!==T){const O=i.slice(T,M);for(T=M;M<n&&d(i.charCodeAt(M));)M++;if(M<n&&M!==T){for(T=M;M<n&&!d(i.charCodeAt(M));)M++;(M===n||M!==T)&&(a=`\\\\${O}\\${i.slice(T,M)}`,o=M)}}}else o=1;else b(P)&&i.charCodeAt(1)===I&&(a=i.slice(0,2),o=2,n>2&&d(i.charCodeAt(2))&&(l=!0,o=3));if(a.length>0)if(u.length>0){if(a.toLowerCase()!==u.toLowerCase())continue}else u=a;if(s){if(u.length>0)break}else if(c=`${i.slice(o)}\\${c}`,s=l,l&&u.length>0)break}return c=p(c,!s,"\\",d),s?`${u}\\${c}`:`${u}${c}`||"."},normalize(f){g(f,"path");const u=f.length;if(u===0)return".";let c=0,s,r=!1;const i=f.charCodeAt(0);if(u===1)return E(i)?"\\":f;if(d(i))if(r=!0,d(f.charCodeAt(1))){let o=2,a=o;for(;o<u&&!d(f.charCodeAt(o));)o++;if(o<u&&o!==a){const l=f.slice(a,o);for(a=o;o<u&&d(f.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&!d(f.charCodeAt(o));)o++;if(o===u)return`\\\\${l}\\${f.slice(a)}\\`;o!==a&&(s=`\\\\${l}\\${f.slice(a,o)}`,c=o)}}}else c=1;else b(i)&&f.charCodeAt(1)===I&&(s=f.slice(0,2),c=2,u>2&&d(f.charCodeAt(2))&&(r=!0,c=3));let n=c<u?p(f.slice(c),!r,"\\",d):"";return n.length===0&&!r&&(n="."),n.length>0&&d(f.charCodeAt(u-1))&&(n+="\\"),s===void 0?r?`\\${n}`:n:r?`${s}\\${n}`:`${s}${n}`},isAbsolute(f){g(f,"path");const u=f.length;if(u===0)return!1;const c=f.charCodeAt(0);return d(c)||u>2&&b(c)&&f.charCodeAt(1)===I&&d(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let u,c;for(let i=0;i<f.length;++i){const n=f[i];g(n,"path"),n.length>0&&(u===void 0?u=c=n:u+=`\\${n}`)}if(u===void 0)return".";let s=!0,r=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++r;const i=c.length;i>1&&d(c.charCodeAt(1))&&(++r,i>2&&(d(c.charCodeAt(2))?++r:s=!1))}if(s){for(;r<u.length&&d(u.charCodeAt(r));)r++;r>=2&&(u=`\\${u.slice(r)}`)}return e.win32.normalize(u)},relative(f,u){if(g(f,"from"),g(u,"to"),f===u)return"";const c=e.win32.resolve(f),s=e.win32.resolve(u);if(c===s||(f=c.toLowerCase(),u=s.toLowerCase(),f===u))return"";let r=0;for(;r<f.length&&f.charCodeAt(r)===m;)r++;let i=f.length;for(;i-1>r&&f.charCodeAt(i-1)===m;)i--;const n=i-r;let o=0;for(;o<u.length&&u.charCodeAt(o)===m;)o++;let a=u.length;for(;a-1>o&&u.charCodeAt(a-1)===m;)a--;const l=a-o,P=n<l?n:l;let M=-1,T=0;for(;T<P;T++){const U=f.charCodeAt(r+T);if(U!==u.charCodeAt(o+T))break;U===m&&(M=T)}if(T!==P){if(M===-1)return s}else{if(l>P){if(u.charCodeAt(o+T)===m)return s.slice(o+T+1);if(T===2)return s.slice(o+T)}n>P&&(f.charCodeAt(r+T)===m?M=T:T===2&&(M=3)),M===-1&&(M=0)}let O="";for(T=r+M+1;T<=i;++T)(T===i||f.charCodeAt(T)===m)&&(O+=O.length===0?"..":"\\..");return o+=M,O.length>0?`${O}${s.slice(o,a)}`:(s.charCodeAt(o)===m&&++o,s.slice(o,a))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const u=e.win32.resolve(f);if(u.length<=2)return f;if(u.charCodeAt(0)===m){if(u.charCodeAt(1)===m){const c=u.charCodeAt(2);if(c!==C&&c!==y)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(b(u.charCodeAt(0))&&u.charCodeAt(1)===I&&u.charCodeAt(2)===m)return`\\\\?\\${u}`;return f},dirname(f){g(f,"path");const u=f.length;if(u===0)return".";let c=-1,s=0;const r=f.charCodeAt(0);if(u===1)return d(r)?f:".";if(d(r)){if(c=s=1,d(f.charCodeAt(1))){let o=2,a=o;for(;o<u&&!d(f.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&d(f.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&!d(f.charCodeAt(o));)o++;if(o===u)return f;o!==a&&(c=s=o+1)}}}}else b(r)&&f.charCodeAt(1)===I&&(c=u>2&&d(f.charCodeAt(2))?3:2,s=c);let i=-1,n=!0;for(let o=u-1;o>=s;--o)if(d(f.charCodeAt(o))){if(!n){i=o;break}}else n=!1;if(i===-1){if(c===-1)return".";i=c}return f.slice(0,i)},basename(f,u){u!==void 0&&g(u,"ext"),g(f,"path");let c=0,s=-1,r=!0,i;if(f.length>=2&&b(f.charCodeAt(0))&&f.charCodeAt(1)===I&&(c=2),u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let n=u.length-1,o=-1;for(i=f.length-1;i>=c;--i){const a=f.charCodeAt(i);if(d(a)){if(!r){c=i+1;break}}else o===-1&&(r=!1,o=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return c===s?s=o:s===-1&&(s=f.length),f.slice(c,s)}for(i=f.length-1;i>=c;--i)if(d(f.charCodeAt(i))){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1);return s===-1?"":f.slice(c,s)},extname(f){g(f,"path");let u=0,c=-1,s=0,r=-1,i=!0,n=0;f.length>=2&&f.charCodeAt(1)===I&&b(f.charCodeAt(0))&&(u=s=2);for(let o=f.length-1;o>=u;--o){const a=f.charCodeAt(o);if(d(a)){if(!i){s=o+1;break}continue}r===-1&&(i=!1,r=o+1),a===y?c===-1?c=o:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===s+1?"":f.slice(c,r)},format:v.bind(null,"\\"),parse(f){g(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const c=f.length;let s=0,r=f.charCodeAt(0);if(c===1)return d(r)?(u.root=u.dir=f,u):(u.base=u.name=f,u);if(d(r)){if(s=1,d(f.charCodeAt(1))){let M=2,T=M;for(;M<c&&!d(f.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&d(f.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&!d(f.charCodeAt(M));)M++;M===c?s=M:M!==T&&(s=M+1)}}}}else if(b(r)&&f.charCodeAt(1)===I){if(c<=2)return u.root=u.dir=f,u;if(s=2,d(f.charCodeAt(2))){if(c===3)return u.root=u.dir=f,u;s=3}}s>0&&(u.root=f.slice(0,s));let i=-1,n=s,o=-1,a=!0,l=f.length-1,P=0;for(;l>=s;--l){if(r=f.charCodeAt(l),d(r)){if(!a){n=l+1;break}continue}o===-1&&(a=!1,o=l+1),r===y?i===-1?i=l:P!==1&&(P=1):i!==-1&&(P=-1)}return o!==-1&&(i===-1||P===0||P===1&&i===o-1&&i===n+1?u.base=u.name=f.slice(n,o):(u.name=f.slice(n,i),u.base=f.slice(n,o),u.ext=f.slice(i,o))),n>0&&n!==s?u.dir=f.slice(0,n-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let u="",c=!1;for(let s=f.length-1;s>=-1&&!c;s--){const r=s>=0?f[s]:w.cwd();g(r,"path"),r.length!==0&&(u=`${r}/${u}`,c=r.charCodeAt(0)===h)}return u=p(u,!c,"/",E),c?`/${u}`:u.length>0?u:"."},normalize(f){if(g(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===h,c=f.charCodeAt(f.length-1)===h;return f=p(f,!u,"/",E),f.length===0?u?"/":c?"./":".":(c&&(f+="/"),u?`/${f}`:f)},isAbsolute(f){return g(f,"path"),f.length>0&&f.charCodeAt(0)===h},join(...f){if(f.length===0)return".";let u;for(let c=0;c<f.length;++c){const s=f[c];g(s,"path"),s.length>0&&(u===void 0?u=s:u+=`/${s}`)}return u===void 0?".":e.posix.normalize(u)},relative(f,u){if(g(f,"from"),g(u,"to"),f===u||(f=e.posix.resolve(f),u=e.posix.resolve(u),f===u))return"";const c=1,s=f.length,r=s-c,i=1,n=u.length-i,o=r<n?r:n;let a=-1,l=0;for(;l<o;l++){const M=f.charCodeAt(c+l);if(M!==u.charCodeAt(i+l))break;M===h&&(a=l)}if(l===o)if(n>o){if(u.charCodeAt(i+l)===h)return u.slice(i+l+1);if(l===0)return u.slice(i+l)}else r>o&&(f.charCodeAt(c+l)===h?a=l:l===0&&(a=0));let P="";for(l=c+a+1;l<=s;++l)(l===s||f.charCodeAt(l)===h)&&(P+=P.length===0?"..":"/..");return`${P}${u.slice(i+a)}`},toNamespacedPath(f){return f},dirname(f){if(g(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===h;let c=-1,s=!0;for(let r=f.length-1;r>=1;--r)if(f.charCodeAt(r)===h){if(!s){c=r;break}}else s=!1;return c===-1?u?"/":".":u&&c===1?"//":f.slice(0,c)},basename(f,u){u!==void 0&&g(u,"ext"),g(f,"path");let c=0,s=-1,r=!0,i;if(u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let n=u.length-1,o=-1;for(i=f.length-1;i>=0;--i){const a=f.charCodeAt(i);if(a===h){if(!r){c=i+1;break}}else o===-1&&(r=!1,o=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return c===s?s=o:s===-1&&(s=f.length),f.slice(c,s)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===h){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1);return s===-1?"":f.slice(c,s)},extname(f){g(f,"path");let u=-1,c=0,s=-1,r=!0,i=0;for(let n=f.length-1;n>=0;--n){const o=f.charCodeAt(n);if(o===h){if(!r){c=n+1;break}continue}s===-1&&(r=!1,s=n+1),o===y?u===-1?u=n:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||s===-1||i===0||i===1&&u===s-1&&u===c+1?"":f.slice(u,s)},format:v.bind(null,"/"),parse(f){g(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const c=f.charCodeAt(0)===h;let s;c?(u.root="/",s=1):s=0;let r=-1,i=0,n=-1,o=!0,a=f.length-1,l=0;for(;a>=s;--a){const P=f.charCodeAt(a);if(P===h){if(!o){i=a+1;break}continue}n===-1&&(o=!1,n=a+1),P===y?r===-1?r=a:l!==1&&(l=1):r!==-1&&(l=-1)}if(n!==-1){const P=i===0&&c?1:i;r===-1||l===0||l===1&&r===n-1&&r===i+1?u.base=u.name=f.slice(P,n):(u.name=f.slice(P,r),u.base=f.slice(P,n),u.ext=f.slice(r,n))}return i>0?u.dir=f.slice(0,i-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[78],ee([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(y,...h){const m=h.reduce((S,g)=>(S[g]=!0,S),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(S=>!m[S]).forEach(S=>{for(let g=0;g<I.length;g++)if(S.search(I[g])!==-1){delete y[S];break}})}e.sanitizeProcessEnvironment=R;function D(y){!y||(delete y.DEBUG,w.isMacintosh&&delete y.DYLD_LIBRARY_PATH,w.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Z[79],ee([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=w.globals.performance&&typeof w.globals.performance.now=="function";class k{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new k(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[3],ee([0,1,18,48,2,126,79]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const y=!1,h=!1;var m;(function(a){a.None=()=>k.Disposable.None;function l(F){if(h){const{onListenerDidAdd:B}=F,V=d.create();let x=0;F.onListenerDidAdd=()=>{++x==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),B?.()}}}function P(F){return(B,V=null,x)=>{let ne=!1,H;return H=F(te=>{if(!ne)return H?H.dispose():ne=!0,B.call(V,te)},null,x),ne&&H.dispose(),H}}a.once=P;function M(F,B,V){return le((x,ne=null,H)=>F(te=>x.call(ne,B(te)),null,H),V)}a.map=M;function T(F,B,V){return le((x,ne=null,H)=>F(te=>{B(te),x.call(ne,te)},null,H),V)}a.forEach=T;function O(F,B,V){return le((x,ne=null,H)=>F(te=>B(te)&&x.call(ne,te),null,H),V)}a.filter=O;function U(F){return F}a.signal=U;function Q(...F){return(B,V=null,x)=>(0,k.combinedDisposable)(...F.map(ne=>ne(H=>B.call(V,H),null,x)))}a.any=Q;function re(F,B,V,x){let ne=V;return M(F,H=>(ne=B(ne,H),ne),x)}a.reduce=re;function le(F,B){let V;const x={onFirstListenerAdd(){V=F(ne.fire,ne)},onLastListenerRemove(){V?.dispose()}};B||l(x);const ne=new b(x);return B?.add(ne),ne.event}function fe(F,B,V=100,x=!1,ne,H){let te,ie,ce,de=0;const ke={leakWarningThreshold:ne,onFirstListenerAdd(){te=F(Me=>{de++,ie=B(ie,Me),x&&!ce&&(Le.fire(ie),ie=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Ae=ie;ie=void 0,ce=void 0,(!x||de>1)&&Le.fire(Ae),de=0},V)})},onLastListenerRemove(){te.dispose()}};H||l(ke);const Le=new b(ke);return H?.add(Le),Le.event}a.debounce=fe;function se(F,B=(x,ne)=>x===ne,V){let x=!0,ne;return O(F,H=>{const te=x||!B(H,ne);return x=!1,ne=H,te},V)}a.latch=se;function ue(F,B,V){return[a.filter(F,B,V),a.filter(F,x=>!B(x),V)]}a.split=ue;function K(F,B=!1,V=[]){let x=V.slice(),ne=F(ie=>{x?x.push(ie):te.fire(ie)});const H=()=>{x?.forEach(ie=>te.fire(ie)),x=null},te=new b({onFirstListenerAdd(){ne||(ne=F(ie=>te.fire(ie)))},onFirstListenerDidAdd(){x&&(B?setTimeout(H):H())},onLastListenerRemove(){ne&&ne.dispose(),ne=null}});return te.event}a.buffer=K;class N{constructor(B){this.event=B,this.disposables=new k.DisposableStore}map(B){return new N(M(this.event,B,this.disposables))}forEach(B){return new N(T(this.event,B,this.disposables))}filter(B){return new N(O(this.event,B,this.disposables))}reduce(B,V){return new N(re(this.event,B,V,this.disposables))}latch(){return new N(se(this.event,void 0,this.disposables))}debounce(B,V=100,x=!1,ne){return new N(fe(this.event,B,V,x,ne,this.disposables))}on(B,V,x){return this.event(B,V,x)}once(B,V,x){return P(this.event)(B,V,x)}dispose(){this.disposables.dispose()}}function _(F){return new N(F)}a.chain=_;function A(F,B,V=x=>x){const x=(...ie)=>te.fire(V(...ie)),ne=()=>F.on(B,x),H=()=>F.removeListener(B,x),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:H});return te.event}a.fromNodeEventEmitter=A;function W(F,B,V=x=>x){const x=(...ie)=>te.fire(V(...ie)),ne=()=>F.addEventListener(B,x),H=()=>F.removeEventListener(B,x),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:H});return te.event}a.fromDOMEventEmitter=W;function $(F){return new Promise(B=>P(F)(B))}a.toPromise=$;function Y(F,B){return B(void 0),F(V=>B(V))}a.runAndSubscribe=Y;function z(F,B){let V=null;function x(H){V?.dispose(),V=new k.DisposableStore,B(H,V)}x(void 0);const ne=F(H=>x(H));return(0,k.toDisposable)(()=>{ne.dispose(),V?.dispose()})}a.runAndSubscribeWithStore=z;class j{constructor(B,V){this.obs=B,this._counter=0,this._hasChanged=!1;const x={onFirstListenerAdd:()=>{B.addObserver(this)},onLastListenerRemove:()=>{B.removeObserver(this)}};V||l(x),this.emitter=new b(x),V&&V.add(this.emitter)}beginUpdate(B){this._counter++}handleChange(B,V){this._hasChanged=!0}endUpdate(B){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(F,B){return new j(F,B).emitter.event}a.fromObservable=L})(m=e.Event||(e.Event={}));class I{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${I._idPool++}`}start(l){this._stopWatch=new D.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let C=-1;function S(a){const l=C;return C=a,{dispose(){C=l}}}e.setGlobalLeakWarningThreshold=S;class g{constructor(l,P=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,P){let M=C;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||P<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let O,U=0;for(const[Q,re]of this._stacks)(!O||U<re)&&(O=Q,U=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${U}):`),console.warn(O)}return()=>{const O=this._stacks.get(l.value)||0;this._stacks.set(l.value,O-1)}}}class d{constructor(l){this.value=l}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(l,P,M){this.callback=l,this.callbackThis=P,this.stack=M,this.subscription=new k.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class b{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=C>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const P of l)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,P,M)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,U;this._leakageMon&&this._listeners.size>=30&&(U=d.create(),O=this._leakageMon.check(U,this._listeners.size+1)),y&&(U=U??d.create());const Q=new E(l,P,U),re=this._listeners.push(Q);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,P);const le=Q.subscription.set(()=>{O?.(),this._disposed||(re(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(le):Array.isArray(M)&&M.push(le),le}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const P of this._listeners)this._deliveryQueue.push(this,P,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class p{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(l,P,M){this._queue.push(new f(l,P,M))}clear(l){const P=new R.LinkedList;for(const M of this._queue)M.emitter!==l&&P.push(M);this._queue=P}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(P){(0,w.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=p;class v extends p{clear(l){this._queue.clear()}}class f{constructor(l,P,M){this.emitter=l,this.listener=P,this.event=M}}class u extends b{async fireAsync(l,P,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,l]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[T,O]=this._asyncDeliveryQueue.shift(),U=[],Q={...O,token:P,waitUntil:re=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");M&&(re=M(re,T.callback)),U.push(re)}};try{T.invoke(Q)}catch(re){(0,w.onUnexpectedError)(re);continue}Object.freeze(U),await Promise.allSettled(U).then(re=>{for(const le of re)le.status==="rejected"&&(0,w.onUnexpectedError)(le.reason)})}}}}e.AsyncEmitter=u;class c extends b{constructor(l){super(l);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class s extends c{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=s;class r extends b{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const P={event:l,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const M=()=>{this.hasListeners&&this.unhook(P);const T=this.events.indexOf(P);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(P=>this.emitter.fire(P))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(l){return(P,M,T)=>l(O=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>P.call(M,O)):P.call(M,O)},void 0,T)}bufferEvents(l){const P=[];this.buffers.push(P);const M=l();return this.buffers.pop(),P.forEach(T=>T()),M}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(Z[21],ee([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(y,h){const m=setTimeout(y.bind(h),0);return{dispose(){clearTimeout(m)}}});var k;(function(y){function h(m){return m===y.None||m===y.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}y.isCancellationToken=h,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(Z[139],ee([0,1,21]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new w.CancellationTokenSource,h=this.task(y.token);return this.result={promise:h,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=t;class k{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const h=JSON.stringify(y);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(y)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(y){this.fn=y,this._map=new Map}get cachedValues(){return this._map}get(y){if(this._map.has(y))return this._map.get(y);const h=this.fn(y);return this._map.set(y,h),h}}e.CachedFunction=R}),define(Z[93],ee([0,1,3,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:w.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{constructor(y){super();this._value=y,this.changeEmitter=this._register(new w.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(y){y!==this._value&&(this._value=y,this.changeEmitter.fire(y))}}e.MutableObservableValue=R}),define(Z[27],ee([0,1,139,125]),function(q,e,w,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function y(G,...ae){return ae.length===0?G:G.replace(D,function(me,Se){const we=parseInt(Se,10);return isNaN(we)||we<0||we>=ae.length?me:ae[we]})}e.format=y;const h=/{([^}]+)}/g;function m(G,ae){return G.replace(h,(me,Se)=>ae[Se]??me)}e.format2=m;function I(G){return G.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=I;function C(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function S(G,ae){let me=0;const Se=ae.charCodeAt(0);for(let we=G.length-1;we>=0;we--)G.charCodeAt(we)===Se&&me++;return me}e.count=S;function g(G,ae,me="\u2026"){return G.length<=ae?G:`${G.substr(0,ae)}${me}`}e.truncate=g;function d(G,ae=" "){const me=E(G,ae);return b(me,ae)}e.trim=d;function E(G,ae){if(!G||!ae)return G;const me=ae.length;if(me===0||G.length===0)return G;let Se=0;for(;G.indexOf(ae,Se)===Se;)Se=Se+me;return G.substring(Se)}e.ltrim=E;function b(G,ae){if(!G||!ae)return G;const me=ae.length,Se=G.length;if(me===0||Se===0)return G;let we=Se,Ie=-1;for(;Ie=G.lastIndexOf(ae,we-1),!(Ie===-1||Ie+me!==we);){if(Ie===0)return"";we=Ie}return G.substring(0,we)}e.rtrim=b;function p(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function v(G){return G.replace(/\*/g,"")}e.stripWildcards=v;function f(G,ae,me={}){if(!G)throw new Error("Cannot create regex from empty string");ae||(G=C(G)),me.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let Se="";return me.global&&(Se+="g"),me.matchCase||(Se+="i"),me.multiline&&(Se+="m"),me.unicode&&(Se+="u"),new RegExp(G,Se)}e.createRegExp=f;function u(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function s(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=s;function r(G){return G.split(/\r\n|\r|\n/)}e.splitLines=r;function i(G){for(let ae=0,me=G.length;ae<me;ae++){const Se=G.charCodeAt(ae);if(Se!==32&&Se!==9)return ae}return-1}e.firstNonWhitespaceIndex=i;function n(G,ae=0,me=G.length){for(let Se=ae;Se<me;Se++){const we=G.charCodeAt(Se);if(we!==32&&we!==9)return G.substring(ae,Se)}return G.substring(ae,me)}e.getLeadingWhitespace=n;function o(G,ae=G.length-1){for(let me=ae;me>=0;me--){const Se=G.charCodeAt(me);if(Se!==32&&Se!==9)return me}return-1}e.lastNonWhitespaceIndex=o;function a(G,ae,me){const Se=[];let we=0;for(const Ie of G.matchAll(ae)){if(Se.push(G.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,Se.push(me(Ie[0],...Ie.slice(1),Ie.index,G,Ie.groups))}return Se.push(G.slice(we)),Promise.all(Se).then(Ie=>Ie.join(""))}e.replaceAsync=a;function l(G,ae){return G<ae?-1:G>ae?1:0}e.compare=l;function P(G,ae,me=0,Se=G.length,we=0,Ie=ae.length){for(;me<Se&&we<Ie;me++,we++){const Ke=G.charCodeAt(me),xe=ae.charCodeAt(we);if(Ke<xe)return-1;if(Ke>xe)return 1}const Oe=Se-me,$e=Ie-we;return Oe<$e?-1:Oe>$e?1:0}e.compareSubstring=P;function M(G,ae){return T(G,ae,0,G.length,0,ae.length)}e.compareIgnoreCase=M;function T(G,ae,me=0,Se=G.length,we=0,Ie=ae.length){for(;me<Se&&we<Ie;me++,we++){let Ke=G.charCodeAt(me),xe=ae.charCodeAt(we);if(Ke===xe)continue;if(Ke>=128||xe>=128)return P(G.toLowerCase(),ae.toLowerCase(),me,Se,we,Ie);U(Ke)&&(Ke-=32),U(xe)&&(xe-=32);const Ye=Ke-xe;if(Ye!==0)return Ye}const Oe=Se-me,$e=Ie-we;return Oe<$e?-1:Oe>$e?1:0}e.compareSubstringIgnoreCase=T;function O(G){return G>=48&&G<=57}e.isAsciiDigit=O;function U(G){return G>=97&&G<=122}e.isLowerAsciiLetter=U;function Q(G){return G>=65&&G<=90}e.isUpperAsciiLetter=Q;function re(G,ae){return G.length===ae.length&&T(G,ae)===0}e.equalsIgnoreCase=re;function le(G,ae){const me=ae.length;return ae.length>G.length?!1:T(G,ae,0,me)===0}e.startsWithIgnoreCase=le;function fe(G,ae){const me=Math.min(G.length,ae.length);let Se;for(Se=0;Se<me;Se++)if(G.charCodeAt(Se)!==ae.charCodeAt(Se))return Se;return me}e.commonPrefixLength=fe;function se(G,ae){const me=Math.min(G.length,ae.length);let Se;const we=G.length-1,Ie=ae.length-1;for(Se=0;Se<me;Se++)if(G.charCodeAt(we-Se)!==ae.charCodeAt(Ie-Se))return Se;return me}e.commonSuffixLength=se;function ue(G){return 55296<=G&&G<=56319}e.isHighSurrogate=ue;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function N(G,ae){return(G-55296<<10)+(ae-56320)+65536}e.computeCodePoint=N;function _(G,ae,me){const Se=G.charCodeAt(me);if(ue(Se)&&me+1<ae){const we=G.charCodeAt(me+1);if(K(we))return N(Se,we)}return Se}e.getNextCodePoint=_;function A(G,ae){const me=G.charCodeAt(ae-1);if(K(me)&&ae>1){const Se=G.charCodeAt(ae-2);if(ue(Se))return N(Se,me)}return me}class W{constructor(ae,me=0){this._str=ae,this._len=ae.length,this._offset=me}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=A(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=_(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class ${constructor(ae,me=0){this._iterator=new W(ae,me)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=ye.getInstance(),me=this._iterator,Se=me.offset;let we=ae.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ie=me.offset,Oe=ae.getGraphemeBreakType(me.nextCodePoint());if(oe(we,Oe)){me.setOffset(Ie);break}we=Oe}return me.offset-Se}prevGraphemeLength(){const ae=ye.getInstance(),me=this._iterator,Se=me.offset;let we=ae.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ie=me.offset,Oe=ae.getGraphemeBreakType(me.prevCodePoint());if(oe(Oe,we)){me.setOffset(Ie);break}we=Oe}return Se-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=$;function Y(G,ae){return new $(G,ae).nextGraphemeLength()}e.nextCharLength=Y;function z(G,ae){return new $(G,ae).prevGraphemeLength()}e.prevCharLength=z;function j(G,ae){ae>0&&K(G.charCodeAt(ae))&&ae--;const me=ae+Y(G,ae);return[me-z(G,me),me]}e.getCharContainingOffset=j;const L=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(G){return L.test(G)}e.containsRTL=F;const B=/^[\t\n\r\x20-\x7E]*$/;function V(G){return B.test(G)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=x;function ne(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=ne;function H(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=H;function te(G,ae){if(G.length<ae)return G;const me=/\b/g;let Se=0;for(;me.test(G)&&!(G.length-me.lastIndex<ae);)Se=me.lastIndex,me.lastIndex+=1;return G.substring(Se).replace(/^\s/,"")}e.lcut=te;const ie=/\x1B\x5B[12]?K/g,ce=/\x1b\[\d+m/g,de=/\x1b\[0?m/g;function ke(G){return G&&(G=G.replace(ie,""),G=G.replace(ce,""),G=G.replace(de,"")),G}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function Me(G){return Le(G)?G.substr(1):G}e.stripUTF8BOM=Me;function Ae(G,ae){if(!G||!ae||G.length<ae.length)return!1;const me=ae.length,Se=G.toLowerCase();let we=0,Ie=-1;for(;we<me;){const Oe=Se.indexOf(ae[we],Ie+1);if(Oe<0)return!1;Ie=Oe,we++}return!0}e.fuzzyContains=Ae;function Ve(G,ae=!1){return G?(ae&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ve;function ge(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=ge;function pe(G,ae=1){if(ae===0)return"";let me=-1;do me=G.indexOf(`
`,me+1),ae--;while(ae>0&&me>=0);return me===-1?G:(G[me-1]==="\r"&&me--,G.substr(0,me))}e.getNLines=pe;function be(G){const ae=90-65+1;return G=G%(2*ae),G<ae?String.fromCharCode(97+G):String.fromCharCode(65+G-ae)}e.singleLetterHash=be;function X(G){return ye.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=X;function oe(G,ae){return G===0?ae!==5&&ae!==7:G===2&&ae===3?!1:G===4||G===2||G===3||ae===4||ae===2||ae===3?!0:!(G===8&&(ae===8||ae===9||ae===11||ae===12)||(G===11||G===9)&&(ae===9||ae===10)||(G===12||G===10)&&ae===10||ae===5||ae===13||ae===7||G===1||G===13&&ae===14||G===6&&ae===6)}var he;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(he=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=Ce()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const me=this._data,Se=me.length/3;let we=1;for(;we<=Se;)if(ae<me[3*we])we=2*we;else if(ae>me[3*we+1])we=2*we+1;else return me[3*we+2];return 0}}ye._INSTANCE=null;function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(G,ae){if(G===0)return 0;const me=Fe(G,ae);if(me!==void 0)return me;const Se=new W(ae,G);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Te;function Fe(G,ae){const me=new W(ae,G);let Se=me.prevCodePoint();for(;Be(Se)||Se===65039||Se===8419;){if(me.offset===0)return;Se=me.prevCodePoint()}if(!H(Se))return;let we=me.offset;return we>0&&me.prevCodePoint()===8205&&(we=me.offset),we}function Be(G){return 127995<=G&&G<=127999}var ze;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class _e{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return _e.cache.get(Array.from(ae))}static getLocales(){return _e._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=_e,k=_e,_e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new w.LRUCachedFunction(G=>{function ae(xe){const Ye=new Map;for(let et=0;et<xe.length;et+=2)Ye.set(xe[et],xe[et+1]);return Ye}function me(xe,Ye){const et=new Map(xe);for(const[ot,at]of Ye)et.set(ot,at);return et}function Se(xe,Ye){if(!xe)return Ye;const et=new Map;for(const[ot,at]of xe)Ye.has(ot)&&et.set(ot,at);return et}const we=k.ambiguousCharacterData.getValue();let Ie=G.filter(xe=>!xe.startsWith("_")&&xe in we);Ie.length===0&&(Ie=["_default"]);let Oe;for(const xe of Ie){const Ye=ae(we[xe]);Oe=Se(Oe,Ye)}const $e=ae(we._common),Ke=me($e,Oe);return new _e(Ke)}),_e._locales=new t.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(ae){return je.getData().has(ae)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je,je._data=void 0}),define(Z[31],ee([0,1,9,4,27,12]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(o){return o===47||o===92}e.isPathSeparator=D;function y(o){return o.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=y;function h(o){return o.indexOf("/")===-1&&(o=y(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=h;function m(o,a=w.posix.sep){if(!o)return"";const l=o.length,P=o.charCodeAt(0);if(D(P)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let T=3;const O=T;for(;T<l&&!D(o.charCodeAt(T));T++);if(O!==T&&!D(o.charCodeAt(T+1))){for(T+=1;T<l;T++)if(D(o.charCodeAt(T)))return o.slice(0,T+1).replace(/[\\/]/g,a)}}return a}else if(p(P)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let M=o.indexOf("://");if(M!==-1){for(M+=3;M<l;M++)if(D(o.charCodeAt(M)))return o.slice(0,M+1)}return""}e.getRoot=m;function I(o){if(!t.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let l=2;const P=l;for(;l<o.length&&(a=o.charCodeAt(l),a!==92);l++);return!(P===l||(a=o.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,a=t.isWindows){const l=a?C:S;return!(!o||o.length===0||/^\s+$/.test(o)||(l.lastIndex=0,l.test(o))||a&&g.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function E(o,a,l){const P=o===a;return!l||P?P:!o||!a?!1:(0,k.equalsIgnoreCase)(o,a)}e.isEqual=E;function b(o,a,l,P=w.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let T=a.length;return a.charAt(a.length-1)===P&&T--,o.charAt(T)===P}return a.charAt(a.length-1)!==P&&(a+=P),o.indexOf(a)===0}e.isEqualOrParent=b;function p(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=p;function v(o,a){return t.isWindows&&o.endsWith(":")&&(o+=w.sep),(0,w.isAbsolute)(o)||(o=(0,w.join)(a,o)),o=(0,w.normalize)(o),t.isWindows?(o=(0,k.rtrim)(o,w.sep),o.endsWith(":")&&(o+=w.sep)):(o=(0,k.rtrim)(o,w.sep),o||(o=w.sep)),o}e.sanitizeFilePath=v;function f(o){const a=(0,w.normalize)(o);return t.isWindows?o.length>3?!1:u(a)&&(o.length===2||a.charCodeAt(2)===92):a===w.posix.sep}e.isRootOrDriveLetter=f;function u(o,a=t.isWindows){return a?p(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(o){return u(o)?o[0]:void 0}e.getDriveLetter=c;function s(o,a,l){return a.length>o.length?-1:o===a?0:(l&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=s;function r(o){const a=o.split(":");let l,P,M;for(const T of a){const O=Number(T);(0,R.isNumber)(O)?P===void 0?P=O:M===void 0&&(M=O):l=l?[l,T].join(":"):T}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:P!==void 0?P:void 0,column:M!==void 0?M:P!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,a,l=8){let P="";for(let T=0;T<l;T++)P+=i.charAt(Math.floor(Math.random()*i.length));let M;return a?M=`${a}-${P}`:M=P,o?(0,w.join)(o,M):M}e.randomPath=n}),define(Z[66],ee([0,1,27]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return k(p,0)}e.hash=t;function k(p,v){switch(typeof p){case"object":return p===null?R(349,v):Array.isArray(p)?h(p,v):m(p,v);case"string":return y(p,v);case"boolean":return D(p,v);case"number":return R(p,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=k;function R(p,v){return(v<<5)-v+p|0}e.numberHash=R;function D(p,v){return R(p?433:863,v)}function y(p,v){v=R(149417,v);for(let f=0,u=p.length;f<u;f++)v=R(p.charCodeAt(f),v);return v}e.stringHash=y;function h(p,v){return v=R(104579,v),p.reduce((f,u)=>k(u,f),v)}function m(p,v){return v=R(181387,v),Object.keys(p).sort().reduce((f,u)=>(f=y(u,f),k(p[u],f)),v)}class I{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=k(v,this._value),this._value}}e.Hasher=I;var C;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function S(p,v,f=32){const u=f-v,c=~((1<<u)-1);return(p<<v|(c&p)>>>u)>>>0}function g(p,v=0,f=p.byteLength,u=0){for(let c=0;c<f;c++)p[v+c]=u}function d(p,v,f="0"){for(;p.length<v;)p=f+p;return p}function E(p,v=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(f=>f.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),v/4)}e.toHexString=E;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const f=v.length;if(f===0)return;const u=this._buff;let c=this._buffLen,s=this._leftoverHighSurrogate,r,i;for(s!==0?(r=s,i=-1,s=0):(r=v.charCodeAt(0),i=0);;){let n=r;if(w.isHighSurrogate(r))if(i+1<f){const o=v.charCodeAt(i+1);w.isLowSurrogate(o)?(i++,n=w.computeCodePoint(r,o)):n=65533}else{s=r;break}else w.isLowSurrogate(r)&&(n=65533);if(c=this._push(u,c,n),i++,i<f)r=v.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=s}_push(v,f,u){return u<128?v[f++]=u:u<2048?(v[f++]=192|(u&1984)>>>6,v[f++]=128|(u&63)>>>0):u<65536?(v[f++]=224|(u&61440)>>>12,v[f++]=128|(u&4032)>>>6,v[f++]=128|(u&63)>>>0):(v[f++]=240|(u&1835008)>>>18,v[f++]=128|(u&258048)>>>12,v[f++]=128|(u&4032)>>>6,v[f++]=128|(u&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=b._bigBlock32,f=this._buffDV;for(let l=0;l<64;l+=4)v.setUint32(l,f.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)v.setUint32(l,S(v.getUint32(l-12,!1)^v.getUint32(l-32,!1)^v.getUint32(l-56,!1)^v.getUint32(l-64,!1),1),!1);let u=this._h0,c=this._h1,s=this._h2,r=this._h3,i=this._h4,n,o,a;for(let l=0;l<80;l++)l<20?(n=c&s|~c&r,o=1518500249):l<40?(n=c^s^r,o=1859775393):l<60?(n=c&s|c&r|s&r,o=2400959708):(n=c^s^r,o=3395469782),a=S(u,5)+n+i+o+v.getUint32(l*4,!1)&4294967295,i=r,r=s,s=S(c,30),c=u,u=a;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[32],ee([0,1,24,27]),function(q,e,w,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.getOrSet=y;function h(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=h;function m(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=m;class I{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return o-a}value(){return this._value[this._pos]}}e.StringIterator=I;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class S{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const a=this._value.charCodeAt(o);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var g;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(g||(g={}));class d{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(b||(b={}));class p{constructor(n){this._iter=n}static forUris(n=()=>!1,o=()=>!1){return new p(new d(n,o))}static forPaths(n=!1){return new p(new S(void 0,!n))}static forStrings(){return new p(new I)}static forConfigKeys(){return new p(new C)}clear(){this._root=void 0}fill(n,o){if(o){const a=o.slice(0);(0,w.shuffle)(a);for(const l of a)this.set(l,n)}else{const a=n.slice(0);(0,w.shuffle)(a);for(const l of a)this.set(l[0],l[1])}}set(n,o){const a=this._iter.reset(n);let l;this._root||(this._root=new E,this._root.segment=a.value());const P=[];for(l=this._root;;){const T=a.cmp(l.segment);if(T>0)l.left||(l.left=new E,l.left.segment=a.value()),P.push([-1,l]),l=l.left;else if(T<0)l.right||(l.right=new E,l.right.segment=a.value()),P.push([1,l]),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new E,l.mid.segment=a.value()),P.push([0,l]),l=l.mid;else break}const M=l.value;l.value=o,l.key=n;for(let T=P.length-1;T>=0;T--){const O=P[T][1];O.updateHeight();const U=O.balanceFactor();if(U<-1||U>1){const Q=P[T][0],re=P[T+1][0];if(Q===1&&re===1)P[T][1]=O.rotateLeft();else if(Q===-1&&re===-1)P[T][1]=O.rotateRight();else if(Q===1&&re===-1)O.right=P[T+1][1]=P[T+1][1].rotateRight(),P[T][1]=O.rotateLeft();else if(Q===-1&&re===1)O.left=P[T+1][1]=P[T+1][1].rotateLeft(),P[T][1]=O.rotateRight();else throw new Error;if(T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}return M}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let a=this._root;for(;a;){const l=o.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else break}return a}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const a=this._iter.reset(n),l=[];let P=this._root;for(;P;){const M=a.cmp(P.segment);if(M>0)l.push([-1,P]),P=P.left;else if(M<0)l.push([1,P]),P=P.right;else if(a.hasNext())a.next(),l.push([0,P]),P=P.mid;else break}if(!!P){if(o?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const M=this._min(P.right),{key:T,value:O,segment:U}=M;this._delete(M.key,!1),P.key=T,P.value=O,P.segment=U}else{const M=P.left??P.right;if(l.length>0){const[T,O]=l[l.length-1];switch(T){case-1:O.left=M;break;case 0:O.mid=M;break;case 1:O.right=M;break}}else this._root=M}for(let M=l.length-1;M>=0;M--){const T=l[M][1];T.updateHeight();const O=T.balanceFactor();if(O>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),l[M][1]=T.rotateLeft()):O<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),l[M][1]=T.rotateRight()),M>0)switch(l[M-1][0]){case-1:l[M-1][1].left=l[M][1];break;case 1:l[M-1][1].right=l[M][1];break;case 0:l[M-1][1].mid=l[M][1];break}else this._root=l[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let a=this._root,l;for(;a;){const P=o.cmp(a.segment);if(P>0)a=a.left;else if(P<0)a=a.right;else if(o.hasNext())o.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(n){const o=this._iter.reset(n);let a=this._root;for(;a;){const l=o.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[o,a]of this)n(a,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const a=o.balanceFactor();return a<-1||a>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=p;class v{constructor(n,o){this.uri=n,this.value=o}}class f{constructor(n,o){this[k]="ResourceMap",n instanceof f?(this.map=new Map(n.map),this.toKey=o??f.defaultToKey):(this.map=new Map,this.toKey=n??f.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new v(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(const[a,l]of this.map)n(l.value,l.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=f,f.defaultToKey=i=>i.toString();class u{constructor(n,o){this[R]="ResourceSet",!n||typeof n=="function"?this._map=new f(n):(this._map=new f(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((a,l)=>n.call(o,l,l,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var c;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class s{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const a=this._map.get(n);if(!!a)return o!==0&&this.touch(a,o),a.value}set(n,o,a=0){let l=this._map.get(n);if(l)l.value=o,a!==0&&this.touch(l,a);else{switch(l={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const a=this._state;let l=this._head;for(;l;){if(o?n.bind(o)(l.value,l.key,this):n(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.key,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}values(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.value,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}entries(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:[a.key,a.value],done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>n;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const a=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const a=n.next,l=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.LinkedMap=s;class r extends s{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r}),define(Z[80],ee([0,1,32]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new w.LRUCache(1e4);function k(m){return h(m,"NFC",t)}e.normalizeNFC=k;const R=new w.LRUCache(1e4);function D(m){return h(m,"NFD",R)}e.normalizeNFD=D;const y=/[^\u0000-\u0080]/;function h(m,I,C){if(!m)return m;const S=C.get(m);if(S)return S;let g;return y.test(m)?g=m.normalize(I):g=m,C.set(m,g),g}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(I){return D(I).replace(m,"")}}()}),define(Z[94],ee([0,1,27]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",y="warn",h="info",m="ignore";function I(S){return S?w.equalsIgnoreCase(R,S)?k.Error:w.equalsIgnoreCase(D,S)||w.equalsIgnoreCase(y,S)?k.Warning:w.equalsIgnoreCase(h,S)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function C(S){switch(S){case k.Error:return R;case k.Warning:return D;case k.Info:return h;default:return m}}k.toString=C}(t||(t={})),e.default=t}),define(Z[7],ee([0,1,9,4]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function y(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function m(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==C&&(n=C+n):n=C;break}return n}const I="",C="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(n,o,a,l,P,M=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=h(n,M),this.authority=o||I,this.path=m(this.scheme,a||I),this.query=l||I,this.fragment=P||I,y(this,M))}static isUri(n){return n instanceof g?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return f(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:a,path:l,query:P,fragment:M}=n;return o===void 0?o=this.scheme:o===null&&(o=I),a===void 0?a=this.authority:a===null&&(a=I),l===void 0?l=this.path:l===null&&(l=I),P===void 0?P=this.query:P===null&&(P=I),M===void 0?M=this.fragment:M===null&&(M=I),o===this.scheme&&a===this.authority&&l===this.path&&P===this.query&&M===this.fragment?this:new E(o,a,l,P,M)}static parse(n,o=!1){const a=S.exec(n);return a?new E(a[2]||I,r(a[4]||I),r(a[5]||I),r(a[7]||I),r(a[9]||I),o):new E(I,I,I,I,I)}static file(n){let o=I;if(t.isWindows&&(n=n.replace(/\\/g,C)),n[0]===C&&n[1]===C){const a=n.indexOf(C,2);a===-1?(o=n.substring(2),n=C):(o=n.substring(2,a),n=n.substring(a)||C)}return new E("file",o,n,I,I)}static from(n){const o=new E(n.scheme,n.authority,n.path,n.query,n.fragment);return y(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&n.scheme==="file"?a=g.file(w.win32.join(f(n,!0),...o)).path:a=w.posix.join(n.path,...o),n.with({path:a})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof g)return n;{const o=new E(n);return o._formatted=n.external,o._fsPath=n._sep===d?n.fsPath:null,o}}else return n}}e.URI=g;const d=t.isWindows?1:void 0;class E extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(i,n){let o,a=-1;for(let l=0;l<i.length;l++){const P=i.charCodeAt(l);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47)a!==-1&&(o+=encodeURIComponent(i.substring(a,l)),a=-1),o!==void 0&&(o+=i.charAt(l));else{o===void 0&&(o=i.substr(0,l));const M=b[P];M!==void 0?(a!==-1&&(o+=encodeURIComponent(i.substring(a,l)),a=-1),o+=M):a===-1&&(a=l)}}return a!==-1&&(o+=encodeURIComponent(i.substring(a))),o!==void 0?o:i}function v(i){let n;for(let o=0;o<i.length;o++){const a=i.charCodeAt(o);a===35||a===63?(n===void 0&&(n=i.substr(0,o)),n+=b[a]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function f(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=f;function u(i,n){const o=n?v:p;let a="",{scheme:l,authority:P,path:M,query:T,fragment:O}=i;if(l&&(a+=l,a+=":"),(P||l==="file")&&(a+=C,a+=C),P){let U=P.indexOf("@");if(U!==-1){const Q=P.substr(0,U);P=P.substr(U+1),U=Q.indexOf(":"),U===-1?a+=o(Q,!1):(a+=o(Q.substr(0,U),!1),a+=":",a+=o(Q.substr(U+1),!1)),a+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?a+=o(P,!1):(a+=o(P.substr(0,U),!1),a+=P.substr(U))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const U=M.charCodeAt(1);U>=65&&U<=90&&(M=`/${String.fromCharCode(U+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const U=M.charCodeAt(0);U>=65&&U<=90&&(M=`${String.fromCharCode(U+32)}:${M.substr(2)}`)}a+=o(M,!0)}return T&&(a+="?",a+=o(T,!1)),O&&(a+="#",a+=n?O:p(O,!1)),a}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(s)?i.replace(s,n=>c(n)):i}}),define(Z[140],ee([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const I=m;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const I=[];let C;try{const S=JSON.parse(m.arguments),g=S[S.length-1];g&&g.__$stack&&(S.pop(),C=g.__$stack),I.push(...S)}catch{I.push("Unable to log remote console arguments",m.arguments)}return{args:I,stack:C}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const I=m;if(I){const C=D(I),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(S&&S.length===4)return{uri:w.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=R;function D(m){if(!m)return m;const I=m.indexOf(`
`);return I===-1?m:m.substring(0,I)}function y(m,I){const{args:C,stack:S}=k(m),g=typeof C[0]=="string"&&C.length===1;let d=D(S);d&&(d=`(${d.trim()})`);let E=[];if(typeof C[0]=="string"?d&&g?E=[`%c[${I}] %c${C[0]} %c${d}`,h("blue"),h(""),h("grey")]:E=[`%c[${I}] %c${C[0]}`,h("blue"),h(""),...C.slice(1)]:E=[`%c[${I}]%`,h("blue"),...C],d&&!g&&E.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,E)}e.log=y;function h(m){return`color: ${m}`}}),define(Z[67],ee([0,1,17,27,7]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,y)}e.stringify=R;function D(m){let I=JSON.parse(m);return I=h(I),I}e.parse=D;function y(m,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function h(m,I=0){if(!m||I>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof w.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let C=0;C<m.length;++C)m[C]=h(m[C],I+1);else for(const C in m)Object.hasOwnProperty.call(m,C)&&(m[C]=h(m[C],I+1))}return m}e.revive=h}),define(Z[13],ee([0,1,4,7]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h){this._remoteResourcesPath=`${h}/${k.vscodeRemoteResource}`}set(h,m,I){this._hosts[h]=m,this._ports[h]=I}setConnectionToken(h,m){this._connectionTokens[h]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)return this._delegate(h);const m=h.authority;let I=this._hosts[m];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const C=this._ports[m],S=this._connectionTokens[m];let g=`path=${encodeURIComponent(h.path)}`;return typeof S=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),t.URI.from({scheme:w.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${I}:${C}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new R;class D{asBrowserUri(h,m){const I=this.toUri(h,m);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===k.file&&(w.isNative||w.isWebWorker&&w.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?I.with({scheme:k.vscodeFileResource,authority:I.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(h,m){const I=this.toUri(h,m);return I.scheme===k.vscodeFileResource?I.with({scheme:k.file,authority:I.authority!==D.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(h,m){return t.URI.isUri(h)?h:t.URI.parse(m.toUrl(h))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(Z[16],ee([0,1,31,13,9,4,27,7]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(g){return(0,y.uriToFsPath)(g,!0)}e.originalFSPath=h;class m{constructor(d){this._ignorePathCasing=d}compare(d,E,b=!1){return d===E?0:(0,D.compare)(this.getComparisonKey(d,b),this.getComparisonKey(E,b))}isEqual(d,E,b=!1){return d===E?!0:!d||!E?!1:this.getComparisonKey(d,b)===this.getComparisonKey(E,b)}getComparisonKey(d,E=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,E,b=!1){if(d.scheme===E.scheme){if(d.scheme===t.Schemas.file)return w.isEqualOrParent(h(d),h(E),this._ignorePathCasing(d))&&d.query===E.query&&(b||d.fragment===E.fragment);if((0,e.isEqualAuthority)(d.authority,E.authority))return w.isEqualOrParent(d.path,E.path,this._ignorePathCasing(d),"/")&&d.query===E.query&&(b||d.fragment===E.fragment)}return!1}joinPath(d,...E){return y.URI.joinPath(d,...E)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let E;return d.scheme===t.Schemas.file?E=y.URI.file(k.dirname(h(d))).path:(E=k.posix.dirname(d.path),d.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),E="/")),d.with({path:E})}normalizePath(d){if(!d.path.length)return d;let E;return d.scheme===t.Schemas.file?E=y.URI.file(k.normalize(h(d))).path:E=k.posix.normalize(d.path),d.with({path:E})}relativePath(d,E){if(d.scheme!==E.scheme||!(0,e.isEqualAuthority)(d.authority,E.authority))return;if(d.scheme===t.Schemas.file){const v=k.relative(h(d),h(E));return R.isWindows?w.toSlashes(v):v}let b=d.path||"/";const p=E.path||"/";if(this._ignorePathCasing(d)){let v=0;for(const f=Math.min(b.length,p.length);v<f&&!(b.charCodeAt(v)!==p.charCodeAt(v)&&b.charAt(v).toLowerCase()!==p.charAt(v).toLowerCase());v++);b=p.substr(0,v)+b.substr(v)}return k.posix.relative(b,p)}resolvePath(d,E){if(d.scheme===t.Schemas.file){const b=y.URI.file(k.resolve(h(d),E));return d.with({authority:b.authority,path:b.path})}return E=w.toPosixPath(E),d.with({path:k.posix.resolve(d.path,E)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,E){return d===E||d!==void 0&&E!==void 0&&(0,D.equalsIgnoreCase)(d,E)}hasTrailingPathSeparator(d,E=k.sep){if(d.scheme===t.Schemas.file){const b=h(d);return b.length>w.getRoot(b).length&&b[b.length-1]===E}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,E=k.sep){return(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,E=k.sep){let b=!1;if(d.scheme===t.Schemas.file){const p=h(d);b=p!==void 0&&p.length===w.getRoot(p).length&&p[p.length-1]===E}else{E="/";const p=d.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(g=>g.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(g,d){const E=[];for(let b=0;b<g.length;b++){const p=d(g[b]);g.some((v,f)=>f===b?!1:(0,e.isEqualOrParent)(p,d(v)))||E.push(g[b])}return E}e.distinctParents=I;var C;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function d(E){const b=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(f=>{const[u,c]=f.split(":");u&&c&&b.set(u,c)});const v=E.path.substring(0,E.path.indexOf(";"));return v&&b.set(g.META_DATA_MIME,v),b}g.parseMetaData=d})(C=e.DataUri||(e.DataUri={}));function S(g,d,E){if(d){let b=g.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),g.with({scheme:E,authority:d,path:b})}return g.with({scheme:E})}e.toLocalResource=S}),define(Z[8],ee([0,1,21,18,3,2,16,4]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(j){return!!j&&typeof j.then=="function"}e.isThenable=h;function m(j){const L=new w.CancellationTokenSource,F=j(L.token),B=new Promise((V,x)=>{const ne=L.token.onCancellationRequested(()=>{ne.dispose(),L.dispose(),x(new t.CancellationError)});Promise.resolve(F).then(H=>{ne.dispose(),L.dispose(),V(H)},H=>{ne.dispose(),L.dispose(),x(H)})});return new class{cancel(){L.cancel()}then(V,x){return B.then(V,x)}catch(V){return this.then(void 0,V)}finally(V){return B.finally(V)}}}e.createCancelablePromise=m;function I(j,L,F){return new Promise((B,V)=>{const x=L.onCancellationRequested(()=>{x.dispose(),B(F)});j.then(B,V).finally(()=>x.dispose())})}e.raceCancellation=I;function C(j,L){return new Promise((F,B)=>{const V=L.onCancellationRequested(()=>{V.dispose(),B(new t.CancellationError)});j.then(F,B).finally(()=>V.dispose())})}e.raceCancellationError=C;async function S(j){let L=-1;const F=j.map((V,x)=>V.then(ne=>(L=x,ne))),B=await Promise.race(F);return j.forEach((V,x)=>{x!==L&&V.cancel()}),B}e.raceCancellablePromises=S;function g(j,L,F){let B;const V=setTimeout(()=>{B?.(void 0),F?.()},L);return Promise.race([j.finally(()=>clearTimeout(V)),new Promise(x=>B=x)])}e.raceTimeout=g;function d(j){return new Promise((L,F)=>{const B=j();h(B)?B.then(L,F):L(B)})}e.asPromise=d;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const F=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(F,F).then(B)})}return new Promise((F,B)=>{this.queuedPromise.then(F,B)})}return this.activePromise=L(),new Promise((F,B)=>{this.activePromise.then(V=>{this.activePromise=null,F(V)},V=>{this.activePromise=null,B(V)})})}}e.Throttler=E;class b{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=b;class p{constructor(){this.promiseMap=new Map}queue(L,F){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=p;const v=(j,L)=>{let F=!0;const B=setTimeout(()=>{F=!1,L()},j);return{isTriggered:()=>F,dispose:()=>{clearTimeout(B),F=!1}}},f=j=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,j())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,F=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,x)=>{this.doResolve=V,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=F===e.MicrotaskDelay?f(B):v(F,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(L){this.delayer=new u(L),this.throttler=new E}trigger(L,F){return this.delayer.trigger(()=>this.throttler.queue(L),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class s{constructor(){this._isOpen=!1,this._promise=new Promise((L,F)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(j,L){return L?new Promise((F,B)=>{const V=setTimeout(()=>{x.dispose(),F()},j),x=L.onCancellationRequested(()=>{clearTimeout(V),x.dispose(),B(new t.CancellationError)})}):m(F=>i(j,F))}e.timeout=i;function n(j,L=0){const F=setTimeout(j,L);return(0,R.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=n;function o(j){const L=[];let F=0;const B=j.length;function V(){return F<B?j[F++]():null}function x(ne){ne!=null&&L.push(ne);const H=V();return H?H.then(x):Promise.resolve(L)}return Promise.resolve(null).then(x)}e.sequence=o;function a(j,L=B=>!!B,F=null){let B=0;const V=j.length,x=()=>{if(B>=V)return Promise.resolve(F);const ne=j[B++];return Promise.resolve(ne()).then(te=>L(te)?Promise.resolve(te):x())};return x()}e.first=a;function l(j,L=B=>!!B,F=null){if(j.length===0)return Promise.resolve(F);let B=j.length;const V=()=>{B=-1;for(const x of j)x.cancel?.()};return new Promise((x,ne)=>{for(const H of j)H.then(te=>{--B>=0&&L(te)?(V(),x(te)):B===0&&x(F)}).catch(te=>{--B>=0&&(V(),ne(te))})})}e.firstParallel=l;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((F,B)=>{this.outstandingPromises.push({factory:L,c:F,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const F=L.factory();F.then(L.c,L.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class M extends P{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new _;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,F=D.extUri){const B=F.getComparisonKey(L);let V=this.queues.get(B);return V||(V=new M,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(B),this.onDidQueueDrain()}),this.queues.set(B,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class O{constructor(L,F){this._token=-1,typeof L=="function"&&typeof F=="number"&&this.setIfNotSet(L,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},F)}setIfNotSet(L,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},F))}}e.TimeoutTimer=O;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,F){this.cancel(),this._token=setInterval(()=>{L()},F)}}e.IntervalTimer=U;class Q{constructor(L,F){this.timeoutToken=-1,this.runner=L,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Q;class re{constructor(L,F){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=F,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=re;class le extends Q{constructor(L,F){super(L,F);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=le;class fe extends R.Disposable{constructor(L,F){super();this.options=L,this.handler=F,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=fe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,y.setTimeout0)(()=>{if(L)return;const F=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(j,L)=>{const F=requestIdleCallback(j,typeof L=="number"?{timeout:L}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(F))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function ue(j,L,F){let B;for(let V=0;V<F;V++)try{return await j()}catch(x){B=x,await i(L)}throw B}e.retry=ue;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,F,B){return this._pending={taskId:L,cancel:()=>B?.(),promise:F},F.then(()=>this.donePending(L),()=>this.donePending(L)),F}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let F,B;const V=new Promise((x,ne)=>{F=x,B=ne});this._next={run:L,promise:V,promiseResolve:F,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=K;class N{constructor(L,F=()=>Date.now()){this.interval=L,this.nowFn=F,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,F)=>{this.completeCallback=L,this.errorCallback=F})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(F=>{this.completeCallback(L),this.resolved=!0,F()})}error(L){return new Promise(F=>{this.errorCallback(L),this.rejected=!0,F()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=_;var A;(function(j){async function L(B){let V;const x=await Promise.all(B.map(ne=>ne.then(H=>H,H=>{V||(V=H)})));if(typeof V!="undefined")throw V;return x}j.settled=L;function F(B){return new Promise(async(V,x)=>{try{await B(V,x)}catch(ne){x(ne)}})}j.withAsyncBody=F})(A=e.Promises||(e.Promises={}));var W;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(W||(W={}));class ${constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const F={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(L(F)),this.resolve()}catch(B){this.reject(B)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}static fromArray(L){return new $(F=>{F.emitMany(L)})}static fromPromise(L){return new $(async F=>{F.emitMany(await L)})}static fromPromises(L){return new $(async F=>{await Promise.all(L.map(async B=>F.emitOne(await B)))})}static merge(L){return new $(async F=>{await Promise.all(L.map(async B=>{for await(const V of B)F.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,F){return new $(async B=>{for await(const V of L)B.emitOne(F(V))})}map(L){return $.map(this,L)}static filter(L,F){return new $(async B=>{for await(const V of L)F(V)&&B.emitOne(V)})}filter(L){return $.filter(this,L)}static coalesce(L){return $.filter(L,F=>!!F)}coalesce(){return $.coalesce(this)}static async toPromise(L){const F=[];for await(const B of L)F.push(B);return F}toPromise(){return $.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=$,$.EMPTY=$.fromArray([]);class Y extends ${constructor(L,F){super(F);this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Y;function z(j){const L=new w.CancellationTokenSource,F=j(L.token);return new Y(L,async B=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),B.reject(new t.CancellationError)});try{for await(const x of F){if(L.token.isCancellationRequested)return;B.emitOne(x)}V.dispose(),L.dispose()}catch(x){V.dispose(),L.dispose(),B.reject(x)}})}e.createCancelableAsyncIterable=z}),define(Z[95],ee([0,1,24,8,31,32,9,4,27]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",C="[^/\\\\]",S=/\//g;function g(_,A){switch(_){case 0:return"";case 1:return`${C}*?`;default:return`(?:${I}|${C}+${I}${A?`|${I}${C}+`:""})*?`}}function d(_,A){if(!_)return[];const W=[];let $=!1,Y=!1,z="";for(const j of _){switch(j){case A:if(!$&&!Y){W.push(z),z="";continue}break;case"{":$=!0;break;case"}":$=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}z+=j}return z&&W.push(z),W}e.splitGlobAware=d;function E(_){if(!_)return"";let A="";const W=d(_,e.GLOB_SPLIT);if(W.every($=>$===e.GLOBSTAR))A=".*";else{let $=!1;W.forEach((Y,z)=>{if(Y===e.GLOBSTAR){if($)return;A+=g(2,z===W.length-1)}else{let j=!1,L="",F=!1,B="";for(const V of Y){if(V!=="}"&&j){L+=V;continue}if(F&&(V!=="]"||!B)){let x;V==="-"?x=V:(V==="^"||V==="!")&&!B?x="^":V===e.GLOB_SPLIT?x="":x=(0,h.escapeRegExpCharacters)(V),B+=x;continue}switch(V){case"{":j=!0;continue;case"[":F=!0;continue;case"}":{A+=`(?:${d(L,",").map(H=>E(H)).join("|")})`,j=!1,L="";break}case"]":{A+="["+B+"]",F=!1,B="";break}case"?":A+=C;continue;case"*":A+=g(1);continue;default:A+=(0,h.escapeRegExpCharacters)(V)}}z<W.length-1&&(W[z+1]!==e.GLOBSTAR||z+2<W.length)&&(A+=I)}$=Y===e.GLOBSTAR})}return A}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new R.LRUCache(1e4),r=function(){return!1},i=function(){return null};function n(_,A){if(!_)return i;let W;typeof _!="string"?W=_.pattern:W=_,W=W.trim();const $=`${W}_${!!A.trimForExclusions}`;let Y=s.get($);if(Y)return o(Y,_);let z;return b.test(W)?Y=l(W.substr(4),W):(z=p.exec(a(W,A)))?Y=P(z[1],W):(A.trimForExclusions?f:v).test(W)?Y=M(W,A):(z=u.exec(a(W,A)))?Y=T(z[1].substr(1),W,!0):(z=c.exec(a(W,A)))?Y=T(z[1],W,!1):Y=O(W),s.set($,Y),o(Y,_)}function o(_,A){if(typeof A=="string")return _;const W=function($,Y){return(0,k.isEqualOrParent)($,A.base,!y.isLinux)?_($.substr(A.base.length+1),Y):null};return W.allBasenames=_.allBasenames,W.allPaths=_.allPaths,W.basenames=_.basenames,W.patterns=_.patterns,W}function a(_,A){return A.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function l(_,A){return function(W,$){return typeof W=="string"&&W.endsWith(_)?A:null}}function P(_,A){const W=`/${_}`,$=`\\${_}`,Y=function(j,L){return typeof j!="string"?null:L?L===_?A:null:j===_||j.endsWith(W)||j.endsWith($)?A:null},z=[_];return Y.basenames=z,Y.patterns=[A],Y.allBasenames=z,Y}function M(_,A){const W=K(_.slice(1,-1).split(",").map(L=>n(L,A)).filter(L=>L!==i),_),$=W.length;if(!$)return i;if($===1)return W[0];const Y=function(L,F){for(let B=0,V=W.length;B<V;B++)if(W[B](L,F))return _;return null},z=W.find(L=>!!L.allBasenames);z&&(Y.allBasenames=z.allBasenames);const j=W.reduce((L,F)=>F.allPaths?L.concat(F.allPaths):L,[]);return j.length&&(Y.allPaths=j),Y}function T(_,A,W){const $=D.sep===D.posix.sep,Y=$?_:_.replace(S,D.sep),z=D.sep+Y,j=D.posix.sep+_;let L;return W?L=function(F,B){return typeof F=="string"&&(F===Y||F.endsWith(z)||!$&&(F===_||F.endsWith(j)))?A:null}:L=function(F,B){return typeof F=="string"&&(F===Y||!$&&F===_)?A:null},L.allPaths=[(W?"*/":"./")+_],L}function O(_){try{const A=new RegExp(`^${E(_)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?_:null}}catch{return i}}function U(_,A,W){return!_||typeof A!="string"?!1:Q(_)(A,void 0,W)}e.match=U;function Q(_,A={}){if(!_)return r;if(typeof _=="string"||re(_)){const W=n(_,A);if(W===i)return r;const $=function(Y,z){return!!W(Y,z)};return W.allBasenames&&($.allBasenames=W.allBasenames),W.allPaths&&($.allPaths=W.allPaths),$}return se(_,A)}e.parse=Q;function re(_){const A=_;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=re;function le(_){return _.allBasenames||[]}e.getBasenameTerms=le;function fe(_){return _.allPaths||[]}e.getPathTerms=fe;function se(_,A){const W=K(Object.getOwnPropertyNames(_).map(L=>ue(L,_[L],A)).filter(L=>L!==i)),$=W.length;if(!$)return i;if(!W.some(L=>!!L.requiresSiblings)){if($===1)return W[0];const L=function(V,x){let ne;for(let H=0,te=W.length;H<te;H++){const ie=W[H](V,x);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(ne||(ne=[]),ne.push(ie))}return ne?(async()=>{for(const H of ne){const te=await H;if(typeof te=="string")return te}return null})():null},F=W.find(V=>!!V.allBasenames);F&&(L.allBasenames=F.allBasenames);const B=W.reduce((V,x)=>x.allPaths?V.concat(x.allPaths):V,[]);return B.length&&(L.allPaths=B),L}const Y=function(L,F,B){let V,x;for(let ne=0,H=W.length;ne<H;ne++){const te=W[ne];te.requiresSiblings&&B&&(F||(F=(0,D.basename)(L)),V||(V=F.substr(0,F.length-(0,D.extname)(L).length)));const ie=te(L,F,V,B);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(x||(x=[]),x.push(ie))}return x?(async()=>{for(const ne of x){const H=await ne;if(typeof H=="string")return H}return null})():null},z=W.find(L=>!!L.allBasenames);z&&(Y.allBasenames=z.allBasenames);const j=W.reduce((L,F)=>F.allPaths?L.concat(F.allPaths):L,[]);return j.length&&(Y.allPaths=j),Y}function ue(_,A,W){if(A===!1)return i;const $=n(_,W);if($===i)return i;if(typeof A=="boolean")return $;if(A){const Y=A.when;if(typeof Y=="string"){const z=(j,L,F,B)=>{if(!B||!$(j,L))return null;const V=Y.replace("$(basename)",F),x=B(V);return(0,t.isThenable)(x)?x.then(ne=>ne?_:null):x?_:null};return z.requiresSiblings=!0,z}}return $}function K(_,A){const W=_.filter(L=>!!L.basenames);if(W.length<2)return _;const $=W.reduce((L,F)=>{const B=F.basenames;return B?L.concat(B):L},[]);let Y;if(A){Y=[];for(let L=0,F=$.length;L<F;L++)Y.push(A)}else Y=W.reduce((L,F)=>{const B=F.patterns;return B?L.concat(B):L},[]);const z=function(L,F){if(typeof L!="string")return null;if(!F){let V;for(V=L.length;V>0;V--){const x=L.charCodeAt(V-1);if(x===47||x===92)break}F=L.substr(V)}const B=$.indexOf(F);return B!==-1?Y[B]:null};z.basenames=$,z.patterns=Y,z.allBasenames=$;const j=_.filter(L=>!L.basenames);return j.push(z),j}function N(_,A){return(0,w.equals)(_,A,(W,$)=>typeof W=="string"&&typeof $=="string"?W===$:typeof W!="string"&&typeof $!="string"?W.base===$.base&&W.pattern===$.pattern:!1)}e.patternsEquals=N}),define(Z[35],ee([0,1,24,31,9,4,16,27]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,n){const{os:o,tildify:a,relative:l}=n;if(l){const T=m(i,l,o);if(typeof T=="string")return T}let P=i.fsPath;if(o===1&&!R.isWindows?P=P.replace(/\//g,"\\"):o!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),o!==1&&a?.userHome){const T=a.userHome.fsPath;let O;i.scheme!==a.userHome.scheme&&i.path.startsWith(k.posix.sep)?O=a.userHome.with({path:i.path}).fsPath:O=i.fsPath,P=S(O,T,o)}return(o===1?k.win32:k.posix).normalize(I(P,o===1))}e.getPathLabel=h;function m(i,n,o){const a=o===1?k.win32:k.posix,l=o===3?D.extUri:D.extUriIgnorePathCase,P=n.getWorkspace(),M=(0,w.firstOrDefault)(P.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=M.uri.with({path:i.path}));const T=n.getWorkspaceFolder(i);if(!T)return;let O;if(l.isEqual(T.uri,i)?O="":O=l.relativePath(T.uri,i)??"",O&&(O=a.normalize(O)),P.folders.length>1&&!n.noPrefix){const U=T.name?T.name:l.basenameOrAuthority(T.uri);O=O?`${U} \u2022 ${O}`:U}return O}function I(i,n=R.isWindows){return(0,t.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let C=Object.create(null);function S(i,n,o=R.OS){if(o===1||!i||!n)return i;let a=C.original===n?C.normalized:void 0;a||(a=n,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,y.rtrim)(a,k.posix.sep)}${k.posix.sep}`,C={original:n,normalized:a});let l=i;return R.isWindows&&(l=(0,t.toSlashes)(l)),(o===3?l.startsWith(a):(0,y.startsWithIgnoreCase)(l,a))?`~/${l.substr(a.length)}`:i}e.tildify=S;function g(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=g;const d="\u2026",E="\\\\",b="~";function p(i,n=k.sep){const o=new Array(i.length);let a=!1;for(let l=0;l<i.length;l++){const P=i[l];if(P===""){o[l]=`.${n}`;continue}if(!P){o[l]=P;continue}a=!0;let M="",T=P;T.indexOf(E)===0?(M=T.substr(0,T.indexOf(E)+E.length),T=T.substr(T.indexOf(E)+E.length)):T.indexOf(n)===0?(M=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(b)===0&&(M=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const O=T.split(n);for(let U=1;a&&U<=O.length;U++)for(let Q=O.length-U;a&&Q>=0;Q--){a=!1;let re=O.slice(Q,Q+U).join(n);for(let le=0;!a&&le<i.length;le++)if(le!==l&&i[le]&&i[le].indexOf(re)>-1){const fe=Q+U===O.length,se=Q>0&&i[le].indexOf(n)>-1?n+re:re,ue=i[le].endsWith(se);a=!fe||ue}if(!a){let le="";(O[0].endsWith(":")||M!=="")&&(Q===1&&(Q=0,U++,re=O[0]+n+re),Q>0&&(le=O[0]+n),le=M+le),Q>0&&(le=le+d+n),le=le+re,Q+U<O.length&&(le=le+n+d),o[l]=le}}a&&(o[l]=P)}return o}e.shorten=p;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function f(i,n=Object.create(null)){const o=[];let a=!1,l="";for(const P of i)if(P==="$"||a&&P==="{")l&&o.push({value:l,type:v.TEXT}),l="",a=!0;else if(P==="}"&&a){const M=n[l];if(typeof M=="string")M.length&&o.push({value:M,type:v.VARIABLE});else if(M){const T=o[o.length-1];(!T||T.type!==v.SEPARATOR)&&o.push({value:M.label,type:v.SEPARATOR})}l="",a=!1}else l+=P;return l&&!a&&o.push({value:l,type:v.TEXT}),o.filter((P,M)=>{if(P.type===v.SEPARATOR){const T=o[M-1],O=o[M+1];return[T,O].every(U=>U&&(U.type===v.VARIABLE||U.type===v.TEXT)&&U.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=f;function u(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function c(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function s(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(i){const n=i.indexOf("/")!==-1?k.posix:k.win32,o=n.basename(i),a=n.dirname(i);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(Z[141],ee([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const S=this._uriTransformer.transformIncoming(C);return S===C?C:t(w.URI.from(S))}transformOutgoing(C){const S=this._uriTransformer.transformOutgoing(C);return S===C?C:t(w.URI.from(S))}transformOutgoingURI(C){const S=this._uriTransformer.transformOutgoing(C);return S===C?C:w.URI.from(S)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,C,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof w.URI)return C.transformOutgoing(I);for(const g in I)if(Object.hasOwnProperty.call(I,g)){const d=R(I[g],C,S+1);d!==null&&(I[g]=d)}}return null}function D(I,C){const S=R(I,C,0);return S===null?I:S}e.transformOutgoingURIs=D;function y(I,C,S,g){if(!I||g>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?w.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(const d in I)if(Object.hasOwnProperty.call(I,d)){const E=y(I[d],C,S,g+1);E!==null&&(I[d]=E)}}return null}function h(I,C){const S=y(I,C,!1,0);return S===null?I:S}e.transformIncomingURIs=h;function m(I,C){const S=y(I,C,!0,0);return S===null?I:S}e.transformAndReviveIncomingURIs=m}),define(Z[81],ee([0,1,30,18,32,28,129]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,C=0;const S=(0,w.networkInterfaces)();for(const g in S){const d=S[g];if(d)for(const{mac:E,internal:b}of d)b||(C+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(I+=1))}this._value=C>0?I/C:0}return this._value}};let y;async function h(){return y||(y=(async()=>await m()||R.generateUuid())()),y}e.getMachineId=h;async function m(){try{const I=await new Promise((S,g)=>{q(["crypto"],S,g)}),C=(0,D.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(Z[23],ee([0,1,29,30,142,8,31,80,9,4,16,7]),function(q,e,w,t,k,R,D,y,h,m,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function g(se,ue=S.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ue===S.UNLINK?E(se):d(se)}async function d(se){try{const ue=(0,D.randomPath)((0,t.tmpdir)());try{await w.promises.rename(se,ue)}catch{return E(se)}E(ue).catch(K=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function E(se){return(0,k.promisify)(w.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function b(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function p(se,ue){return u(await(ue?v(se):(0,k.promisify)(w.readdir)(se)))}async function v(se){try{return await(0,k.promisify)(w.readdir)(se,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const ue=[],K=await p(se);for(const N of K){let _=!1,A=!1,W=!1;try{const $=await e.Promises.lstat((0,h.join)(se,N));_=$.isFile(),A=$.isDirectory(),W=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}ue.push({name:N,isFile:()=>_,isDirectory:()=>A,isSymbolicLink:()=>W})}return ue}function f(se){return u(w.readdirSync(se))}e.readdirSync=f;function u(se){return se.map(ue=>typeof ue=="string"?m.isMacintosh?(0,y.normalizeNFC)(ue):ue:(ue.name=m.isMacintosh?(0,y.normalizeNFC)(ue.name):ue.name,ue))}async function c(se){const ue=await p(se),K=[];for(const N of ue)await r.existsDirectory((0,h.join)(se,N))&&K.push(N);return K}function s(se,ue=1e3){return new Promise(K=>{let N=!1;const _=setInterval(()=>{N||(N=!0,w.access(se,A=>{N=!1,A&&(clearInterval(_),K(void 0))}))},ue)})}e.whenDeleted=s;var r;(function(se){async function ue(_){let A;try{if(A=await e.Promises.lstat(_),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(m.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw $}throw W}}se.stat=ue;async function K(_){try{const{stat:A,symbolicLink:W}=await se.stat(_);return A.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=K;async function N(_){try{const{stat:A,symbolicLink:W}=await se.stat(_);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=N})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function n(se,ue,K){return i.queueFor(C.URI.file(se),I.extUriBiasedIgnorePathCase).queue(()=>{const N=M(K);return new Promise((_,A)=>l(se,ue,N,W=>W?A(W):_()))})}let o=!0;function a(se){o=se}e.configureFlushOnWrite=a;function l(se,ue,K,N){if(!o)return w.writeFile(se,ue,{mode:K.mode,flag:K.flag},N);w.open(se,K.flag,K.mode,(_,A)=>{if(_)return N(_);w.writeFile(A,ue,W=>{if(W)return w.close(A,()=>N(W));w.fdatasync(A,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),a(!1)),w.close(A,Y=>N(Y))))})})}function P(se,ue,K){const N=M(K);if(!o)return w.writeFileSync(se,ue,{mode:N.mode,flag:N.flag});const _=w.openSync(se,N.flag,N.mode);try{w.writeFileSync(_,ue);try{w.fdatasyncSync(_)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),a(!1)}}finally{w.closeSync(_)}}e.writeFileSync=P;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,ue){if(se!==ue)try{await e.Promises.rename(se,ue)}catch(K){if(se.toLowerCase()!==ue.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await O(se,ue,{preserveSymlinks:!1}),await g(se,S.MOVE);else throw K}}async function O(se,ue,K){return Q(se,ue,{root:{source:se,target:ue},options:K,handledSourcePaths:new Set})}const U=511;async function Q(se,ue,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:N,symbolicLink:_}=await r.stat(se);if(_){if(K.options.preserveSymlinks)try{return await fe(se,ue,K)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(_.dangling)return}return N.isDirectory()?re(se,ue,N.mode&U,K):le(se,ue,N.mode&U)}async function re(se,ue,K,N){await e.Promises.mkdir(ue,{recursive:!0,mode:K});const _=await p(se);for(const A of _)await Q((0,h.join)(se,A),(0,h.join)(ue,A),N)}async function le(se,ue,K){await e.Promises.copyFile(se,ue),await e.Promises.chmod(ue,K)}async function fe(se,ue,K){let N=await e.Promises.readlink(se);(0,D.isEqualOrParent)(N,K.root.source,!m.isLinux)&&(N=(0,h.join)(K.root.target,N.substr(K.root.source.length+1))),await e.Promises.symlink(N,ue)}e.Promises=new class{get access(){return(0,k.promisify)(w.access)}get stat(){return(0,k.promisify)(w.stat)}get lstat(){return(0,k.promisify)(w.lstat)}get utimes(){return(0,k.promisify)(w.utimes)}get read(){return(se,ue,K,N,_)=>new Promise((A,W)=>{w.read(se,ue,K,N,_,($,Y,z)=>$?W($):A({bytesRead:Y,buffer:z}))})}get readFile(){return(0,k.promisify)(w.readFile)}get write(){return(se,ue,K,N,_)=>new Promise((A,W)=>{w.write(se,ue,K,N,_,($,Y,z)=>$?W($):A({bytesWritten:Y,buffer:z}))})}get appendFile(){return(0,k.promisify)(w.appendFile)}get fdatasync(){return(0,k.promisify)(w.fdatasync)}get truncate(){return(0,k.promisify)(w.truncate)}get rename(){return(0,k.promisify)(w.rename)}get copyFile(){return(0,k.promisify)(w.copyFile)}get open(){return(0,k.promisify)(w.open)}get close(){return(0,k.promisify)(w.close)}get symlink(){return(0,k.promisify)(w.symlink)}get readlink(){return(0,k.promisify)(w.readlink)}get chmod(){return(0,k.promisify)(w.chmod)}get mkdir(){return(0,k.promisify)(w.mkdir)}get unlink(){return(0,k.promisify)(w.unlink)}get rmdir(){return(0,k.promisify)(w.rmdir)}get realpath(){return(0,k.promisify)(w.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return c}get writeFile(){return n}get rm(){return g}get move(){return T}get copy(){return O}}}),define(Z[96],ee([0,1,29,9,4,27,23]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function y(S){if(k.isLinux)return S;const g=(0,t.dirname)(S);if(S===g)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const b=(0,D.readdirSync)(g).filter(p=>p.toLowerCase()===d);if(b.length===1){const p=y(g);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(d);if(p>=0){const v=y(g);if(v)return(0,t.join)(v,b[p])}}}catch{}return null}e.realcaseSync=y;async function h(S){if(k.isLinux)return S;const g=(0,t.dirname)(S);if(S===g)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const b=(await D.Promises.readdir(g)).filter(p=>p.toLowerCase()===d);if(b.length===1){const p=await h(g);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(d);if(p>=0){const v=await h(g);if(v)return(0,t.join)(v,b[p])}}}catch{}return null}e.realcase=h;async function m(S){try{return await D.Promises.realpath(S)}catch{const d=C(S);return await D.Promises.access(d,w.constants.R_OK),d}}e.realpath=m;function I(S){try{return w.realpathSync(S)}catch{const d=C(S);return w.accessSync(d,w.constants.R_OK),d}}e.realpathSync=I;function C(S){return(0,R.rtrim)((0,t.normalize)(S),t.sep)}}),define(Z[143],ee([0,1,30,9,23]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var h;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(h||(h={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(c,s,r){this.exePath=c,this.displayName=s,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:u=!1}={}){return u?m===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:u=!1,findPreview:c=!1}={}){const s=S({useAlternateBitness:u});if(!s)return null;const r=t.join(s,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const l of await k.Promises.readdir(r)){let P=-1;if(c){const T=l.indexOf("-");if(T<0)continue;const O=l.substring(0,T);if(!R.test(O)||l.substring(T+1)!=="preview")continue;P=parseInt(O,10)}else{if(!R.test(l))continue;P=parseInt(l,10)}if(P<=i)continue;const M=t.join(r,l,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(n=M,i=P)}if(!n)return null;const o=s.includes("x86")?" (x86)":"",a=c?" Preview":"";return new C(n,`PowerShell${a}${o}`,!0)}async function d({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:s,pwshMsixName:r}=u?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(c))if(s.test(i)){const n=t.join(c,i,"pwsh.exe");return new C(n,r)}return null}function E(){const u=t.join(w.homedir(),".dotnet","tools","pwsh.exe");return new C(u,".NET Core PowerShell Global Tool")}function b(){const u=t.join(process.env.windir,m===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(u,"Windows PowerShell",!0)}async function*p(){let u=await g();u&&(yield u),u=await g({useAlternateBitness:!0}),u&&(yield u),u=await d(),u&&(yield u),u=E(),u&&(yield u),u=await g({findPreview:!0}),u&&(yield u),u=await d({findPreview:!0}),u&&(yield u),u=await g({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=b(),u&&(yield u)}async function*v(){for await(const u of p())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=v;async function f(){for await(const u of v())return u;return null}e.getFirstAvailablePowerShellInstallation=f}),define(Z[82],ee([0,1,9,4,34,78,12,23]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(C=k.env){return C.comspec||"cmd.exe"}e.getWindowsShell=h;function m(C){let S=[],g=!1;const d=function(E){if(g){S.push(E);return}(!C.send(E,p=>{if(p&&console.error(p),g=!1,S.length>0){const v=S.slice(0);S=[],v.forEach(f=>d(f))}})||t.isWindows)&&(g=!0)};return{send:d}}e.createQueuedSender=m;var I;(function(C){async function S(g,d,E){if(w.isAbsolute(g))return g;if(d===void 0&&(d=k.cwd()),w.dirname(g)!=="."||(E===void 0&&D.isString(k.env.PATH)&&(E=k.env.PATH.split(w.delimiter)),E===void 0||E.length===0))return w.join(d,g);async function p(v){if(await y.Promises.exists(v)){let f;try{f=await y.Promises.stat(v)}catch(u){u.message.startsWith("EACCES")&&(f=await y.Promises.lstat(v))}return f?!f.isDirectory():!1}return!1}for(const v of E){let f;if(w.isAbsolute(v)?f=w.join(v,g):f=w.join(d,v,g),await p(f))return f;let u=f+".com";if(await p(u)||(u=f+".exe",await p(u)))return u}return w.join(d,g)}C.findExecutable=S})(I=e.win32||(e.win32={}))}),define(Z[97],ee([0,1,50,13]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((y,h)=>{let m;const I=new Map;function C(g,d,E,b,p){const v=I.get(d);if(g===D||v){const f={name:S(E),cmd:E,pid:g,ppid:d,load:b,mem:p};I.set(g,f),g===D&&(m=f),v&&(v.children||(v.children=[]),v.children.push(f),v.children.length>1&&(v.children=v.children.sort((u,c)=>u.pid-c.pid)))}}function S(g){const d=/--vscode-window-kind=shared-process/,E=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,f=/--crashes-directory/,u=/\\pipe\\winpty-control/,c=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(f.exec(g))return"electron-crash-reporter";if(u.exec(g))return"winpty-process";if(c.exec(g))return"console-window-host (Windows internal process)";let r=s.exec(g);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(g)?"shared-process":E.exec(g)?"issue-reporter":b.exec(g)?"process-explorer":"window";if(r[1]==="utility"){if(p.exec(g))return"utility-network-service";if(v.exec(g))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let n="";do r=i.exec(g),r&&(n+=r+" ");while(r);return n&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${n}`:g}if(process.platform==="win32"){const g=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,E)=>{q(["windows-process-tree"],d,E)}).then(d=>{d.getProcessList(D,E=>{if(!E){h(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(E,b=>{const p=new Map;b.forEach(v=>{const f=g(v.commandLine||"");p.set(v.pid,{name:S(f),cmd:f,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),m=p.get(D),m?(p.forEach(v=>{const f=p.get(v.ppid);f&&(f.children||(f.children=[]),f.children.push(v))}),p.forEach(v=>{v.children&&(v.children=v.children.sort((f,u)=>f.pid-u.pid))}),y(m)):h(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let g=function(){let d=[m];const E=[];for(;d.length;){const p=d.shift();p&&(E.push(p.pid),p.children&&(d=d.concat(p.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);b+=" "+E.join(" "),(0,w.exec)(b,{},(p,v,f)=>{if(p||f)h(p||new Error(f.toString()));else{const u=v.toString().split(`
`);for(let c=0;c<E.length;c++){const s=I.get(E[c]);s.load=parseFloat(u[c])}if(!m){h(new Error(`Root process ${D} not found`));return}y(m)}})};(0,w.exec)("which ps",{},(d,E,b)=>{if(d||b)if(process.platform!=="linux")h(d||new Error(b.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,w.exec)(p,{},(v,f,u)=>{v||u?h(v||new Error(u.toString())):(R(f,C),g())})}else{const p=E.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${p} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,u,c)=>{f||c&&!c.includes("screen size is bogus")?h(f||new Error(c.toString())):(R(u,C),process.platform==="linux"?g():m?y(m):h(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,y){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=D.toString().split(`
`);for(const I of m){const C=h.exec(I.trim());C&&C.length===6&&y(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(Z[144],ee([0,1,30,4,143,82]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(g,d){return g===1?t.isWindows?C():R.getWindowsShell(d):m(g,d)}e.getSystemShell=D;function y(g,d){return g===1?t.isWindows?S(d):R.getWindowsShell(d):m(g,d)}e.getSystemShellSync=y;let h=null;function m(g,d){if(t.isLinux&&g===2||t.isMacintosh&&g===3)return"/bin/bash";if(!h){let E;if(t.isWindows)E="/bin/bash";else{if(E=d.SHELL,!E)try{E=(0,w.userInfo)().shell}catch{}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}h=E}return h}let I=null;async function C(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function S(g){if(I)return I;const d=t.isWindows&&parseFloat((0,w.release)())>=10,E=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${g.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?b:R.getWindowsShell(g)}});var ve=this&&this.__decorate||function(q,e,w,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,w):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(q,e,w,t);else for(var y=q.length-1;y>=0;y--)(D=q[y])&&(R=(k<3?D(R):k>3?D(e,w,R):D(e,w))||R);return k>3&&R&&Object.defineProperty(e,w,R),R};define(Z[44],ee([0,1,24,8,17,21,52,18,3,2,67,27,12]),function(q,e,w,t,k,R,D,y,h,m,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function d(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function b(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(p||(p={}));class v{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class f{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var u;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(u||(u={}));function c(_){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(_,0),A}function s(_){return _.read(4).readUInt32BE(0)}function r(_){const A=k.VSBuffer.alloc(1);return A.writeUInt8(_,0),A}const i={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object)},n=typeof Buffer!="undefined";function o(_,A){if(typeof A=="undefined")_.write(i.Undefined);else if(typeof A=="string"){const W=k.VSBuffer.fromString(A);_.write(i.String),_.write(c(W.byteLength)),_.write(W)}else if(n&&Buffer.isBuffer(A)){const W=k.VSBuffer.wrap(A);_.write(i.Buffer),_.write(c(W.byteLength)),_.write(W)}else if(A instanceof k.VSBuffer)_.write(i.VSBuffer),_.write(c(A.byteLength)),_.write(A);else if(Array.isArray(A)){_.write(i.Array),_.write(c(A.length));for(const W of A)o(_,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(A));_.write(i.Object),_.write(c(W.byteLength)),_.write(W)}}function a(_){switch(_.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return _.read(s(_)).toString();case u.Buffer:return _.read(s(_)).buffer;case u.VSBuffer:return _.read(s(_));case u.Array:{const W=s(_),$=[];for(let Y=0;Y<W;Y++)$.push(a(_));return $}case u.Object:return JSON.parse(_.read(s(_)).toString())}}class l{constructor(A,W,$=null,Y=1e3){this.protocol=A,this.ctx=W,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,b(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,b(A.type),A.data);return}}}send(A,W=void 0){const $=new f;return o($,A),o($,W),this.sendBuffer($.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new v(A),$=a(W),Y=a(W),z=$[0];switch(z){case 100:return this.logger?.logIncoming(A.byteLength,$[1],1,`${d(z)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:z,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger?.logIncoming(A.byteLength,$[1],1,`${d(z)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:z,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger?.logIncoming(A.byteLength,$[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:$[1]});case 103:return this.logger?.logIncoming(A.byteLength,$[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:$[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const $=new R.CancellationTokenSource;let Y;try{Y=W.call(this.ctx,A.name,A.arg,$.token)}catch(L){Y=Promise.reject(L)}const z=A.id;Y.then(L=>{this.sendResponse({id:z,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:z,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:z,data:L,type:203}),this.activeRequests.delete(A.id)});const j=(0,m.toDisposable)(()=>$.cancel());this.activeRequests.set(A.id,j)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const $=A.id,z=W.listen(this.ctx,A.name,A.arg)(j=>this.sendResponse({id:$,data:j,type:204}));this.activeRequests.set(A.id,z)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const $=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:$})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const $ of W)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var P;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=W}getChannel(A){const W=this;return{call($,Y,z){return W.isDisposed?Promise.reject(new y.CancellationError):W.requestPromise(A,$,Y,z)},listen($,Y){return W.isDisposed?h.Event.None:W.requestEvent(A,$,Y)}}}requestPromise(A,W,$,Y=R.CancellationToken.None){const z=this.lastRequestId++,L={id:z,type:100,channelName:A,name:W,arg:$};if(Y.isCancellationRequested)return Promise.reject(new y.CancellationError);let F;return new Promise((V,x)=>{if(Y.isCancellationRequested)return x(new y.CancellationError);const ne=()=>{const ce=de=>{switch(de.type){case 201:this.handlers.delete(z),V(de.data);break;case 202:{this.handlers.delete(z);const ke=new Error(de.data.message);ke.stack=de.data.stack,ke.name=de.data.name,x(ke);break}case 203:this.handlers.delete(z),x(de.data);break}};this.handlers.set(z,ce),this.sendRequest(L)};let H=null;this.state===p.Idle?ne():(H=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),H.then(()=>{H=null,ne()}));const te=()=>{H?(H.cancel(),H=null):this.sendRequest({id:z,type:101}),x(new y.CancellationError)},ie=Y.onCancellationRequested(te);F=(0,m.combinedDisposable)((0,m.toDisposable)(te),ie),this.activeRequests.add(F)}).finally(()=>{this.activeRequests.delete(F)})}requestEvent(A,W,$){const Y=this.lastRequestId++,j={id:Y,type:102,channelName:A,name:W,arg:$};let L=null;const F=new h.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(F),this.sendRequest(j)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(F),this.sendRequest({id:Y,type:103}))}}),B=V=>F.fire(V.data);return this.handlers.set(Y,B),F.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${d(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,d(A.type));return}}}send(A,W=void 0){const $=new f;return o($,A),o($,W),this.sendBuffer($.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new v(A),$=a(W),Y=a(W),z=$[0];switch(z){case 200:return this.logger?.logIncoming(A.byteLength,0,0,b(z)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,$[1],0,b(z),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:$})=>{h.Event.once(W.onMessage)(z=>{const j=new v(z),L=a(j),F=new l(W,L),B=new M(W);this.channels.forEach((x,ne)=>F.registerChannel(ne,x));const V={channelServer:F,channelClient:B,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),$(()=>{F.dispose(),B.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const $=this;return{call(Y,z,j){let L;if((0,S.isFunction)(W)){const B=(0,w.getRandomElement)($.connections.filter(W));L=B?Promise.resolve(B):h.Event.toPromise(h.Event.filter($.onDidAddConnection,W))}else L=W.routeCall($,Y,z);const F=L.then(B=>B.channelClient.getChannel(A));return U(F).call(Y,z,j)},listen(Y,z){if((0,S.isFunction)(W))return $.getMulticastEvent(A,W,Y,z);const j=W.routeEvent($,Y,z).then(L=>L.channelClient.getChannel(A));return U(j).listen(Y,z)}}}getMulticastEvent(A,W,$,Y){const z=this;let j=new m.DisposableStore;const L=new h.Emitter({onFirstListenerAdd:()=>{j=new m.DisposableStore;const F=new h.EventMultiplexer,B=new Map,V=ne=>{const te=ne.channelClient.getChannel(A).listen($,Y),ie=F.add(te);B.set(ne,ie)},x=ne=>{const H=B.get(ne);!H||(H.dispose(),B.delete(ne))};z.connections.filter(W).forEach(V),h.Event.filter(z.onDidAddConnection,W)(V,void 0,j),z.onDidRemoveConnection(x,void 0,j),F.event(L.fire,L,j),j.add(F)},onLastListenerRemove:()=>{j.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach($=>{$.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class O{constructor(A,W,$=null){const Y=new f;o(Y,W),A.send(Y.buffer),this.channelClient=new M(A,$),this.channelServer=new l(A,W,$)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function U(_){return{call(A,W,$){return _.then(Y=>Y.call(A,W,$))},listen(A,W){const $=new h.Relay;return _.then(Y=>$.input=Y.listen(A,W)),$.event}}}e.getDelayedChannel=U;function Q(_){let A=!1;return{call(W,$,Y){return A?_.call(W,$,Y):(0,t.timeout)(0).then(()=>A=!0).then(()=>_.call(W,$,Y))},listen(W,$){if(A)return _.listen(W,$);const Y=new h.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>Y.input=_.listen(W,$)),Y.event}}}e.getNextTickChannel=Q;class re{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await h.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=re;var le;(function(_){function A(z,j){const L=z,F=j&&j.disableMarshalling,B=new Map;for(const V in L)$(V)&&B.set(V,h.Event.buffer(L[V],!0));return new class{listen(V,x,ne){const H=B.get(x);if(H)return H;if(Y(x)){const te=L[x];if(typeof te=="function")return te.call(L,ne)}throw new Error(`Event not found: ${x}`)}call(V,x,ne){const H=L[x];if(typeof H=="function"){if(!F&&Array.isArray(ne))for(let te=0;te<ne.length;te++)ne[te]=(0,I.revive)(ne[te]);return H.apply(L,ne)}throw new Error(`Method not found: ${x}`)}}}_.fromService=A;function W(z,j){const L=j&&j.disableMarshalling;return new Proxy({},{get(F,B){if(typeof B=="string")return j?.properties?.has(B)?j.properties.get(B):Y(B)?function(V){return z.listen(B,V)}:$(B)?z.listen(B):async function(...V){let x;j&&!(0,S.isUndefinedOrNull)(j.context)?x=[j.context,...V]:x=V;const ne=await z.call(B,x);return L?ne:(0,I.revive)(ne)};throw new Error(`Property not found: ${String(B)}`)}})}_.toService=W;function $(z){return z[0]==="o"&&z[1]==="n"&&C.isUpperAsciiLetter(z.charCodeAt(2))}function Y(z){return/^onDynamic/.test(z)&&C.isUpperAsciiLetter(z.charCodeAt(9))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const A=_.toString();if(A!=="[object Object]")return A}return _}function ue(_){return Array.isArray(_)?_.map(se):se(_)}function K(_,A,W,$,Y,z,j){j=ue(j);const L=fe[Y],F=L[$%L.length];let B=[`%c[${_}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String($).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(z)?(B=B.concat(j),B.push(")")):B.push(j),console.log.apply(console,B)}e.logWithColors=K;class N{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,$,Y,z){this._totalOutgoing+=A,K(this._outgoingPrefix,this._totalOutgoing,A,W,$,Y,z)}logIncoming(A,W,$,Y,z){this._totalIncoming+=A,K(this._incomingPrefix,this._totalIncoming,A,W,$,Y,z)}}e.IPCLogger=N}),define(Z[145],ee([0,1,17,3,44]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(h){this.port=h,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",m=>w.VSBuffer.wrap(m.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(h,m){const I=new R(h);super(I,m);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=D}),define(Z[98],ee([0,1,17,3,2,44]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let a=0;function l(M,T){if(!o.has(M)){const O=String(++a);o.set(M,O)}return o.get(M)}function P(M,T,O,U){if(!n.enableDiagnostics)return;const Q=l(M,T);if(U instanceof w.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const re=w.VSBuffer.alloc(U.byteLength);re.set(U),n.records.push({timestamp:Date.now(),id:Q,label:T,type:O,buff:re})}else n.records.push({timestamp:Date.now(),id:Q,label:T,type:O,data:U})}n.traceSocketEvent=P})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function I(){return m||(m=w.VSBuffer.alloc(0)),m}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,a){if(o===0)return I();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const T=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=o),T}if(this._chunks[0].byteLength>o){const T=this._chunks[0].slice(0,o);return a&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),T}const l=w.VSBuffer.alloc(o);let P=0,M=0;for(;o>0;){const T=this._chunks[M];if(T.byteLength>o){const O=T.slice(0,o);l.set(O,P),P+=o,a&&(this._chunks[M]=T.slice(o),this._totalLength-=o),o-=o}else l.set(T,P),P+=T.byteLength,a?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,o-=T.byteLength}return l}}e.ChunkStream=C;var S;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(S||(S={}));function g(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class E{constructor(o,a,l,P){this.type=o,this.id=a,this.ack=l,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends k.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,P=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new E(l,P,M,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=w.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(a,o.data)}_bufferAdd(o,a){const l=this._totalLength===0;return this._data.push(o,a),this._totalLength+=o.byteLength+a.byteLength,l}_bufferTake(){const o=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,a){this._bufferAdd(o,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class v extends k.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new E(1,0,0,o))}}e.Protocol=v;class f extends R.IPCClient{constructor(o,a,l=null){super(o,a,l);this.protocol=o}static fromSocket(o,a){return new f(new v(o),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=f;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let o=0,a=this._first;for(;a;)a=a.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let a=0,l=this._first;for(;l;)o[a++]=l.data,l=l.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const a=new c(o);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let a=0;a<r._HISTORY_LENGTH;a++)this.lastRuns[a]=o-1e3*a;setInterval(()=>{for(let a=r._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),a=(1+r._HISTORY_LENGTH)*1e3;let l=0;for(let P=0;P<r._HISTORY_LENGTH;P++)o-this.lastRuns[P]<=a&&l++;return 1-l/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{constructor(o,a=null,l=r.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new E(5,0,0,I());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new E(7,0,0,I());this._socketWriter.write(o)}sendResume(){const o=new E(8,0,0,I());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new E(3,0,this._incomingAckId,I());this._socketWriter.write(o);const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new E(6,0,0,I())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new E(1,a,this._incomingAckId,o);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(o){const a=new E(2,0,0,o);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),a=Date.now()-o.writtenTime,l=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&l>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:l});return}const M=Math.max(2e4-a,2e4-l,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new E(3,0,this._incomingAckId,I());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(Z[146],ee([0,1,40,17,3,2,44,131]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(I,C){const S=k.Event.fromNodeEventEmitter(w.validatedIpcMain,C,(d,E)=>({event:d,message:E})),g=k.Event.filter(S,({event:d})=>d.sender.id===I);return k.Event.map(g,({message:d})=>d&&t.VSBuffer.wrap(d))}class m extends D.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const C=k.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:hello",({sender:S})=>S);return k.Event.map(C,S=>{const g=S.id;m.Clients.get(g)?.dispose();const E=new k.Emitter;m.Clients.set(g,(0,R.toDisposable)(()=>E.fire()));const b=h(g,"vscode:message"),p=k.Event.any(k.Event.signal(h(g,"vscode:disconnect")),E.event);return{protocol:new y.Protocol(S,b),onDidClientDisconnect:p}})}}e.Server=m,m.Clients=new Map}),define(Z[99],ee([0,1,40,3,28,145]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(m,I){super({addEventListener:(C,S)=>m.addListener(C,S),removeEventListener:(C,S)=>m.removeListener(C,S),postMessage:C=>m.postMessage(C),start:()=>m.start(),close:()=>m.close()},I)}}e.Client=D;async function y(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();h.webContents.send("vscode:createMessageChannel",m);const I=t.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:createMessageChannelResult",(S,g)=>({nonce:g,port:S.ports[0]})),{port:C}=await t.Event.toPromise(t.Event.once(t.Event.filter(I,S=>S.nonce===m)));return C}e.connect=y}),define(Z[147],ee([0,1,50,8,17,21,140,18,3,2,49,82,78,44]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends g.ChannelServer{constructor(p){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",v=>k.VSBuffer.wrap(Buffer.from(v,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=d;class E{constructor(p,v){this.modulePath=p,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new t.Delayer(f),this.child=null,this._client=null}getChannel(p){const v=this;return{call(f,u,c){return v.requestPromise(p,f,u,c)},listen(f,u){return v.requestEvent(p,f,u)}}}requestPromise(p,v,f,u=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),s=(0,t.createCancelablePromise)(n=>c.call(v,f,n)),r=u.onCancellationRequested(()=>s.cancel()),i=(0,m.toDisposable)(()=>s.cancel());return this.activeRequests.add(i),s.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(p,v,f){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let u;const c=new h.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(p).listen(v,f)(c.fire,c),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,S.removeDangerousEnvVariables)(v.env),this.child=(0,w.fork)(this.modulePath,p,v);const f=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,D.isRemoteConsoleLog)(o)){(0,D.log)(o,`IPC Library: ${this.options.serverName}`);return}f.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const c=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&c.send(o.buffer.toString("base64")),r=f.event,i={send:s,onMessage:r};this._client=new g.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(l=>(0,m.dispose)(l)),this.activeRequests.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:a})})}return this._client}getCachedChannel(p){let v=this.channels.get(p);return v||(v=this.client.getChannel(p),this.channels.set(p,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(Z[83],ee([0,1,17,18,3,2,9,4,28,44,98]),function(q,e,w,t,k,R,D,y,h,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:q.__$__nodeRequire("crypto"),zlib:q.__$__nodeRequire("zlib"),net:q.__$__nodeRequire("net"),os:q.__$__nodeRequire("os")}}class S{constructor(l,P=""){this.debugLabel=P,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener)}traceSocketEvent(l,P){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const P=M=>{this.traceSocketEvent("read",M),l(w.VSBuffer.wrap(M))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(l){const P=M=>{this.traceSocketEvent("close",{hadError:M}),l({type:0,hadError:M,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(l){const P=()=>{this.traceSocketEvent("nodeEndReceived"),l()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(l){if(!this.socket.destroyed)try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=S;var g;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class E extends R.Disposable{constructor(l,P,M,T){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new b(this,P,M,T,this._onData,(O,U)=>this._write(O,U))),this._register(this._flowManager.onError(O=>{console.error(O),(0,t.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,P){this.socket.traceSocketEvent(l,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let M=2;l.byteLength<126?M+=0:l.byteLength<2**16?M+=2:M+=8;const T=w.VSBuffer.alloc(M);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),l.byteLength<126)T.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){T.writeUInt8(126,1);let O=1;T.writeUInt8(l.byteLength>>>8&255,++O),T.writeUInt8(l.byteLength>>>0&255,++O)}else{T.writeUInt8(127,1);let O=1;T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(l.byteLength>>>24&255,++O),T.writeUInt8(l.byteLength>>>16&255,++O),T.writeUInt8(l.byteLength>>>8&255,++O),T.writeUInt8(l.byteLength>>>0&255,++O)}this.socket.write(w.VSBuffer.concat([T,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),M=P.readUInt8(0),T=(M&128)>>>7,O=(M&64)>>>6,U=P.readUInt8(1),Q=(U&128)>>>7,re=U&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),M=P.readUInt8(1),T=(M&128)>>>7;let O=M&127,U=1;O===126?O=P.readUInt8(++U)*2**8+P.readUInt8(++U):O===127&&(O=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let Q=0;T&&(Q=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=O,this._state.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),f(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class b extends R.Disposable{constructor(l,P,M,T,O,U){super();this._tracer=l,this._onData=O,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new p(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Q=>this._onError.fire(Q))),this._register(this._zlibDeflateStream.onError(Q=>this._onError.fire(Q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:w.VSBuffer.alloc(0)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(P,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,P){return new Promise((M,T)=>{l.write(P),l.flush(O=>M(O))})}acceptFrame(l,P,M){this._readQueue.push({data:l,isCompressed:P,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,P,M){return new Promise((T,O)=>{l.write(P),M&&l.write(w.VSBuffer.fromByteArray([0,0,255,255])),l.flush(U=>T(U))})}}class p extends R.Disposable{constructor(l,P,M,T){super();this._tracer=l,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(T),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent("zlibInflateData",O),this._pendingInflateData.push(w.VSBuffer.wrap(O))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?w.VSBuffer.concat(this._recordedInflateBytes):w.VSBuffer.alloc(0)}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=w.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(P)})}}class v extends R.Disposable{constructor(l,P){super();this._tracer=l,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(w.VSBuffer.wrap(M))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=w.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),l(P)})}}function f(a,l){if(l===0)return;const P=a.byteLength>>>2;for(let re=0;re<P;re++){const le=a.readUInt32BE(re*4);a.writeUInt32BE(le^l,re*4)}const M=P*4,T=a.byteLength-M,O=l>>>24&255,U=l>>>16&255,Q=l>>>8&255;T>=1&&a.writeUInt8(a.readUInt8(M)^O,M),T>=2&&a.writeUInt8(a.readUInt8(M+1)^U,M+1),T>=3&&a.writeUInt8(a.readUInt8(M+2)^Q,M+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const u={[2]:107,[1]:103};function c(){const a=(0,h.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):l=(0,D.join)(C().os.tmpdir(),`vscode-ipc-${a}.sock`),r(l),l}e.createRandomIPCHandle=c;function s(a,l,P){const M=C().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${P}-${l}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${P}-${l}.sock`):T=(0,D.join)(a,`${P}-${l}.sock`),r(T),T}e.createStaticIPCHandle=s;function r(a){const l=u[y.platform];typeof l=="number"&&a.length>=l&&console.warn(`WARNING: IPC handle "${a}" is longer than ${l} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{constructor(l){super(i.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const P=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(P,M=>({protocol:new I.Protocol(new S(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(a){return new Promise((l,P)=>{const M=C().net.createServer();M.on("error",P),M.listen(a,()=>{M.removeListener("error",P),l(new i(M))})})}e.serve=n;function o(a,l){return new Promise((P,M)=>{const T=C().net.createConnection(a,()=>{T.removeListener("error",M),P(I.Client.fromSocket(new S(T,`ipc-client${l}`),l))});T.once("error",M)})}e.connect=o}),define(Z[100],ee([0,1,8,3,2,12]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function y(C){const S=C;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var h;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(S,g=Object.create(null)){super();this.database=S,this.options=g,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((g,d)=>this.accept(d,g)),S.deleted?.forEach(g=>this.accept(g,void 0))}accept(S,g){if(this.state===h.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(g)?d=this.cache.delete(S):this.cache.get(S)!==g&&(this.cache.set(S,g),d=!0),d&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,g){const d=this.cache.get(S);return(0,R.isUndefinedOrNull)(d)?g:d}getBoolean(S,g){const d=this.get(S);return(0,R.isUndefinedOrNull)(d)?g:d==="true"}getNumber(S,g){const d=this.get(S);return(0,R.isUndefinedOrNull)(d)?g:parseInt(d,10)}async set(S,g){if(this.state===h.Closed)return;if((0,R.isUndefinedOrNull)(g))return this.delete(S);const d=String(g);if(this.cache.get(S)!==d)return this.cache.set(S,d),this.pendingInserts.set(S,d),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===h.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((g,d)=>this.items.set(d,g)),S.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=I}),define(Z[148],ee([0,1,8,3,32,9,23]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class y{constructor(I,C=Object.create(null)){this.path=I,this.options=C,this.name=(0,R.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const I=await this.whenConnected,C=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(g=>C.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${C.size} rows`),C}async updateItems(I){const C=await this.whenConnected;return this.doUpdateItems(C,I)}doUpdateItems(I,C){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${C.insert?(0,k.mapToString)(C.insert):"0"}), delete(${C.delete?(0,k.setToString)(C.delete):"0"})`),this.transaction(I,()=>{const S=C.insert,g=C.delete;if(S&&S.size>0){const d=[];d.push([]);let E=0;S.forEach((b,p)=>{let v=d[E];v.length>y.MAX_HOST_PARAMETERS&&(E++,v=[],d.push(v)),v.push(p,b)}),d.forEach(b=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,p=>p.run(b),()=>{const p=[];let v=0;return S.forEach((f,u)=>{p.push(u),v+=f.length}),`Keys: ${p.join(", ")} Length: ${v}`})})}if(g&&g.size){const d=[];d.push([]);let E=0;g.forEach(b=>{let p=d[E];p.length>y.MAX_HOST_PARAMETERS&&(E++,p=[],d.push(p)),p.push(b)}),d.forEach(b=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,p=>p.run(b),()=>{const p=[];return g.forEach(v=>{p.push(v)}),`Keys: ${p.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const C=await this.whenConnected;return this.doClose(C,I)}doClose(I,C){return new Promise((S,g)=>{I.db.close(d=>(d&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${d}`),this.path===y.IN_MEMORY_PATH?S():!I.isErroneous&&!I.isInMemory?this.backup().then(S,E=>(this.logger.error(`[storage ${this.name}] backup(): ${E}`),S())):typeof C=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(E=>{const b=()=>this.doClose(E,void 0);return this.doUpdateItems(E,{insert:C()}).then(()=>b(),p=>(b(),Promise.reject(p)))})).then(S,g):g(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return D.Promises.copy(this.path,I,{preserveSymlinks:!1})}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const C=await this.whenConnected,S=await this.get(C,I?"PRAGMA integrity_check":"PRAGMA quick_check"),g=I?S.integrity_check:S.quick_check;return C.isErroneous?`${g} (last error: ${C.lastError})`:C.isInMemory?`${g} (in-memory!)`:g}async connect(I,C=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${C})`);try{return await this.doConnect(I)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&C)return await(0,w.timeout)(y.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{await D.Promises.unlink(I);try{await D.Promises.rename(this.toBackupPath(I),I)}catch{}return await this.doConnect(I)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(y.IN_MEMORY_PATH)}}}handleSQLiteError(I,C){I.isErroneous=!0,I.lastError=C,this.logger.error(C)}doConnect(I){return new Promise((C,S)=>{new Promise((g,d)=>{q(["@vscode/sqlite3"],g,d)}).then(g=>{const d={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(I,E=>E?d.db&&E.code!=="SQLITE_CANTOPEN"?d.db.close(()=>S(E)):S(E):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>C(d),b=>d.db.close(()=>S(b)))),isInMemory:I===y.IN_MEMORY_PATH};d.db.on("error",E=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${E}`)),this.logger.isTracing&&d.db.on("trace",E=>this.logger.trace(`[storage ${this.name}] Trace (event): ${E}`))},S)})}exec(I,C){return new Promise((S,g)=>{I.db.exec(C,d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${d}`),g(d)):S())})}get(I,C){return new Promise((S,g)=>{I.db.get(C,(d,E)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${d}`),g(d)):S(E))})}all(I,C){return new Promise((S,g)=>{I.db.all(C,(d,E)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${d}`),g(d)):S(E))})}transaction(I,C){return new Promise((S,g)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),C(),I.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${d}`),g(d)):S())})})}prepare(I,C,S,g){const d=I.db.prepare(C),E=b=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${b} (${C}). Details: ${g()}`)};d.on("error",E),S(d),d.finalize(b=>{b&&E(b),d.removeListener("error",E)})}}e.SQLiteStorageDatabase=y,y.IN_MEMORY_PATH=":memory:",y.BUSY_OPEN_TIMEOUT=2e3,y.MAX_HOST_PARAMETERS=256;class h{constructor(I){I&&typeof I.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace?.(I)}error(I){this.logError?.(I)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[149],ee([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(Z[150],ee([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[151],ee([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[152],ee([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(Z[153],ee([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(Z[154],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[155],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[156],ee([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[157],ee([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[158],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(Z[159],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(Z[160],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(Z[161],ee([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[162],ee([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[163],ee([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[164],ee([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[165],ee([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[166],ee([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(Z[167],ee([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(Z[168],ee([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[169],ee([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[170],ee([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[171],ee([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[172],ee([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[173],ee([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(Z[174],ee([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[175],ee([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[176],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function w(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(Z[177],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function w(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=w}),define(Z[178],ee([0,1,3,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(y,h,m){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(y,h,m){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(y){super();this.channel=y}reload(y){this.channel.call("reload",[y])}get onReload(){return this.channel.listen("reload")}close(y){this.channel.call("close",[y])}get onClose(){return this.channel.listen("close")}attachSession(y,h,m){this.channel.call("attach",[y,h,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(y,h){this.channel.call("terminate",[y,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(y,h){return this.channel.call("openExtensionDevelopmentHostWindow",[y,h])}}e.ExtensionHostDebugChannelClient=R}),define(Z[179],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class w{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>q(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=w}),define(Z[180],ee([0,1,134,52,13,9,34,16,7]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(E,b,p){this._args=E,this.paths=b,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",q).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,y.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(h.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=D.env.VSCODE_PORTABLE;return E?h.URI.file((0,R.join)(E,"argv.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,R.resolve)(E):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=this.args["extensions-download-dir"];return E?(0,R.resolve)(E):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,R.resolve)(E);const b=D.env.VSCODE_EXTENSIONS;if(b)return b;const p=D.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(b=>/^[^:/?#]+?:\/\//.test(b)?h.URI.parse(b):h.URI.file((0,R.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,R.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,y.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=D.env.VSCODE_PORTABLE;return E?h.URI.file((0,R.join)(E,"policy.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],m.prototype,"appRoot",null),ve([t.memoize],m.prototype,"userHome",null),ve([t.memoize],m.prototype,"userDataPath",null),ve([t.memoize],m.prototype,"appSettingsHome",null),ve([t.memoize],m.prototype,"tmpDir",null),ve([t.memoize],m.prototype,"cacheHome",null),ve([t.memoize],m.prototype,"stateResource",null),ve([t.memoize],m.prototype,"userRoamingDataHome",null),ve([t.memoize],m.prototype,"userDataSyncHome",null),ve([t.memoize],m.prototype,"userDataSyncLogResource",null),ve([t.memoize],m.prototype,"editSessionsLogResource",null),ve([t.memoize],m.prototype,"sync",null),ve([t.memoize],m.prototype,"machineSettingsResource",null),ve([t.memoize],m.prototype,"workspaceStorageHome",null),ve([t.memoize],m.prototype,"localHistoryHome",null),ve([t.memoize],m.prototype,"keyboardLayoutResource",null),ve([t.memoize],m.prototype,"argvResource",null),ve([t.memoize],m.prototype,"isExtensionDevelopment",null),ve([t.memoize],m.prototype,"untitledWorkspacesHome",null),ve([t.memoize],m.prototype,"installSourcePath",null),ve([t.memoize],m.prototype,"builtinExtensionsPath",null),ve([t.memoize],m.prototype,"extensionsPath",null),ve([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],m.prototype,"extensionDevelopmentKind",null),ve([t.memoize],m.prototype,"extensionTestsLocationURI",null),ve([t.memoize],m.prototype,"debugExtensionHost",null),ve([t.memoize],m.prototype,"serviceMachineIdResource",null),ve([t.memoize],m.prototype,"telemetryLogResource",null),ve([t.memoize],m.prototype,"disableWorkspaceTrust",null),ve([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function I(d,E){return g(d["inspect-extensions"],d["inspect-brk-extensions"],5870,E,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=I;function C(d,E){return g(d["inspect-search"],d["inspect-brk-search"],5876,E,d.extensionEnvironment)}e.parseSearchPort=C;function S(d,E){return g(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,E,d.extensionEnvironment)}e.parsePtyHostPort=S;function g(d,E,b,p,v,f){const c=Number(E||d)||(p?null:b),s=c?Boolean(!!E):!1;let r;if(f)try{r=JSON.parse(f)}catch{}return{port:c,break:s,debugId:v,env:r}}}),define(Z[101],ee([0,1,269,4,152]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function y(d,E,b=D){const p={},v=["_"],f=[];for(const r in E){const i=E[r];i.alias&&(p[r]=i.alias),i.type==="string"||i.type==="string[]"?(v.push(r),i.deprecates&&v.push(...i.deprecates)):i.type==="boolean"&&(f.push(r),i.deprecates&&f.push(...i.deprecates))}const u=w(d,{string:v,boolean:f,alias:p}),c={},s=u;c._=u._.map(r=>String(r)).filter(r=>r.length>0),delete s._;for(const r in E){const i=E[r];i.alias&&delete s[i.alias];let n=s[r];if(i.deprecates)for(const o of i.deprecates)s.hasOwnProperty(o)&&(n||(n=s[o],n&&b.onDeprecatedOption(o,i.deprecationMessage||(0,k.localize)(35,null,r))),delete s[o]);if(typeof n!="undefined"){if(i.type==="string[]"){if(Array.isArray(n)||(n=[n]),!i.allowEmptyValue){const o=n.filter(a=>a.length>0);o.length!==n.length&&(b.onEmptyValue(r),n=o.length>0?o:void 0)}}else i.type==="string"&&(Array.isArray(n)?(n=n.pop(),b.onMultipleValues(r,n)):!n&&!i.allowEmptyValue&&(b.onEmptyValue(r),n=void 0));c[r]=n,i.deprecationMessage&&b.onDeprecatedOption(r,i.deprecationMessage)}delete s[r]}for(const r in s)b.onUnknownOption(r);return c}e.parseArgs=y;function h(d,E){let b="";return E.args&&(Array.isArray(E.args)?b=` <${E.args.join("> <")}>`:b=` <${E.args}>`),E.alias?`-${E.alias} --${d}${b}`:`--${d}${b}`}function m(d,E){let b=0;const p=[];for(const c in d){const s=d[c],r=h(c,s);b=Math.max(b,r.length),p.push([r,s.description])}const v=b+2+1;if(E-v<25)return p.reduce((c,s)=>c.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const f=E-v-1,u=[];for(const c of p){const s=c[0],r=C(c[1],f),i=I(v-s.length-2);u.push("  "+s+i+r[0]);for(let n=1;n<r.length;n++)u.push(I(v)+r[n])}return u}e.formatOptions=m;function I(d){return" ".repeat(d)}function C(d,E){const b=[];for(;d.length;){const p=d.length<E?d.length:d.lastIndexOf(" ",E),v=d.slice(0,p).trim();d=d.slice(p),b.push(v)}return b}function S(d,E,b,p,v){const f=process.stdout.isTTY&&process.stdout.columns||80,u=v?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",c=[`${d} ${b}`];c.push(""),c.push(`${(0,k.localize)(37,null)}: ${E} [${(0,k.localize)(38,null)}]${u}`),c.push(""),v?.noPipe!==!0&&(t.isWindows?c.push((0,k.localize)(39,null,E)):c.push((0,k.localize)(40,null,E)),c.push(""));const s={};for(const r in p){const i=p[r];if(i.description&&i.cat){let n=s[i.cat];n||(s[i.cat]=n={}),n[r]=i}}for(const r in s){const i=r,n=s[i];n&&(c.push(R[i]),c.push(...m(n,f)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=S;function g(d,E){return`${d||(0,k.localize)(41,null)}
${E||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=g}),define(Z[181],ee([0,1,77,178,101]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(y){super();this.windowsMainService=y}call(y,h,m){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(y,h,m)}async openExtensionDevelopmentHostWindow(y,h){const m=(0,k.parseArgs)(y,k.OPTIONS);m.debugRenderer=h;const I=m.extensionDevelopmentPath;if(!I)return{success:!1};const[C]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:m});if(!h)return{success:!0};const S=C.win;if(!S)return{success:!0};const g=S.webContents.debugger;let d=g.isAttached()?1/0:0;const E=(0,w.createServer)(b=>{d++==0&&g.attach();let p=!1;const v=c=>{p||b.write(JSON.stringify(c)+"\0")},f=(c,s,r,i)=>v({method:s,params:r,sessionId:i});S.on("close",()=>{g.removeListener("message",f),b.end(),p=!0}),g.addListener("message",f);let u=Buffer.alloc(0);b.on("data",c=>{u=Buffer.concat([u,c]);for(let s=u.indexOf(0);s!==-1;s=u.indexOf(0)){let r;try{const i=u.slice(0,s).toString("utf8");u=u.slice(s+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}g.sendCommand(r.method,r.params,r.sessionId).then(i=>v({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>v({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),b.on("error",c=>{console.error("error on cdp pipe:",c)}),b.on("close",()=>{p=!0,--d==0&&g.detach()})});return await new Promise(b=>E.listen(0,b)),S.on("close",()=>E.close()),{rendererDebugPort:E.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[59],ee([0,1,270,153,101]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(S,g){const d={onUnknownOption:b=>{console.warn((0,t.localize)(0,null,b))},onMultipleValues:(b,p)=>{console.warn((0,t.localize)(1,null,b,p))},onEmptyValue:b=>{console.warn((0,t.localize)(2,null,b))},onDeprecatedOption:(b,p)=>{console.warn((0,t.localize)(3,null,b,p))}},E=(0,k.parseArgs)(S,k.OPTIONS,g?d:void 0);return E.goto&&E._.forEach(b=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,t.localize)(4,null))),E["max-memory"]&&w(parseInt(E["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),E}function y(S){const g=S.findIndex(d=>!/^-/.test(d));if(g>-1)return[...S.slice(0,g),...S.slice(g+1)]}function h(S){let[,...g]=S;process.env.VSCODE_DEV&&(g=y(g)||[]);const d=!C(process.env);return D(g,d)}e.parseMainProcessArgv=h;function m(S){const[,,...g]=S;return D(g,!0)}e.parseCLIProcessArgv=m;function I(S,...g){const d=S.indexOf("--");return d===-1?S.push(...g):S.splice(d,0,...g),S}e.addArg=I;function C(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function q(e,w,t,k){function R(y){const h=D(y),m=[h];return e.isAbsolute(h)||m.unshift(k),e.resolve(...m)}function D(y){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,t);const I=y["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(C,"AppData","Roaming")}break;case"darwin":m=e.join(w.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,t)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[182],ee([0,271,30,13,16,34]),function(e,w,t,k,R,D){const y=R.dirname(k.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(R.joinPath(y,"package.json").fsPath);return q(w,t,h.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),t=require("os");module.exports=q(w,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[183],ee([0,1,30,180,182]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(y,h){super(y,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,k.getUserDataPath)(y)},h)}}e.NativeEnvironmentService=R}),define(Z[184],ee([0,1,29,30,31]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(D){const y=(0,k.randomPath)((0,t.tmpdir)());try{return(0,w.writeFileSync)(y,""),D&&console.log(`Marker file for --wait created: ${y}`),y}catch(h){D&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=R}),define(Z[185],ee([0,1,16,94,156,186]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function h(p){return p=p.trim(),p==="*"||D.test(p)}e.isValidVersionStr=h;function m(p){if(!h(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=p.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=m;function I(p){if(!p)return null;const v=p.majorBase,f=p.majorMustEqual,u=p.minorBase;let c=p.minorMustEqual;const s=p.patchBase;let r=p.patchMustEqual;p.hasCaret&&(v===0||(c=!1),r=!1);let i=0;if(p.preRelease){const n=y.exec(p.preRelease);if(n){const[,o,a,l]=n;i=Date.UTC(Number(o),Number(a)-1,Number(l))}}return{majorBase:v,majorMustEqual:f,minorBase:u,minorMustEqual:c,patchBase:s,patchMustEqual:r,isMinimum:p.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function C(p,v,f){let u;typeof p=="string"?u=I(m(p)):u=p;let c;v instanceof Date?c=v.getTime():typeof v=="string"&&(c=new Date(v).getTime());let s;if(typeof f=="string"?s=I(m(f)):s=f,!u||!s)return!1;const r=u.majorBase,i=u.minorBase,n=u.patchBase;let o=s.majorBase,a=s.minorBase,l=s.patchBase;const P=s.notBefore;let M=s.majorMustEqual,T=s.minorMustEqual,O=s.patchMustEqual;return s.isMinimum?r>o?!0:r<o?!1:i>a?!0:i<a||c&&c<P?!1:n>=l:(r===1&&o===0&&(!M||!T||!O)&&(o=1,a=0,l=0,M=!0,T=!1,O=!1),r<o?!1:r>o?!M:i<a?!1:i>a?!T:n<l?!1:n>l?!O:!(c&&c<P))}e.isValidVersion=C;function S(p,v,f,u,c){const s=[];if(typeof u.publisher!="undefined"&&typeof u.publisher!="string")return s.push([t.default.Error,k.localize(0,null)]),s;if(typeof u.name!="string")return s.push([t.default.Error,k.localize(1,null,"name")]),s;if(typeof u.version!="string")return s.push([t.default.Error,k.localize(2,null,"version")]),s;if(!u.engines)return s.push([t.default.Error,k.localize(3,null,"engines")]),s;if(typeof u.engines.vscode!="string")return s.push([t.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof u.extensionDependencies!="undefined"&&!b(u.extensionDependencies))return s.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof u.activationEvents!="undefined"){if(!b(u.activationEvents))return s.push([t.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof u.main=="undefined"&&typeof u.browser=="undefined")return s.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),s}if(typeof u.extensionKind!="undefined"&&typeof u.main=="undefined"&&s.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof u.main!="undefined"){if(typeof u.main!="string")return s.push([t.default.Error,k.localize(9,null,"main")]),s;{const n=(0,w.joinPath)(f,u.main);(0,w.isEqualOrParent)(n,f)||s.push([t.default.Warning,k.localize(10,null,n.path,f.path)])}if(typeof u.activationEvents=="undefined")return s.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),s}if(typeof u.browser!="undefined"){if(typeof u.browser!="string")return s.push([t.default.Error,k.localize(12,null,"browser")]),s;{const n=(0,w.joinPath)(f,u.browser);(0,w.isEqualOrParent)(n,f)||s.push([t.default.Warning,k.localize(13,null,n.path,f.path)])}if(typeof u.activationEvents=="undefined")return s.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),s}if(!R.valid(u.version))return s.push([t.default.Error,k.localize(15,null)]),s;const r=[];if(!g(p,v,u,c,r))for(const n of r)s.push([t.default.Error,n]);return s}e.validateExtensionManifest=S;function g(p,v,f,u,c){return u||typeof f.main=="undefined"&&typeof f.browser=="undefined"?!0:E(p,v,f.engines.vscode,c)}e.isValidExtensionVersion=g;function d(p,v,f){return p==="*"||E(v,f,p)}e.isEngineValid=d;function E(p,v,f,u=[]){const c=I(m(f));if(!c)return u.push(k.localize(16,null,f)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return u.push(k.localize(17,null,f)),!1}else if(!c.majorMustEqual)return u.push(k.localize(18,null,f)),!1;return C(p,v,c)?!0:(u.push(k.localize(19,null,p,f)),!1)}function b(p){if(!Array.isArray(p))return!1;for(let v=0,f=p.length;v<f;v++)if(typeof p[v]!="string")return!1;return!0}}),define(Z[187],ee([0,1,17,28]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,y){let h=y&&y.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const I=(await D.readFile(R.serviceMachineIdResource)).value.toString();h=(0,t.isUUID)(I)?I:null}catch{h=null}if(!h){h=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,w.VSBuffer.fromString(h))}catch{}}return y?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=k}),define(Z[68],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=w}),define(Z[188],ee([0,1,68]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(D,y,h){y instanceof w.SyncDescriptor||(y=new w.SyncDescriptor(y,[],h)),t.push([D,y])}e.registerSingleton=k;function R(){return t}e.getSingletonServiceDescriptors=R}),define(Z[189],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=w;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const y=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(D);y.outgoing.set(this._hashFn(D),h),h.incoming.set(this._hashFn(R),y)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const y of this._nodes.values())y.outgoing.delete(D),y.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let y=this._nodes.get(D);return y||(y=new w(R),this._nodes.set(D,y)),y}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,y]of this._nodes)R.push(`${D}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const y=new Set([R]),h=this._findCycle(D,y);if(h)return h}}_findCycle(R,D){for(const[y,h]of R.outgoing){if(D.has(y))return[...D,y].join(" -> ");D.add(y);const m=this._findCycle(h,D);if(m)return m;D.delete(y)}}}e.Graph=t}),define(Z[5],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(h){return h[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(w=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,y,h){y[w.DI_TARGET]===y?y[w.DI_DEPENDENCIES].push({id:D,index:h}):(y[w.DI_DEPENDENCIES]=[{id:D,index:h}],y[w.DI_TARGET]=y)}function k(D){if(w.serviceIds.has(D))return w.serviceIds.get(D);const y=function(h,m,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(y,h,I)};return y.toString=()=>D,w.serviceIds.set(D,y),y}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(Z[60],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(Z[19],ee([0,1,12,7,5]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var y;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function m(p,v){const f=Object.create(null);for(const u in p)I(f,u,p[u],v);return f}e.toValuesTree=m;function I(p,v,f,u){const c=v.split("."),s=c.pop();let r=p;for(let i=0;i<c.length;i++){const n=c[i];let o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${v} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[s]=f}catch{u(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function C(p,v){const f=v.split(".");S(p,f)}e.removeFromValueTree=C;function S(p,v){const f=v.shift();if(v.length===0){delete p[f];return}if(Object.keys(p).indexOf(f)!==-1){const u=p[f];typeof u=="object"&&!Array.isArray(u)&&(S(u,v),Object.keys(u).length===0&&delete p[f])}}function g(p,v,f){function u(r,i){let n=r;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const c=v.split("."),s=u(p,c);return typeof s=="undefined"?f:s}e.getConfigurationValue=g;function d(p,v,f){Object.keys(v).forEach(u=>{u!=="__proto__"&&(u in p?w.isObject(p[u])&&w.isObject(v[u])?d(p[u],v[u],f):f&&(p[u]=v[u]):p[u]=v[u])})}e.merge=d;function E(p,v,f){const u=p.inspect(v),c=p.inspect(f);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=E;function b(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(Z[69],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,y){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=y}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const y of Object.keys(this.secretVault[R]||{}))D.push({account:y,password:this.secretVault[R][y]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(Z[84],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,y){return{}}async getSystemInfo(D,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,y){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(Z[102],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(Z[36],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[25],ee([0,1,52,9,83,36,183,5]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,y.refineServiceDecorator)(R.IEnvironmentService);class h extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([w.memoize],h.prototype,"cachedLanguagesPath",null),ve([w.memoize],h.prototype,"backupHome",null),ve([w.memoize],h.prototype,"backupWorkspacesPath",null),ve([w.memoize],h.prototype,"mainIPCHandle",null),ve([w.memoize],h.prototype,"mainLockfile",null),ve([w.memoize],h.prototype,"disableUpdates",null),ve([w.memoize],h.prototype,"disableKeytar",null),ve([w.memoize],h.prototype,"codeCachePath",null),ve([w.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(Z[190],ee([0,1,154,5]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(p,v){switch(p){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function y(p,v){return v==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function h(p,v,f){return y(v,f)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===f?!0:m(f).includes(p)}e.isTargetPlatformCompatible=h;function m(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function I(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=I;var C;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var S;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var g;(function(p){p.Install="install",p.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var d;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var E;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(v,f){super(v);this.code=f,this.name=f}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,w.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(Z[191],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(Z[192],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[103],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(Z[193],ee([0,1,50,13,9,4,78,23,82,157,103]),function(q,e,w,t,k,R,D,y,h,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=m.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends S{openTerminal(u,c){return this.spawnTerminal(w,u,h.getWindowsShell(),c)}spawnTerminal(u,c,s,r){const i=c.windowsExec||g.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=k.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return u.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((a,l)=>{const P=b(process),M=u.spawn(s,o,{cwd:r,env:P});M.on("error",l),M.on("exit",()=>a())})}runInTerminal(u,c,s,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:g.getDefaultTerminalWindows();return new Promise((o,a)=>{const l=`"${c} - ${C}"`,P=`""${s.join('" "')}" & pause"`,M=["/c","start",l,"/wait",n,"/c",P],T=Object.assign({},b(process),r);Object.keys(T).filter(Q=>T[Q]===null).forEach(Q=>delete T[Q]);const O={cwd:c,env:T,windowsVerbatimArguments:!0};w.spawn(g.CMD,M,O).on("error",Q=>{a(p(Q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class d extends S{openTerminal(u,c){return this.spawnTerminal(w,u,c)}runInTerminal(u,c,s,r,i){const n=i.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{if(n===I.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const l=n===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,q).fsPath,"-t",u||C,"-w",c];for(const U of s)M.push("-a"),M.push(U);if(r){const U=Object.assign({},b(process),r);for(const Q in U){const re=U[Q];re===null?(M.push("-u"),M.push(Q)):(M.push("-e"),M.push(`${Q}=${re}`))}}let T="";const O=w.spawn(d.OSASCRIPT,M);O.on("error",U=>{a(p(U))}),O.stderr.on("data",U=>{T+=U.toString()}),O.on("exit",U=>{if(U===0)o(void 0);else if(T){const Q=T.split(`
`,1);a(new Error(Q[0]))}else a(new Error(m.localize(1,null,l,U)))})}else a(new Error(m.localize(2,null,n)))})}spawnTerminal(u,c,s){const r=c.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",r];s&&o.push(s);const a=b(process),l=u.spawn("/usr/bin/open",o,{cwd:s,env:a});l.on("error",n),l.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class E extends S{openTerminal(u,c){return this.spawnTerminal(w,u,c)}runInTerminal(u,c,s,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{const l=[];n.then(P=>{P.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const M=`${v(s)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;l.push(`''${M}''`);const T=Object.assign({},b(process),r);Object.keys(T).filter(re=>T[re]===null).forEach(re=>delete T[re]);const O={cwd:c,env:T};let U="";const Q=w.spawn(P,l,O);Q.on("error",re=>{a(p(re))}),Q.stderr.on("data",re=>{U+=re.toString()}),Q.on("exit",re=>{if(re===0)o(void 0);else if(U){const le=U.split(`
`,1);a(new Error(le[0]))}else a(new Error(m.localize(4,null,P,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await y.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,s){const r=c.linuxExec?Promise.resolve(c.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(o=>{const a=b(process),l=u.spawn(o,[],{cwd:s,env:a});l.on("error",n),l.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=E,E.WAIT_MESSAGE=m.localize(3,null);function b(f){const u={...f.env};return(0,D.sanitizeProcessEnvironment)(u),u}function p(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(m.localize(5,null,f.path)):f}function v(f){let u="";for(const c of f)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(Z[14],ee([0,1,32,9,27,12,7,159,5]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function m(N){return N.create===!0}e.isFileOpenForWriteOptions=m;var I;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function(N){N[N.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var S;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=g;function d(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=d;function E(N){return!!(N.capabilities&32768)}e.hasFileCloneCapability=E;function b(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function p(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=p;function v(N){return!!(N.capabilities&2048)}e.hasFileReadCapability=v;function f(N){return g(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;var u;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(_,A){super(_);this.code=A}}e.FileSystemProviderError=c;function s(N,_){const A=new c(N.toString(),_);return i(A,_),A}e.createFileSystemProviderError=s;function r(N){return N||s((0,y.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=r;function i(N,_){return N.name=_?`${_} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=i;function n(N){if(!N)return u.Unknown;if(N instanceof c)return N.code;const _=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!_)return u.Unknown;switch(_[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function o(N){if(N instanceof O)return N.fileOperationResult;switch(n(N)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var a;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class l{constructor(_,A,W){this.resource=_,this.operation=A,this.target=W}isOperation(_){return this.operation===_}}e.FileOperationEvent=l;var P;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(P=e.FileChangeType||(e.FileChangeType={}));class M{constructor(_,A){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=_;const W=new Map;for(const $ of _){const Y=W.get($.type);switch(Y?Y.push([$.resource,$]):W.set($.type,[[$.resource,$]]),$.type){case 1:this.rawAdded.push($.resource);break;case 0:this.rawUpdated.push($.resource);break;case 2:this.rawDeleted.push($.resource);break}}for(const[$,Y]of W)switch($){case 1:this.added=w.TernarySearchTree.forUris(()=>A),this.added.fill(Y);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>A),this.updated.fill(Y);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>A),this.deleted.fill(Y);break}}contains(_,...A){return this.doContains(_,{includeChildren:!1},...A)}affects(_,...A){return this.doContains(_,{includeChildren:!0},...A)}doContains(_,A,...W){if(!_)return!1;const $=W.length>0;return!!((!$||W.includes(1))&&(this.added?.get(_)||A.includeChildren&&this.added?.findSuperstr(_))||(!$||W.includes(0))&&(this.updated?.get(_)||A.includeChildren&&this.updated?.findSuperstr(_))||(!$||W.includes(2))&&(this.deleted?.findSubstr(_)||A.includeChildren&&this.deleted?.findSuperstr(_)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=M;function T(N,_,A){return!N||!_||N===_||_.length>N.length?!1:(_.charAt(_.length-1)!==t.sep&&(_+=t.sep),A?(0,k.startsWithIgnoreCase)(N,_):N.indexOf(_)===0)}e.isParent=T;class O extends Error{constructor(_,A,W){super(_);this.fileOperationResult=A,this.options=W}}e.FileOperationError=O;class U extends O{constructor(_,A,W){super(_,2,W);this.stat=A}}e.NotModifiedSinceFileOperationError=U;var Q;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var re;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(re=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function le(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=le;async function fe(N,_){if(!_.hasProvider(D.URI.from({scheme:N.scheme})))return new Promise(A=>{const W=_.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===N.scheme&&$.added&&(W.dispose(),A())})})}e.whenProviderRegistered=fe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(_){return(0,R.isNumber)(_)||(_=0),_<se.KB?(0,y.localize)(1,null,_.toFixed(0)):_<se.MB?(0,y.localize)(2,null,(_/se.KB).toFixed(2)):_<se.GB?(0,y.localize)(3,null,(_/se.MB).toFixed(2)):_<se.TB?(0,y.localize)(4,null,(_/se.GB).toFixed(2)):(0,y.localize)(5,null,(_/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var ue;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(ue=e.Arch||(e.Arch={}));function K(N){return{maxFileSize:N===0?300*se.MB:16*se.GB,maxHeapSize:N===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=K}),define(Z[194],ee([0,1,17,43,18,3,2,58,7,28,14]),function(q,e,w,t,k,R,D,y,h,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends D.Disposable{constructor(g,d){super();this.channel=g,this.extraCapabilities=d,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,d){const{buffer:E}=await this.channel.call("readFile",[g,d]);return E}readFileStream(g,d,E){const b=(0,y.newWriteableStream)(v=>w.VSBuffer.concat(v.map(f=>w.VSBuffer.wrap(f))).buffer),p=this.channel.listen("readFileStream",[g,d])(v=>{if(v instanceof w.VSBuffer)b.write(v.buffer);else{if(v==="end")b.end();else{let f=v;f instanceof Error||(f=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(f),I.FileSystemProviderErrorCode.Unknown)),b.error(f),b.end()}p.dispose()}});return E.onCancellationRequested(()=>{b.error((0,k.canceled)()),b.end(),p.dispose()}),b}writeFile(g,d,E){return this.channel.call("writeFile",[g,w.VSBuffer.wrap(d),E])}open(g,d){return this.channel.call("open",[g,d])}close(g){return this.channel.call("close",[g])}async read(g,d,E,b,p){const[v,f]=await this.channel.call("read",[g,d,p]);return E.set(v.buffer.slice(0,f),b),f}write(g,d,E,b,p){return this.channel.call("write",[g,d,w.VSBuffer.wrap(E),b,p])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,d){return this.channel.call("delete",[g,d])}rename(g,d,E){return this.channel.call("rename",[g,d,E])}copy(g,d,E){return this.channel.call("copy",[g,d,E])}cloneFile(g,d){return this.channel.call("cloneFile",[g,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const d=g;this._onDidChange.fire(d.map(E=>({resource:h.URI.revive(E.resource),type:E.type})))}else{const d=g;this._onDidWatchError.fire(d)}}))}watch(g,d){const E=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,E,g,d]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,E]))}}e.DiskFileSystemProviderClient=C}),define(Z[104],ee([0,1,17,18,160,14]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(I,C,S,g,d,E){let b;try{await y(I,C,S,g,d,E)}catch(p){b=p}finally{b&&d.errorTransformer&&(b=d.errorTransformer(b)),typeof b!="undefined"&&S.error(b),S.end()}}e.readFileIntoStream=D;async function y(I,C,S,g,d,E){h(E);const b=await I.open(C,{create:!1});try{h(E);let p=0,v=0,f=d&&typeof d.length=="number"?d.length:void 0,u=w.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,s=0;do v=await I.read(b,c,u.buffer,s,u.byteLength-s),c+=v,s+=v,p+=v,typeof f=="number"&&(f-=v),s===u.byteLength&&(await S.write(g(u)),u=w.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),s=0);while(v>0&&(typeof f!="number"||f>0)&&h(E)&&m(p,d));if(s>0){let r=s;typeof f=="number"&&(r=Math.min(s,f)),S.write(g(u.slice(0,r)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await I.close(b)}}function h(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function m(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[70],ee([0,1,95,2,9,4,7,14]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(p){return p.recursive===!0}e.isRecursiveWatchRequest=h;class m extends t.Disposable{constructor(v,f,u,c){super();this.onFileChanges=v,this.onLogMessage=f,this.verboseLogging=u,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const v=new t.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),v.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),v.add(this.watcher.onDidError(f=>this.onError(f)))}onError(v){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${v}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${v}`):this.error(v)}restart(v){this.restartCounter++,this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class I extends m{constructor(v,f,u){super(v,f,u,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class C extends m{constructor(v,f,u){super(v,f,u,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function S(p){return p.map(v=>({type:v.type,resource:D.URI.file(v.path)}))}e.toFileChanges=S;function g(p){const v=new b;for(const f of p)v.processEvent(f);return v.coalesce()}e.coalesceEvents=g;function d(p,v){return typeof v=="string"&&!v.startsWith(w.GLOBSTAR)&&!(0,k.isAbsolute)(v)?{base:p,pattern:v}:v}e.normalizeWatcherPattern=d;function E(p,v){const f=[];for(const u of v)f.push((0,w.parse)(d(p,u)));return f}e.parseWatcherPatterns=E;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return R.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const f=this.mapPathToChange.get(this.toKey(v));let u=!1;if(f){const c=f.type,s=v.type;f.path!==v.path&&(v.type===2||v.type===1)?u=!0:c===1&&s===2?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(f)):c===2&&s===1?f.type=0:c===1&&s===0||(f.type=s)}else u=!0;u&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],f=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(v.push(u),!1):!0).sort((u,c)=>u.path.length-c.path.length).filter(u=>f.some(c=>(0,y.isParent)(u.path,c,!R.isLinux))?!1:(f.push(u.path),!0)).concat(v)}}}),define(Z[195],ee([0,1,29,8,21,31,2,80,9,4,96,23,70]),function(q,e,w,t,k,R,D,y,h,m,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends D.Disposable{constructor(b,p,v,f){super();this.request=b,this.onDidFilesChange=p,this.onLogMessage=v,this.verboseLogging=f,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(g.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await C.Promises.stat(b);this._register(await this.doWatch(b,p.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(b)}}async normalizePath(b){let p=b.path;try{p=await C.Promises.realpath(b.path),b.path===p&&(p=await(0,I.realcase)(b.path)??b.path),b.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${p})`)}catch{}return p}async doWatch(b,p){if(m.isMacintosh&&(0,R.isEqualOrParent)(b,"/Volumes/",!0))return this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const v=new k.CancellationTokenSource(this.cts.token),f=new D.DisposableStore;try{const u=(0,h.basename)(b),c=(0,w.watch)(b);f.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${b}'`);const s=new Set;if(p)try{for(const i of await C.Promises.readdir(b))s.add(i)}catch(i){this.error(i)}const r=new Map;f.add((0,D.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),c.on("error",(i,n)=>{this.error(`Failed to watch ${b} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),c.on("change",(i,n)=>{if(v.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),m.isMacintosh&&(o=(0,y.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(p)if(i==="rename"){r.get(o)?.dispose();const a=setTimeout(async()=>{if(r.delete(o),o===u&&!await C.Promises.exists(b)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,h.join)(b,o));if(v.token.isCancellationRequested)return;let P;l?s.has(o)?P=0:(P=1,s.add(o)):(s.delete(o),P=2),this.onFileChange({path:(0,h.join)(this.request.path,o),type:P})},g.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;s.has(o)?a=0:(a=1,s.add(o)),this.onFileChange({path:(0,h.join)(this.request.path,o),type:a})}else if(i==="rename"||o!==u){const a=setTimeout(async()=>{const l=await C.Promises.exists(b);v.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(b,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},g.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await C.Promises.exists(b)&&!v.token.isCancellationRequested&&this.error(`Failed to watch ${b} for changes using fs.watch() (${u.toString()})`)}return(0,D.toDisposable)(()=>{v.dispose(!0),f.dispose()})}async onFileChange(b,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!p&&this.excludes.some(v=>v(b.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${b.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(b.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${b.path}`):this.fileChangesBuffer.push(b);try{await this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,S.coalesceEvents)(v);if(f.length>0){if(this.verboseLogging)for(const c of f)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(b){if(m.isLinux)return C.Promises.exists(b);try{const p=(0,h.basename)(b);return(await C.Promises.readdir((0,h.dirname)(b))).some(f=>f===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.FILE_DELETE_HANDLER_DELAY=100,g.FILE_CHANGES_HANDLER_DELAY=50;async function d(E,b,p,v,f=512){const u=await C.Promises.open(E,"r"),c=Buffer.allocUnsafe(f),s=new k.CancellationTokenSource(v);let r,i=!1;const n={path:E,excludes:[],recursive:!1},o=new g(n,a=>{(async()=>{for(const{type:l}of a)if(l===0){if(i)return;i=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:P}=await C.Promises.read(u,c,0,f,null);if(!P||s.token.isCancellationRequested)break;b(c.slice(0,P))}}catch(P){r=new Error(P),s.dispose(!0)}finally{i=!1}}})()});return await o.ready,p(),new Promise((a,l)=>{s.token.onCancellationRequested(async()=>{o.dispose();try{await C.Promises.close(u)}catch(P){r=new Error(P)}r?l(r):a()})})}e.watchFileContents=d}),define(Z[196],ee([0,1,3,95,2,4,195]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new w.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new w.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=w.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const I=this.normalizeRequests(m),C=I.filter(g=>{const d=this.watchers.get(g.path);return d?!(0,t.patternsEquals)(d.request.excludes,g.excludes)||!(0,t.patternsEquals)(d.request.includes,g.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:g})=>!I.find(d=>d.path===g.path&&(0,t.patternsEquals)(d.excludes,g.excludes)&&(0,t.patternsEquals)(d.includes,g.includes))).map(({request:g})=>g.path);C.length&&this.trace(`Request to start watching: ${C.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const g of S)this.stopWatching(g);for(const g of C)this.startWatching(g)}startWatching(m){const I=new D.NodeJSFileWatcherLibrary(m,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),C={request:m,instance:I};this.watchers.set(m.path,C)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const I=this.watchers.get(m);I&&(this.watchers.delete(m),I.instance.dispose())}normalizeRequests(m){const I=new Map;for(const C of m){const S=R.isLinux?C.path:C.path.toLowerCase();I.set(S,C)}return Array.from(I.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,I]of this.watchers)I.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,I){return I?`[File Watcher (node.js)] ${m} (path: ${I.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=y}),define(Z[197],ee([0,1,70,196]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends w.AbstractNonRecursiveWatcherClient{constructor(D,y,h){super(D,y,h);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[198],ee([0,1,13,44,147,70]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(h,m,I){super(h,m,I);this.init()}createWatcher(h){const m=h.add(new k.Client(w.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(m.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(Z[85],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=w}),define(Z[199],ee([0,1,8,18,68,189,5,85]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const h=!1;class m extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class I{constructor(d=new y.ServiceCollection,E=!1,b){this._activeInstantiations=new Set,this._services=d,this._strict=E,this._parent=b,this._services.set(D.IInstantiationService,this)}createChild(d){return new I(d,this._strict,this)}invokeFunction(d,...E){const b=S.traceInvocation(d);let p=!1;try{return d({get:f=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(f,b);if(!u)throw new Error(`[invokeFunction] unknown service '${f}'`);return u}},...E)}finally{p=!0,b.stop()}}createInstance(d,...E){let b,p;return d instanceof k.SyncDescriptor?(b=S.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(E),b)):(b=S.traceCreation(d),p=this._createInstance(d,E,b)),b.stop(),p}_createInstance(d,E=[],b){const p=D._util.getServiceDependencies(d).sort((u,c)=>u.index-c.index),v=[];for(const u of p){const c=this._getOrCreateServiceInstance(u.id,b);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${u.id}.`,!1),v.push(c)}const f=p.length>0?p[0].index:E.length;if(E.length!==f){console.trace(`[createInstance] First service dependency of ${d.name} at position ${f+1} conflicts with ${E.length} static arguments`);const u=f-E.length;u>0?E=E.concat(new Array(u)):E=E.slice(0,f)}return new d(...[...E,...v])}_setServiceInstance(d,E){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,E);else if(this._parent)this._parent._setServiceInstance(d,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const E=this._services.get(d);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):E}_getOrCreateServiceInstance(d,E){const b=this._getServiceInstanceOrDescriptor(d);return b instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,b,E.branch(d,!0)):(E.branch(d,!1),b)}_safeCreateAndCacheServiceInstance(d,E,b){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,E,b)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,E,b){const p=new R.Graph(u=>u.id.toString());let v=0;const f=[{id:d,desc:E,_trace:b}];for(;f.length;){const u=f.pop();if(p.lookupOrInsertNode(u),v++>1e3)throw new m(p);for(const c of D._util.getServiceDependencies(u.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(c.id);if(s||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),s instanceof k.SyncDescriptor){const r={id:c.id,desc:s,_trace:u._trace.branch(c.id,!0)};p.insertEdge(u,r),f.push(r)}}}for(;;){const u=p.roots();if(u.length===0){if(!p.isEmpty())throw new m(p);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,E,b=[],p,v){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(E,b,p,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,E,b,p,v);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(d,E=[],b,p){if(b){const v=new w.IdleValue(()=>this._createInstance(d,E,p));return new Proxy(Object.create(null),{get(f,u){if(u in f)return f[u];const c=v.value;let s=c[u];return typeof s!="function"||(s=s.bind(c),f[u]=s),s},set(f,u,c){return v.value[u]=c,!0}})}else return this._createInstance(d,E,p)}_throwIfStrict(d,E){if(E&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=I;var C;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(C||(C={}));class S{constructor(d,E){this.type=d,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return h?new S(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(d){return h?new S(0,d.name):S._None}branch(d,E){const b=new S(2,d.toString());return this._dep.push([d,E,b]),b}stop(){const d=Date.now()-this._start;S._totals+=d;let E=!1;function b(v,f){const u=[],c=new Array(v+1).join("	");for(const[s,r,i]of f._dep)if(r&&i){E=!0,u.push(`${c}CREATES -> ${s}`);const n=b(v+1,i);n&&u.push(n)}else u.push(`${c}uses -> ${s}`);return u.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(d>2||E)&&console.log(p.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(Z[6],ee([0,1,43,3,2,4,5]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function y(){return new Date().toISOString()}var h;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function m(r,i,n){switch(i){case h.Trace:r.trace(n);break;case h.Debug:r.debug(n);break;case h.Info:r.info(n);break;case h.Warning:r.warn(n);break;case h.Error:r.error(n);break;case h.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}e.log=m;function I(r){let i="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}e.format=I;class C extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class S extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(h.Trace)&&this.log(h.Trace,I([i,...n]))}debug(i,...n){this.checkLogLevel(h.Debug)&&this.log(h.Debug,I([i,...n]))}info(i,...n){this.checkLogLevel(h.Info)&&this.log(h.Info,I([i,...n]))}warn(i,...n){this.checkLogLevel(h.Warning)&&this.log(h.Warning,I([i,...n]))}error(i,...n){if(this.checkLogLevel(h.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(h.Error,I(o))}else this.log(h.Error,I([i,...n]))}critical(i,...n){this.checkLogLevel(h.Critical)&&this.log(h.Critical,I([i,...n]))}flush(){}}e.AbstractMessageLogger=S;class g extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...n){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}debug(i,...n){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}info(i,...n){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}warn(i,...n){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,i,...n):console.warn(`[main ${y()}]`,i,...n))}error(i,...n){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,i,...n):console.error(`[main ${y()}]`,i,...n))}critical(i,...n){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,i,...n):console.error(`[main ${y()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class d extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class E extends C{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,w.toErrorMessage)(i,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class b extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=b;class p extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=p;class v extends k.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?h.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return h.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=f;function u(r){if(r.verbose)return h.Trace;if(typeof r.logLevel=="string"){const i=c(r.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(r){switch(r){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=c;function s(r){switch(r){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=s});var J=this&&this.__param||function(q,e){return function(w,t){e(w,t,q)}};define(Z[200],ee([0,1,69,3,2,6,4]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let y=class St extends k.Disposable{constructor(m){super();this.logService=m,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(m,I){let C;try{C=await this.withKeytar()}catch{return null}const S=await C.getPassword(m,I);if(S)try{let{content:g,hasNextChunk:d}=JSON.parse(S);if(!g||!d)return S;let E=1;for(;d;){const b=await C.getPassword(m,`${I}-${E}`),p=JSON.parse(b);g+=p.content,d=p.hasNextChunk,E++}return g}catch{return S}return S}async setPassword(m,I,C){let S;try{S=await this.withKeytar()}catch(E){throw this.surfaceKeytarLoadError?.(E),E}const g=3,d=async(E,b,p)=>{let v=0,f;for(;v<g;)try{await S.setPassword(E,b,p);return}catch(u){f=u,this.logService.warn("Error attempting to set a password: ",u?.message??u),v++,await new Promise(c=>setTimeout(c,200))}throw f};if(D.isWindows&&C.length>St.MAX_PASSWORD_LENGTH){let E=0,b=0,p=!0;for(;p;){const v=C.substring(E,E+St.PASSWORD_CHUNK_SIZE);E+=St.PASSWORD_CHUNK_SIZE,p=C.length-E>0;const f={content:v,hasNextChunk:p};await d(m,b?`${I}-${b}`:I,JSON.stringify(f)),b++}}else await d(m,I,C);this._onDidChangePassword.fire({service:m,account:I})}async deletePassword(m,I){let C;try{C=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const S=await C.getPassword(m,I);if(!S)return!1;const g=await C.deletePassword(m,I);try{let{content:d,hasNextChunk:E}=JSON.parse(S);if(d&&E){let b=1;for(;E;){const p=`${I}-${b}`,v=await C.getPassword(m,p);await C.deletePassword(m,p),E=JSON.parse(v).hasNextChunk,b++}}}catch{}return g&&this._onDidChangePassword.fire({service:m,account:I}),g}async findPassword(m){let I;try{I=await this.withKeytar()}catch{return null}return I.findPassword(m)}async findCredentials(m){let I;try{I=await this.withKeytar()}catch{return[]}return I.findCredentials(m)}clear(){return this._keytarCache instanceof w.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};y.MAX_PASSWORD_LENGTH=2500,y.PASSWORD_CHUNK_SIZE=y.MAX_PASSWORD_LENGTH-100,y=ve([J(0,R.ILogService)],y),e.BaseCredentialsMainService=y}),define(Z[201],ee([0,1,24,8,18,3,2,9,70,6]),function(q,e,w,t,k,R,D,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends D.Disposable{constructor(S,g){super();this.logService=S,this.options=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,g):this.watchNonRecursive(S,g)}watchUniversal(S,g){const d={path:this.toFilePath(S),excludes:g.excludes,includes:g.includes,recursive:g.recursive},E=(0,w.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,k.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&S.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,g){const d={path:this.toFilePath(S),excludes:g.excludes,includes:g.includes,recursive:!1},E=(0,w.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,k.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,y.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(Z[202],ee([0,1,24,8,17,21,3,66,57,2,32,13,71,16,58,158,14,104,6]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends m.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,s){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${c}`);const r=new m.DisposableStore;return this.provider.set(c,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:s}),r.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new b.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&r.add(s.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:c}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:s}),this.provider.delete(c),(0,m.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){s.push(r)}}),!this.provider.has(c)&&await t.Promises.settled(s)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,s){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&s)}listCapabilities(){return h.Iterable.map(this.provider,([c,s])=>({scheme:c,capabilities:s.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new b.FileOperationError((0,E.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const s=this.provider.get(c.scheme);if(!s){const r=new Error;throw r.name="ENOPRO",r.message=(0,E.localize)(1,null,c.toString()),r}return s}async withReadProvider(c){const s=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s)||(0,b.hasFileReadStreamCapability)(s)||(0,b.hasFileReadCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream, FileOpenReadWriteClose nor Readonly capability which is needed for the read operation.`)}async withWriteProvider(c){const s=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,s){try{return await this.doResolveFile(c,s)}catch(r){throw(0,b.toFileSystemProviderErrorCode)(r)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,E.localize)(2,null,this.resourceForError(c)),1):(0,b.ensureFileSystemProviderError)(r)}}async doResolveFile(c,s){const r=await this.withProvider(c),i=this.isPathCaseSensitive(r),n=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,l=await r.stat(c);let P;return this.toFileStat(r,c,l,void 0,!!a,(M,T)=>(P||(P=I.TernarySearchTree.forUris(()=>!i),P.set(c,!0),n&&P.fill(!0,n)),P.get(M.resource)||P.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&o?T===1:!1))}async toFileStat(c,s,r,i,n,o){const{providerExtUri:a}=this.getExtUri(c),l={resource:s,name:a.basename(s),isFile:(r.type&b.FileType.File)!=0,isDirectory:(r.type&b.FileType.Directory)!=0,isSymbolicLink:(r.type&b.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&b.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,b.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(l.isDirectory&&o(l,i)){try{const P=await c.readdir(s),M=await t.Promises.settled(P.map(async([T,O])=>{try{const U=a.joinPath(s,T),Q=n?await c.stat(U):{type:O};return await this.toFileStat(c,U,Q,P.length,n,o)}catch(U){return this.logService.trace(U),null}}));l.children=(0,w.coalesce)(M)}catch(P){this.logService.trace(P),l.children=[]}return l}return l}async resolveAll(c){return t.Promises.settled(c.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(c){const s=await this.withProvider(c),r=await s.stat(c);return this.toFileStat(s,c,r,void 0,!0,()=>!1)}async exists(c){const s=await this.withProvider(c);try{return!!await s.stat(c)}catch{return!1}}async canCreateFile(c,s){try{await this.doValidateCreateFile(c,s)}catch(r){return r}return!0}async doValidateCreateFile(c,s){if(!s?.overwrite&&await this.exists(c))throw new b.FileOperationError((0,E.localize)(3,null,this.resourceForError(c)),3,s)}async createFile(c,s=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const i=await this.writeFile(c,s);return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,i)),i}async writeFile(c,s,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,c,r)||await this.mkdirp(i,n.dirname(c));let a;if((0,b.hasReadWriteCapability)(i)&&!(s instanceof k.VSBuffer))if((0,d.isReadableStream)(s)){const l=await(0,d.peekStream)(s,3);l.ended?a=k.VSBuffer.concat(l.buffer):a=l}else a=(0,d.peekReadable)(s,l=>k.VSBuffer.concat(l),3);else a=s;!(0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)&&a instanceof k.VSBuffer?await this.doWriteUnbuffered(i,c,r,a):await this.doWriteBuffered(i,c,r,a instanceof k.VSBuffer?(0,k.bufferToReadable)(a):a),this._onDidRunOperation.fire(new b.FileOperationEvent(c,4))}catch(o){throw new b.FileOperationError((0,E.localize)(4,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,s,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(s)));let n;try{n=await c.stat(s)}catch{return}if((n.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,E.localize)(6,null,this.resourceForError(s)),0,r);if(this.throwIfFileIsReadonly(s,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==b.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,b.etag)({mtime:r.mtime,size:n.size}))throw new b.FileOperationError((0,E.localize)(7,null),3,r);return n}async readFile(c,s,r){const i=await this.withReadProvider(c);return s?.atomic?this.doReadFileAtomic(i,c,s,r):this.doReadFile(i,c,s,r)}async doReadFileAtomic(c,s,r,i){return new Promise((n,o)=>{this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,s,r,i);n(a)}catch(a){o(a)}})})}async doReadFile(c,s,r,i){const n=await this.doReadFileStream(c,s,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,k.streamToBuffer)(n.value)}}async readFileStream(c,s,r){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,s,r)}async doReadFileStream(c,s,r,i){const n=new R.CancellationTokenSource(i),o=this.validateReadFile(s,r).then(l=>l,l=>{throw n.cancel(),l});let a;try{return typeof r?.etag=="string"&&r.etag!==b.ETAG_DISABLED&&await o,r?.atomic&&(0,b.hasFileAtomicReadCapability)(c)||!((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasFileReadStreamCapability)(c))||(0,b.hasReadWriteCapability)(c)&&r?.preferUnbuffered?a=this.readFileUnbuffered(c,s,r):(0,b.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,s,n.token,r):a=this.readFileBuffered(c,s,n.token,r),{...await o,value:a}}catch(l){a&&await(0,d.consumeStream)(a);const P=(0,E.localize)(8,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(l).toString());throw l instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(P,l.stat,r):new b.FileOperationError(P,(0,b.toFileOperationResult)(l),r)}}readFileStreamed(c,s,r,i=Object.create(null)){const n=c.readFileStream(s,i,r);return(0,d.transform)(n,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new b.FileOperationError((0,E.localize)(9,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),i)},o=>k.VSBuffer.concat(o))}readFileBuffered(c,s,r,i=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,s,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new b.FileOperationError((0,E.localize)(10,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),i)},r),n}readFileUnbuffered(c,s,r){const i=(0,d.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,b.hasFileAtomicReadCapability)(c)?n=await c.readFile(s,{atomic:!0}):n=await c.readFile(s),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(s,n.byteLength,r),i.end(k.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(c,s){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new b.FileOperationError((0,E.localize)(11,null,this.resourceForError(c)),0,s);if(typeof s?.etag=="string"&&s.etag!==b.ETAG_DISABLED&&s.etag===r.etag)throw new b.NotModifiedSinceFileOperationError((0,E.localize)(12,null),r,s);return this.validateReadFileLimits(c,r.size,s),r}validateReadFileLimits(c,s,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&s>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&s>r.limits.size&&(i=7),typeof i=="number")throw new b.FileOperationError((0,E.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,s,r){return this.doCanMoveCopy(c,s,"move",r)}async canCopy(c,s,r){return this.doCanMoveCopy(c,s,"copy",r)}async doCanMoveCopy(c,s,r,i){if(c.toString()!==s.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,c,o,s,r,i)}catch(n){return n}return!0}async move(c,s,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"move",!!r),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,o==="move"?2:3,a)),a}async copy(c,s,r){const i=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"copy",!!r),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,o==="copy"?3:2,a)),a}async doMoveCopy(c,s,r,i,n,o){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,s,r,i,n,o);if(a&&!l&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),n==="copy"){if(c===r&&(0,b.hasFileFolderCopyCapability)(c))await c.copy(s,i,{overwrite:o});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(c,P,r,i):await this.doCopyFile(c,s,r,i)}return n}else return c===r?(await c.rename(s,i,{overwrite:o}),n):(await this.doMoveCopy(c,s,r,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(c,s,r,i){if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,s,r,i);if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,s,r,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,s,r,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,s,r,i)}async doCopyFolder(c,s,r,i){await r.mkdir(i),Array.isArray(s.children)&&await t.Promises.settled(s.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),r,o):this.doCopyFile(c,n.resource,r,o)}))}async doValidateMoveCopy(c,s,r,i,n,o){let a=!1;if(c===r){const{providerExtUri:P,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(a=P.isEqual(s,i)),a&&n==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&P.isEqualOrParent(i,s))throw new Error((0,E.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!a){if(!o)throw new b.FileOperationError((0,E.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(c===r){const{providerExtUri:P}=this.getExtUri(c);if(P.isEqualOrParent(s,i))throw new Error((0,E.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const s=this.isPathCaseSensitive(c);return{providerExtUri:s?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(s,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,r)),r}async mkdirp(c,s){const r=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(s,i.dirname(s));)try{if(((await c.stat(s)).type&b.FileType.Directory)==0)throw new Error((0,E.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,b.toFileSystemProviderErrorCode)(n)!==b.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(s)),s=i.dirname(s)}for(let n=r.length-1;n>=0;n--){s=i.joinPath(s,r[n]);try{await c.mkdir(s)}catch(o){if((0,b.toFileSystemProviderErrorCode)(o)!==b.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,s){try{await this.doValidateDelete(c,s)}catch(r){return r}return!0}async doValidateDelete(c,s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!s?.useTrash&&!(r.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(c)));let n;try{n=await r.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new b.FileOperationError((0,E.localize)(20,null,this.resourceForError(c)),1);if(!!!s?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(c)))}return r}async del(c,s){const r=await this.doValidateDelete(c,s),i=!!s?.useTrash,n=!!s?.recursive;await r.delete(c,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new b.FileOperationEvent(c,1))}async cloneFile(c,s){const r=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(c,s))return;if(r===i&&(0,b.hasFileCloneCapability)(r))return r.cloneFile(c,s);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s));const n=this.writeQueue.queueFor(c,this.getExtUri(r).providerExtUri);return r===i&&(0,b.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(c,s,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,c,i,s))}watch(c,s={recursive:!1,excludes:[]}){const r=new m.DisposableStore;let i=!1,n=()=>{i=!0};return r.add((0,m.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(c,s);i?(0,m.dispose)(o):n=()=>(0,m.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(c,s){const r=await this.withProvider(c),i=(0,y.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(c),s]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:r.watch(c,s)},this.activeWatchers.set(i,n)),n.count+=1,(0,m.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,m.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,s,r,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(s,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,n,i):await this.doWriteReadableBufferedQueued(c,n,i)}catch(o){throw(0,b.ensureFileSystemProviderError)(o)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,s,r){let i=0,n;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,s,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,a)=>{(0,d.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(c,s,l,l.byteLength,i,0)}catch(P){return a(P)}i+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>a(l),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,s,r){let i=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(c,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(c,s,r,i,n,o){let a=0;for(;a<i;)a+=await c.write(s,n+a,r.buffer,o+a,i-a)}async doWriteUnbuffered(c,s,r,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,s,r,i))}async doWriteUnbufferedQueued(c,s,r,i){let n;i instanceof k.VSBuffer?n=i:(0,d.isReadableStream)(i)?n=await(0,k.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?n=await(0,k.bufferedStreamToBuffer)(i):n=(0,k.readableToBuffer)(i),await c.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,s,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,s,r,i))}async doPipeBufferedQueued(c,s,r,i){let n,o;try{n=await c.open(s,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const a=k.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,P=0,M=0;do M=await c.read(n,l,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(r,o,a,M,l,P),l+=M,P+=M,P===a.byteLength&&(P=0);while(M>0)}catch(a){throw(0,b.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,s,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,s,r,i))}async doPipeUnbufferedQueued(c,s,r,i){return r.writeFile(i,await c.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,s,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,s,r,i))}async doPipeUnbufferedToBufferedQueued(c,s,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await c.readFile(s);await this.doWriteBuffer(r,n,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,b.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(c,s,r,i){const n=await(0,k.streamToBuffer)(this.readFileBuffered(c,s,R.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,n)}throwIfFileSystemIsReadonly(c,s){if(c.capabilities&2048)throw new b.FileOperationError((0,E.localize)(22,null,this.resourceForError(s)),6);return c}throwIfFileIsReadonly(c,s){if((s.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,E.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===C.Schemas.file?c.fsPath:c.toString(!0)}};f=ve([J(0,v.ILogService)],f),e.FileService=f}),define(Z[86],ee([0,1,29,272,8,32,17,3,31,2,9,4,16,58,23,162,14,104,201,43,198,197]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(w)}catch(r){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(r)}`)}})();class s extends v.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=y.Event.None,this.resourceLocks=new R.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,S.joinPath)(i,a.name))).type:l=this.toType(a),o.push([a.name,l])}catch(l){this.logService.trace(l)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=b.FileType.Unknown:i.isFile()?o=b.FileType.File:i.isDirectory()?o=b.FileType.Directory:o=b.FileType.Unknown,n&&(o|=b.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const a=new k.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const a=this.toFilePath(i);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{o?.dispose()}}readFileStream(i,n,o){const a=(0,g.newWriteableStream)(l=>D.VSBuffer.concat(l.map(P=>D.VSBuffer.wrap(P))).buffer);return(0,p.readFileIntoStream)(this,i,a,l=>l.buffer,{...n,bufferSize:256*1024},o),a}async writeFile(i,n,o){let a;try{const l=this.toFilePath(i);if(!o.create||!o.overwrite){if(await d.Promises.exists(l)){if(!o.overwrite)throw(0,b.createFileSystemProviderError)((0,E.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,b.createFileSystemProviderError)((0,E.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){s.canFlush=i}async open(i,n){const o=this.toFilePath(i);let a;(0,b.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(i));let l;try{if((0,b.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:M}=await d.SymlinkSupport.stat(o);M.mode&128||await d.Promises.chmod(o,M.mode|128)}catch(M){this.logService.trace(M)}let P;if((0,b.isFileOpenForWriteOptions)(n)){if(C.isWindows)try{await d.Promises.truncate(o,0),P="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}P||(P="w")}else P="r";l=await d.Promises.open(o,P)}catch(P){throw a?.dispose(),(0,b.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(l,0),(0,b.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(l,i),a){const P=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${o})`),this.mapHandleToLock.set(l,a),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${o})`),P.dispose())}return l}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&s.canFlush)try{await d.Promises.fdatasync(i)}catch(o){s.configureFlushOnWrite(!1),this.logService.error(o)}return await d.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,a,l){const P=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.read(i,o,a,l,P)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,P,M)}return M}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,a+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,a,l){return(0,k.retry)(()=>this.doWrite(i,n,o,a,l),100,3)}async doWrite(i,n,o,a,l){const P=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.write(i,o,a,l,P)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,P,M)}return M}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await d.Promises.move(a,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,E.localize)(2,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await d.Promises.copy(a,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,E.localize)(3,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(i,n,o,a){const l=this.toFilePath(i),P=this.toFilePath(n);let M=!1;if(!!(this.capabilities&1024)||(M=(0,h.isEqual)(l,P,!0)),M&&o==="copy")throw(0,b.createFileSystemProviderError)((0,E.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!M&&await d.Promises.exists(P)){if(!a)throw(0,b.createFileSystemProviderError)((0,E.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n),P=!!(this.capabilities&1024);if((0,h.isEqual)(a,l,!P))return;const M=new m.DisposableStore;try{const[T,O]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);M.add(T),M.add(O),o&&await d.Promises.mkdir((0,I.dirname)(l),{recursive:!0}),await d.Promises.copyFile(a,l)}catch(T){if(T.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(i,n,o){return new u.UniversalWatcherClient(a=>i(a),a=>n(a),o)}createNonRecursiveWatcher(i,n,o){return new c.NodeJSWatcherClient(a=>i(a),a=>n(a),o)}toFileSystemProviderError(i){if(i instanceof b.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=b.FileSystemProviderErrorCode.NoPermissions;break;default:n=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(o=(0,b.createFileSystemProviderError)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return o}}e.DiskFileSystemProvider=s,s.canFlush=!0}),define(Z[203],ee([0,1,3,86,2,17,58,21]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends k.Disposable{constructor(C,S){super();this.provider=C,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(C,S,g){const d=this.getUriTransformer(C);switch(S){case"stat":return this.stat(d,g[0]);case"readdir":return this.readdir(d,g[0]);case"open":return this.open(d,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(d,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(d,g[0],g[1],g[2]);case"rename":return this.rename(d,g[0],g[1],g[2]);case"copy":return this.copy(d,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(d,g[0],g[1]);case"mkdir":return this.mkdir(d,g[0]);case"delete":return this.delete(d,g[0],g[1]);case"watch":return this.watch(d,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${S} not found`)}listen(C,S,g){const d=this.getUriTransformer(C);switch(S){case"fileChange":return this.onFileChange(d,g[0]);case"readFileStream":return this.onReadFileStream(d,g[0],g[1])}throw new Error(`Unknown event ${S}`)}stat(C,S){const g=this.transformIncoming(C,S,!0);return this.provider.stat(g)}readdir(C,S){const g=this.transformIncoming(C,S);return this.provider.readdir(g)}async readFile(C,S,g){const d=this.transformIncoming(C,S,!0),E=await this.provider.readFile(d,g);return R.VSBuffer.wrap(E)}onReadFileStream(C,S,g){const d=this.transformIncoming(C,S,!0),E=new y.CancellationTokenSource,b=new w.Emitter({onLastListenerRemove:()=>{E.cancel()}}),p=this.provider.readFileStream(d,g,E.token);return(0,D.listenStream)(p,{onData:v=>b.fire(R.VSBuffer.wrap(v)),onError:v=>b.fire(v),onEnd:()=>{b.fire("end"),b.dispose(),E.dispose()}}),b.event}writeFile(C,S,g,d){const E=this.transformIncoming(C,S);return this.provider.writeFile(E,g.buffer,d)}open(C,S,g){const d=this.transformIncoming(C,S,!0);return this.provider.open(d,g)}close(C){return this.provider.close(C)}async read(C,S,g){const d=R.VSBuffer.alloc(g),E=0,b=await this.provider.read(C,S,d.buffer,E,g);return[d,b]}write(C,S,g,d,E){return this.provider.write(C,S,g.buffer,d,E)}mkdir(C,S){const g=this.transformIncoming(C,S);return this.provider.mkdir(g)}delete(C,S,g){const d=this.transformIncoming(C,S);return this.provider.delete(d,g)}rename(C,S,g,d){const E=this.transformIncoming(C,S),b=this.transformIncoming(C,g);return this.provider.rename(E,b,d)}copy(C,S,g,d){const E=this.transformIncoming(C,S),b=this.transformIncoming(C,g);return this.provider.copy(E,b,d)}cloneFile(C,S,g){const d=this.transformIncoming(C,S),E=this.transformIncoming(C,g);return this.provider.cloneFile(d,E)}onFileChange(C,S){const g=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(C,g))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return g.event}async watch(C,S,g,d,E){const b=this.sessionToWatcher.get(S);if(b){const p=this.transformIncoming(C,d),v=b.watch(g,p,E);this.watchRequests.set(S+g,v)}}async unwatch(C,S){const g=C+S,d=this.watchRequests.get(g);d&&((0,k.dispose)(d),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,C]of this.watchRequests)C.dispose();this.watchRequests.clear();for(const[,C]of this.sessionToWatcher)C.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class m extends k.Disposable{constructor(C,S,g,d){super();this.uriTransformer=C,this.logService=g,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(C){const S=this._register(new w.Emitter);this._register(S.event(g=>{C.fire(g.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(g=>S.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>C.fire(g)))}getRecursiveWatcherOptions(C){}getExtraExcludes(C){}watch(C,S,g){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(g.excludes=[...g.excludes,...d]),this.watcherRequests.set(C,this.fileWatcher.watch(S,g)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(C)),this.watcherRequests.delete(C)})}dispose(){super.dispose();for(const[,C]of this.watcherRequests)C.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=m}),define(Z[204],ee([0,1,15,161,4,7,14,9,203,141]),function(q,e,w,t,k,R,D,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I extends h.AbstractDiskFileSystemProviderChannel{constructor(g,d,E){super(g,d);this.environmentService=E}getUriTransformer(g){return m.DefaultURITransformer}transformIncoming(g,d){return R.URI.revive(d)}async delete(g,d,E){if(!E.useTrash)return super.delete(g,d,E);const b=this.transformIncoming(g,d),p=(0,y.normalize)(b.fsPath);try{await w.shell.trashItem(p)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,y.basename)(p)):(0,t.localize)(1,null,(0,y.basename)(p)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(g,d){return new C(g,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=I;class C extends h.AbstractSessionFileWatcher{watch(g,d,E){if(E.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(g,d,E)}}}),define(Z[105],ee([0,1,6]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case w.LogLevel.Trace:return R.trace;case w.LogLevel.Debug:return R.debug;case w.LogLevel.Info:return R.info;case w.LogLevel.Warning:return R.warn;case w.LogLevel.Error:return R.error;case w.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends w.AbstractLogger{constructor(D=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(y=>{this._logger?.setLevel(y)}))}set logger(D){this._logger=D;for(const{level:y,args:h}of this.buffer)t(D,y).apply(D,h);this.buffer=[]}_log(D,...y){this._logger?t(this._logger,D).apply(this._logger,y):this.getLevel()<=D&&this.buffer.push({level:D,args:y})}trace(D,...y){this._log(w.LogLevel.Trace,D,...y)}debug(D,...y){this._log(w.LogLevel.Debug,D,...y)}info(D,...y){this._log(w.LogLevel.Info,D,...y)}warn(D,...y){this._log(w.LogLevel.Warning,D,...y)}error(D,...y){this._log(w.LogLevel.Error,D,...y)}critical(D,...y){this._log(w.LogLevel.Critical,D,...y)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(Z[205],ee([0,1,8,17,16,14,5,105,6]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*R.ByteSize.MB;let I=class extends h.AbstractLogger{constructor(g,d,E,b,p){super();this.name=g,this.resource=d,this.donotUseFormatters=b,this.fileService=p,this.backupIndex=1,this.setLevel(E),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,(0,h.format)(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,(0,h.format)(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,(0,h.format)(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,(0,h.format)(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const g=arguments[0];if(g instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=g.stack,this._log(h.LogLevel.Error,(0,h.format)(d))}else this._log(h.LogLevel.Error,(0,h.format)(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,(0,h.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(g){if(g.fileOperationResult!==3)throw g}}_log(g,d){this.queue.queue(async()=>{await this.initializePromise;let E=await this.loadContent();E.length>m&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(E)),E=""),this.donotUseFormatters?E+=d:E+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(g)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(E))})}getCurrentTimestamp(){const g=b=>b<10?`0${b}`:b,d=b=>b<10?`00${b}`:b<100?`0${b}`:b,E=new Date;return`${E.getFullYear()}-${g(E.getMonth()+1)}-${g(E.getDate())} ${g(E.getHours())}:${g(E.getMinutes())}:${g(E.getSeconds())}.${d(E.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(g){switch(g){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}};I=ve([J(4,R.IFileService)],I),e.FileLogger=I;let C=class extends h.AbstractLoggerService{constructor(g,d,E){super(g.getLevel(),g.onDidChangeLogLevel);this.instantiationService=d,this.fileService=E}doCreateLogger(g,d,E){const b=new y.BufferLogService(d);return(0,R.whenProviderRegistered)(g,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(I,E?.name||(0,k.basename)(g),g,b.getLevel(),!!E?.donotUseFormatters)),b}};C=ve([J(0,h.ILogService),J(1,D.IInstantiationService),J(2,R.IFileService)],C),e.FileLoggerService=C}),define(Z[206],ee([0,1,3,7,6]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(S){this.service=S,this.onDidChangeLogLevel=w.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(S,g,d){switch(g){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=R;class D{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){D.setLevel(this.channel,S)}static setLevel(S,g){return S.call("setLevel",g)}}e.LogLevelChannelClient=D;class y{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,g){throw new Error(`Event not found: ${g}`)}async call(S,g,d){switch(g){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${g}`)}createLogger(S,g){this.loggers.set(S.toString(),this.loggerService.createLogger(S,g))}consoleLog(S,g){let d=console.log;switch(S){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...g)}log(S,g){const d=this.loggers.get(S.toString());if(!d)throw new Error("Create the logger before logging");for(const[E,b]of g)(0,k.log)(d,E,b)}}e.LoggerChannel=y;class h extends k.AbstractLoggerService{constructor(S,g,d){super(S,g);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(S,g)=>{this.channel.call("consoleLog",[S,g])}})}doCreateLogger(S,g,d){return new m(this.channel,S,g,d)}}e.LoggerChannelClient=h;class m extends k.AbstractMessageLogger{constructor(S,g,d,E){super(E?.always);this.channel=S,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[g,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,g){const d=[[S,g]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(S){this.channel.call("log",[this.file,S])}}class I extends k.LogService{constructor(S,g){super(g);this.parent=S,this._register(S.onDidChangeLogLevel(d=>g.setLevel(d)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=I}),define(Z[106],ee([0,1,14,6]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(y,h,m,I,C){try{const S=await new Promise((d,E)=>{q(["spdlog"],d,E)});S.setFlushOn(t.LogLevel.Trace);const g=await S.createAsyncRotatingLogger(y,h,m,I);return C&&g.clearFormatters(),g}catch(S){console.error(S)}return null}function R(y,h,m){switch(h){case t.LogLevel.Trace:y.trace(m);break;case t.LogLevel.Debug:y.debug(m);break;case t.LogLevel.Info:y.info(m);break;case t.LogLevel.Warning:y.warn(m);break;case t.LogLevel.Error:y.error(m);break;case t.LogLevel.Critical:y.critical(m);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(h,m,I,C,S){super();this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(h,m,I,C),this._register(this.onDidChangeLogLevel(g=>{this._logger?.setLevel(g)}))}async _createSpdLogLogger(h,m,I,C){const S=I?6:1,g=30/S*w.ByteSize.MB,d=await k(h,m,g,S,C);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:E,message:b}of this.buffer)R(this._logger,E,b);this.buffer=[]}}log(h,m){this._logger?R(this._logger,h,m):this.getLevel()<=h&&this.buffer.push({level:h,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(Z[207],ee([0,1,13,16,28,14,205,6,106]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends y.AbstractLoggerService{constructor(C,S){super(C.getLevel(),C.onDidChangeLogLevel);this.fileService=S}doCreateLogger(C,S,g){return C.scheme===w.Schemas.file?new h.SpdLogLogger(g?.name||(0,k.generateUuid)(),C.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,S):new D.FileLogger(g?.name??(0,t.basename)(C),C,S,!!g?.donotUseFormatters,this.fileService)}};m=ve([J(0,y.ILogService),J(1,R.IFileService)],m),e.LoggerService=m}),define(Z[208],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!w(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(Z[39],ee([0,1,3,57,2,5]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(m){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(m),t.Iterable.reduce(this.policies.entries(),(C,[S,g])=>({...C,[S]:g}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[I,C])=>({...m,[I]:{definition:C,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=D;class y{constructor(){this.onDidChange=w.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=y}),define(Z[209],ee([0,1,8,3,57,12,14,6,39]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(C,S){const g=[];for(const d of k.Iterable.concat(C.keys(),S.keys()))C.get(d)!==S.get(d)&&g.push(d);return g}let I=class extends h.AbstractPolicyService{constructor(S,g,d){super();this.file=S,this.fileService=g,this.logService=d,this.throttledDelayer=this._register(new w.ThrottledDelayer(500));const E=t.Event.filter(g.onDidFilesChange,b=>b.affects(S));this._register(g.watch(S)),this._register(E(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(S){await this.refresh()}async read(){const S=new Map;try{const g=await this.fileService.readFile(this.file),d=JSON.parse(g.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(d))this.policyDefinitions[E]&&S.set(E,d[E])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return S}async refresh(){const S=await this.read(),g=m(this.policies,S);this.policies=S,g.length>0&&this._onDidChange.fire(g)}};I=ve([J(1,D.IFileService),J(2,y.ILogService)],I),e.FilePolicyService=I}),define(Z[210],ee([0,1,3,2,39]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(h){this.service=h,this.disposables=new t.DisposableStore}listen(h,m){switch(m){case"onDidChange":return w.Event.map(this.service.onDidChange,I=>I.reduce((C,S)=>({...C,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(h,m,I){switch(m){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(h,m){super();this.channel=m;for(const I in h){const{definition:C,value:S}=h[I];this.policyDefinitions[I]=C,S!==void 0&&this.policies.set(I,S)}this.channel.listen("onDidChange")(I=>{for(const C in I){const S=I[C];S===null?this.policies.delete(C):this.policies.set(C,S)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(h){const m=await this.channel.call("registerPolicyDefinitions",h);for(const I in m)this.policies.set(I,m[I])}}e.PolicyChannelClient=D}),define(Z[53],ee([0,1,13,4,34,16]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const y=t.globals.vscode.context.configuration();if(y)D=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const y=(0,R.dirname)(w.FileAccess.asFileUri("",q));D=q.__$__nodeRequire((0,R.joinPath)(y,"product.json").fsPath);const h=q.__$__nodeRequire((0,R.joinPath)(y,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:h.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(Z[20],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[211],ee([0,1,76,6,20]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(y,h){this.productService=y,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(y,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(h);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,I,C]=m;let S=this.trustedExtensionUrlPublicKeys.get(y);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[y],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",y),!1;this.trustedExtensionUrlPublicKeys.set(y,[...S])}const g=Buffer.from(decodeURIComponent(C),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const d=g.slice(0,6),E=g.readUIntBE(0,6),b=Date.now()-E;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const p=g.slice(6),v=w.createVerify("SHA256");v.write(d),v.write(Buffer.from(I)),v.end();for(let f=0;f<S.length;f++){let u=S[f];if(u!==null){if(typeof u=="string")try{u=w.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),S[f]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${f+1} for ${y}:`,c),S[f]=null;continue}if(v.verify(u,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};R=ve([J(0,k.IProductService),J(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[61],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(Z[45],ee([0,1,120,12]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,y){w.ok(t.isString(D)),w.ok(t.isObject(y)),w.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,y)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(Z[212],ee([0,1,3,45]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class R{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,m){this.schemasById[k(h)]=m,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(Z[62],ee([0,1,24,3,12,150,19,212,45]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=h.Registry.as(y.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const i=this.doRegisterConfigurations(s,r);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(s){const r=this.doDeregisterConfigurations(s);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:s,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(s,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(i)})}registerDefaultConfigurations(s){const r=[],i=[];for(const{overrides:n,source:o}of s)for(const a in n)if(r.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const l=this.configurationDefaultsOverrides.get(a),P=l?.valuesSources??new Map;if(o)for(const U of Object.keys(n[a]))P.set(U,o);const M={...l?.value||{},...n[a]};this.configurationDefaultsOverrides.set(a,{source:o,value:M,valuesSources:P});const T=(0,D.getLanguageTagSettingPlainKey)(a),O={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(o)?void 0:o,defaultValueSource:o};i.push(...E(a)),this.configurationProperties[a]=O,this.defaultLanguageConfigurationOverridesNode.properties[a]=O}else{this.configurationDefaultsOverrides.set(a,{value:n[a],source:o});const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:i,source:n}of s)for(const o in i){const a=this.configurationDefaultsOverrides.get(o),l=k.isString(n)?n:n?.id,P=k.isString(a?.source)?a?.source:a?.source?.id;if(l===P)if(r.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const M=this.configurationProperties[o];M&&(this.updatePropertyDefaultValue(o,M),this.updateSchema(o,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const r of s)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,r){const i=[];return s.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(s){const r=[],i=n=>{if(n.properties)for(const o in n.properties){r.push(o);const a=this.configurationProperties[o];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of s){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(s,r=!0,i,n,o=3){o=k.isUndefinedOrNull(s.scope)?o:s.scope;const a=[],l=s.properties;if(l)for(const M in l){const T=l[M];if(r&&f(M,T)){delete l[M];continue}if(T.source=i,T.defaultDefaultValue=l[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?o:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!n?.includes(M):T.restricted),l[M].hasOwnProperty("included")&&!l[M].included){this.excludedConfigurationProperties[M]=l[M],delete l[M];continue}else this.configurationProperties[M]=l[M],l[M].policy?.name&&this.policyConfigurations.set(l[M].policy.name,M);!l[M].deprecationMessage&&l[M].markdownDeprecationMessage&&(l[M].deprecationMessage=l[M].markdownDeprecationMessage),a.push(M)}const P=s.allOf;if(P)for(const M of P)a.push(...this.validateAndRegisterProperties(M,r,i,n,o));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const r=i=>{const n=i.properties;if(n)for(const a in n)this.updateSchema(a,n[a]);i.allOf?.forEach(r)};r(s)}updateSchema(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.resourceLanguageSettingsSchema.properties[s]=r;break}}removeFromSchema(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const r=`[${s}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,r){const i=this.configurationDefaultsOverrides.get(s);let n=i?.value,o=i?.source;k.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),k.isUndefined(n)&&(n=p(r.type)),r.default=n,r.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",d=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(c){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=d.exec(c);for(;r?.length;){const i=r[1].trim();i&&s.push(i),r=d.exec(c)}}return(0,w.distinct)(s)}e.overrideIdentifiersFromKey=E;function b(c){return c.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=b;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const v=new S;h.Registry.add(e.Extensions.Configuration,v);function f(c,s){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):v.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):s.policy?.name&&v.getPolicyConfigurations().get(s.policy?.name)!==void 0?R.localize(9,null,c,s.policy?.name,v.getPolicyConfigurations().get(s.policy?.name)):null:R.localize(6,null)}e.validateProperty=f;function u(){const c=[],s=v.getConfigurationProperties();for(const r of Object.keys(s))c.push([r,s[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=u}),define(Z[107],ee([0,1,24,3,42,2,32,49,12,7,19,62,45]),function(q,e,w,t,k,R,D,y,h,m,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class g{constructor(r={},i=[],n=[]){this._contents=r,this._keys=i,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,I.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const n=this.getContentsForOverrideIdentifer(i);return n?r?(0,I.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return w.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=y.deepClone(this.contents),n=y.deepClone(this.overrides),o=[...this.keys];for(const a of r)if(!a.isEmpty()){this.mergeContents(i,a.contents);for(const l of a.overrides){const[P]=n.filter(M=>w.equals(M.identifiers,l.identifiers));P?(this.mergeContents(P.contents,l.contents),P.keys.push(...l.keys),P.keys=w.distinct(P.keys)):n.push(y.deepClone(l))}for(const l of a.keys)o.indexOf(l)===-1&&o.push(l)}return new g(i,o,n)}freeze(){return this.frozen=!0,this}clone(){return new g(y.deepClone(this.contents),[...this.keys],y.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o];const l=i[o];l&&(typeof a=="object"&&typeof l=="object"?(a=y.deepClone(a),this.mergeContents(a,l)):a=l),n[o]=a}return new g(n,this.keys,this.overrides)}mergeContents(r,i){for(const n of Object.keys(i)){if(n in r&&h.isObject(r[n])&&h.isObject(i[n])){this.mergeContents(r[n],i[n]);continue}r[n]=y.deepClone(i[n])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?y.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,n=null;const o=a=>{a&&(n?this.mergeContents(n,a):n=y.deepClone(a))};for(const a of this.overrides)w.equals(a.identifiers,[r])?i=a.contents:a.identifiers.includes(r)&&o(a.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,I.addToValueTree)(this.contents,r,i,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,I.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let n=0;n<i;n++)r.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!h.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:n,keys:o,overrides:a,restricted:l}=this.doParseRaw(r,i);this._configurationModel=new g(n,o,a),this._restrictedConfigurations=l||[]}doParseContent(r){let i={},n=null,o=[];const a=[],l=[];function P(T){Array.isArray(o)?o.push(T):n!==null&&(o[n]=T)}const M={onObjectBegin:()=>{const T={};P(T),a.push(o),o=T,n=null},onObjectProperty:T=>{n=T},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const T=[];P(T),a.push(o),o=T,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:P,onError:(T,O,U)=>{l.push({error:T,offset:O,length:U})}};if(r)try{k.visit(r,M),i=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(r,i){const n=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,n,!0,i);r=o.raw;const a=(0,I.toValuesTree)(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),l=Object.keys(r),P=this.toOverrides(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:a,keys:l,overrides:P,restricted:o.restricted}}filter(r,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const a={},l=[];for(const P in r)if(C.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const M=this.filter(r[P],i,!1,o);a[P]=M.raw,l.push(...M.restricted)}else{const M=i[P],T=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&l.push(P),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&M?.restricted||(a[P]=r[P]))}return{raw:a,restricted:l}}toOverrides(r,i){const n=[];for(const o of Object.keys(r))if(C.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const l in r[o])a[l]=r[o][l];n.push({identifiers:(0,C.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,I.toValuesTree)(a,i)})}return n}}e.ConfigurationModelParser=d;class E extends R.Disposable{constructor(r,i,n,o){super();this.userSettingsResource=r,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&n.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class b{constructor(r,i,n,o,a=new g,l=new g,P=new D.ResourceMap,M=new g,T=new D.ResourceMap,O=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=l,this._folderConfigurations=P,this._memoryConfiguration=M,this._memoryConfigurationByResource=T,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,i,n){return this.getConsolidatedConfigurationModel(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new g,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,n){const o=this.getConsolidatedConfigurationModel(r,i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),M=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),T=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),O=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),U=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),Q=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),re=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,le=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,fe=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(r):l.getValue(r),se=o.getValue(r),ue=w.distinct(o.overrides.map(K=>K.identifiers).flat()).filter(K=>o.getOverrideValue(r,K)!==void 0);return{defaultValue:P,policyValue:M,applicationValue:T,userValue:O,userLocalValue:U,userRemoteValue:Q,workspaceValue:re,workspaceFolderValue:le,memoryValue:fe,value:se,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,policy:M!==void 0?{value:M}:void 0,application:T!==void 0?{value:T,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:Q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:re!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:le!==void 0?{value:a?.freeze().getValue(r),override:i.overrideIdentifier?a?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:fe!==void 0?{value:l.getValue(r),override:i.overrideIdentifier?l.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ue.length?ue:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:a,removed:l}=u(this._defaultConfiguration,r);i=[...o,...a,...l]}for(const o of i)for(const a of(0,C.overrideIdentifiersFromKey)(o)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),P=r.getKeysForOverrideIdentifier(a),M=[...P.filter(T=>l.indexOf(T)===-1),...l.filter(T=>P.indexOf(T)===-1),...l.filter(T=>!y.equals(this._defaultConfiguration.override(a).getValue(T),r.override(a).getValue(T)))];n.push([a,M])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=u(this._policyConfiguration,r),a=[...i,...n,...o];return a.length&&this.updatePolicyConfiguration(r),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.applicationConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateApplicationConfiguration(r),{keys:l,overrides:a}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.localUserConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateLocalUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.remoteUserConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateRemoteUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.workspaceConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateWorkspaceConfiguration(r),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:o,updated:a,removed:l,overrides:P}=u(n,i),M=[...o,...a,...l];return(M.length||!n)&&this.updateFolderConfiguration(r,i),{keys:M,overrides:P}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:a,overrides:l}=u(i,void 0);return{keys:[...n,...o,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:r},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const o=i.getFolder(r);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(r);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=n}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return r.push([i,{contents:n,overrides:o,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.policy),o=this.parseConfigurationModel(r.application),a=this.parseConfigurationModel(r.user),l=this.parseConfigurationModel(r.workspace),P=r.folders.reduce((M,T)=>(M.set(m.URI.revive(T[0]),this.parseConfigurationModel(T[1])),M),new D.ResourceMap);return new b(i,n,o,a,new g,l,P,new g,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new g(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=b;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,i=new Map;for(const o of s)o.keys.forEach(a=>r.add(a)),o.overrides.forEach(([a,l])=>{const P=(0,D.getOrSet)(i,a,new Set);l.forEach(M=>P.add(M))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=p;class v{constructor(r,i,n,o){this.change=r,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(P=>a.add(P)),r.overrides.forEach(([,P])=>P.forEach(M=>a.add(M))),this.affectedKeys=[...a.values()];const l=new g;this.affectedKeys.forEach(P=>l.setValue(P,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!y.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let n=(0,I.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(r=r[o],!r)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=v;class f extends v{constructor(r,i,n,o){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=f;function u(s,r){const{added:i,removed:n,updated:o}=c(r,s),a=[],l=s?.getAllOverrideIdentifiers()||[],P=r?.getAllOverrideIdentifiers()||[];if(r){const M=P.filter(T=>!l.includes(T));for(const T of M)a.push([T,r.getKeysForOverrideIdentifier(T)])}if(s){const M=l.filter(T=>!P.includes(T));for(const T of M)a.push([T,s.getKeysForOverrideIdentifier(T)])}if(r&&s){for(const M of l)if(P.includes(M)){const T=c({contents:s.getOverrideValue(void 0,M)||{},keys:s.getKeysForOverrideIdentifier(M)},{contents:r.getOverrideValue(void 0,M)||{},keys:r.getKeysForOverrideIdentifier(M)});a.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:n,updated:o,overrides:a}}function c(s,r){const i=s?r?s.keys.filter(a=>r.keys.indexOf(a)===-1):[...s.keys]:[],n=r?s?r.keys.filter(a=>s.keys.indexOf(a)===-1):[...r.keys]:[],o=[];if(s&&r){for(const a of r.keys)if(s.keys.indexOf(a)!==-1){const l=(0,I.getConfigurationValue)(r.contents,a),P=(0,I.getConfigurationValue)(s.contents,a);y.equals(l,P)||o.push(a)}}return{added:i,removed:n,updated:o}}}),define(Z[213],ee([0,1,24,3,2,49,12,19,107,62,6,39,45]),function(q,e,w,t,k,R,D,y,h,m,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class g extends k.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:f})=>this.onDidUpdateConfiguration(v,f))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(v,f){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=g;class d extends h.ConfigurationModel{constructor(v={}){const f=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(f),c=Object.create(null),s=[];for(const r in f){const i=v[r],n=i!==void 0?i:f[r].default;(0,y.addToValueTree)(c,r,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(c))m.OVERRIDE_PROPERTY_REGEX.test(r)&&s.push({identifiers:(0,m.overrideIdentifiersFromKey)(r),keys:Object.keys(c[r]),contents:(0,y.toValuesTree)(c[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,u,s)}}e.DefaultConfigurationModel=d;class E{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new h.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=E;let b=class extends k.Disposable{constructor(v,f,u){super();this.defaultConfiguration=v,this.policyService=f,this.logService=u,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new h.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.registerPolicyDefinitions(v),!0))),this._configurationModel}async registerPolicyDefinitions(v){const f={},u=[],c=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const s of v){const r=c[s];if(!r){u.push(s);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}u.push(s),f[r.policy.name]={type:r.type}}}return(0,D.isEmptyObject)(f)||await this.policyService.registerPolicyDefinitions(f),u}onDidChangePolicies(v){const f=S.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),u=(0,w.coalesce)(v.map(c=>f.get(c)));this.update(u,!0)}update(v,f){const u=S.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),c=[],s=this._configurationModel.isEmpty();for(const r of v){const i=u[r]?.policy?.name;if(i){const n=this.policyService.getPolicyValue(i);(s?n!==void 0:!(0,R.equals)(this._configurationModel.getValue(r),n))&&c.push([r,n])}else this._configurationModel.getValue(r)!==void 0&&c.push([r,void 0])}if(c.length){const r=this._configurationModel;this._configurationModel=new h.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,n]of c)n===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,n);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};b=ve([J(1,C.IPolicyService),J(2,I.ILogService)],b),e.PolicyConfiguration=b}),define(Z[214],ee([0,1,8,3,2,16,19,107,213,39]),function(q,e,w,t,k,R,D,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(S,g,d,E){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=d instanceof m.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,d,E)),this.userConfiguration=this._register(new y.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,g)),this.configuration=new y.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new y.ConfigurationModel,new y.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:b,properties:p})=>this.onDidDefaultConfigurationChange(b,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(b=>this.onDidPolicyConfigurationChange(b))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,g,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new y.Configuration(S,g,new y.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(S,g){const d=typeof S=="string"?S:void 0,E=(0,D.isConfigurationOverrides)(S)?S:(0,D.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(d,E,void 0)}updateValue(S,g,d,E){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const g=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(d,g,2)}onDidDefaultConfigurationChange(S,g){const d=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(S,g);this.trigger(E,d,7)}onDidPolicyConfigurationChange(S){const g=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(d,g,7)}trigger(S,g,d){const E=new y.ConfigurationChangeEvent(S,{data:g},this.configuration);E.source=d,E.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Z[215],ee([0,1,18,5]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends w.ErrorNoTelemetry{constructor(y,h=k.Unknown,m){super(y);this._message=y,this._code=h,this._detail=m,this.isHandled=h===k.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===k.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===k.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}}e.RemoteAuthorityResolverError=R}),define(Z[63],ee([0,1,13]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const I=m.indexOf("+");return I<0?m:m.substr(0,I)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(m){const{host:I,port:C}=h(m);if(typeof C=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:C}}e.parseAuthorityWithPort=D;function y(m,I){let{host:C,port:S}=h(m);return typeof S=="undefined"&&(S=I),{host:C,port:S}}e.parseAuthorityWithOptionalPort=y;function h(m){const I=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const C=m.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(Z[108],ee([0,1,27,5,63]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function D(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var h;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(h=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,b){if(typeof E=="undefined"||E===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof E=="string"||typeof b=="string"){const p=typeof E=="string"?E:E.value,v=typeof b=="string"?b:b.value;return w.equalsIgnoreCase(p,v)}return E._lower===b._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=m;function I(d){return C(d)}e.isApplicationScopedExtension=I;function C(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function S(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function g(d,E){if(E){const b=`onResolveRemoteAuthority:${(0,k.getRemoteName)(E)}`;return d.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[109],ee([0,1,27,190,108,4,7,18,34]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,w.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=m;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new C(i.identifier,n,o)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new C({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof C?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=C;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(r){const i=S.exec(r);return i&&i[1]?[E(i[1]),i[2]]:[E(r),void 0]}e.getIdAndVersion=g;function d(r,i){return`${r}.${i}`}e.getExtensionId=d;function E(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function b(r,i){return E(d(r,i))}e.getGalleryExtensionId=b;function p(r,i){const n=[],o=a=>{for(const l of n)if(l.some(P=>m(i(P),i(a))))return l;return null};for(const a of r){const l=o(a);l?l.push(a):n.push([a])}return n}e.groupByExtension=p;function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function f(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function u(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&n.every(l=>!m(l.identifier,{id:a}))){const l=r.filter(P=>m(P.identifier,{id:a}));l.length===1&&(n.push(l[0]),o.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=u;async function c(r,i){if(!R.isLinux)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function s(r,i){const n=await c(r,i),o=(0,t.getTargetPlatform)(n?"alpine":R.platform,h.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(Z[72],ee([0,1,8,17,2,32,7,109,14,5,6]),function(q,e,w,t,k,R,D,y,h,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let C=class extends k.Disposable{constructor(g,d){super();this.fileService=g,this.logService=d,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(g){return this.withProfileExtensions(g)}addExtensionsToProfile(g,d){return this.withProfileExtensions(d,E=>(E=E.filter(b=>g.some(([p])=>!(0,y.areSameExtensions)(b.identifier,p.identifier))),E.push(...g.map(([b,p])=>({identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:p}))),E))}removeExtensionFromProfile(g,d){return this.withProfileExtensions(d,E=>E.filter(b=>!(0,y.areSameExtensions)(b.identifier,g)))}async withProfileExtensions(g,d){return this.getResourceAccessQueue(g).queue(async()=>{let E=[];try{const b=await this.fileService.readFile(g),p=JSON.parse(b.value.toString());for(const v of p){if(!v.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",v);continue}if(!v.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",v);continue}if(!v.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",v);continue}E.push({identifier:v.identifier,location:D.URI.revive(v.location),version:v.version,metadata:v.metadata})}}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}if(d){E=d(E);const b=E.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(g,t.VSBuffer.fromString(JSON.stringify(b)))}return E})}getResourceAccessQueue(g){let d=this.resourcesAccessQueueMap.get(g);return d||(d=new w.Queue,this.resourcesAccessQueueMap.set(g,d)),d}};C=ve([J(0,h.IFileService),J(1,I.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(Z[216],ee([0,1,8,17,21,18,3,2,28,98,215,63]),function(q,e,w,t,k,R,D,y,h,m,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var g;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function d(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function E(z){const j=new k.CancellationTokenSource;return setTimeout(()=>j.cancel(),z),j.token}function b(z,j){if(z.isCancellationRequested||j.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return z.onCancellationRequested(()=>L.cancel()),j.onCancellationRequested(()=>L.cancel()),L.token}class p{constructor(j){this._state="pending",this._disposables=new y.DisposableStore,this.promise=new Promise((L,F)=>{this._resolvePromise=L,this._rejectPromise=F}),j.isCancellationRequested?this._timeout():this._disposables.add(j.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(j){this._state==="pending"?this._disposables.add(j):j.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(j))}reject(j){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(j))}}function v(z,j){const L=new p(j);return L.registerDisposable(z.onControlMessage(F=>{const B=JSON.parse(F.toString()),V=_(B);V?L.reject(V):L.resolve(B)})),L.promise}function f(z,j,L,F,B,V,x,ne){const H=new p(ne);return j.connect(L,F,B,V,x,(te,ie)=>{H.didTimeout?(te&&z.error(te),ie?.dispose()):te||!ie?H.reject(te):H.resolve(ie)}),H.promise}function u(z,j){const L=new p(j);return z.then(F=>{L.didTimeout||L.resolve(F)},F=>{L.didTimeout||L.reject(F)}),L.promise}async function c(z,j,L,F){const B=$(z,j);z.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let V;try{V=await f(z.logService,z.socketFactory,z.host,z.port,(0,C.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${d(j)}-${z.reconnectionToken}`,F)}catch(ie){throw z.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ie),ie}z.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let x,ne;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(V,null),x=z.reconnectionProtocol,ne=!1):(x=new m.PersistentProtocol(V,null),ne=!0),z.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const H=await u(z.signService.createNewMessage((0,h.generateUuid)()),F),te={type:"auth",auth:z.connectionToken||"00000000000000000000",data:H.data};x.sendControl(t.VSBuffer.fromString(JSON.stringify(te)));try{const ie=await v(x,b(F,E(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(z.logService.trace(`${B} 4/6. received SignRequest control message.`),!await u(z.signService.validate(H,ie.signedData),F)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const de=await u(z.signService.sign(ie.data),F),ke={type:"connectionType",commit:z.commit,signedData:de,desiredConnectionType:j};return L&&(ke.args=L),z.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(t.VSBuffer.fromString(JSON.stringify(ke))),{protocol:x,ownsProtocol:ne}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(z.logService.error(`${B} the handshake timed out. Error:`),z.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${B} received error control message when negotiating connection. Error:`),z.logService.error(ie)),ne&&N(x),ie}}async function s(z,j,L,F){const B=Date.now(),V=$(z,j),{protocol:x,ownsProtocol:ne}=await c(z,j,L,F),H=new p(F);return H.registerDisposable(x.onControlMessage(te=>{const ie=JSON.parse(te.toString()),ce=_(ie);ce?(z.logService.error(`${V} received error control message when negotiating connection. Error:`),z.logService.error(ce),ne&&N(x),H.reject(ce)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${Y(B)}!`),H.resolve({protocol:x,firstMessage:ie}))})),H.promise}async function r(z,j){const{protocol:L}=await s(z,1,void 0,j);return{protocol:L}}async function i(z,j,L){const{protocol:F,firstMessage:B}=await s(z,2,j,L),V=B&&B.debugPort;return{protocol:F,debugPort:V}}async function n(z,j,L){const F=Date.now(),B=$(z,3),{protocol:V}=await c(z,3,j,L);return z.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${Y(F)}!`),V}async function o(z,j,L){const{host:F,port:B,connectionToken:V}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:F,port:B,connectionToken:V,reconnectionToken:j,reconnectionProtocol:L,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function a(z,j,L){return P(z,async F=>{const{protocol:B}=await r(F,k.CancellationToken.None);return new ue(z,j,L,F.reconnectionToken,B)})}e.connectRemoteAgentManagement=a;async function l(z,j){return P(z,async L=>{const{protocol:F,debugPort:B}=await i(L,j,k.CancellationToken.None);return new K(z,j,L.reconnectionToken,F,B)})}e.connectRemoteAgentExtensionHost=l;async function P(z,j){const L=5;for(let F=1;;F++)try{const B=(0,h.generateUuid)(),V=await o(z,B,null);return await j(V)}catch(B){if(F<L)z.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(B);else throw z.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(B),se.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(B)),B}}async function M(z,j,L){const F=await o(z,(0,h.generateUuid)(),null);return await n(F,{host:j,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(z){return(0,w.createCancelablePromise)(j=>new Promise((L,F)=>{const B=setTimeout(L,z*1e3);j.onCancellationRequested(()=>{clearTimeout(B),L()})}))}var O;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(O=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(j,L){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class Q{constructor(j,L,F,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.durationSeconds=F,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=Q;class re{constructor(j,L,F){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=re;class le{constructor(j,L,F){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=F,this.type=4}}e.ConnectionGainEvent=le;class fe{constructor(j,L,F,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=F,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class se extends y.Disposable{constructor(j,L,F,B,V){super();this._connectionType=j,this._options=L,this.reconnectionToken=F,this.protocol=B,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new le(this.reconnectionToken,0,0)),this._register(B.onSocketClose(x=>{const ne=W(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${ne} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${ne} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${ne} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(x=>{const ne=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,y.toDisposable)(()=>{const x=se._instances.indexOf(this);x>=0&&se._instances.splice(x,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(j,L,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=j,this._permanentFailureAttempt=L,this._permanentFailureHandled=F,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(j=>j._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(j=>j._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const j=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const B=F<L.length?L[F]:L[L.length-1];try{if(B>0){const x=T(B);this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,x)),this._options.logService.info(`${j} waiting for ${B} seconds before reconnecting...`);try{await x}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${j} resolving connection...`);const V=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${j} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,E(S)),this._options.logService.info(`${j} reconnected!`),this._onDidStateChange.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,I.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(j,L,F){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(j,L,F):this._gotoPermanentFailure(j,L,F)}_gotoPermanentFailure(j,L,F){this._onDidStateChange.fire(new fe(this.reconnectionToken,j,L,F)),N(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class ue extends se{constructor(j,L,F,B,V){super(1,j,B,V,!0);this.client=this._register(new m.Client(V,{remoteAuthority:L,clientId:F},j.ipcLogger))}async _reconnect(j,L){await r(j,L)}}e.ManagementPersistentConnection=ue;class K extends se{constructor(j,L,F,B,V){super(2,j,F,B,!1);this._startArguments=L,this.debugPort=V}async _reconnect(j,L){await i(j,this._startArguments,L)}}e.ExtensionHostPersistentConnection=K;function N(z){try{z.acceptDisconnect();const j=z.getSocket();z.dispose(),j.dispose()}catch(j){(0,R.onUnexpectedError)(j)}}function _(z){if(z&&z.type==="error"){const j=new Error(`Connection error: ${z.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function A(z,j){for(;z.length<j;)z+=" ";return z}function W(z,j,L){return`[remote-connection][${A(d(z),13)}][${j.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function $(z,j){return`${W(j,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function Y(z){return`${Date.now()-z} ms`}}),define(Z[217],ee([0,1,77,83]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,y,h,m){const I=S=>m(S,void 0),C=w.createConnection({host:k,port:R},()=>{C.removeListener("error",I);const S=Buffer.alloc(16);for(let b=0;b<16;b++)S[b]=Math.round(Math.random()*256);const g=S.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${y}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];C.write(d.join(`\r
`)+`\r
\r
`);const E=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",E),m(void 0,new t.NodeSocket(C,h)))};C.on("data",E)});C.setNoDelay(!0),C.once("error",I)}}}),define(Z[54],ee([0,1,17,166,62,5,45]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=y;function h(E){return E.res.statusCode===204}async function m(E){return h(E)?null:(await(0,w.streamToBuffer)(E.stream)).toString()}e.asText=m;async function I(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return m(E)}e.asTextOrError=I;async function C(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(h(E))return null;const p=(await(0,w.streamToBuffer)(E.stream)).toString();try{return JSON.parse(p)}catch(v){throw v.message+=`:
`+p,v}}e.asJson=C;function S(E){d(E)}e.updateProxyConfigurationsScope=S;let g;function d(E){const b=D.Registry.as(k.Extensions.Configuration),p=g;g={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[g],remove:p?[p]:[]})}d(2)}),define(Z[218],ee([0,1,17,21]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(y){this.service=y}listen(y,h){throw new Error("Invalid listen")}call(y,h,m,I=t.CancellationToken.None){switch(h){case"request":return this.service.request(m[0],I).then(async({res:C,stream:S})=>{const g=await(0,w.streamToBuffer)(S);return[{statusCode:C.statusCode,headers:C.headers},g]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(y){this.channel=y}async request(y,h){const[m,I]=await this.channel.call("request",[y],h);return{res:m,stream:(0,w.bufferToStream)(I)}}async resolveProxy(y){return this.channel.call("resolveProxy",[y])}}e.RequestChannelClient=R}),define(Z[219],ee([0,1,220,12]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,y){return D.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:D.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function R(D,y,h={}){const m=(0,w.parse)(D),I=h.proxyUrl||k(m,y);if(!I)return null;const C=(0,w.parse)(I);if(!/^https?:$/.test(C.protocol||""))return null;const S={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,t.isBoolean)(h.strictSSL)?h.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((g,d)=>{q(["http-proxy-agent"],g,d)}))(S):new(await new Promise((g,d)=>{q(["https-proxy-agent"],g,d)}))(S)}e.getProxyAgent=R}),define(Z[110],ee([0,1,50,9,167,21,43,18,4,28,144,59,8]),function(q,e,w,t,k,R,D,y,h,m,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const g=1e4;let d;async function E(p,v,f){return v["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(f)&&!v["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=S.Promises.withAsyncBody(async(u,c)=>{const s=new R.CancellationTokenSource,r=setTimeout(()=>{s.dispose(!0),c(new Error((0,k.localize)(0,null)))},g);try{u(await b(p,s.token))}catch(i){!(0,y.isCancellationError)(i)&&!s.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(i)))):u({})}finally{clearTimeout(r),s.dispose()}})),d)}e.getResolvedShellEnv=E;async function b(p,v){const f=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",f);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",u);const c=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(c+"(.*)"+c),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",r);const i=await(0,I.getSystemShell)(h.OS,r);return p.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(v.isCancellationRequested)return o((0,y.canceled)());const a=(0,t.basename)(i);let l,P;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,P=["-Login","-Command"]):(l=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?P=["-ic"]:P=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const T=(0,w.spawn)(i,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(T.kill(),o((0,y.canceled)()))),T.on("error",Q=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(Q)),o(Q)});const O=[];T.stdout.on("data",Q=>O.push(Q));const U=[];T.stderr.on("data",Q=>U.push(Q)),T.on("close",(Q,re)=>{const le=Buffer.concat(O).toString("utf8");p.trace("getUnixShellEnvironment#raw",le);const fe=Buffer.concat(U).toString("utf8");if(fe.trim()&&p.trace("getUnixShellEnvironment#stderr",fe),Q||re)return o(new Error((0,k.localize)(2,null,Q,re)));const se=s.exec(le),ue=se?se[1]:"{}";try{const K=JSON.parse(ue);f?K.ELECTRON_RUN_AS_NODE=f:delete K.ELECTRON_RUN_AS_NODE,u?K.ELECTRON_NO_ATTACH_CONSOLE=u:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",K),n(K)}catch(K){p.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(K)),o(K)}})})}}),define(Z[87],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[221],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>q(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const y=String(w._nextId++);return this.validators.set(y,D),{id:y,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=w,w._nextId=1}),define(Z[41],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(Z[22],ee([0,1,15,40,8,3,2,4,34,12,5,6,41,25]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var d;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var E;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen"})(E=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class yt extends D.Disposable{constructor(v,f,u){super();this.logService=v,this.stateMainService=f,this.environmentMainService=u,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(yt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(yt.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),y.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};w.app.addListener("before-quit",v);const f=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!y.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",f),w.app.once("will-quit",u=>{this.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",v),w.app.removeListener("window-all-closed",f),w.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const f=[];return this._onWillShutdown.fire({reason:v,join(u){f.push(u)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(f)}catch(u){this.logService.error(u)}try{await this.stateMainService.close()}catch(u){this.logService.error(u)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const f=this.phaseWhen.get(this._phase);f&&(f.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let f=this.phaseWhen.get(v);f||(f=new k.Barrier,this.phaseWhen.set(v,f)),await f.wait()}registerWindow(v){const f=new D.DisposableStore;this.windowCounter++,f.add(v.onWillLoad(c=>this._onWillLoadWindow.fire({window:v,workspace:c.workspace,reason:c.reason})));const u=(0,m.assertIsDefined)(v.win);u.on("close",c=>{const s=v.id;if(this.windowToCloseRequest.has(s)){this.windowToCloseRequest.delete(s);return}this.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),c.preventDefault(),this.unload(v,1).then(r=>{if(r){this.windowToCloseRequest.delete(s);return}this.windowToCloseRequest.add(s),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${s}`),this._onBeforeCloseWindow.fire(v),v.close()})}),u.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,f.dispose(),this.windowCounter===0&&(!y.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(v,f){await this.unload(v,3)||v.reload(f)}unload(v,f){const u=this.mapWindowIdToPendingUnload.get(v.id);if(u)return u;const c=this.doUnload(v,f).finally(()=>{this.mapWindowIdToPendingUnload.delete(v.id)});return this.mapWindowIdToPendingUnload.set(v.id,c),c}async doUnload(v,f){if(!v.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${v.id}`);const u=this._quitRequested?2:f,c=await this.onBeforeUnloadWindowInRenderer(v,u);return c?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(c)):(await this.onWillUnloadWindowInRenderer(v,u),!1)}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,f){return new Promise(u=>{const c=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${c}`,r=`vscode:cancel${c}`;t.validatedIpcMain.once(s,()=>{u(!1)}),t.validatedIpcMain.once(r,()=>{u(!0)}),v.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:r,reason:f})})}onWillUnloadWindowInRenderer(v,f){return new Promise(u=>{const s=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(s,()=>u()),v.send("vscode:onWillUnload",{replyChannel:s,reason:f})})}quit(v){return this.trace(`Lifecycle#quit() - begin (willRestart: ${v})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(v&&this.stateMainService.setItem(yt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(f=>{this.pendingQuitPromiseResolve=f,this.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}trace(v){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(v):this.logService.trace(v)}async relaunch(v){this.trace("Lifecycle#relaunch()");const f=process.argv.slice(1);if(v?.addArgs&&f.push(...v.addArgs),v?.removeArgs)for(const s of v.removeArgs){const r=f.indexOf(s);r>=0&&f.splice(r,1)}const u=()=>{try{if(y.isWindows){const s=(0,h.cwd)();s!==process.cwd()&&process.chdir(s)}}catch(s){this.logService.error(s)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:f})};w.app.once("quit",u),await this.quit(!0)&&w.app.removeListener("quit",u)}async kill(v){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const f of w.BrowserWindow.getAllWindows())if(f&&!f.isDestroyed()){let u;f.webContents&&!f.webContents.isDestroyed()?u=new Promise(c=>f.once("closed",c)):u=Promise.resolve(),f.destroy(),await u}})()]),w.app.exit(v)}};b.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",b=ve([J(0,C.ILogService),J(1,S.IStateMainService),J(2,g.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(Z[222],ee([0,1,4,3,2,5,22]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let y=class extends k.Disposable{constructor(I){super();this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,I.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const I=await new Promise((C,S)=>{q(["native-keymap"],C,S)});this._keyboardLayoutData=h(I),w.isCI||I.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(I),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};y=ve([J(0,D.ILifecycleMainService)],y),e.KeyboardLayoutMainService=y;function h(m){const I=m.getKeyMap(),C=m.getCurrentKeyboardLayout();return{keyboardMapping:I,keyboardLayoutInfo:C}}}),define(Z[223],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,w.createDecorator)("stateService")}),define(Z[224],ee([0,1,8,17,12,36,14,6]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(C,S,g){this.storagePath=C,this.logService=S,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}}getItem(C,S){const g=this.storage[C];return(0,k.isUndefinedOrNull)(g)?S:g}setItem(C,S){this.setItems([{key:C,data:S}])}setItems(C){let S=!1;for(const{key:g,data:d}of C)this.storage[g]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.storage[g])||(this.storage[g]=void 0,S=!0):(this.storage[g]=d,S=!0));S&&this.save()}removeItem(C){(0,k.isUndefined)(this.storage[C])||(this.storage[C]=void 0,this.save())}async save(C){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),C)}async doSave(){if(!this.initializing)return;await this.initializing;const C=JSON.stringify(this.storage,null,4);if(C!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(C)),this.lastSavedStorageContents=C}catch(S){this.logService.error(S)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=h;let m=class{constructor(C,S,g){this.fileStorage=new h(C.stateResource,S,g)}async init(){await this.fileStorage.init()}getItem(C,S){return this.fileStorage.getItem(C,S)}};m=ve([J(0,R.IEnvironmentService),J(1,y.ILogService),J(2,D.IFileService)],m),e.StateService=m}),define(Z[225],ee([0,1,224]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends w.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(Z[111],ee([0,1,4,34,7,28]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(m){if(w.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function y(m,I,C,S,g,d,E,b,p,v){const f=Object.create(null);f["common.machineId"]=E,f.sessionID=(0,R.generateUuid)()+Date.now(),f.commitHash=g,f.version=d,f["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,w.PlatformToString)(w.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=S,f["common.product"]=v||"desktop",b&&(f["common.msftInternal"]=b);let u=0;const c=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),w.isLinuxSnap&&(f["common.snap"]="true");const s=D(C);s&&(f["common.platformDetail"]=s);try{const r=await m.readFile(k.URI.file(p));f["common.source"]=r.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=y;function h(m){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return m.some(S=>C===S)}e.verifyMicrosoftInternalDomain=h}),define(Z[37],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[226],ee([0,1,30,57,8,42,13,9,4,7,81,23,97,84,14,20,37]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function v(r,i){const n=`${r}::${i.join(":")}`,o=p.get(n);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,P=new Map,M=2e4;function T(U,Q,re,le){const fe=Q.substring(U.length+1);return k.Promises.withAsyncBody(async se=>{let ue;try{ue=await C.Promises.readdir(Q,{withFileTypes:!0})}catch{se();return}if(le.count>=M){le.count+=ue.length,le.maxReached=!0,se();return}let K=ue.length;if(K===0){se();return}let N=ue;le.count+ue.length>M&&(le.maxReached=!0,K=M-le.count,N=ue.slice(0,K)),le.count+=ue.length;for(const _ of N)if(_.isDirectory()){if(re.includes(_.name)||await T(U,(0,y.join)(Q,_.name),re,le),--K==0){se();return}}else{const A=_.name.lastIndexOf(".");if(A>=0){const W=_.name.substring(A+1);W&&l.set(W,(l.get(W)??0)+1)}for(const W of a)W.relativePathPattern?.test(fe)!==!1&&W.filePattern.test(_.name)&&P.set(W.tag,(P.get(W.tag)??0)+1);if(--K==0){se();return}}})}const O=k.Promises.withAsyncBody(async U=>{const Q={count:0,maxReached:!1};await T(r,r,i,Q);const re=await c(r);U({configFiles:f(P),fileTypes:f(l),fileCount:Q.count,maxFilesReached:Q.maxReached,launchConfigFiles:re})});return p.set(n,O),O}e.collectWorkspaceStats=v;function f(r){return[...t.Iterable.map(r.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function u(){const r={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},i=w.cpus();return i&&i.length>0&&(r.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),r}e.getMachineInfo=u;async function c(r){try{const i=new Map,n=(0,y.join)(r,".vscode","launch.json"),o=await C.Promises.readFile(n),a=[],l=(0,R.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const P of l.configurations){const M=P.type;M&&(i.has(M)?i.set(M,i.get(M)+1):i.set(M,1))}return f(i)}catch{return[]}}e.collectLaunchConfigs=c;let s=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const o=w.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(w.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||n.push(`Load (avg):       ${w.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,S.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,l]=o,P=this.formatProcessList(i,a);return n.forEach(M=>{if((0,g.isRemoteDiagnosticError)(M))P+=`
${M.errorMessage}`,l+=`
${M.errorMessage}`;else if(P+=`

Remote: ${M.hostName}`,M.processes&&(P+=`
${this.formatProcessList(i,M.processes)}`),M.workspaceMetadata){l+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const O=M.workspaceMetadata[T];let U=`${O.fileCount} files`;O.maxFilesReached&&(U=`more than ${U}`),l+=`|    Folder (${T}): ${U}`,l+=this.formatWorkspaceStats(O)}}}),{processInfo:P,workspaceInfo:l}})}async getSystemInfo(i,n){const{memory:o,vmHint:a,os:l,cpus:P}=u(),M={os:l,memory:o,cpus:P,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return h.isWindows||(M.load=`${w.loadavg().map(T=>Math.round(T)).join(", ")}`),h.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(i,n){const o=[];return(0,S.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(l=>{if((0,g.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.formatMachineInfo(l.machineInfo)),l.processes&&o.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const P of Object.keys(l.workspaceMetadata)){const M=l.workspaceMetadata[P];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),o.push(`Folder (${P}): ${T}`),o.push(this.formatWorkspaceStats(M))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let a=0;const l=(O,U)=>{const Q=` ${O}(${U})`;a+Q.length>o?(n.push(P),P="|                 ",a=P.length):a+=Q.length,P+=Q};let P="|      File types:";const M=10,T=i.fileTypes.length>M?M:i.fileTypes.length;for(let O=0;O<T;O++){const U=i.fileTypes[O];l(U.name,U.count)}if(n.push(P),i.configFiles.length>=0&&(P="|      Conf files:",a=0,i.configFiles.forEach(O=>{l(O.name,O.count)}),n.push(P)),i.launchConfigFiles.length>0){let O="|      Launch Configs:";i.launchConfigFiles.forEach(U=>{O+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),n.push(O)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const P=m.URI.revive(l);if(P.scheme===D.Schemas.file){const M=P.fsPath;o.push(v(M,["node_modules",".git"]).then(T=>{let O=`${T.fileCount} files`;T.maxFilesReached&&(O=`more than ${O}`),n.push(`|    Folder (${(0,y.basename)(M)}): ${O}`),n.push(this.formatWorkspaceStats(T))}).catch(T=>{n.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else n.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(l=>o.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,a,n,0),a.join(`
`)}formatProcessItem(i,n,o,a,l){const P=l===0;let M;P?M=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(M=`${M} (${n.get(a.pid)})`));const T=process.platform==="win32"?a.mem:w.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(T/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(a.children)&&a.children.forEach(O=>this.formatProcessItem(i,n,o,O,l+1))}async getWorkspaceFileExtensions(i){const n=new Set;for(const{uri:o}of i.folders){const a=m.URI.revive(o);if(a.scheme!==D.Schemas.file)continue;const l=a.fsPath;try{(await v(l,["node_modules",".git"])).fileTypes.forEach(M=>n.add(M.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=m.URI.revive(n);if(o.scheme!==D.Schemas.file)continue;const a=o.fsPath;try{const l=await v(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),l.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),l.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})})}catch{}}}};s=ve([J(0,b.ITelemetryService),J(1,E.IProductService)],s),e.DiagnosticsService=s}),define(Z[227],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:y,data:h}){return this.appenders.forEach(m=>m.log(y,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,y=>`Failed to log telemetry: ${console.warn(y)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(Z[73],ee([0,1,49,93,12,19,111,37]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class h{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(s,r){return Promise.resolve(void 0)}publicLog2(s,r){return this.publicLog(s,r)}publicLogError(s,r){return Promise.resolve(void 0)}publicLogError2(s,r){return this.publicLogError(s,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class m{async publicLog(s,r,i){}async publicLogError(s,r,i){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(c,s){return s.onDidChangeConfiguration(r=>{r.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(r.source),configurationKeys:p(r.sourceConfig)})})}e.configurationTelemetry=I;function C(c,s){return!(s.disableTelemetry||!c.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=C;function S(c){const s=c.getValue(y.TELEMETRY_SETTING_ID),r=c.getValue("telemetry.enableCrashReporter");if(c.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function g(c){const s={},r={},i={};b(c,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),s[n]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(s[n]=o)}return{properties:s,measurements:r}}e.validateTelemetryData=g;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function E(c){if(!c)return"none";for(const s of d)if(c.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=E;function b(c,s,r=0,i){if(!!c)for(const n of Object.getOwnPropertyNames(c)){const o=c[n],a=i?i+n:n;Array.isArray(o)?s[a]=(0,w.safeStringify)(o):o instanceof Date?s[a]=o.toISOString():(0,k.isObject)(o)?r<2?b(o,s,r+1,a+"."):s[a]=(0,w.safeStringify)(o):s[a]=o}}function p(c){if(!c)return[];const s=[];return v(s,"",c),s}function v(c,s,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(i=>v(c,s?`${s}.${i}`:i,r[i])):c.push(s)}function f(c,s){const r=c.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(r)||i}e.isInternalTelemetry=f;function u(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=u}),define(Z[228],ee([0,1,187,73]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,y,h,m,I,C){const S={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`},g=await(0,w.getServiceMachineId)(y,m,I),{sessionId:d}=await C.getTelemetryInfo();return(0,t.supportsTelemetry)(D,y)&&(0,t.getTelemetryLevel)(h)===3&&(S["X-Market-User-Id"]=g,S["VSCode-SessionId"]=d),S}e.resolveMarketplaceHeaders=k}),define(Z[229],ee([0,1,2,49,93,4,27,168,19,62,53,20,45,37,73]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(v,f,u){this._configurationService=f,this._productService=u,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,f){this._experimentProperties[v]=f}_updateTelemetryLevel(){let v=(0,d.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const u=f.usage?3:f.error?2:0;v=Math.min(v,u)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties,f=v.sessionID,u=v["common.machineId"],c=v["common.firstSessionDate"],s=v["common.msftInternal"];return{sessionId:f,machineId:u,firstSessionDate:c,msftInternal:s}}dispose(){this._disposables.dispose()}_log(v,f,u,c){return this.telemetryLevel.value<f?Promise.resolve(void 0):this._commonProperties.then(s=>{u=(0,t.mixin)(u,s),u=(0,t.mixin)(u,this._experimentProperties),u=(0,t.cloneAndChange)(u,r=>{if(typeof r=="string")return this._cleanupInfo(r,c)}),this._appenders.forEach(r=>r.log(v,u))},s=>{console.error(s)})}publicLog(v,f,u){return this._log(v,3,f,u)}publicLog2(v,f,u){return this.publicLog(v,f,u)}publicLogError(v,f){return this._sendErrorTelemetry?this._log(v,2,f,!0):Promise.resolve(void 0)}publicLogError2(v,f){return this.publicLogError(v,f)}_anonymizeFilePaths(v){let f=v;const u=[];for(const i of this._cleanupPatterns)for(;;){const n=i.exec(v);if(!n)break;u.push([n.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(f="";;){const i=s.exec(v);if(!i)break;!c.test(i[0])&&u.every(([n,o])=>i.index<n||i.index>=o)&&(f+=v.substring(r,i.index)+"<REDACTED: user-file-path>",r=s.lastIndex)}return r<v.length&&(f+=v.substr(r)),f}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const f=v.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of u)if(c.regex.test(f))return`<REDACTED: ${c.label}>`;return v}_cleanupInfo(v,f){let u=v;f&&(u=this._anonymizeFilePaths(u));for(const c of this._cleanupPatterns)u=u.replace(c,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ve([J(1,h.IConfigurationService),J(2,C.IProductService)],E),e.TelemetryService=E;function b(){const p=(0,y.localize)(0,null,I.default.nameLong),v=I.default.privacyStatementUrl?(0,y.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,y.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.isWeb?"":(0,y.localize)(3,null),u=(0,y.localize)(4,null),c=(0,y.localize)(5,null),s=(0,y.localize)(6,null),r=(0,y.localize)(7,null),i=`
|       | ${u} | ${c} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,y.localize)(8,null);return`
${p} ${v} ${f}

&nbsp;

${r}
${i}

&nbsp;

${n}
`}S.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,y.localize)(10,null),(0,y.localize)(11,null),(0,y.localize)(12,null),(0,y.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,y.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,y.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,y.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[230],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(w=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===w.HIGH_CONTRAST_DARK||R===w.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===w.DARK||R===w.HIGH_CONTRAST_DARK}e.isDark=k}),define(Z[231],ee([0,1,121,3,2,5,45,230]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var h;(function(b){function p(v){return v&&typeof v=="object"&&typeof v.id=="string"}b.isThemeColor=p})(h=e.ThemeColor||(e.ThemeColor={}));function m(b){return{id:b}}e.themeColorFromId=m;var I;(function(b){function p(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||h.isThemeColor(n.color))}b.isThemeIcon=p;const v=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const o=v.exec(n);if(!o)return;const[,a]=o;return{id:a}}b.fromString=f;function u(n){return{id:n}}b.fromId=u;function c(n,o){let a=n.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),o&&(a=`${a}~${o}`),{id:a}}b.modify=c;function s(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}b.getModifier=s;function r(n,o){return n.id===o.id&&n.color?.id===o.color?.id}b.isEqual=r;function i(n,o){return{id:n.id,color:o?m(o):void 0}}b.asThemeIcon=i,b.asClassNameArray=w.CSSIcon.asClassNameArray,b.asClassName=w.CSSIcon.asClassName,b.asCSSSelector=w.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function C(b){switch(b){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const v=this.themingParticipants.indexOf(p);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const g=new S;D.Registry.add(e.Extensions.ThemingContribution,g);function d(b){return g.onColorThemeChange(b)}e.registerThemingParticipant=d;class E extends k.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,v){let f=this.theme.getColor(p);return f&&v&&(f=v(f,this.theme)),f?f.toString():null}}e.Themable=E}),define(Z[64],ee([0,1,15,3,2,4,19,5,41]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",I="#1E1E1E",C="#000000",S="#FFFFFF",g="theme",d="themeBackground",E="windowSplash";e.IThemeMainService=(0,y.createDecorator)("themeMainService");let b=class extends k.Disposable{constructor(v,f){super();this.stateMainService=v,this.configurationService=f,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&w.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return v.dark?C:S;let f=this.stateMainService.getItem(d,null);if(!f)switch(this.stateMainService.getItem(g,"vs-dark").split(" ")[0]){case"vs":f=m;break;case"hc-black":f=C;break;case"hc-light":f=S;break;default:f=I}return R.isMacintosh&&f.toUpperCase()===I&&(f="#171717"),f}saveWindowSplash(v,f){this.stateMainService.setItems([{key:g,data:f.baseTheme},{key:d,data:f.colorInfo.background},{key:E,data:f}]),typeof v=="number"&&this.updateBackgroundColor(v,f)}updateBackgroundColor(v,f){for(const u of w.BrowserWindow.getAllWindows())if(u.id===v){u.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};b=ve([J(0,h.IStateMainService),J(1,D.IConfigurationService)],b),e.ThemeMainService=b}),define(Z[112],ee([0,1,3,4,5,6]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(E){E.Http="http",E.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(y=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=C;function S(E,b){return b?b!==1&&E<1024:!t.isWindows&&E<1024}e.isPortPrivileged=S;class g{constructor(b,p,v){this.remoteAddress=b,this.localAddress=p,this._dispose=v,this._onDispose=new w.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let d=class{constructor(b){this.logService=b,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],p=Array.from(this._tunnels.values());for(const v of p){const f=Array.from(v.values());for(const u of f){const c=await u.value;c&&b.push(c)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:p}of b.values())await p.then(v=>v?.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,p,v,f,u=!1,c,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${v} on local port ${f}.`),!b)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(b,p,v,f,u,c,s);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==p||i.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const p=this._tunnels.get(b.tunnelRemoteHost);if(p){const v=p.get(b.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,v))}}}}async tryDisposeTunnel(b,p,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${p}.`);const f=v.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(p),f}}async closeTunnel(b,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${p} `);const v=this._tunnels.get(b);if(v&&v.has(p)){const f=v.get(p);f.refcount=0,await this.tryDisposeTunnel(b,p,f)}}addTunnelToMap(b,p,v){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(p,{refcount:1,value:v})}async removeEmptyTunnelFromMap(b,p){const v=this._tunnels.get(b);v&&(await v.get(p)||v.delete(p),v.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,p){const v=[b];I(b)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):C(b)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const f=v.map(u=>this._tunnels.get(u));for(const u of f){const c=u?.get(p);if(c)return c}}canTunnel(b){return!!m(b)}createWithProvider(b,p,v,f,u,c,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${v} on local port ${f}.`);const r=v;this._factoryInProgress.add(r);const n={elevationRequired:u?S(f===void 0?v:f):!1},o={remoteAddress:{host:p,port:v},localAddressPort:f,privacy:c,public:c?c!==y.Private:void 0,protocol:s},a=b.forwardPort(o,n);return a?(this.addTunnelToMap(p,v,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),a}};d=ve([J(0,R.ILogService)],d),e.AbstractTunnelService=d}),define(Z[232],ee([0,1,77,92,217,8,2,19,6,20,216,112,87]),function(q,e,w,t,k,R,D,y,h,m,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(v,f,u,c,s){let r;for(let i=3;i&&(r?.dispose(),r=await new d(v,f,u,c,s).waitForReady(),!(s&&t.BROWSER_RESTRICTED_PORTS[s]||!t.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));i--);return r}class d extends D.Disposable{constructor(f,u,c,s,r){super();this.defaultTunnelHost=u,this.suggestedLocalPort=r,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=w.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let f=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(f){f.pause();const u=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,I.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),s=c.getSocket().socket,r=c.readEntireBuffer();c.dispose(),r.byteLength>0&&f.write(r.buffer),f.on("end",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),s.end()}),f.on("close",()=>s.end()),f.on("error",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),s.destroy()}),s.on("end",()=>f.end()),s.on("close",()=>f.end()),s.on("error",()=>{f.destroy()}),f.pipe(s),s.pipe(f),f.localAddress&&this._socketsDispose.set(f.localAddress,()=>{f.end(),s.end()})}}let E=class extends C.AbstractTunnelService{constructor(f,u,c,s,r){super(u);this.socketFactory=f,this.signService=c,this.productService=s,this.configurationService=r}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,u,c,s,r,i,n){const o=this.getTunnelFromMap(u,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,s,r,i,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${s}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},l=g(a,this.defaultTunnelHost,u,c,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,l),l}}};E=ve([J(1,h.ILogService),J(2,S.ISignService),J(3,m.IProductService),J(4,y.IConfigurationService)],E),e.BaseTunnelService=E;let b=class extends E{constructor(f,u,c,s){super(k.nodeSocketFactory,f,u,c,s)}};b=ve([J(0,h.ILogService),J(1,S.ISignService),J(2,m.IProductService),J(3,y.IConfigurationService)],b),e.TunnelService=b;let p=class extends D.Disposable{constructor(f,u,c,s){super();this.logService=f,this.productService=u,this.signService=c,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(f,u,c,s,r,i,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${r}.`),!this._tunnelServices.has(f)){const a=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(f,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(u,c,s,r,i,n,o)}};p=ve([J(0,h.ILogService),J(1,m.IProductService),J(2,S.ISignService),J(3,y.IConfigurationService)],p),e.SharedTunnelsService=p}),define(Z[46],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(Z[233],ee([0,1,4,169,62,45]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[234],ee([0,1,3,46]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(y){this.service=y}listen(y,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(y,h,m){switch(h){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(m)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=k;class R{constructor(y){this.channel=y,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(y){this._state=y,this._onStateChange.fire(y)}checkForUpdates(y){return this.channel.call("checkForUpdates",y)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(y){return this.channel.call("_applySpecificUpdate",y)}}e.UpdateChannelClient=R}),define(Z[88],ee([0,1,8,21,3,19,25,22,6,20,54,46]),function(q,e,w,t,k,R,D,y,h,m,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(d,E,b){return`${b.updateUrl}/api/update/${d}/${E}/${b.commit}`}e.createUpdateURL=S;let g=class{constructor(E,b,p,v,f,u){this.lifecycleMainService=E,this.configurationService=b,this.environmentMainService=p,this.requestService=v,this.logService=f,this.productService=u,this._state=C.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(E){this.logService.info("update#setState",E.type),this._state=E,this._onStateChange.fire(E)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const E=this.getUpdateMode(),b=this.getProductQuality(E);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(C.State.Idle(this.getUpdateType())),E==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}E==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(E){return E==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(E=60*60*1e3){return(0,w.timeout)(E).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(E){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(E)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(E){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(E=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${E}`),!E&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(E){}getUpdateType(){return 1}doQuitAndInstall(){}};g=ve([J(0,y.ILifecycleMainService),J(1,R.IConfigurationService),J(2,D.IEnvironmentMainService),J(3,I.IRequestService),J(4,h.ILogService),J(5,m.IProductService)],g),e.AbstractUpdateService=g}),define(Z[235],ee([0,1,15,52,3,2,19,25,22,6,20,54,37,46,88]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let E=class extends d.AbstractUpdateService{constructor(p,v,f,u,c,s,r){super(p,v,u,c,s,r);this.telemetryService=f,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"error",(p,v)=>v)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(p,v,f)=>({url:v,version:f,productVersion:f}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(p,v,f,u)=>({releaseNotes:v,version:f,productVersion:f,date:u}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const f=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(g.State.Idle(1,f))}buildUpdateFeedUrl(p){let v;this.productService.darwinUniversalAssetId?v=this.productService.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,d.createUpdateURL)(v,p,this.productService);try{w.autoUpdater.setFeedURL({url:f})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return f}doCheckForUpdates(p){this.setState(g.State.CheckingForUpdates(p)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(g.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(g.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(g.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],E.prototype,"onRawError",null),ve([t.memoize],E.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],E.prototype,"onRawUpdateAvailable",null),ve([t.memoize],E.prototype,"onRawUpdateDownloaded",null),E=ve([J(0,h.ILifecycleMainService),J(1,D.IConfigurationService),J(2,S.ITelemetryService),J(3,y.IEnvironmentMainService),J(4,C.IRequestService),J(5,m.ILogService),J(6,I.IProductService)],E),e.DarwinUpdateService=E}),define(Z[236],ee([0,1,50,29,8,3,9,25,22,6,37,46]),function(q,e,w,t,k,R,D,y,h,m,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(E,b,p){if(this.lifecycleMainService=E,this.logService=p,this._state=C.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(C.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}get state(){return this._state}setState(E){this.logService.info("update#setState",E.type),this._state=E,this._onStateChange.fire(E)}scheduleCheckForUpdates(E=60*60*1e3){return(0,k.timeout)(E).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(E){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(E)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(E){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(E=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${E}`),!E&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(E){}};S=ve([J(0,h.ILifecycleMainService),J(1,y.IEnvironmentMainService),J(2,m.ILogService)],S);let g=class extends S{constructor(E,b,p,v,f,u){super(p,v,f);this.snap=E,this.snapRevision=b,this.telemetryService=u;const c=(0,t.watch)(D.dirname(this.snap)),s=R.Event.fromNodeEventEmitter(c,"change",(o,a)=>a),r=R.Event.filter(s,o=>o==="current"),n=R.Event.debounce(r,(o,a)=>a,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{n.dispose(),c.close()})}doCheckForUpdates(){this.setState(C.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(E=>{E?this.setState(C.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2)))},E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2,E.message||E))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const E=await new Promise((p,v)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(f,u)=>f?v(f):p(u))),b=D.basename(E);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,E=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=ve([J(2,h.ILifecycleMainService),J(3,y.IEnvironmentMainService),J(4,m.ILogService),J(5,I.ITelemetryService)],g),e.SnapUpdateService=g}),define(Z[55],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,w.createDecorator)("IUriIdentityService")}),define(Z[237],ee([0,1,55,188,14,16,127,3,2]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(S){this.uri=S,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let I=class{constructor(S){this._fileService=S,this._dispooables=new h.DisposableStore,this._limit=2**16;const g=new Map,d=E=>{let b=g.get(E.scheme);return b===void 0&&(b=S.hasProvider(E)&&!this._fileService.hasCapability(E,1024),g.set(E.scheme,b)),b};this._dispooables.add(y.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(E=>{g.delete(E.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new D.SkipList((E,b)=>this.extUri.compare(E,b,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,R.normalizePath)(S));const g=this._canonicalUris.get(S);return g?g.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new m(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((d,E)=>d[1].touch<E[1].touch?1:d[1].touch>E[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let d=0;d<g;d++)this._canonicalUris.set(S[d][0],S[d][1].touch())}};I=ve([J(0,k.IFileService)],I),e.UriIdentityService=I,(0,t.registerSingleton)(w.IUriIdentityService,I,!0)}),define(Z[113],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(Z[238],ee([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(y){this.handler=y}listen(y,h){throw new Error(`Event not found: ${h}`)}call(y,h,m){switch(h){case"handleURL":return this.handler.handleURL(w.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=t;class k{constructor(y){this.channel=y}handleURL(y,h){return this.channel.call("handleURL",[y.toJSON(),h])}}e.URLHandlerChannelClient=k;class R{constructor(y){this.next=y}async routeCall(y,h,m,I){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(m){const C=w.URI.revive(m);if(C&&C.query){const S=/\bwindowId=(\d+)/.exec(C.query);if(S){const g=S[1],d=new RegExp(`window:${g}`),E=y.connections.find(b=>d.test(b.ctx));if(E)return E}}}return this.next.routeCall(y,h,m,I)}routeEvent(y,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=R}),define(Z[239],ee([0,1,8,2,7,20]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(m,I){const C=[...this.handlers.values()];return(0,w.first)(C.map(S=>()=>S.handleURL(m,I)),void 0,!1).then(S=>S||!1)}registerHandler(m){return this.handlers.add(m),(0,t.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=D;let y=class extends D{constructor(m){super();this.productService=m}create(m){let{authority:I,path:C,query:S,fragment:g}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return I&&C&&C.indexOf("/")!==0&&(C=`/${C}`),k.URI.from({scheme:this.productService.urlProtocol,authority:I,path:C,query:S,fragment:g})}};y=ve([J(0,R.IProductService)],y),e.NativeURLService=y}),define(Z[240],ee([0,1,15,8,3,2,4,7]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(I){try{return y.URI.parse(I)}catch{return null}}class m{constructor(C,S,g,d,E){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=C,D.isWindows){const v=d.isBuilt?[]:[`"${d.appRoot}"`];v.push("--open-url","--"),w.app.setAsDefaultProtocolClient(E.urlProtocol,process.execPath,v)}const b=k.Event.map(k.Event.fromNodeEventEmitter(w.app,"open-url",(v,f)=>({event:v,url:f})),({event:v,url:f})=>(v.preventDefault(),f));this.disposables.add(b(v=>{const f=h(v);!f||this.urlService.open(f,{originalUrl:v})})),g.getWindows().filter(v=>v.isReady).length>0?this.flush():k.Event.once(g.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const C=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||C.push(S);C.length!==0&&(this.uris=C,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(Z[241],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(Z[242],ee([0,1,15,2,13,7]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(k.Schemas.vscodeWebview,h)}handleWebviewRequest(h,m){try{const I=R.URI.parse(h.url),C=D.validWebviewFilePaths.get(I.path);if(typeof C=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${C}`,g=k.FileAccess.asFileUri(S,q);return m(decodeURIComponent(g.fsPath))}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(Z[74],ee([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(I){return!!I.workspaceUri}e.isWorkspaceToOpen=t;function k(I){return!!I.folderUri}e.isFolderToOpen=k;function R(I){return!!I.fileUri}e.isFileToOpen=R;function D(I){const C=y(I),S=I.getValue("window.menuBarVisibility");return S==="default"||C==="native"&&S==="compact"||w.isMacintosh&&w.isNative?"classic":S}e.getMenuBarVisibility=D;function y(I){if(w.isWeb)return"custom";const C=I.getValue("window");if(C){if(w.isMacintosh&&C.nativeTabs===!0||w.isMacintosh&&C.nativeFullScreen===!1)return"native";const d=C.titleBarStyle;if(d==="native"||d==="custom")return d}return w.isLinux?"native":"custom"}e.getTitleBarStyle=y;function h(I,C){if(!w.isWindows||w.isWeb||!C.isBuilt||y(I)==="native")return!1;const S=I.getValue("window.experimental.windowControlsOverlay.enabled");return typeof S=="boolean"?S:!0}e.useWindowControlsOverlay=h;function m(I=0){return Math.pow(1.2,I)}e.zoomLevelToZoomFactor=m}),define(Z[114],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var w;(function(y){y[y.INITIAL=1]="INITIAL",y[y.LOAD=2]="LOAD",y[y.RELOAD=3]="RELOAD"})(w=e.LoadReason||(e.LoadReason={}));var t;(function(y){y[y.CLOSE=1]="CLOSE",y[y.QUIT=2]="QUIT",y[y.RELOAD=3]="RELOAD",y[y.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(y=1){return{width:1024,height:768,mode:y}};e.defaultWindowState=k;var R;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(y){y[y.UNRESPONSIVE=1]="UNRESPONSIVE",y[y.CRASHED=2]="CRASHED",y[y.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(Z[33],ee([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,w.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(Z[243],ee([0,1,15,21,3,66,2,28,69,102,6,20,33]),function(q,e,w,t,k,R,D,y,h,m,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(E){E[E.Initial=1]="Initial",E[E.StoredCredentialsUsed=2]="StoredCredentialsUsed",E[E.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let d=class extends D.Disposable{constructor(b,p,v,f,u){super();this.logService=b,this.windowsMainService=p,this.credentialsService=v,this.encryptionMainService=f,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=k.Event.fromNodeEventEmitter(w.app,"login",(p,v,f,u,c)=>({event:p,webContents:v,req:f,authInfo:u,callback:c}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:p,req:v,callback:f}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&v.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(u?.username,u?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(b);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const p=String((0,R.hash)({scheme:b.scheme,host:b.host,port:b.port}));let v,f;try{const r=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(r){const i=JSON.parse(await this.encryptionMainService.decrypt(r));v=i.username,f=i.password}}catch(r){this.logService.error(r)}if(this.state!==g.StoredCredentialsUsed&&typeof v=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:v,password:f};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:b,username:this.sessionCredentials?.username??v,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,y.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=g.LoginDialogShown;const s=await new Promise(r=>{const i=async(n,o,a)=>{if(o===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",i),a){const l={username:a.username,password:a.password};try{if(a.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(P){this.logService.error(P)}r({username:l.username,password:l.password})}else r(void 0)};u.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=s,s}};d=ve([J(0,I.ILogService),J(1,S.IWindowsMainService),J(2,h.ICredentialsMainService),J(3,m.IEncryptionMainService),J(4,C.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[244],ee([0,1,69,6,36,20,33,200]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=class extends y.BaseCredentialsMainService{constructor(I,C,S,g){super(I);this.environmentMainService=C,this.productService=S,this.windowsMainService=g,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new w.InMemoryCredentialsProvider,this._keytarCache;const I=await new Promise((C,S)=>{q(["keytar"],C,S)});return await I.findCredentials("test-keytar-loads"),this._keytarCache=I,this._keytarCache}};h=ve([J(0,t.ILogService),J(1,k.INativeEnvironmentService),J(2,R.IProductService),J(3,D.IWindowsMainService)],h),e.CredentialsNativeMainService=h}),define(Z[245],ee([0,1,18,2,3,6,22,79,50,273,8,13,49,4,34,15,33]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=E.UtilityProcess,v=typeof p!="undefined";let f=class At{constructor(r,i,n){this._logService=r,this._windowsMainService=n,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(o=>{this._shutdown=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(r){const i=this._extHosts.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this._getExtHost(r).onStdout}onDynamicStderr(r){return this._getExtHost(r).onStderr}onDynamicMessage(r){return this._getExtHost(r).onMessage}onDynamicError(r){return this._getExtHost(r).onError}onDynamicExit(r){return this._getExtHost(r).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(r){if(this._shutdown)throw(0,w.canceled)();const i=String(++At._lastId);let n;if(r){if(!v)throw new Error("Cannot use UtilityProcess!");n=new c(i,this._logService,this._windowsMainService)}else n=new u(i,this._logService);return this._extHosts.set(i,n),n.onExit(({pid:o,code:a,signal:l})=>{this._logService.info(`Extension host with pid ${o} exited with code: ${a}, signal: ${l}.`),setTimeout(()=>{n.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(r,i){if(this._shutdown)throw(0,w.canceled)();return this._getExtHost(r).start(i)}async enableInspectPort(r){if(this._shutdown)throw(0,w.canceled)();const i=this._extHosts.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this._shutdown)throw(0,w.canceled)();const i=this._extHosts.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this._extHosts)r.kill()}async _waitForAllExit(r){const i=[];for(const[,n]of this._extHosts)i.push(n.waitForExit(r));return I.Promises.settled(i).then(()=>{})}};f._lastId=0,f=ve([J(0,R.ILogService),J(1,D.ILifecycleMainService),J(2,b.IWindowsMainService)],f),e.ExtensionHostStarter=f;let u=class extends t.Disposable{constructor(r,i){super();this.id=r,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){g.isCI&&this._logService.info("Calling fork to start extension host...");const i=y.StopWatch.create(!1);this._process=(0,h.fork)(C.FileAccess.asFileUri("bootstrap-fork",q).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,S.mixin)({cwd:(0,d.cwd)()},r));const n=i.elapsed(),o=this._process.pid;this._logService.info(`Starting extension host with pid ${o} (fork() took ${n} ms).`);const a=new m.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const M=typeof P=="string"?P:a.write(P);this._onStdout.fire(M)});const l=new m.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const M=typeof P=="string"?P:l.write(P);this._onStderr.fire(M)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,w.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,M)=>{this._hasExited=!0,this._onExit.fire({pid:o,code:P,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(r)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this._process.kill())}};u=ve([J(1,R.ILogService)],u);let c=class extends t.Disposable{constructor(r,i,n){super();this.id=r,this._logService=i,this._windowsMainService=n,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){const i=this._windowsMainService.getWindowById(r.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const n=i.win;if(!n||n.isDestroyed()||n.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=`extensionHost${this.id}`,a=C.FileAccess.asFileUri("bootstrap-fork.js",q).fsPath,l=["--type=extensionHost","--skipWorkspaceStorageLock"],P=r.execArgv||[],M={...r.env};for(const re of Object.keys(M))M[re]=String(M[re]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new p(a,l,{serviceName:o,env:M,execArgv:P}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const T=k.Event.fromNodeEventEmitter(this._process,"exit",(re,le)=>le);this._register(T(re=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:re,signal:""})}));const O=(re,le)=>{le.type==="Utility"&&le.name===o&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${le.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:le.exitCode,signal:""}))};E.app.on("child-process-gone",O),this._register((0,t.toDisposable)(()=>{E.app.off("child-process-gone",O)}));const{port1:U,port2:Q}=new E.MessageChannelMain;this._process.postMessage("port",null,[Q]),n.webContents.postMessage(r.responseChannel,r.responseNonce,[U])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(r)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this._process.kill())}};c=ve([J(1,R.ILogService),J(2,b.IWindowsMainService)],c)}),define(Z[246],ee([0,1,15,3,2,242,33]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let y=class extends k.Disposable{constructor(m){super();this.windowsMainService=m,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,I){let C;if(typeof m.windowId=="number"){const{windowId:S}=m,g=this.windowsMainService.getWindowById(S);if(!g?.win)throw new Error(`Invalid windowId: ${S}`);C=g.win.webContents}else{const{webContentsId:S}=m;if(C=w.webContents.fromId(S),!C)throw new Error(`Invalid webContentsId: ${S}`)}C.isDestroyed()||C.setIgnoreMenuShortcuts(I)}async findInFrame(m,I,C,S){const d=this.getFrameByName(m,I);if(typeof d.findInFrame=="function"){d.findInFrame(C,{findNext:S.findNext,forward:S.forward});const E=(b,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),d.removeListener("found-in-frame",E))};d.on("found-in-frame",E)}}async stopFindInFrame(m,I,C){const g=this.getFrameByName(m,I);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(C.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,I){const C=this.windowsMainService.getWindowById(m.windowId);if(!C?.win)throw new Error(`Invalid windowId: ${m}`);const S=C.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===I);if(!S)throw new Error(`Unknown frame: ${I}`);return S}};y=ve([J(0,D.IWindowsMainService)],y),e.WebviewMainService=y}),define(Z[247],ee([0,1,8,3,2]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:y,onDidFocusWindow:h,getActiveWindowId:m}){super();this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(y,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>m()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(y){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=y}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[26],ee([0,1,173,9,32,16,7,5,13]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function m(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=m;function I(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=I;function C(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=C;function S(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=S;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=d;function E(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=E;class b{constructor(n,o,a,l,P){this._id=n,this._transient=a,this._configuration=l,this._ignorePathCasing=P,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class p{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function v(i){return new p({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(i,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=c;function s(i,n){return!u(i,n)&&!c(i)}e.isSavedWorkspace=s;function r(i){return(typeof i=="string"?(0,t.extname)(i):(0,R.extname)(i))===f}e.hasWorkspaceFileExtension=r}),define(Z[248],ee([0,1,76,29,31,13,9,4,16,7,23,177,19,25,14,6,176,26]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(u,c,s){this.configurationService=c,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,i)=>(0,k.isEqual)(r,i,!y.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await I.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(r=>({workspace:{id:r.id,configPath:m.URI.parse(r.configURIPath)},remoteAuthority:r.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let s=[];try{Array.isArray(u.folderWorkspaceInfos)?s=u.folderWorkspaceInfos.map(r=>({folderUri:m.URI.parse(r.folderUri),remoteAuthority:r.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(s=u.folderURIWorkspaces.map(r=>({folderUri:m.URI.parse(r),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(r=>u.workspace.id===r.workspace.id)||(this.workspaces.push(u),this.saveSync());const s=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(s,c),s}moveBackupFolderSync(u,c){if(t.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),t.existsSync(c))try{t.renameSync(c,u)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,s=this.workspaces.findIndex(r=>r.workspace.id===c);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(s=>this.backupUriComparer.isEqual(u,s.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const s=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:c}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,D.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,s=[];for(const r of u){const i=r.workspace;if(!(0,p.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const n=this.getBackupPath(i.id);await this.doHasBackups(n)?i.configPath.scheme!==R.Schemas.file||await I.Promises.exists(i.configPath.fsPath)?s.push(r):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return s}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],s=new Set;for(const r of u){const i=r.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!s.has(n)){s.add(n);const o=this.getBackupPath(this.getFolderHash(r));await this.doHasBackups(o)?i.scheme!==R.Schemas.file||await I.Promises.exists(i.fsPath)?c.push(r):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],s=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!s.has(i)){s.add(i);const n=this.getBackupPath(i);await this.doHasBackups(n)?c.push(r):await this.deleteStaleBackup(n)}}return c}async deleteStaleBackup(u){try{await I.Promises.exists(u)&&await I.Promises.rm(u,I.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const s=this.getBackupPath(c);try{await I.Promises.rename(u,s)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const s=this.getBackupPath(c);try{t.renameSync(u,s)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,C.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,b.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await I.Promises.readdir(u);for(const s of c)try{if((await I.Promises.readdir((0,D.join)(u,s))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,I.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await I.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let s;return c.scheme===R.Schemas.file?s=y.isLinux?c.fsPath:c.fsPath.toLowerCase():s=c.toString().toLowerCase(),(0,w.createHash)("md5").update(s).digest("hex")}};v=ve([J(0,g.IEnvironmentMainService),J(1,S.IConfigurationService),J(2,E.ILogService)],v),e.BackupMainService=v}),define(Z[56],ee([0,1,15,8,66,35,2,80,4,12,23,151,5,6,26]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let E=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,v){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,C.localize)(0,null)},v)}pickFolder(p,v){return this.doPick({...p,pickFolders:!0,title:(0,C.localize)(1,null)},v)}pickFile(p,v){return this.doPick({...p,pickFiles:!0,title:(0,C.localize)(2,null)},v)}pickWorkspace(p,v){const f=(0,C.localize)(3,null),u=(0,R.mnemonicButtonLabel)((0,C.localize)(4,null)),c=d.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:f,filters:c,buttonLabel:u},v)}async doPick(p,v){const f={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(f.properties=void 0,p.pickFiles&&p.pickFolders&&(f.properties=["multiSelections","openDirectory","openFile","createDirectory"])),f.properties||(f.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&f.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(f,(0,m.withNullAsUndefined)(v||w.BrowserWindow.getFocusedWindow()));if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}getWindowDialogQueue(p){if(p){let v=this.windowDialogQueues.get(p.id);return v||(v=new t.Queue,this.windowDialogQueues.set(p.id,v)),v}else return this.noWindowDialogueQueue}showMessageBox(p,v){return this.getWindowDialogQueue(v).queue(async()=>v?w.dialog.showMessageBox(v,p):w.dialog.showMessageBox(p))}async showSaveDialog(p,v){const f=this.acquireFileDialogLock(p,v);if(!f)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(v).queue(async()=>{let u;return v?u=await w.dialog.showSaveDialog(v,p):u=await w.dialog.showSaveDialog(p),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,D.dispose)(f)}}normalizePath(p){return p&&h.isMacintosh&&(p=(0,y.normalizeNFC)(p)),p}normalizePaths(p){return p.map(v=>this.normalizePath(v))}async showOpenDialog(p,v){p.defaultPath&&(await I.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const f=this.acquireFileDialogLock(p,v);if(!f)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(v).queue(async()=>{let u;return v?u=await w.dialog.showOpenDialog(v,p):u=await w.dialog.showOpenDialog(p),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,D.dispose)(f)}}acquireFileDialogLock(p,v){if(!v)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let f=this.windowFileDialogLocks.get(v.id);f||(f=new Set,this.windowFileDialogLocks.set(v.id,f));const u=(0,k.hash)(p);if(!f.has(u))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),f.add(u),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),f?.delete(u),f?.size===0&&this.windowFileDialogLocks.delete(v.id)})}};E=ve([J(0,g.ILogService)],E),e.DialogMainService=E}),define(Z[249],ee([0,1,3,2,67,26]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(h,m){super();this.logService=h,this.storageMainService=m,this.onDidChangeApplicationStorageEmitter=this._register(new w.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(m.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,m){this._register(w.Event.debounce(h.onDidChangeStorage,(I,C)=>(I?I.push(C):I=[C],I),D.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&m.fire(this.serializeStorageChangeEvents(I,h))}))}serializeStorageChangeEvents(h,m){const I=new Map,C=new Set;return h.forEach(S=>{const g=m.get(S.key);typeof g=="string"?I.set(S.key,g):C.add(S.key)}),{changed:Array.from(I.entries()),deleted:Array.from(C.values())}}listen(h,m,I){switch(m){case"onDidChangeStorage":{const C=I.profile?(0,k.revive)(I.profile):void 0;if(!C)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(C.id);return S||(S=this._register(new w.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(C),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(C.id,S)),S.event}}throw new Error(`Event not found: ${m}`)}async call(h,m,I){const C=I.profile?(0,k.revive)(I.profile):void 0,S=(0,R.reviveIdentifier)(I.workspace),g=await this.withStorageInitialized(C,S);switch(m){case"getItems":return Array.from(g.items.entries());case"updateItems":{const d=I;if(d.insert)for(const[E,b]of d.insert)g.set(E,b);d.delete?.forEach(E=>g.delete(E));break}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(h,m){let I;m?I=this.storageMainService.workspaceStorage(m):h?I=this.storageMainService.profileStorage(h):I=this.storageMainService.applicationStorage;try{await I.init()}catch(C){this.logService.error(`StorageIPC#init: Unable to init ${m?"workspace":h?"profile":"application"} storage due to ${C}`)}return I}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[38],ee([0,1,66,3,2,16,12,7,170,36,14,5,6,26,32,55,8,28]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function v(s){const r=s;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&y.URI.isUri(r.location)&&y.URI.isUri(r.globalStorageHome)&&y.URI.isUri(r.settingsResource)&&y.URI.isUri(r.keybindingsResource)&&y.URI.isUri(r.tasksResource)&&y.URI.isUri(r.snippetsHome)&&((0,D.isUndefined)(r.extensionsResource)||y.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=v,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function f(s,r){return{id:s.id,isDefault:s.isDefault,name:s.name,location:y.URI.revive(s.location).with({scheme:r}),globalStorageHome:y.URI.revive(s.globalStorageHome).with({scheme:r}),settingsResource:y.URI.revive(s.settingsResource).with({scheme:r}),keybindingsResource:y.URI.revive(s.keybindingsResource).with({scheme:r}),tasksResource:y.URI.revive(s.tasksResource).with({scheme:r}),snippetsHome:y.URI.revive(s.snippetsHome).with({scheme:r}),extensionsResource:y.URI.revive(s.extensionsResource)?.with({scheme:r})}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function u(s,r,i){return{id:(0,w.hash)(r.path).toString(16),name:s,location:r,isDefault:!1,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:i}}e.toUserDataProfile=u;let c=class extends k.Disposable{constructor(r,i,n,o){super();this.environmentService=r,this.fileService=i,this.uriIdentityService=n,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(a=>u(a.name,a.location,a.useDefaultFlags)):[];let i;const n=new d.ResourceMap,o=u((0,h.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0?o.extensionsResource:void 0}),r.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[l,P]of Object.entries(a.workspaces)){const M=y.URI.parse(l),T=y.URI.parse(P),O=r.find(U=>this.uriIdentityService.extUri.isEqual(U.location,T));O&&n.set(M,O)}if(a.emptyWindow){const l=y.URI.parse(a.emptyWindow);i=r.find(P=>this.uriIdentityService.extUri.isEqual(P.location,l))}}this._profilesObject={profiles:r,workspaces:n,emptyWindow:i}}return this._profilesObject}getProfile(r,i){if(!this.enabled)return this.defaultProfile;const n=this.getWorkspace(r);let o=y.URI.isUri(n)?this.profilesObject.workspaces.get(n):this.profilesObject.emptyWindow;return o||(o=i,this.profiles.length>1&&this.updateWorkspaceAssociation(r,o)),o}getWorkspace(r){return(0,g.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,g.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}async createProfile(r,i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=await this.doCreateProfile(r,i);return n&&await this.setProfileForWorkspace(o,n),o}async doCreateProfile(r,i){let n=this.profileCreationPromises.get(r);return n||(n=(async()=>{try{const o=this.profiles.find(P=>P.name===r);if(o)return o;const a=u(r,(0,R.joinPath)(this.profilesHome,(0,w.hash)((0,p.generateUuid)()).toString(16)),i);await this.fileService.createFolder(a.location);const l=[];return this._onWillCreateProfile.fire({profile:a,join(P){l.push(P)}}),await b.Promises.settled(l),this.updateProfiles([a],[],[]),a}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,n)),n}async updateProfile(r,i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);return o=u(i,o.location,n),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(r,i){this.setProfileForWorkspaceSync(r,i)}setProfileForWorkspaceSync(r,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const n=this.profiles.find(o=>o.id===r.id);if(!n)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,n)}async unsetWorkspace(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r)}async resetWorkspaces(){this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(o=>o.id===r.id);if(!i)throw new Error(`Profile '${r.name}' does not exist`);const n=[];this._onWillRemoveProfile.fire({profile:i,join(o){n.push(o)}}),await b.Promises.settled(n),i.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])i.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[i],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(i.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(r,i,n){const o=[];for(let a of[...this.profilesObject.profiles,...r])a.isDefault||i.some(l=>a.id===l.id)||(a=n.find(l=>a.id===l.id)??a,o.push({location:a.location,name:a.name,useDefaultFlags:a.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(r,i,n)}triggerProfilesChanges(r,i,n){this._onDidChangeProfiles.fire({added:r,removed:i,updated:n,all:this.profiles})}updateWorkspaceAssociation(r,i){const n=this.getWorkspace(r);y.URI.isUri(n)?(this.profilesObject.workspaces.delete(n),i&&this.profilesObject.workspaces.set(n,i)):this.profilesObject.emptyWindow=i,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[n,o]of this.profilesObject.workspaces.entries())r[n.toString()]=o.location.toString();const i=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:i}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};c.PROFILES_KEY="userDataProfiles",c.PROFILE_ASSOCIATIONS_KEY="profileAssociations",c=ve([J(0,m.IEnvironmentService),J(1,I.IFileService),J(2,E.IUriIdentityService),J(3,S.ILogService)],c),e.UserDataProfilesService=c}),define(Z[89],ee([0,1,24,8,49,17,18,42,137,2,13,9,4,16,186,94,12,7,155,36,109,108,185,14,5,6,20,3,67,72,38,55]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c,s,r,i,n,o,a,l,P,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var O;(function(ue){function K(N,_){if(N===_)return!0;const A=Object.keys(N),W=new Set;for(const $ of Object.keys(_))W.add($);if(A.length!==W.size)return!1;for(const $ of A){if(N[$]!==_[$])return!1;W.delete($)}return W.size===0}ue.equals=K})(O=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let U=class extends m.Disposable{constructor(K,N,_,A,W,$,Y,z,j,L,F){super();this.systemExtensionsLocation=K,this.userExtensionsLocation=N,this.extensionsControlLocation=_,this.cacheLocation=A,this.userDataProfilesService=W,this.extensionsProfileScannerService=$,this.fileService=Y,this.logService=z,this.environmentService=j,this.productService=L,this.instantiationService=F,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(le,(0,g.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(le,(0,g.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,N){const[_,A]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(N)]),W=await this.scanExtensionsUnderDevelopment(K,[..._,...A]);return this.dedupExtensions(_,A,W,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const N=[];N.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),N.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[_,A]=await Promise.all(N);return this.applyScanOptions([..._,...A],0,K,!1)}async scanUserExtensions(K){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(K.profileLocation??this.userExtensionsLocation,!!K.profileLocation,1,!K.includeUninstalled,K.language);let A=await(K.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return A=await this.applyScanOptions(A,1,K,!0),this.logService.trace("Scanned user extensions:",A.length),A}async scanExtensionsUnderDevelopment(K,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const _=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(A=>A.scheme===I.Schemas.file).map(async A=>{const W=await this.createExtensionScannerInput(A,!1,1,!0,K.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=N.find(z=>(0,u.areSameExtensions)(z.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,W)))}))).flat();return this.applyScanOptions(_,"development",K,!0)}return[]}async scanExistingExtension(K,N,_){const A=await this.createExtensionScannerInput(K,!1,N,!0,_.language),W=await this.extensionsScanner.scanExtension(A);return!W||!_.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(K,N,_){const A=await this.createExtensionScannerInput(K,!1,N,!0,_.language),W=await this.extensionsScanner.scanOneOrMultipleExtensions(A);return this.applyScanOptions(W,N,_,!0)}async scanMetadata(K){const N=(0,g.joinPath)(K,"package.json"),_=(await this.fileService.readFile(N)).value.toString();return JSON.parse(_).__metadata}async updateMetadata(K,N){const _=(0,g.joinPath)(K,"package.json"),A=(await this.fileService.readFile(_)).value.toString(),W=JSON.parse(A);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,W.__metadata={...W.__metadata,...N},await this.fileService.writeFile((0,g.joinPath)(K,"package.json"),R.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async applyScanOptions(K,N,_,A){return _.includeAllVersions||(K=this.dedupExtensions(N===0?K:void 0,N===1?K:void 0,N==="development"?K:void 0,await this.getTargetPlatform(),A)),_.includeInvalid||(K=K.filter(W=>W.isValid)),K.sort((W,$)=>{const Y=C.basename(W.location.fsPath),z=C.basename($.location.fsPath);return Y<z?-1:Y>z?1:0})}dedupExtensions(K,N,_,A,W){const $=(z,j,L)=>{if(z.isValid&&!j.isValid)return!1;if(z.isValid===j.isValid){if(W&&d.gt(z.manifest.version,j.manifest.version))return this.logService.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version} in favour of ${z.location.path} with version ${z.manifest.version}`),!1;if(d.eq(z.manifest.version,j.manifest.version)){if(z.type===0)return this.logService.debug(`Skipping extension ${j.location.path} in favour of system extension ${z.location.path} with same version`),!1;if(z.targetPlatform===A)return this.logService.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`),!1}}return L?this.logService.warn(`Overwriting user extension ${z.location.path} with ${j.location.path}.`):this.logService.debug(`Overwriting user extension ${z.location.path} with ${j.location.path}.`),!0},Y=new Map;return K?.forEach(z=>{const j=c.ExtensionIdentifier.toKey(z.identifier.id),L=Y.get(j);(!L||$(L,z,!1))&&Y.set(j,z)}),N?.forEach(z=>{const j=c.ExtensionIdentifier.toKey(z.identifier.id),L=Y.get(j);if(!L&&K&&z.type===0){this.logService.debug(`Skipping obsolete system extension ${z.location.path}.`);return}(!L||$(L,z,!1))&&Y.set(j,z)}),_?.forEach(z=>{const j=c.ExtensionIdentifier.toKey(z.identifier.id),L=Y.get(j);(!L||$(L,z,!0))&&Y.set(j,z),Y.set(j,z)}),[...Y.values()]}async scanDefaultSystemExtensions(K,N){this.logService.trace("Started scanning system extensions");const _=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),W=await(K&&!_.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(_);return this.logService.trace("Scanned system extensions:",W.length),W}async scanDevSystemExtensions(K,N){const _=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!_?.length)return[];this.logService.trace("Started scanning dev system extensions");const A=N?await this.getBuiltInExtensionControl():{},W=[],$=p.URI.file(C.normalize(C.join(I.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions")));for(const z of _){const j=A[z.name]||"marketplace";switch(j){case"disabled":break;case"marketplace":W.push((0,g.joinPath)($,z.name));break;default:W.push(p.URI.file(j));break}}const Y=await Promise.all(W.map(async z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(z,!1,0,!0,K))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,w.coalesce)(Y)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,N,_,A,W,$=!0){const Y=await this.getTranslations(W??S.language),z=await this.getMtime(K),j=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,L=j?await this.getMtime(j):void 0;return new Q(K,z,j,L,N,_,A,$,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,W,Y)}async getMtime(K){try{const N=await this.fileService.stat(K);if(typeof N.mtime=="number")return N.mtime}catch{}}};U=ve([J(4,M.IUserDataProfilesService),J(5,P.IExtensionsProfileScannerService),J(6,r.IFileService),J(7,n.ILogService),J(8,f.IEnvironmentService),J(9,o.IProductService),J(10,i.IInstantiationService)],U),e.AbstractExtensionsScannerService=U;class Q{constructor(K,N,_,A,W,$,Y,z,j,L,F,B,V,x){this.location=K,this.mtime=N,this.applicationExtensionslocation=_,this.applicationExtensionslocationMtime=A,this.profile=W,this.type=$,this.excludeObsolete=Y,this.validate=z,this.productVersion=j,this.productDate=L,this.productCommit=F,this.devMode=B,this.language=V,this.translations=x}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,N){return(0,g.isEqual)(K.location,N.location)&&K.mtime===N.mtime&&(0,g.isEqual)(K.applicationExtensionslocation,N.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&K.profile===N.profile&&K.type===N.type&&K.excludeObsolete===N.excludeObsolete&&K.validate===N.validate&&K.productVersion===N.productVersion&&K.productDate===N.productDate&&K.productCommit===N.productCommit&&K.devMode===N.devMode&&K.language===N.language&&O.equals(K.translations,N.translations)}}let re=class extends m.Disposable{constructor(K,N,_,A,W){super();this.obsoleteFile=K,this.extensionsProfileScannerService=N,this.uriIdentityService=_,this.fileService=A,this.logService=W}async scanExtensions(K){const N=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let _={};if(K.excludeObsolete&&K.type===1)try{const A=(await this.fileService.readFile(this.obsoleteFile)).value.toString();_=JSON.parse(A)}catch{}return(0,b.isEmptyObject)(_)?N:N.filter(A=>!_[u.ExtensionKey.create(A).toString()])}async scanExtensionsFromLocation(K){const N=await this.fileService.resolve(K.location);if(!N.children?.length)return[];const _=await Promise.all(N.children.map(async A=>{if(!A.isDirectory||K.type===1&&(0,g.basename)(A.resource).indexOf(".")===0)return null;const W=new Q(A.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(W)}));return(0,w.coalesce)(_).sort((A,W)=>A.location.path<W.location.path?-1:1)}async scanExtensionsFromProfile(K){let N=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){N=N.filter(A=>!A.metadata?.isApplicationScoped);const _=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,A=>!!A.metadata?.isApplicationScoped,K);N.push(..._)}return N}async scanExtensionsFromProfileResource(K,N,_){const A=await this.extensionsProfileScannerService.scanProfileExtensions(K);if(!A.length)return[];const W=await Promise.all(A.map(async $=>{if(N($)){const Y=new Q($.location,_.mtime,_.applicationExtensionslocation,_.applicationExtensionslocationMtime,_.profile,_.type,_.excludeObsolete,_.validate,_.productVersion,_.productDate,_.productCommit,_.devMode,_.language,_.translations);return this.scanExtension(Y,$.metadata)}return null}));return(0,w.coalesce)(W)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,g.joinPath)(K.location,"package.json"))){const N=await this.scanExtension(K);return N?[N]:[]}else return await this.scanExtensions(K)}catch(N){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,D.getErrorMessage)(N)),[]}}async scanExtension(K,N){try{let _=await this.scanExtensionManifest(K.location);if(_){_.publisher||(_.publisher=c.UNDEFINED_PUBLISHER),N=N??_.__metadata,delete _.__metadata;const A=(0,u.getGalleryExtensionId)(_.publisher,_.name),W=N?.id?{id:A,uuid:N.id}:{id:A},$=N?.isSystem?0:K.type,Y=$===0||!!N?.isBuiltin;_=await this.translateManifest(K.location,_,Q.createNlsConfiguration(K));const z={type:$,identifier:W,manifest:_,location:K.location,isBuiltin:Y,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return K.validate?this.validate(z,K):z}}catch(_){K.type!==0&&this.logService.error(_)}return null}validate(K,N){let _=!0;const A=(0,s.validateExtensionManifest)(N.productVersion,N.productDate,N.location,K.manifest,K.isBuiltin);for(const[W,$]of A)W===E.default.Error&&(_=!1,this.logService.error(this.formatMessage(N.location,$)));return K.isValid=_,K.validations=A,K}async scanExtensionManifest(K){const N=(0,g.joinPath)(K,"package.json");let _;try{_=(await this.fileService.readFile(N)).value.toString()}catch(W){return(0,r.toFileOperationResult)(W)!==1&&this.logService.error(this.formatMessage(K,(0,v.localize)(0,null,N.path,W.message))),null}let A;try{A=JSON.parse(_)}catch{const $=[];(0,y.parse)(_,$);for(const Y of $)this.logService.error(this.formatMessage(K,(0,v.localize)(1,null,N.path,Y.offset,Y.length,(0,h.getParseErrorMessage)(Y.error))));return null}return(0,y.getNodeType)(A)!=="object"?(this.logService.error(this.formatMessage(K,(0,v.localize)(2,null,N.path))),null):A}async translateManifest(K,N,_){const A=await this.getLocalizedMessages(K,N,_);if(A)try{const W=[],$=await this.resolveOriginalMessageBundle(A.default,W);if(W.length>0)return W.forEach(z=>{this.logService.error(this.formatMessage(K,(0,v.localize)(3,null,A.default?.path,(0,h.getParseErrorMessage)(z.error))))}),N;if((0,y.getNodeType)(A)!=="object")return this.logService.error(this.formatMessage(K,(0,v.localize)(4,null,A.default?.path))),N;const Y=A.values||Object.create(null);this.replaceNLStrings(_.pseudo,N,Y,$,K)}catch{}return N}async getLocalizedMessages(K,N,_){const A=(0,g.joinPath)(K,"package.nls.json"),W=(j,L)=>{L.forEach(F=>{this.logService.error(this.formatMessage(K,(0,v.localize)(5,null,j?.path,(0,h.getParseErrorMessage)(F.error))))})},$=j=>{this.logService.error(this.formatMessage(K,(0,v.localize)(6,null,j?.path)))},Y=`${N.publisher}.${N.name}`,z=_.translations[Y];if(z)try{const j=p.URI.file(z),L=(await this.fileService.readFile(j)).value.toString(),F=[],B=(0,y.parse)(L,F);return F.length>0?(W(j,F),{values:void 0,default:A}):(0,y.getNodeType)(B)!=="object"?($(j),{values:void 0,default:A}):{values:B.contents?B.contents.package:void 0,default:A}}catch{return{values:void 0,default:A}}else{if(!await this.fileService.exists(A))return;let L;try{L=await this.findMessageBundles(K,_)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const F=(await this.fileService.readFile(L.localized)).value.toString(),B=[],V=(0,y.parse)(F,B);return B.length>0?(W(L.localized,B),{values:void 0,default:L.original}):(0,y.getNodeType)(V)!=="object"?($(L.localized),{values:void 0,default:L.original}):{values:V,default:L.original}}catch{return{values:void 0,default:L.original}}}}async resolveOriginalMessageBundle(K,N){if(K)try{const _=(await this.fileService.readFile(K)).value.toString();return(0,y.parse)(_,N)}catch{return null}else return null}findMessageBundles(K,N){return new Promise((_,A)=>{const W=$=>{const Y=(0,g.joinPath)(K,`package.nls.${$}.json`);this.fileService.exists(Y).then(z=>{z&&_({localized:Y,original:(0,g.joinPath)(K,"package.nls.json")});const j=$.lastIndexOf("-");j===-1?_({localized:(0,g.joinPath)(K,"package.nls.json"),original:null}):($=$.substring(0,j),W($))})};if(N.devMode||N.pseudo||!N.language)return _({localized:(0,g.joinPath)(K,"package.nls.json"),original:null});W(N.language)})}replaceNLStrings(K,N,_,A,W){const $=(Y,z,j)=>{const L=Y[z];if((0,b.isString)(L)){const F=L,B=F.length;if(B>1&&F[0]==="%"&&F[B-1]==="%"){const V=F.substr(1,B-2);let x=_[V];x===void 0&&A&&(x=A[V]);let ne=typeof x=="string"?x:x.message;if(ne!==void 0)if(K&&(ne="\uFF3B"+ne.replace(/[aouei]/g,"$&$&")+"\uFF3D"),j&&A&&(z==="title"||z==="category")){const H=A[V],te={value:ne,original:typeof H=="string"?H:H?.message};Y[z]=te}else Y[z]=ne;else this.logService.warn(this.formatMessage(W,(0,v.localize)(7,null,V)))}}else if((0,b.isObject)(L))for(const F in L)L.hasOwnProperty(F)&&(F==="commands"?$(L,F,!0):$(L,F,j));else if(Array.isArray(L))for(let F=0;F<L.length;F++)$(L,F,j)};for(const Y in N)N.hasOwnProperty(Y)&&$(N,Y)}formatMessage(K,N){return`[${K.path}]: ${N}`}};re=ve([J(1,P.IExtensionsProfileScannerService),J(2,T.IUriIdentityService),J(3,r.IFileService),J(4,n.ILogService)],re);let le=class extends re{constructor(K,N,_,A,W,$){super(N,_,A,W,$);this.cacheFile=K,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const N=await this.readExtensionCache();if(this.input=K,N&&N.input&&Q.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(A=>(A.location=p.URI.revive(A.location),A));const _=await super.scanExtensions(K);return await this.writeExtensionCache({input:K,result:_}),_}async readExtensionCache(){try{const K=await this.fileService.readFile(this.cacheFile),N=JSON.parse(K.value.toString());return{result:N.result,input:(0,l.revive)(N.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(K))}return null}async writeExtensionCache(K){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(K)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const K=await this.readExtensionCache();if(!K)return;const N=K.result,_=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(_,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(A){this.logService.error(A)}}};le=ve([J(2,P.IExtensionsProfileScannerService),J(3,T.IUriIdentityService),J(4,r.IFileService),J(5,n.ILogService)],le);function fe(ue,K){const N=(0,u.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:N,identifier:new c.ExtensionIdentifier(N),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:K,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=fe;class se extends U{constructor(K,N,_,A,W,$,Y,z,j,L,F){super(K,N,(0,g.joinPath)(_,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(A,c.MANIFEST_CACHE_FOLDER),W,$,Y,z,j,L,F);this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const B=await this.fileService.readFile(p.URI.file(S.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=se}),define(Z[250],ee([0,1,7,36,72,89,14,5,6,20,38]),function(q,e,w,t,k,R,D,y,h,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let C=class extends R.NativeExtensionsScannerService{constructor(g,d,E,b,p,v,f){super(w.URI.file(p.builtinExtensionsPath),w.URI.file(p.extensionsPath),p.userHome,w.URI.file(p.userDataPath),g,d,E,b,p,v,f)}};C=ve([J(0,I.IUserDataProfilesService),J(1,k.IExtensionsProfileScannerService),J(2,D.IFileService),J(3,h.ILogService),J(4,t.INativeEnvironmentService),J(5,m.IProductService),J(6,y.IInstantiationService)],C),e.ExtensionsScannerService=C}),define(Z[251],ee([0,1,15,40,2,32,13,9,4,7,28,36,6,38]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends k.Disposable{constructor(b,p,v){super();this.logService=v,this.validRoots=R.TernarySearchTree.forPaths(!h.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:b}=w.session;b.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(p,v)=>this.handleResourceRequest(p,v)),b.protocol.interceptFileProtocol(D.Schemas.file,(p,v)=>this.handleFileRequest(p,v)),this._register((0,k.toDisposable)(()=>{b.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(b){const p=(0,y.normalize)(b);return this.validRoots.get(p)?k.Disposable.None:(this.validRoots.set(p,!0),(0,k.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(b,p){const v=m.URI.parse(b.url);return this.logService.error(`Refused to load resource ${v.fsPath} from ${D.Schemas.file}: protocol (original URL: ${b.url})`),p({error:-3})}handleResourceRequest(b,p){const v=this.requestToNormalizedFilePath(b);return this.validRoots.findSubstr(v)?p({path:v}):this.validExtensions.has((0,y.extname)(v).toLowerCase())?p({path:v}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),p({error:-3}))}requestToNormalizedFilePath(b){const p=m.URI.parse(b.url),v=D.FileAccess.asFileUri(p);return(0,y.normalize)(v.fsPath)}createIPCObjectUrl(){let b;const p=m.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),v=p.toString(),f=async()=>b;return t.validatedIpcMain.handle(v,f),this.logService.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:p,update:u=>b=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${v}.`),t.validatedIpcMain.removeHandler(v)}}}};d=ve([J(0,C.INativeEnvironmentService),J(1,g.IUserDataProfilesService),J(2,S.ILogService)],d),e.ProtocolMainService=d}),define(Z[252],ee([0,1,15,40,8,3,2,13,12,99,25,22,6,53,61,64,43,38,39]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends D.Disposable{constructor(c,s,r,i,n,o,a,l,P){super();this.machineId=c,this.userEnv=s,this.environmentMainService=r,this.userDataProfilesService=i,this.lifecycleMainService=n,this.logService=o,this.policyService=a,this.themeMainService=l,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,s)=>this.onWindowConnection(c,s)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,s)=>this.onWorkerConnection(c,s)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,s){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const r=await this.connect();if(c.sender.isDestroyed())return r.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",s,[r])}onWorkerConnection(c,s){this.logService.trace("SharedProcess: onWorkerConnection",s);const r=new D.DisposableStore,i=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,s),r.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",s))},n=w.BrowserWindow.fromId(s.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!s.reply.channel){i("unavailable");return}r.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===n)(()=>i("load"))),r.add(R.Event.fromNodeEventEmitter(n,"closed")(()=>i("closed"))),n.webContents.postMessage(s.reply.channel,s.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...s){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...s)}catch(r){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,b.toErrorMessage)(r)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default,policiesData:this.policyService.serialize()}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,s)=>this._onDidError.fire({type:2,details:s})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,s,r)=>this._onDidError.fire({type:3,details:{reason:r,exitCode:s}})))}async connect(){await this.whenIpcReady;const c=(0,h.assertIsDefined)(this.window);return(0,m.connect)(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};f=ve([J(2,I.IEnvironmentMainService),J(3,p.IUserDataProfilesService),J(4,C.ILifecycleMainService),J(5,S.ILogService),J(6,v.IPolicyService),J(7,E.IThemeMainService),J(8,d.IProtocolMainService)],f),e.SharedProcess=f}),define(Z[115],ee([0,1,8,3,2,71,12,100,5,38]),function(q,e,w,t,k,R,D,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var C;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var g;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(f={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,u){if(u===I){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:u,target:this.getKeyTargets(f)[u]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,u,c){return this.getStorage(u)?.get(f,c)}getBoolean(f,u,c){return this.getStorage(u)?.getBoolean(f,c)}getNumber(f,u,c){return this.getStorage(u)?.getNumber(f,c)}store(f,u,c,s){if((0,D.isUndefinedOrNull)(u)){this.remove(f,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,c,s),this.getStorage(c)?.set(f,u)})}remove(f,u){this.withPausedEmitters(()=>{this.updateKeyTarget(f,u,void 0),this.getStorage(u)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,u){const c=[],s=this.getKeyTargets(f);for(const r of Object.keys(s))s[r]===u&&c.push(r);return c}updateKeyTarget(f,u,c){const s=this.getKeyTargets(u);typeof c=="number"?s[f]!==c&&(s[f]=c,this.getStorage(u)?.set(I,JSON.stringify(s))):typeof s[f]=="number"&&(delete s[f],this.getStorage(u)?.set(I,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const u=this.get(I,f);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=C.NONE){this._onWillSaveState.fire({reason:f});const u=this.getStorage(-1),c=this.getStorage(0),s=this.getStorage(1);switch(f){case C.NONE:await w.Promises.settled([u?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await w.Promises.settled([u?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return p(f,u,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(f,u){return this.emitWillSaveState(C.NONE),(0,m.isUserDataProfile)(f)?this.switchToProfile(f,u):this.switchToWorkspace(f,u)}canSwitchProfile(f,u){return!(f.id===u.id||E(u)&&E(f))}switchData(f,u,c,s){this.withPausedEmitters(()=>{if(s)for(const[r,i]of f)u.set(r,i);else{const r=new Set;for(const[i,n]of f)r.add(i),u.get(i)!==n&&this.emitDidChangeValue(c,i);for(const[i]of u.items)r.has(i)||this.emitDidChangeValue(c,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function E(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class b extends d{constructor(){super();this.applicationStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.profileStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=b;async function p(v,f,u,c,s,r){const i=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,o=new Map;v.forEach((U,Q)=>{n.set(Q,U),o.set(Q,i(U))});const a=new Map,l=new Map;f.forEach((U,Q)=>{a.set(Q,U),l.set(Q,i(U))});const P=new Map,M=new Map;u.forEach((U,Q)=>{P.set(Q,U),M.set(Q,i(U))}),console.group(c!==s?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const T=[];if(n.forEach((U,Q)=>{T.push({key:Q,value:U})}),console.table(T),console.groupEnd(),console.log(o),c!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const U=[];a.forEach((Q,re)=>{U.push({key:re,value:Q})}),console.table(U),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const O=[];P.forEach((U,Q)=>{O.push({key:Q,value:U})}),console.table(O),console.groupEnd(),console.log(M)}e.logStorage=p}),define(Z[253],ee([0,1,24,8,3,2,9,79,7,23,100,148,6,115,37,26]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends R.Disposable{constructor(r,i){super();this.logService=r,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=I.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===I.StorageState.None)try{const r=await this.doCreate();this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(r);const i=r.getBoolean(g.IS_NEW_KEY);i===void 0?r.set(g.IS_NEW_KEY,!0):i&&r.set(g.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=I.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,i){return this._storage.get(r,i)}set(r,i){return this._storage.set(r,i)}delete(r){return this._storage.delete(r)}async close(){const r=new y.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>b.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(!!this.path)try{const i=(0,w.top)(Array.from(this._storage.items.entries()).map(([o,a])=>({key:o,length:a.length})),(o,a)=>a.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=I.StorageState.Closed,await this._storage.close()}}b.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends b{constructor(r,i,n,o){super(n,o);this.profile=r,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,p.STORAGE_NAME)}async doCreate(){return new I.Storage(new C.SQLiteStorageDatabase(this.path??C.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}p.STORAGE_NAME="state.vscdb";class v extends p{constructor(r,i,n,o){super(r,i,n,o)}}e.ProfileStorageMain=v;class f extends p{constructor(r,i,n,o){super(i.defaultProfile,r,n,o)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(d.firstSessionDateStorageKey,void 0)===void 0&&r.set(d.firstSessionDateStorageKey,new Date().toUTCString());const n=r.get(d.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();r.set(d.lastSessionDateStorageKey,typeof n=="undefined"?null:n),r.set(d.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=f;class u extends b{constructor(r,i,n,o,a){super(n,a);this.workspace=r,this.options=i,this.environmentService=o}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,u.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:r,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new C.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:i?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:C.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(r,u.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await m.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let i;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,D.join)(r,u.WORKSPACE_META_NAME);await m.Promises.exists(n)||await m.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=u,u.WORKSPACE_STORAGE_NAME="state.vscdb",u.WORKSPACE_META_NAME="workspace.json";class c extends b{get path(){}async doCreate(){return new I.Storage(new I.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(Z[254],ee([0,1,67,36,14,6,223,55,38]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class Pt extends h.UserDataProfilesService{constructor(C,S,g,d,E){super(g,d,S,E);this.stateService=C}getStoredProfiles(){return(0,w.revive)(this.stateService.getItem(Pt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,w.revive)(this.stateService.getItem(Pt.PROFILE_ASSOCIATIONS_KEY,{}))}};m=ve([J(0,D.IStateService),J(1,y.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,R.ILogService)],m),e.UserDataProfilesService=m}),define(Z[51],ee([0,1,7,36,14,5,6,41,55,38,254]),function(q,e,w,t,k,R,D,y,h,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let C=class bt extends I.UserDataProfilesService{constructor(g,d,E,b,p){super(g,d,E,b,p);this.stateMainService=g}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(g){if(!!this.isEnabled()&&!!g.profile&&!(!g._.length&&!g["folder-uri"]&&!g["file-uri"])&&!this.profiles.some(d=>d.name===g.profile))return this.createProfile(g.profile)}saveStoredProfiles(g){this.stateMainService.setItem(bt.PROFILES_KEY,g)}saveStoredProfileAssociations(g){this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,g)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",d=this.stateMainService.getItem(g,void 0);if(d){this.stateMainService.removeItem(g);const E=d.reduce((b,{workspace:p,profile:v})=>(b[w.URI.revive(p).toString()]=w.URI.revive(v).toString(),b),{});this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}return super.getStoredProfileAssociations()}};C=ve([J(0,y.IStateMainService),J(1,h.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,D.ILogService)],C),e.UserDataProfilesMainService=C}),define(Z[255],ee([0,1,2,16,72,89,14,38,51]),function(q,e,w,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let m=class extends w.Disposable{constructor(C,S,g,d){super();this.userDataProfilesService=C,this.fileService=S,this.extensionsScannerService=g,this.extensionsProfileScannerService=d,this._register(C.onWillCreateProfile(E=>{C.profiles.length===1&&E.join(this.initialize())})),this._register(C.onDidChangeProfiles(E=>{C.profiles.length===1&&this.uninitialize()}))}async initialize(){const C=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(C)}catch{}const S=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(S.map(g=>[g,g.metadata]),C)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,y.EXTENSIONS_RESOURCE_NAME)}};m=ve([J(0,h.IUserDataProfilesMainService),J(1,D.IFileService),J(2,R.IExtensionsScannerService),J(3,k.IExtensionsProfileScannerService)],m),e.DefaultExtensionsProfileInitHandler=m}),define(Z[90],ee([0,1,48,2,36,14,5,22,6,115,253,38,51]),function(q,e,w,t,k,R,D,y,h,m,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let g=class extends t.Disposable{constructor(b,p,v,f,u){super();this.logService=b,this.environmentService=p,this.userDataProfilesService=v,this.lifecycleMainService=f,this.fileService=u,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.applicationStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=b.reason,b.join(this.applicationStorage.close());for(const[,p]of this.mapProfileToStorage)b.join(p.close());for(const[,p]of this.mapWorkspaceToStorage)b.join(p.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(b=>{b.join((async()=>{await this.fileService.exists(b.profile.globalStorageHome)||await this.fileService.createFolder(b.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(b=>{const p=this.mapProfileToStorage.get(b.profile.id);p&&b.join(p.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const b=new I.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,w.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,m.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let p=this.mapProfileToStorage.get(b.id);return p||(this.logService.trace(`StorageMainService: creating profile storage (${b.name})`),p=this.createProfileStorage(b),this.mapProfileToStorage.set(b.id,p),(0,w.once)(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${b.name})`),this.mapProfileToStorage.delete(b.id)})),p}createProfileStorage(b){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.ProfileStorageMain(b,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(b){let p=this.mapWorkspaceToStorage.get(b.id);return p||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),p=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,p),(0,w.once)(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),p}createWorkspaceStorage(b){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};g=ve([J(0,h.ILogService),J(1,k.IEnvironmentService),J(2,S.IUserDataProfilesMainService),J(3,y.ILifecycleMainService),J(4,R.IFileService)],g),e.StorageMainService=g,e.IApplicationStorageMainService=(0,D.createDecorator)("applicationStorageMainService");let d=class extends m.AbstractStorageService{constructor(b,p){super();this.userDataProfilesService=b,this.storageMainService=p,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(b){if(b===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(b){if(b===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};d=ve([J(0,C.IUserDataProfilesService),J(1,e.IStorageMainService)],d),e.ApplicationStorageMainService=d}),define(Z[116],ee([0,1,16,7,26]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(h,m,I){for(const S of h){const g=S.openedWorkspace;if((0,k.isWorkspaceIdentifier)(g)){const d=I(g);if(d){if(d.folders.some(E=>w.extUriBiasedIgnorePathCase.isEqualOrParent(m,E.uri)))return S}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.configPath))return S}}const C=h.filter(S=>(0,k.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(m,S.openedWorkspace.uri));if(C.length)return C.sort((S,g)=>-(S.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(h,m){for(const I of h)if((0,k.isWorkspaceIdentifier)(I.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.uri,m))return I}e.findWindowOnWorkspaceOrFolder=D;function y(h,m){const I=C=>m.some(S=>w.extUriBiasedIgnorePathCase.isEqual(t.URI.file(S),t.URI.file(C)));for(const C of h)if(C.config?.extensionDevelopmentPath?.some(S=>I(S)))return C}e.findWindowOnExtensionDevelopmentPath=y}),define(Z[256],ee([0,1,15,2,4,16,7,19,22,6,41,33,114,26]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class kt extends t.Disposable{constructor(u,c,s,r,i){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=s,this.logService=r,this.configurationService=i,this._state=E(this.stateMainService.getItem(kt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(c.lastActiveWindow=this.toWindowState(i),c.lastActiveWindow.uiState.mode===3&&u.add(c.lastActiveWindow.uiState.display))}const s=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);s&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(s),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(c.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!s.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=0):u.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?k.isMacintosh&&n.windowId!==c.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=0):u.add(n.uiState.display)),n}));const r=p(c);this.stateMainService.setItem(kt.windowsStateStorageKey,r),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",r)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(s=>{const r=(0,g.isWorkspaceIdentifier)(u.openedWorkspace)&&s.workspace?.id===u.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&s.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(s.folderUri,u.openedWorkspace.uri);(r||i)&&(s.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{windowId:u.id,workspace:(0,g.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),s=this.configurationService.getValue("window");if(c.mode===3){let r;c.hasDefaultState?r=!!(s?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):r=!!(this.lifecycleMainService.wasRestarted||s?.restoreFullscreen),r||(c.mode=0)}return c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=u.workspace;if((0,g.isWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===a.id).map(M=>M.uiState);if(P.length)return P[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,a.uri)).map(M=>M.uiState);if(P.length)return P[0]}else if(u.backupPath){const P=this.state.openedWindows.filter(M=>M.backupPath===u.backupPath).map(M=>M.uiState);if(P.length)return P[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!c&&l)return l.uiState}let s;const r=w.screen.getAllDisplays();if(r.length===1)s=r[0];else{if(k.isMacintosh){const a=w.screen.getCursorScreenPoint();s=w.screen.getDisplayNearestPoint(a)}!s&&c&&(s=w.screen.getDisplayMatching(c.getBounds())),s||(s=w.screen.getPrimaryDisplay()||r[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(s.bounds.x+s.bounds.width/2-i.width/2),i.y=Math.round(s.bounds.y+s.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&c){const a=c.serializeWindowState();a.mode===3?i.mode=3:i=a,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;c.some(s=>s.x===u.x||s.y===u.y);)u.x+=30,u.y+=30;return u}};d.windowsStateStorageKey="windowsState",d=ve([J(0,C.IWindowsMainService),J(1,I.IStateMainService),J(2,h.ILifecycleMainService),J(3,m.ILogService),J(4,y.IConfigurationService)],d),e.WindowsStateHandler=d;function E(f){const u={openedWindows:[]},c=f||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=b(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=b(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(s=>b(s))),u}e.restoreWindowsState=E;function b(f){const u={uiState:f.uiState};return f.backupPath&&(u.backupPath=f.backupPath),f.remoteAuthority&&(u.remoteAuthority=f.remoteAuthority),f.folder&&(u.folderUri=D.URI.parse(f.folder)),f.workspaceIdentifier&&(u.workspace={id:f.workspaceIdentifier.id,configPath:D.URI.parse(f.workspaceIdentifier.configURIPath)}),u}function p(f){return{lastActiveWindow:f.lastActiveWindow&&v(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&v(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(u=>v(u))}}e.getWindowsStateStoreData=p;function v(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(Z[91],ee([0,1,31,42,124,35,13,9,4,16,7,5,63,26]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,C.createDecorator)("workspacesService");function d(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function E(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=E;function b(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=b;function p(M){return v(M)||f(M)}e.isStoredWorkspaceFolder=p;function v(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function f(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function u(M,T,O,U,Q){if(M.scheme!==U.scheme)return{name:O,uri:M.toString(!0)};let re=T?void 0:Q.relativePath(U,M);if(re!==void 0)re.length===0?re=".":h.isWindows&&(re=c(re));else if(M.scheme===D.Schemas.file)re=M.fsPath,h.isWindows&&(re=c(re));else if(Q.isEqualAuthority(M.authority,U.authority))re=M.path;else return{name:O,uri:M.toString(!0)};return{name:O,path:re}}e.getStoredWorkspaceFolder=u;function c(M){return M=(0,R.normalizeDriveLetter)(M),(0,w.isUNC)(M)||(M=(0,w.toSlashes)(M)),M}function s(M,T,O){const U=[],Q=new Set,re=O.dirname(T);for(const le of M){let fe;if(v(le))le.path&&(fe=O.resolvePath(re,le.path));else if(f(le))try{fe=I.URI.parse(le.uri),fe.path[0]!==y.posix.sep&&(fe=fe.with({path:y.posix.sep+fe.path}))}catch(se){console.warn(se)}if(fe){const se=O.getComparisonKey(fe);if(!Q.has(se)){Q.add(se);const ue=le.name||O.basenameOrAuthority(fe);U.push(new g.WorkspaceFolder({uri:fe,name:ue,index:U.length},le))}}}return U}e.toWorkspaceFolders=s;function r(M,T,O,U,Q){const re=i(T,M),le=Q.dirname(T),fe=Q.dirname(U),se=[];for(const _ of re.folders){const A=v(_)?Q.resolvePath(le,_.path):I.URI.parse(_.uri);let W;O?W=!1:W=!v(_)||(0,y.isAbsolute)(_.path),se.push(u(A,W,_.name,fe,Q))}const ue={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},K=k.setProperty(M,["folders"],se,ue);let N=k.applyEdits(M,K);return(0,m.isEqualAuthority)(re.remoteAuthority,(0,S.getRemoteAuthority)(U))&&(N=k.applyEdits(N,k.removeProperty(N,["remoteAuthority"],ue))),N}e.rewriteWorkspaceFileForNewLocation=r;function i(M,T){const O=t.parse(T);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(U=>p(U));else throw new Error(`${M} looks like an invalid workspace file.`);return O}function n(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function o(M){return typeof M.folderUri=="string"}function a(M){return typeof M.fileUri=="string"}function l(M,T){const O={workspaces:[],files:[]};if(M){const U=function(re,le){for(let fe=0;fe<re.length;fe++)try{le(re[fe],fe)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(re[fe])}: ${se.toString()}. Skip entry.`)}},Q=M;Array.isArray(Q.entries)&&U(Q.entries,re=>{const le=re.label,fe=re.remoteAuthority;n(re)?O.workspaces.push({label:le,remoteAuthority:fe,workspace:{id:re.workspace.id,configPath:I.URI.parse(re.workspace.configPath)}}):o(re)?O.workspaces.push({label:le,remoteAuthority:fe,folderUri:I.URI.parse(re.folderUri)}):a(re)&&O.files.push({label:le,remoteAuthority:fe,fileUri:I.URI.parse(re.fileUri)})})}return O}e.restoreRecentlyOpened=l;function P(M){const T={entries:[]};for(const O of M.workspaces)E(O)?T.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):T.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of M.files)T.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return T}e.toStoreData=P}),define(Z[117],ee([0,1,76,29,13,4,16]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function y(m){function I(){let C=m.scheme===k.Schemas.file?(0,D.originalFSPath)(m):m.toString();return R.isLinux||(C=C.toLowerCase()),(0,w.createHash)("md5").update(C).digest("hex")}return{id:I(),configPath:m}}e.getWorkspaceIdentifier=y;function h(m,I){function C(){if(m.scheme!==k.Schemas.file)return(0,w.createHash)("md5").update(m.toString()).digest("hex");if(!I)try{I=(0,t.statSync)(m.fsPath)}catch{return}let g;return R.isLinux?g=I.ino:R.isMacintosh?g=I.birthtime.getTime():R.isWindows&&(typeof I.birthtimeMs=="number"?g=Math.floor(I.birthtimeMs):g=I.birthtime.getTime()),(0,w.createHash)("md5").update(m.fsPath).update(g?String(g):"").digest("hex")}const S=C();if(typeof S=="string")return{id:S,uri:m}}e.getSingleFolderWorkspaceIdentifier=h}),define(Z[47],ee([0,1,15,29,3,42,35,2,13,9,16,12,23,175,60,56,25,5,6,20,51,116,26,91,117]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let n=class extends y.Disposable{constructor(a,l,P,M,T,O){super();this.environmentMainService=a,this.logService=l,this.userDataProfilesMainService=P,this.backupMainService=M,this.dialogMainService=T,this.productService=O,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,l=>(0,t.readFileSync)(l,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,l=>S.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(a,l){if(!!this.isWorkspacePath(a)&&a.scheme===h.Schemas.file)try{const P=l(a.fsPath);return P instanceof Promise?P.then(M=>this.doResolveWorkspace(a,M),M=>{}):this.doResolveWorkspace(a,P)}catch{return}}isWorkspacePath(a){return(0,s.isUntitledWorkspace)(a,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,l){try{const P=this.doParseStoredWorkspace(a,l),M=(0,i.getWorkspaceIdentifier)(a);return{id:M.id,configPath:M.configPath,folders:(0,r.toWorkspaceFolders)(P.folders,M.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(a,l){const P=(0,R.parse)(l);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(M=>(0,r.isStoredWorkspaceFolder)(M));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),T=P.configPath.fsPath;return await S.Promises.mkdir((0,m.dirname)(T),{recursive:!0}),await S.Promises.writeFile(T,JSON.stringify(M,null,"	")),P}createUntitledWorkspaceSync(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),T=P.configPath.fsPath;return(0,t.mkdirSync)((0,m.dirname)(T),{recursive:!0}),(0,S.writeFileSync)(T,JSON.stringify(M,null,"	")),P}newUntitledWorkspace(a=[],l){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,I.joinPath)(this.untitledWorkspacesHome,P),T=(0,I.joinPath)(M,s.UNTITLED_WORKSPACE_NAME),O=[];for(const U of a)O.push((0,r.getStoredWorkspaceFolder)(U.uri,!0,U.name,M,I.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(T),storedWorkspace:{folders:O,remoteAuthority:l}}}async getWorkspaceIdentifier(a){return(0,i.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,s.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const l=(0,I.originalFSPath)(a.configPath);try{(0,S.rimrafSync)((0,m.dirname)(l));const P=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,t.existsSync)(P)&&(0,S.writeFileSync)((0,m.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${l} (${P}).`)}}getUntitledWorkspacesSync(){const a=[];try{const l=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,I.joinPath)(this.untitledWorkspacesHome,P,s.UNTITLED_WORKSPACE_NAME));for(const P of l){const M=(0,i.getWorkspaceIdentifier)(P),T=this.resolveLocalWorkspaceSync(P);T?a.push({workspace:M,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return a}async enterWorkspace(a,l,P){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,l,P))return;const T=this.doEnterWorkspace(a,(0,i.getWorkspaceIdentifier)(P));if(!!T)return this._onDidEnterWorkspace.fire({window:a,workspace:T.workspace}),T}async isValidTargetWorkspacePath(a,l,P){if(!P)return!0;if((0,s.isWorkspaceIdentifier)(a.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,P))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,P)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(0,null))],message:(0,g.localize)(1,null,(0,I.basename)(P)),detail:(0,g.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,C.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,l){if(!a.config)return;a.focus();let P;return a.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,s.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=l,a.config.backupPath=P,{workspace:l,backupPath:P}}};n=ve([J(0,b.IEnvironmentMainService),J(1,v.ILogService),J(2,u.IUserDataProfilesMainService),J(3,d.IBackupMainService),J(4,E.IDialogMainService),J(5,f.IProductService)],n),e.WorkspacesManagementMainService=n}),define(Z[118],ee([0,1,40,21,5,33,26,47]),function(q,e,w,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,k.createDecorator)(e.ID);let h=class{constructor(I,C){this.windowsMainService=I,this.workspacesManagementMainService=C}async getRemoteDiagnostics(I){const C=this.windowsMainService.getWindows();return(await Promise.all(C.map(g=>new Promise(d=>{const E=g.remoteAuthority;if(E){const b=`vscode:getDiagnosticInfoResponse${g.id}`,p={includeProcesses:I.includeProcesses,folders:I.includeWorkspaceMetadata?this.getFolderURIs(g):void 0};g.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:b,args:p}),w.validatedIpcMain.once(b,(v,f)=>{f||d({hostName:E,errorMessage:`Unable to resolve connection to '${E}'.`}),d(f)}),setTimeout(()=>{d({hostName:E,errorMessage:`Connection to '${E}' could not be established`})},5e3)}else d(void 0)})))).filter(g=>!!g)}getFolderURIs(I){const C=[],S=I.openedWorkspace;if((0,D.isSingleFolderWorkspaceIdentifier)(S))C.push(S.uri);else if((0,D.isWorkspaceIdentifier)(S)){const g=this.workspacesManagementMainService.resolveLocalWorkspaceSync(S.configPath);g&&g.folders.forEach(E=>{C.push(E.uri)})}return C}};h=ve([J(0,R.IWindowsMainService),J(1,y.IWorkspacesManagementMainService)],h),e.DiagnosticsMainService=h}),define(Z[119],ee([0,1,15,24,4,12,7,23,19,59,5,6,113,33,26,47,51]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let p=class{constructor(f,u,c,s,r,i){this.logService=f,this.windowsMainService=u,this.urlService=c,this.workspacesManagementMainService=s,this.configurationService=r,this.userDataProfilesMainService=i}async start(f,u){this.logService.trace("Received data from other instance: ",f,u),k.isMacintosh&&w.app.focus({steal:!0});const c=this.parseOpenUrl(f);if(c.length){let s=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(s=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),s.then(()=>{for(const{uri:r,url:i}of c)this.urlService.open(r,{originalUrl:i})})}else return this.startOpenWindow(f,u)}parseOpenUrl(f){return f["open-url"]&&f._urls&&f._urls.length>0?(0,t.coalesce)(f._urls.map(u=>{try{return{uri:D.URI.parse(u),url:u}}catch{return null}})):[]}async startOpenWindow(f,u){const c=(0,m.isLaunchedFromCli)(u)?0:4;let s=[];const r=f.wait&&f.waitMarkerFilePath?D.URI.file(f.waitMarkerFilePath):void 0,i=f.remote||void 0,n=this.userDataProfilesMainService.checkAndCreateProfileFromCli(f);n&&await n;const o={context:c,cli:f,userEnv:u,waitMarkerFileURI:r,remoteAuthority:i};if(f.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(f.extensionDevelopmentPath,o);else if(!f._.length&&!f["folder-uri"]&&!f["file-uri"]){let a=!1;if(f["new-window"]||f["unity-launch"])a=!0;else if(f["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!k.isMacintosh}if(a)s=this.windowsMainService.open({...o,forceNewWindow:!0,forceEmpty:!0});else{const l=this.windowsMainService.getLastActiveWindow();l?(this.windowsMainService.openExistingWindow(l,o),s=[l]):s=this.windowsMainService.open({...o,forceEmpty:!0})}}else s=this.windowsMainService.open({...o,forceNewWindow:f["new-window"],preferNewWindow:!f["reuse-window"]&&!f.wait,forceReuseWindow:f["reuse-window"],diffMode:f.diff,mergeMode:f.merge,addMode:f.add,noRecentEntry:!!f["skip-add-to-recently-opened"],gotoLineMode:f.goto});if(r&&s.length===1&&s[0])return Promise.race([s[0].whenClosedOrLoaded,(0,y.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const f=[];return w.BrowserWindow.getAllWindows().forEach(u=>{const c=this.windowsMainService.getWindowById(u.id);c?f.push(this.codeWindowToInfo(c)):f.push(this.browserWindowToInfo(u))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}getFolderURIs(f){const u=[],c=f.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(c))u.push(c.uri);else if((0,d.isWorkspaceIdentifier)(c)){const s=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);s&&s.folders.forEach(i=>{u.push(i.uri)})}return u}codeWindowToInfo(f){const u=this.getFolderURIs(f),c=(0,R.assertIsDefined)(f.win);return this.browserWindowToInfo(c,u,f.remoteAuthority)}browserWindowToInfo(f,u=[],c){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:u,remoteAuthority:c}}};p=ve([J(0,C.ILogService),J(1,g.IWindowsMainService),J(2,S.IURLService),J(3,E.IWorkspacesManagementMainService),J(4,h.IConfigurationService),J(5,b.IUserDataProfilesMainService)],p),e.LaunchMainService=p}),define(Z[65],ee([0,1,50,15,30,142,52,3,35,2,13,9,4,7,96,81,23,92,165,56,25,5,22,6,20,64,33,26,47,17]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c,s,r,i,n,o,a,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let M=class extends m.Disposable{constructor(O,U,Q,re,le,fe,se,ue,K){super();this.sharedProcess=O,this.windowsMainService=U,this.dialogMainService=Q,this.lifecycleMainService=re,this.environmentMainService=le,this.logService=fe,this.productService=se,this.themeMainService=ue,this.workspacesManagementMainService=K,this.onDidOpenWindow=y.Event.map(this.windowsMainService.onDidOpenWindow,N=>N.id),this.onDidTriggerSystemContextMenu=y.Event.filter(y.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:N,x:_,y:A})=>({windowId:N.id,x:_,y:A})),({windowId:N})=>!!this.windowsMainService.getWindowById(N)),this.onDidMaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(N,_)=>_.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidUnmaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(N,_)=>_.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidBlurWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(N,_)=>_.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidFocusWindow=y.Event.any(y.Event.map(y.Event.filter(y.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),N=>!!N),N=>N.id),y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(N,_)=>_.id),N=>!!this.windowsMainService.getWindowById(N))),this.onDidResumeOS=y.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new y.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=y.Event.debounce(y.Event.any(y.Event.filter(y.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(N,_,A)=>A),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),y.Event.fromNodeEventEmitter(t.screen,"display-added"),y.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace,title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(O){return this.windowsMainService.getWindowCount()}async getActiveWindowId(O){const U=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(O,U,Q){return Array.isArray(U)?this.doOpenWindow(O,U,Q):this.doOpenEmptyWindow(O,U)}async doOpenWindow(O,U,Q=Object.create(null)){U.length>0&&this.windowsMainService.open({context:5,contextWindowId:O,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:Q.forceNewWindow,forceReuseWindow:Q.forceReuseWindow,preferNewWindow:Q.preferNewWindow,diffMode:Q.diffMode,mergeMode:Q.mergeMode,addMode:Q.addMode,gotoLineMode:Q.gotoLineMode,noRecentEntry:Q.noRecentEntry,waitMarkerFileURI:Q.waitMarkerFileURI,remoteAuthority:Q.remoteAuthority||void 0})}async doOpenEmptyWindow(O,U){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:O},U)}async toggleFullScreen(O){this.windowById(O)?.toggleFullScreen()}async handleTitleDoubleClick(O){this.windowById(O)?.handleTitleDoubleClick()}async isMaximized(O){const U=this.windowById(O);return U?.win?U.win.isMaximized():!1}async maximizeWindow(O){const U=this.windowById(O);U?.win&&U.win.maximize()}async unmaximizeWindow(O){const U=this.windowById(O);U?.win&&U.win.unmaximize()}async minimizeWindow(O){const U=this.windowById(O);U?.win&&U.win.minimize()}async updateWindowControls(O,U){const Q=this.windowById(O);Q&&Q.updateWindowControls(U)}async focusWindow(O,U){U&&typeof U.windowId=="number"&&(O=U.windowId),this.windowById(O)?.focus({force:U?.force??!1})}async setMinimumSize(O,U,Q){const re=this.windowById(O);if(re?.win){const[le,fe]=re.win.getSize(),[se,ue]=re.win.getMinimumSize(),[K,N]=[U??se,Q??ue],[_,A]=[Math.max(le,K),Math.max(fe,N)];(se!==K||ue!==N)&&re.win.setMinimumSize(K,N),(le!==_||fe!==A)&&re.win.setSize(_,A)}}async saveWindowSplash(O,U){this.themeMainService.saveWindowSplash(O,U)}async installShellCommand(O){const{source:U,target:Q}=await this.getShellCommandLink();try{const{symbolicLink:re}=await b.SymlinkSupport.stat(U);if(re&&!re.dangling){const le=await(0,d.realpath)(U);if(Q===le)return}await b.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await b.Promises.symlink(Q,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:le}=await this.showMessageBox(O,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(le===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Q}' '${U}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(fe)}catch{throw new Error((0,v.localize)(3,null,U))}}}async uninstallShellCommand(O){const{source:U}=await this.getShellCommandLink();try{await b.Promises.unlink(U)}catch(Q){switch(Q.code){case"EACCES":{const{response:re}=await this.showMessageBox(O,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const le=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(le)}catch{throw new Error((0,v.localize)(7,null,U))}break}case"ENOENT":break;default:throw Q}}}async getShellCommandLink(){const O=(0,C.resolve)(this.environmentMainService.appRoot,"bin","code"),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(O))throw new Error((0,v.localize)(8,null,O));return{source:U,target:O}}async showMessageBox(O,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(O))}async showSaveDialog(O,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(O))}async showOpenDialog(O,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(O))}toBrowserWindow(O){const U=this.windowById(O);if(U?.win)return U.win}async pickFileFolderAndOpen(O,U){const Q=await this.dialogMainService.pickFileFolder(U);Q&&this.doOpenPicked(await Promise.all(Q.map(async re=>await b.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),U,O)}async pickFolderAndOpen(O,U){const Q=await this.dialogMainService.pickFolder(U);Q&&this.doOpenPicked(Q.map(re=>({folderUri:g.URI.file(re)})),U,O)}async pickFileAndOpen(O,U){const Q=await this.dialogMainService.pickFile(U);Q&&this.doOpenPicked(Q.map(re=>({fileUri:g.URI.file(re)})),U,O)}async pickWorkspaceAndOpen(O,U){const Q=await this.dialogMainService.pickWorkspace(U);Q&&this.doOpenPicked(Q.map(re=>({workspaceUri:g.URI.file(re)})),U,O)}doOpenPicked(O,U,Q){this.windowsMainService.open({context:3,contextWindowId:Q,cli:this.environmentMainService.args,urisToOpen:O,forceNewWindow:U.forceNewWindow})}async showItemInFolder(O,U){t.shell.showItemInFolder(U)}async setRepresentedFilename(O,U){this.windowById(O)?.setRepresentedFilename(U)}async setDocumentEdited(O,U){this.windowById(O)?.setDocumentEdited(U)}async openExternal(O,U){return S.isLinuxSnap?this.safeSnapOpenExternal(U):t.shell.openExternal(U),!0}safeSnapOpenExternal(O){const U=process.env.GDK_PIXBUF_MODULE_FILE,Q=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(O),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=Q}moveItemToTrash(O,U){return t.shell.trashItem(U)}async isAdmin(){let O;return S.isWindows?O=(await new Promise((U,Q)=>{q(["native-is-elevated"],U,Q)}))():O=process.getuid()===0,O}async writeElevated(O,U,Q,re){const le=await new Promise((fe,se)=>{q(["@vscode/sudo-prompt"],fe,se)});return new Promise((fe,se)=>{const ue=[`"${this.cliPath}"`];re?.unlock&&ue.push("--file-chmod"),ue.push("--file-write",`"${U.fsPath}"`,`"${Q.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};le.exec(ue.join(" "),K,(N,_,A)=>{_&&this.logService.trace(`[sudo-prompt] received stdout: ${_}`),A&&this.logService.trace(`[sudo-prompt] received stderr: ${A}`),N?se(N):fe(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,C.join)(this.environmentMainService.appRoot,"bin","code"):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return E.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(O,U,Q){process.kill(U,Q)}async readClipboardText(O,U){return t.clipboard.readText(U)}async writeClipboardText(O,U,Q){return t.clipboard.writeText(U,Q)}async readClipboardFindText(O){return t.clipboard.readFindText()}async writeClipboardFindText(O,U){return t.clipboard.writeFindText(U)}async writeClipboardBuffer(O,U,Q,re){return t.clipboard.writeBuffer(U,Buffer.from(Q.buffer),re)}async readClipboardBuffer(O,U){return P.VSBuffer.wrap(t.clipboard.readBuffer(U))}async hasClipboard(O,U,Q){return t.clipboard.has(U,Q)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(O,U){this.windowById(O)?.updateTouchBar(U)}async notifyReady(O){this.windowById(O)?.setReady()}async relaunch(O,U){return this.lifecycleMainService.relaunch(U)}async reload(O,U){const Q=this.windowById(O);if(Q){if((0,a.isWorkspaceIdentifier)(Q.openedWorkspace)){const re=Q.openedWorkspace.configPath;if(re.scheme===I.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(Q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Q,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(O){this.closeWindowById(O,O)}async closeWindowById(O,U){const Q=this.windowById(U);if(Q?.win)return Q.win.close()}async quit(O){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(O,U){await this.lifecycleMainService.kill(U)}async resolveProxy(O,U){const re=this.windowById(O)?.win?.webContents?.session;if(re)return re.resolveProxy(U)}findFreePort(O,U,Q,re,le=1){return(0,p.findFreePort)(U,Q,re,le)}async openDevTools(O,U){const Q=this.windowById(O);Q?.win&&Q.win.webContents.openDevTools(U)}async toggleDevTools(O){const U=this.windowById(O);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(O,U){const Q=this.windowById(O);Q?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&Q.win.webContents.sendInputEvent(U)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(O,U,Q,re){if(!S.isWindows)return;const le=await new Promise((fe,se)=>{q(["@vscode/windows-registry"],fe,se)});try{return le.GetStringRegKey(U,Q,re)}catch{return}}windowById(O){if(typeof O=="number")return this.windowsMainService.getWindowById(O)}};ve([D.memoize],M.prototype,"cliPath",null),M=ve([J(1,o.IWindowsMainService),J(2,f.IDialogMainService),J(3,s.ILifecycleMainService),J(4,u.IEnvironmentMainService),J(5,r.ILogService),J(6,i.IProductService),J(7,n.IThemeMainService),J(8,l.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(Z[257],ee([0,1,15,40,30,35,2,13,4,97,163,84,118,56,25,5,119,6,65,53,20,61,74]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,E.createDecorator)("issueMainService");let r=class Tt{constructor(n,o,a,l,P,M,T,O,U,Q){this.userEnv=n,this.environmentMainService=o,this.launchMainService=a,this.logService=l,this.diagnosticsService=P,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=O,this.protocolMainService=U,this.productService=Q,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async n=>{const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(o,a);this.safeSend(n,"vscode:issueSystemInfoResponse",l)}),t.validatedIpcMain.on("vscode:listProcesses",async n=>{const o=[];try{const a=await this.launchMainService.getMainProcessId();o.push({name:(0,I.localize)(0,null),rootProcess:await(0,m.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(P=>{(0,C.isRemoteDiagnosticError)(P)?o.push({name:P.hostName,rootProcess:P}):P.processes&&o.push({name:P.hostName,rootProcess:P.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(n,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async n=>{const o={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(n,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async n=>{const o=await this.getPerformanceInfo();this.safeSend(n,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const n={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(n,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(n,o)=>{const{id:a,from:l,args:P}=o;let M;switch(l){case"issueReporter":M=this.issueReporterParentWindow;break;case"processExplorer":M=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}M?.webContents.send("vscode:runAction",{id:a,from:l,args:P})}),t.validatedIpcMain.on("vscode:openExternal",(n,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",n=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",n=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async n=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(n,"vscode:windowsInfoResponse",o.windows)})}safeSend(n,o,...a){n.sender.isDestroyed()||n.sender.send(o,...a)}async openReporter(n){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:n.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:n,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:f.default}),this.issueReporterWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(n){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:n.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:n,product:f.default}),this.processExplorerWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(n){n.isMinimized()&&n.restore(),n.focus()}createBrowserWindow(n,o,a,l){const P=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:n.width,height:n.height,minWidth:300,minHeight:200,x:n.x,y:n.y,title:a.title,backgroundColor:a.backgroundColor||Tt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${l}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return P.setMenuBarVisibility(!1),P}async getSystemStatus(){const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(n,o)}getWindowPosition(n,o,a){let l;const P=w.screen.getAllDisplays();if(P.length===1)l=P[0];else{if(h.isMacintosh){const O=w.screen.getCursorScreenPoint();l=w.screen.getDisplayNearestPoint(O)}!l&&n&&(l=w.screen.getDisplayMatching(n.getBounds())),l||(l=w.screen.getPrimaryDisplay()||P[0])}const M={width:o,height:a},T=l.bounds;return M.x=T.x+T.width/2-M.width/2,M.y=T.y+T.height/2-M.height/2,T.width>0&&T.height>0&&(M.x<T.x&&(M.x=T.x),M.y<T.y&&(M.y=T.y),M.x>T.x+T.width&&(M.x=T.x),M.y>T.y+T.height&&(M.y=T.y),M.width>T.width&&(M.width=T.width),M.height>T.height&&(M.height=T.height)),M}async getPerformanceInfo(){try{const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(n,o)}catch(n){throw this.logService.warn("issueService#getPerformanceInfo ",n.message),n}}};r.DEFAULT_BACKGROUND_COLOR="#1E1E1E",r=ve([J(1,d.IEnvironmentMainService),J(2,b.ILaunchMainService),J(3,p.ILogService),J(4,C.IDiagnosticsService),J(5,S.IDiagnosticsMainService),J(6,g.IDialogMainService),J(7,v.INativeHostMainService),J(8,c.IProtocolMainService),J(9,u.IProductService)],r),e.IssueMainService=r}),define(Z[258],ee([0,1,21,19,25,22,6,65,20,54,37,46,88]),function(q,e,w,t,k,R,D,y,h,m,I,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends S.AbstractUpdateService{constructor(E,b,p,v,f,u,c,s){super(E,b,v,f,u,s);this.telemetryService=p,this.nativeHostMainService=c}buildUpdateFeedUrl(E){return(0,S.createUpdateURL)(`linux-${process.arch}`,E,this.productService)}doCheckForUpdates(E){!this.url||(this.setState(C.State.CheckingForUpdates(E)),this.requestService.request({url:this.url},w.CancellationToken.None).then(m.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E}),this.setState(C.State.Idle(1))):this.setState(C.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E});const p=E?b.message||b:void 0;this.setState(C.State.Idle(1,p))}))}async doDownloadUpdate(E){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):E.update.url&&this.nativeHostMainService.openExternal(void 0,E.update.url),this.setState(C.State.Idle(1))}};g=ve([J(0,R.ILifecycleMainService),J(1,t.IConfigurationService),J(2,I.ITelemetryService),J(3,k.IEnvironmentMainService),J(4,m.IRequestService),J(5,D.ILogService),J(6,y.INativeHostMainService),J(7,h.IProductService)],g),e.LinuxUpdateService=g}),define(Z[259],ee([0,1,50,29,30,8,21,52,9,7,128,23,19,25,14,22,6,65,20,54,37,46,88]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(a,l=1e3){for(;!a();)await(0,R.timeout)(l)}let i;function n(){return typeof i=="undefined"&&(i=t.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends s.AbstractUpdateService{constructor(l,P,M,T,O,U,Q,re,le){super(l,P,T,O,U,le);this.telemetryService=M,this.fileService=Q,this.nativeHostMainService=re}get cachePath(){const l=h.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return C.Promises.mkdir(l,{recursive:!0}).then(()=>l)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(l){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),n()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,s.createUpdateURL)(P,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},D.CancellationToken.None).then(f.asJson).then(P=>{const M=n();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(c.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(T=>C.Promises.exists(T).then(O=>{if(O)return Promise.resolve(T);const U=P.url,Q=P.hash,re=`${T}.tmp`;return this.requestService.request({url:U},D.CancellationToken.None).then(le=>this.fileService.writeFile(m.URI.file(re),le.stream)).then(Q?()=>(0,I.checksum)(re,P.hash):()=>{}).then(()=>C.Promises.rename(re,T)).then(()=>T)})).then(T=>{const O=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},O&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(P)):this.setState(c.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const M=l?P.message||P:void 0;this.setState(c.State.Idle(n(),M))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(n()))}async getUpdatePackagePath(l){const P=await this.cachePath;return h.join(P,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const P=l?U=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(U):()=>!0,M=await this.cachePath,O=(await C.Promises.readdir(M)).filter(P).map(async U=>{try{await C.Promises.unlink(h.join(M,U))}catch{}});await Promise.all(O)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const P=await this.cachePath;this.availableUpdate.updateFilePath=h.join(P,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await C.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(n()))});const T=`${this.productService.win32MutexName}-ready`,O=await new Promise((U,Q)=>{q(["windows-mutex"],U,Q)});r(()=>O.isActive(T)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(l){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:l},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};ve([y.memoize],o.prototype,"cachePath",null),o=ve([J(0,E.ILifecycleMainService),J(1,S.IConfigurationService),J(2,u.ITelemetryService),J(3,g.IEnvironmentMainService),J(4,f.IRequestService),J(5,b.ILogService),J(6,d.IFileService),J(7,p.INativeHostMainService),J(8,v.IProductService)],o),e.Win32UpdateService=o}),define(Z[260],ee([0,1,15,8,21,43,3,35,2,13,9,71,4,7,171,60,19,56,25,59,14,22,6,20,61,228,90,37,231,64,74,33,26,47,114,122,39,38,41,53]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c,s,r,i,n,o,a,l,P,M,T,O,U,Q,re,le,fe,se,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var K;(function(_){_[_.NONE=0]="NONE",_[_.NAVIGATING=1]="NAVIGATING",_[_.READY=2]="READY"})(K||(K={}));let N=class Mt extends h.Disposable{constructor(A,W,$,Y,z,j,L,F,B,V,x,ne,H,te,ie,ce,de,ke,Le){super();this.logService=W,this.environmentMainService=$,this.policyService=Y,this.userDataProfilesService=z,this.fileService=j,this.applicationStorageMainService=L,this.storageMainService=F,this.configurationService=B,this.themeMainService=V,this.workspacesManagementMainService=x,this.backupMainService=ne,this.telemetryService=H,this.dialogMainService=te,this.lifecycleMainService=ie,this.productService=ce,this.protocolMainService=de,this.windowsMainService=ke,this.stateMainService=Le,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Me,Ae]=this.restoreWindowState(A.state);this.windowState=Me,this.logService.trace("window#ctor: using window state",Me);const Ve=this.windowState.mode===0||this.windowState.mode===3,ge=this.configurationService.getValue("window");let pe=!1;typeof ge?.experimental?.useSandbox=="boolean"?pe=ge.experimental.useSandbox:pe=typeof ue.default.quality=="string"&&ue.default.quality!=="stable";const be={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!Ve,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(ge?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...pe?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};S.isLinux?be.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(be.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(be.fullscreenable=!1),S.isMacintosh&&(be.acceptFirstMouse=!0,ge?.clickThroughInactive===!1&&(be.acceptFirstMouse=!1));const X=S.isMacintosh&&ge?.nativeTabs===!0;X&&(be.tabbingIdentifier=this.productService.nameShort);const oe=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(oe&&(be.titleBarStyle="hidden",S.isMacintosh||(be.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const he=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=re.Color.fromHex(he).isDarker()?"#FFFFFF":"#000000";be.titleBarOverlay={height:29,color:he,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,C.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(be),(0,C.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,S.isMacintosh&&oe&&this._win.setSheetOffset(22),oe&&(S.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||S.isMacintosh)){const he=this.stateMainService.getItem(Mt.windowControlHeightStateStorageKey);he&&this.updateWindowControls({height:he})}if(S.isWindows&&oe){const he=278;this._win.hookWindowMessage(he,()=>{const[ye,Ce]=this._win.getPosition(),Te=w.screen.getCursorScreenPoint(),Fe=Te.x-ye,Be=Te.y-Ce;return(()=>!(Fe>30&&Be>=0&&Be<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Fe,y:Be})),0})}(S.isMacintosh||S.isWindows)&&Ae&&(!X||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),Ve&&((0,C.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,C.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getProfile(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(A){S.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){S.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){S.isMacintosh&&A?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){$.dispose(),Y.dispose(),A()}const $=this.onDidClose(()=>W()),Y=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(W,$,Y)=>this.onWindowError(3,{reason:Y,exitCode:$})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),w.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),w.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,$)=>{const Y=await this.getMarketplaceHeaders();$({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,Y)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const $=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if($.response!==1){const Y=$.response===0;this.destroyWindow(Y,$.checkboxChecked)}}else if(A===2){let $;W?$=(0,d.localize)(7,null,W.reason,W.exitCode??"<unknown>"):$=(0,d.localize)(6,null);const Y=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(9,null))],message:$,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),z=Y.response===0;this.destroyWindow(z,Y.checkboxChecked)}break}}async destroyWindow(A,W){const $=this._config?.workspace;if(W&&$)try{const Y=this.storageMainService.workspaceStorage($);await Y.init(),Y.delete("memento/workbench.parts.editor"),await Y.close()}catch(Y){this.logService.error(Y)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let Y,z;(0,O.isSingleFolderWorkspaceIdentifier)($)?Y={folderUri:$.uri}:(0,O.isWorkspaceIdentifier)($)?Y={workspaceUri:$.configPath}:z=!0;const[j]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Y?[Y]:void 0,forceEmpty:z,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});j.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let $=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;$?.endsWith("/")&&($=$.substr(0,$.length-1));const Y=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if(($||"").indexOf("@")===-1&&($!==this.currentHttpProxy||Y!==this.currentNoProxy)){this.currentHttpProxy=$,this.currentNoProxy=Y;const z=$||"",j=Y?`${Y},<local>`:"<local>";this.logService.trace(`Setting proxy to '${z}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:z,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(A){S.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",q).toString(!0));const $=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:$?2:1})}updateConfiguration(A,W){const $=(this._config??this.pendingLoadConfig)?.userEnv;if($){const Y=(0,f.isLaunchedFromCli)($)&&!(0,f.isLaunchedFromCli)(A.userEnv),z=this.isExtensionDevelopmentHost;(Y||z)&&(A.userEnv={...$,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,C.mark)("code/willOpenNewWindow"),A.perfMarks=(0,C.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,O.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}else if((0,O.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,Q.defaultWindowState)();if(this.isFullScreen){let $;try{$=w.screen.getDisplayMatching(this.getBounds())}catch{}const Y=(0,Q.defaultWindowState)();return{mode:3,display:$?$.id:void 0,width:this.windowState.width||Y.width,height:this.windowState.height||Y.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!S.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let $;W===1?$=this.getBounds():$=this._win.getNormalBounds(),A.x=$.x,A.y=$.y,A.width=$.width,A.height=$.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Mt.windowControlHeightStateStorageKey,A.height),S.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):S.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,C.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const $=w.screen.getAllDisplays();W=$.length>1,A=this.validateWindowState(A,$)}catch($){this.logService.warn(`Unexpected error validating window state: ${$}
${$.stack}`)}return(0,C.mark)("code/didRestoreCodeWindowState"),[A||(0,Q.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const z=this.getWorkingArea(W[0]);if(z){let j=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!z||(A.x<z.x&&(A.x=z.x),A.y<z.y&&(A.y=z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",z),j(),A.width>z.width&&(A.width=z.width),A.height>z.height&&(A.height=z.height),A.x>z.x+z.width-128&&(A.x=z.x+z.width-A.width),A.y>z.y+z.height-128&&(A.y=z.y+z.height-A.height),j()}return A}if(A.display&&A.mode===3){const z=W.find(j=>j.id===A.display);if(z&&typeof z.bounds?.x=="number"&&typeof z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const j=(0,Q.defaultWindowState)(3);return j.x=z.bounds.x,j.y=z.bounds.y,j}}let $,Y;try{$=w.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),Y=this.getWorkingArea($)}catch{}if($&&Y&&A.x+A.width>Y.x&&A.y+A.height>Y.y&&A.x<Y.x+Y.width&&A.y<Y.y+Y.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",Y),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[$,Y]=this._win.getSize();return{x:A,y:W,width:$,height:Y}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return S.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){S.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){S.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...$){this.isReady?this.send(A,...$):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...$)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch($){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)($)}`)}}}updateTouchBar(A){!S.isMacintosh||this.touchBarGroups.forEach((W,$)=>{const Y=A[$];W.segments=this.createTouchBarGroupSegments(Y)})}createTouchBar(){if(!!S.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),$=new w.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:Y=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:$.segments[Y].id,from:"touchbar"})}});return $}createTouchBarGroupSegments(A=[]){return A.map($=>{let Y;$.icon&&!l.ThemeIcon.isThemeIcon($.icon)&&$.icon?.dark?.scheme===m.Schemas.file&&(Y=w.nativeImage.createFromPath(g.URI.revive($.icon.dark).fsPath),Y.isEmpty()&&(Y=void 0));let z;return typeof $.title=="string"?z=$.title:z=$.title.value,{id:$.id,label:Y?void 0:z,icon:Y}})}dispose(){super.dispose(),this._win=null}};N.windowControlHeightStateStorageKey="windowControlHeight",N=ve([J(1,s.ILogService),J(2,v.IEnvironmentMainService),J(3,le.IPolicyService),J(4,fe.IUserDataProfilesService),J(5,u.IFileService),J(6,o.IApplicationStorageMainService),J(7,o.IStorageMainService),J(8,b.IConfigurationService),J(9,P.IThemeMainService),J(10,U.IWorkspacesManagementMainService),J(11,E.IBackupMainService),J(12,a.ITelemetryService),J(13,p.IDialogMainService),J(14,c.ILifecycleMainService),J(15,r.IProductService),J(16,i.IProtocolMainService),J(17,T.IWindowsMainService),J(18,se.IStateMainService)],N),e.CodeWindow=N}),define(Z[75],ee([0,1,15,24,8,3,35,2,13,4,16,7,23,174,5,22,6,90,91,26,47]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let c=class it extends y.Disposable{constructor(r,i,n,o){super();this.logService=r,this.workspacesManagementMainService=i,this.lifecycleMainService=n,this.applicationStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],n=[];for(const o of r)if((0,v.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,v.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const a=this.indexOfFile(n,o.fileUri)>=0,l=o.fileUri.scheme===h.Schemas.file&&it.COMMON_FILES_FILTER.indexOf((0,I.basename)(o.fileUri))>=0;!a&&!l&&(n.push(o),m.isWindows&&o.fileUri.scheme===h.Schemas.file&&w.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,n),i.length>it.MAX_TOTAL_RECENT_ENTRIES&&(i.length=it.MAX_TOTAL_RECENT_ENTRIES),n.length>it.MAX_TOTAL_RECENT_ENTRIES&&(n.length=it.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:n}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=l=>{const P=this.location(l);for(const M of r)if(I.extUriBiasedIgnorePathCase.isEqual(M,P))return!1;return!0},n=await this.getRecentlyOpened(),o=n.workspaces.filter(i),a=n.files.filter(i);(o.length!==n.workspaces.length||a.length!==n.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const r=[],i=[];return await this.addEntriesFromStorage(r,i),{workspaces:r,files:i}}async addEntriesFromStorage(r,i){const n=await this.getRecentlyOpenedFromStorage();for(const o of n.workspaces){const a=(0,v.isRecentFolder)(o)?this.indexOfFolder(r,o.folderUri):this.indexOfWorkspace(r,o.workspace);a>=0?r[a].label=r[a].label||o.label:r.push(o)}for(const o of n.files){const a=this.indexOfFile(i,o.fileUri);a>=0?i[a].label=i[a].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const i=this.applicationStorageMainService.get(it.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{r=JSON.parse(i)}catch(n){this.logService.error("Unexpected error parsing opened paths list",n)}return(0,v.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(it.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,v.toStoreData)(r)),-1,1)}location(r){return(0,v.isRecentFolder)(r)?r.folderUri:(0,v.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(n=>(0,v.isRecentWorkspace)(n)&&n.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(n=>(0,v.isRecentFolder)(n)&&I.extUriBiasedIgnorePathCase.isEqual(n.folderUri,i))}indexOfFile(r,i){return r.findIndex(n=>I.extUriBiasedIgnorePathCase.isEqual(n.fileUri,i))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of w.app.getJumpListSettings().removedItems){const l=a.args;if(l){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(l);P&&i.push(C.URI.parse(P[2]))}}await this.removeRecentlyOpened(i);let n=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,it.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const l=(0,v.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:P,description:M}=this.getWindowsJumpListLabel(l,a.label);let T;return C.URI.isUri(l)?T=`--folder-uri "${l.toString()}"`:(n=!0,T=`--file-uri "${l.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&r.push({type:"custom",name:n?(0,g.localize)(2,null):(0,g.localize)(3,null),items:o})}r.push({type:"recent"});try{const i=w.app.setJumpList(r);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,D.splitName)(i).name,description:i};if(C.URI.isUri(r))return{title:(0,I.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,g.localize)(4,null),description:""};let n=(0,I.basename)(r.configPath);return n.endsWith(f.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,n),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,D.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;w.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let n=0;for(let a=0;a<r.workspaces.length&&n<it.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const l=this.location(r.workspaces[a]);if(l.scheme===h.Schemas.file){const P=(0,I.originalFSPath)(l);await S.Promises.exists(P)&&(i.push(P),n++)}}const o=[];for(let a=0;a<r.files.length&&n<it.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const l=this.location(r.files[a]);if(l.scheme===h.Schemas.file){const P=(0,I.originalFSPath)(l);if(it.COMMON_FILES_FILTER.includes((0,I.basename)(l))||i.includes(P))continue;await S.Promises.exists(P)&&(o.push(P),n++)}}o.reverse().forEach(a=>w.app.addRecentDocument(a)),i.reverse().forEach(a=>w.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ve([J(0,b.ILogService),J(1,u.IWorkspacesManagementMainService),J(2,E.ILifecycleMainService),J(3,p.IApplicationStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(Z[261],ee([0,1,15,8,21,35,4,7,164,19,25,22,6,208,65,20,41,37,46,74,33,75]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let r=class Dt{constructor(o,a,l,P,M,T,O,U,Q,re,le){this.updateService=o,this.configurationService=a,this.windowsMainService=l,this.environmentMainService=P,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=O,this.lifecycleMainService=U,this.logService=Q,this.nativeHostMainService=re,this.productService=le,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,f.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(Dt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,O,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,O,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,O,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,O,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,O,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,a){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(Dt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!D.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=w.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(D.isMacintosh?new w.Menu:null);return}const a=new w.Menu;let l;if(D.isMacintosh){const M=new w.Menu;l=new w.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),a.append(l)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new w.Menu;M.append(new w.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:M});this.setMenuById(M,"File"),a.append(T)}if(this.shouldDrawMenu("Edit")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),a.append(T)}if(this.shouldDrawMenu("Selection")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),a.append(T)}if(this.shouldDrawMenu("View")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:M});this.setMenuById(M,"View"),a.append(T)}if(this.shouldDrawMenu("Go")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),a.append(T)}if(this.shouldDrawMenu("Run")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),a.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),a.append(T)}let P;if(this.shouldDrawMenu("Window")){const M=new w.Menu;P=new w.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(P&&a.append(P),this.shouldDrawMenu("Help")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),a.append(T)}a.items&&a.items.length>0?w.Menu.setApplicationMenu(a):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const a=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const fe=new w.Menu;this.setMenuById(fe,"Preferences"),P=new w.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:fe})}const M=new w.Menu,T=new w.MenuItem({label:h.localize(12,null),role:"services",submenu:M}),O=new w.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new w.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new w.MenuItem({label:h.localize(15,null),role:"unhide"}),re=new w.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(fe,se,ue)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(ue)&&this.nativeHostMainService.quit(void 0)}})),le=[a];le.push(...l),P&&le.push(i(),P),le.push(i(),T,i(),O,U,Q,i(),re),le.forEach(fe=>o.append(fe))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(o)){const l={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(h.localize(17,null)),(0,R.mnemonicButtonLabel)(h.localize(18,null))],message:h.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,l);return P===0}return!0}shouldDrawMenu(o){if(!D.isMacintosh&&(0,f.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,a){a.forEach(l=>{if((0,g.isMenubarMenuItemSeparator)(l))o.append(i());else if((0,g.isMenubarMenuItemSubmenu)(l)){const P=new w.Menu,M=new w.MenuItem({label:this.mnemonicLabel(l.label),submenu:P});this.setMenu(P,l.submenu.items),o.append(M)}else(0,g.isMenubarMenuItemRecentAction)(l)?o.append(this.createOpenRecentMenuItem(l)):(0,g.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?o.append(new w.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):o.append(this.createMenuItem(l.label,l.id,!1,l.checked)):o.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):o.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(o,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(o,this.menubarMenus[a].items)}insertCheckForUpdatesItems(o){const a=this.getUpdateMenuItems();a.length&&(a.forEach(l=>o.append(l)),o.append(i()))}createOpenRecentMenuItem(o){const a=y.URI.revive(o.uri),l=o.id,P=l==="openRecentFile"?{fileUri:a}:l==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new w.MenuItem(this.likeAction(l,{label:o.label,click:(M,T,O)=>{const U=this.isOptionClick(O);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(o){return!!(o&&(!D.isMacintosh&&(o.ctrlKey||o.shiftKey)||D.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,a,l){const P={label:this.mnemonicLabel(o),role:l,enabled:!0};return new w.MenuItem(this.withKeybinding(a,P))}setMacWindowMenu(o){const a=new w.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new w.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new w.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,l,i(),M,...T,i(),P].forEach(O=>o.append(O))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,a,l,P){const M=this.mnemonicLabel(o),T=typeof a=="function"?a:(le,fe,se)=>{const ue=le?le.userSettingsLabel:null;let K=a;Array.isArray(a)&&(K=this.isOptionClick(se)?a[1]:a[0]),ue&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ue}):this.runActionInRenderer({type:"commandId",commandId:K})},O=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,Q={label:M,click:T,enabled:O};U&&(Q.type="checkbox",Q.checked=U);let re;return typeof a=="string"?re=a:Array.isArray(a)&&(re=a[0]),D.isMacintosh&&(re==="editor.action.clipboardCutAction"?Q.role="cut":re==="editor.action.clipboardCopyAction"?Q.role="copy":re==="editor.action.clipboardPasteAction"&&(Q.role="paste"),re==="undo"?Q.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?Q.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(re,Q))}makeContextAwareClickHandler(o,a){return(l,P,M)=>{const T=w.BrowserWindow.getFocusedWindow();if(!T)return a.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return a.inDevTools(T.webContents.devToolsWebContents);o(l,P||T,M)}}runActionInRenderer(o){let a=w.BrowserWindow.getFocusedWindow();if(!a){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(a=P.win)}const l=a?this.windowsMainService.getWindowById(a.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",o),D.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const P={id:o.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:o.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,a){const l=typeof o=="string"?this.keybindings[o]:void 0;if(l?.label){if(l.isNative!==!1)a.accelerator=l.label,a.userSettingsLabel=l.userSettingsLabel;else if(typeof a.label=="string"){const P=a.label.indexOf("[");P>=0?a.label=`${a.label.substr(0,P)} [${l.label}]`:a.label=`${a.label} [${l.label}]`}}else a.accelerator=void 0;return a}likeAction(o,a,l=!a.accelerator){l&&(a=this.withKeybinding(o,a));const P=a.click;return a.click=(M,T,O)=>{this.reportMenuActionTelemetry(o),P?.(M,T,O)},a}openUrl(o,a){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,R.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=ve([J(0,v.IUpdateService),J(1,m.IConfigurationService),J(2,u.IWindowsMainService),J(3,I.IEnvironmentMainService),J(4,p.ITelemetryService),J(5,c.IWorkspacesHistoryMainService),J(6,b.IStateMainService),J(7,C.ILifecycleMainService),J(8,S.ILogService),J(9,d.INativeHostMainService),J(10,E.IProductService)],r),e.Menubar=r;function i(){return new w.MenuItem({type:"separator"})}}),define(Z[262],ee([0,1,5,22,6,261]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let D=class{constructor(h,m,I){this.instantiationService=h,this.lifecycleMainService=m,this.logService=I,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(h,m){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(m,h)}};D=ve([J(0,w.IInstantiationService),J(1,t.ILifecycleMainService),J(2,k.ILogService)],D),e.MenubarMainService=D}),define(Z[263],ee([0,1,15,29,30,24,21,3,31,48,35,2,13,9,71,4,34,16,12,7,172,60,19,56,25,14,5,22,6,53,20,61,63,41,74,260,116,256,26,117,75,47,64,39,51]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c,s,r,i,n,o,a,l,P,M,T,O,U,Q,re,le,fe,se,ue,K,N,_,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(j){return(0,se.isWorkspaceIdentifier)(j?.workspace)}function Y(j){return(0,se.isSingleFolderWorkspaceIdentifier)(j?.workspace)}let z=class lt extends C.Disposable{constructor(L,F,B,V,x,ne,H,te,ie,ce,de,ke,Le,Me,Ae,Ve,ge,pe){super();this.machineId=L,this.initialUserEnv=F,this.logService=B,this.stateMainService=V,this.policyService=x,this.environmentMainService=ne,this.userDataProfilesMainService=H,this.lifecycleMainService=te,this.backupMainService=ie,this.configurationService=ce,this.workspacesHistoryMainService=de,this.workspacesManagementMainService=ke,this.instantiationService=Le,this.dialogMainService=Me,this.fileService=Ae,this.productService=Ve,this.protocolMainService=ge,this.themeMainService=pe,this._onDidOpenWindow=this._register(new y.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new y.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new y.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new y.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new y.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new fe.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const F=new C.DisposableStore;if(F.add(y.Event.any(L.onDidClose,L.onDidDestroy)(()=>F.dispose())),L.config.extensionDevelopmentPath)for(const B of L.config.extensionDevelopmentPath)F.add(this.protocolMainService.addValidFileRoot(B));L.config.extensionTestsPath&&F.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,F){const B=this.environmentMainService.args,V=F?.remoteAuthority||void 0,x=!0,ne=F?.forceReuseWindow,H=!ne;return this.open({...L,cli:B,forceEmpty:x,forceNewWindow:H,forceReuseWindow:ne,remoteAuthority:V})}openExistingWindow(L,F){L.focus(),this.handleWaitMarkerFile(F,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const F=[],B=[],V=[],x=[],ne=[];let H,te=0;const ie=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const Me of ie)Y(Me)?L.addMode?F.push(Me):B.push(Me):$(Me)?V.push(Me):Me.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),H.filesToOpenOrCreate.push(Me)):Me.backupPath?ne.push({backupFolder:(0,g.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):te++;L.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),L.mergeMode&&H&&H.filesToOpenOrCreate.length===4&&(H.filesToMerge=H.filesToOpenOrCreate.slice(0,4),H.filesToOpenOrCreate=[],H.filesToDiff=[]),H&&L.waitMarkerFileURI&&(H.filesToWait={paths:(0,R.coalesce)([...H.filesToDiff,H.filesToMerge[3],...H.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...x),ne.push(...this.backupMainService.getEmptyWindowBackupPaths())):ne.length=0;const{windows:ce,filesOpenedInWindow:de}=this.doOpen(L,V,B,ne,te,H,F);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${B.length}, emptyToRestore: ${ne.length}, emptyToOpen: ${te})`),ce.length>1)if(de)de.focus();else{const Me=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,Ve=!0;if(Me){const ge=ce.filter(pe=>this.windowsStateHandler.state.lastActiveWindow&&pe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ge.length&&(ge[0].focus(),Ae=!1,Ve=!1)}if(Ae)for(let ge=ce.length-1;ge>=0;ge--){const pe=ce[ge];if(!(pe.openedWorkspace&&x.some(be=>pe.openedWorkspace&&be.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&ne.some(be=>pe.backupPath&&be.backupFolder===(0,g.basename)(pe.backupPath)))){pe.focus(),Ve=!1;break}}Ve&&ce[ce.length-1].focus()}const ke=H&&H.filesToDiff.length>0,Le=H&&H.filesToMerge.length>0;if(!ce.some(Me=>Me.isExtensionDevelopmentHost)&&!ke&&!Le&&!L.noRecentEntry){const Me=[];for(const Ae of ie)$(Ae)&&!Ae.transient?Me.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):Y(Ae)?Me.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Me.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Me)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,F){const B=L.waitMarkerFileURI;L.context===0&&B&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.fileService.del(B)}catch{}})()}doOpen(L,F,B,V,x,ne,H){const te=[];let ie;function ce(ge,pe){te.push(ge),pe&&(ie=ge,ne=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:ke}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&H.length>0){const ge=H[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(ge);pe&&ce(this.doAddFoldersToExistingWindow(pe,H.map(be=>be.workspace.uri)))}const Le=B.length+F.length+V.length;if(ne&&Le===0){const ge=ne.filesToOpenOrCreate[0]||ne.filesToDiff[0]||ne.filesToMerge[3],pe=this.getWindows().filter(X=>ne&&(0,p.isEqualAuthority)(X.remoteAuthority,ne.remoteAuthority));let be;ge?.fileUri&&!ke&&((L.context===4||L.context===0||L.context===1)&&(be=(0,le.findWindowOnFile)(pe,ge.fileUri,X=>X.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(X.configPath):void 0)),be||(be=this.doGetLastActiveWindow(pe))),be?(0,se.isWorkspaceIdentifier)(be.openedWorkspace)?F.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?B.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,be,ne),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:ne,forceNewWindow:!0,remoteAuthority:ne.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow}),!0)}const Me=(0,R.distinct)(F,ge=>ge.workspace.id);if(Me.length>0){const ge=(0,R.coalesce)(Me.map(pe=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(ge.length>0){const pe=ge[0],be=(0,p.isEqualAuthority)(ne?.remoteAuthority,pe.remoteAuthority)?ne:void 0;ce(this.doOpenFilesInExistingWindow(L,pe,be),!!be),de=!0}Me.forEach(pe=>{if(ge.some(oe=>oe.openedWorkspace&&oe.openedWorkspace.id===pe.workspace.id))return;const be=pe.remoteAuthority,X=(0,p.isEqualAuthority)(ne?.remoteAuthority,be)?ne:void 0;ce(this.doOpenFolderOrWorkspace(L,pe,de,X),!!X),de=!0})}const Ae=(0,R.distinct)(B,ge=>p.extUriBiasedIgnorePathCase.getComparisonKey(ge.workspace.uri));if(Ae.length>0){const ge=(0,R.coalesce)(Ae.map(pe=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(ge.length>0){const pe=ge[0],be=(0,p.isEqualAuthority)(ne?.remoteAuthority,pe.remoteAuthority)?ne:void 0;ce(this.doOpenFilesInExistingWindow(L,pe,be),!!be),de=!0}Ae.forEach(pe=>{if(ge.some(oe=>(0,se.isSingleFolderWorkspaceIdentifier)(oe.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(oe.openedWorkspace.uri,pe.workspace.uri)))return;const be=pe.remoteAuthority,X=(0,p.isEqualAuthority)(ne?.remoteAuthority,be)?ne:void 0;ce(this.doOpenFolderOrWorkspace(L,pe,de,X),!!X),de=!0})}const Ve=(0,R.distinct)(V,ge=>ge.backupFolder);if(Ve.length>0&&Ve.forEach(ge=>{const pe=ge.remoteAuthority,be=(0,p.isEqualAuthority)(ne?.remoteAuthority,pe)?ne:void 0;ce(this.doOpenEmpty(L,!0,pe,be,ge),!!be),de=!0}),te.length===0||ne){ne&&!x&&x++;const ge=ne?ne.remoteAuthority:L.remoteAuthority;for(let pe=0;pe<x;pe++)ce(this.doOpenEmpty(L,de,ge,ne),!!ne),de=!0}return{windows:(0,R.distinct)(te),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(L,F,B){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:B}),F.focus();const V={filesToOpenOrCreate:B?.filesToOpenOrCreate,filesToDiff:B?.filesToDiff,filesToMerge:B?.filesToMerge,filesToWait:B?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",D.CancellationToken.None,V),F}doAddFoldersToExistingWindow(L,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),L.focus();const B={foldersToAdd:F};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,B),L}doOpenEmpty(L,F,B,V,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:B,filesToOpen:V,forceNewWindow:F});let ne;return!F&&typeof L.contextWindowId=="number"&&(ne=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:B,forceNewWindow:F,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:ne,emptyWindowBackupInfo:x})}doOpenFolderOrWorkspace(L,F,B,V,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:V}),!B&&!x&&typeof L.contextWindowId=="number"&&(x=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:x,userDataProfileInfo:F.userDataProfileInfo})}getPathsToOpen(L){let F,B=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(F=this.doExtractPathsFromAPI(L),B=!0):L.forceEmpty?F=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(F=this.doExtractPathsFromCLI(L.cli),F.length===0&&F.push(Object.create(null)),B=!0):(F=this.doGetPathsFromLastSession(),F.length===0&&F.push(Object.create(null)),V=!0),!L.addMode&&B){const x=F.filter(ne=>Y(ne));if(x.length>1){const ne=x[0].remoteAuthority;if(x.every(H=>(0,p.isEqualAuthority)(H.remoteAuthority,ne))){const H=this.workspacesManagementMainService.createUntitledWorkspaceSync(x.map(te=>({uri:te.workspace.uri})));F.push({workspace:H,remoteAuthority:ne}),F=F.filter(te=>!Y(te))}}}return L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&F.unshift(...this.doGetPathsFromLastSession().filter(x=>$(x)||Y(x)||x.backupPath)),F}doExtractPathsFromAPI(L){const F=[],B={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const V of(0,R.coalesce)(L.urisToOpen||[])){const x=this.resolveOpenable(V,B);if(x)x.label=V.label,F.push(x);else{const ne=this.resourceFromOpenable(V),H={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:ne.scheme===S.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:ne.scheme===S.Schemas.file?(0,u.localize)(3,null,(0,I.getPathLabel)(ne,{os:E.OS,tildify:this.environmentMainService})):(0,u.localize)(4,null,ne.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(H,(0,v.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(L){const F=[],B={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V)for(const te of V){const ie=this.cliArgToUri(te);if(ie){const ce=this.resolveOpenable({folderUri:ie},B);ce&&F.push(ce)}}const x=L["file-uri"];if(x)for(const te of x){const ie=this.cliArgToUri(te);if(ie){const ce=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(te)?{workspaceUri:ie}:{fileUri:ie},B);ce&&F.push(ce)}}const ne=L._;for(const te of ne){const ie=B.remoteAuthority?this.doResolvePathRemote(te,B):this.doResolveFilePath(te,B);ie&&F.push(ie)}const H=L.profile;if(H)for(const te of F)te.userDataProfileInfo={name:H};return F}cliArgToUri(L){try{const F=f.URI.parse(L);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${L}, ${F.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];L!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const V of F)if(V.workspace){const x=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});$(x)&&B.push(x)}else if(V.folderUri){const x=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});Y(x)&&B.push(x)}else L!=="folders"&&V.backupPath&&B.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return B}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,F=Object.create(null)){const B=this.resourceFromOpenable(L);return B.scheme===S.Schemas.file?((0,Q.isFileToOpen)(L)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(B.fsPath,F)):this.doResolveRemoteOpenable(L,F)}doResolveRemoteOpenable(L,F){let B=this.resourceFromOpenable(L);const V=(0,O.getRemoteAuthority)(B)||F.remoteAuthority;if(B=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(B)),(0,Q.isFileToOpen)(L)){if(F.gotoLineMode){const{path:x,line:ne,column:H}=(0,h.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:x}),options:{selection:ne?{startLineNumber:ne,startColumn:H||1}:void 0},remoteAuthority:V}}return{fileUri:B,remoteAuthority:V}}else if((0,Q.isWorkspaceToOpen)(L))return{workspace:(0,ue.getWorkspaceIdentifier)(B),remoteAuthority:V};return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:V}}resourceFromOpenable(L){return(0,Q.isWorkspaceToOpen)(L)?L.workspaceUri:(0,Q.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,F){let B,V;F.gotoLineMode&&({path:L,line:B,column:V}=(0,h.parseLineAndColumnAware)(L)),L=(0,h.sanitizeFilePath)((0,g.normalize)(L),(0,b.cwd)());try{const x=(0,t.statSync)(L);if(x.isFile()){if(!F.forceOpenWorkspaceAsFile){const ne=this.workspacesManagementMainService.resolveLocalWorkspaceSync(f.URI.file(L));if(ne)return ne.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:n.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:f.URI.file(L),type:n.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:V||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(f.URI.file(L),x),type:n.FileType.Directory,exists:!0};if(!E.isWindows&&L==="/dev/null")return{fileUri:f.URI.file(L),type:n.FileType.File,exists:!0}}}catch{const ne=f.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([ne]),F.ignoreFileNotFound)return{fileUri:ne,type:n.FileType.File,exists:!1}}}doResolvePathRemote(L,F){const B=L.charCodeAt(0),V=F.remoteAuthority;let x,ne;F.gotoLineMode&&({path:L,line:x,column:ne}=(0,h.parseLineAndColumnAware)(L)),B!==47&&((0,h.isWindowsDriveLetter)(B)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,h.toSlashes)(L)),L=`/${L}`);const H=f.URI.from({scheme:S.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return F.forceOpenWorkspaceAsFile?{fileUri:H,options:{selection:x?{startLineNumber:x,startColumn:ne||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,ue.getWorkspaceIdentifier)(H),remoteAuthority:V};if(F.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:H,options:{selection:x?{startLineNumber:x,startColumn:ne||1}:void 0},remoteAuthority:V}}return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:V}}shouldOpenNewWindow(L){const F=this.configurationService.getValue("window"),B=F?.openFoldersInNewWindow||"default",V=F?.openFilesInNewWindow||"off";let x=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(B==="on"||B==="off")&&(x=B==="on");let ne=!1;return L.forceNewWindow||L.forceReuseWindow?ne=!!L.forceNewWindow&&!L.forceReuseWindow:(E.isMacintosh?L.context===1&&(ne=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(ne=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(ne=V==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:ne}}openExtensionDevelopmentHostWindow(L,F){const B=(0,le.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(B)return this.lifecycleMainService.reload(B,F.cli),B.focus(),[B];let V=F.cli["folder-uri"]||[],x=F.cli["file-uri"]||[],ne=F.cli._;if(!ne.length&&!V.length&&!x.length&&!F.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,de=ce&&(ce.workspace||ce.folderUri);de&&(f.URI.isUri(de)?de.scheme===S.Schemas.file?ne=[de.fsPath]:V=[de.toString()]:de.configPath.scheme===S.Schemas.file?ne=[(0,p.originalFSPath)(de.configPath)]:x=[de.configPath.toString()])}let H=F.remoteAuthority;for(const ce of L)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const de=f.URI.parse(ce),ke=(0,O.getRemoteAuthority)(de);ke&&(H?(0,p.isEqualAuthority)(ke,H)||this.logService.error("more than one extension development path authority"):H=ke)}ne=ne.filter(ce=>{const de=f.URI.file(ce);return(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),de)?!1:(0,p.isEqualAuthority)((0,O.getRemoteAuthority)(de),H)}),V=V.filter(ce=>{const de=this.cliArgToUri(ce);return de&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),de)?!1:de?(0,p.isEqualAuthority)((0,O.getRemoteAuthority)(de),H):!1}),x=x.filter(ce=>{const de=this.cliArgToUri(ce);return de&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),de)?!1:de?(0,p.isEqualAuthority)((0,O.getRemoteAuthority)(de),H):!1}),F.cli._=ne,F.cli["folder-uri"]=V,F.cli["file-uri"]=x;const te=!ne.length&&!V.length&&!x.length,ie={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:te,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:H};return this.open(ie)}openInBrowserWindow(L){const F=this.configurationService.getValue("window"),B={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const x=V.config;!B.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(B.extensionDevelopmentPath=x.extensionDevelopmentPath,B.extensionDevelopmentKind=x.extensionDevelopmentKind,B["enable-proposed-api"]=x["enable-proposed-api"],B.verbose=x.verbose,B["inspect-extensions"]=x["inspect-extensions"],B["inspect-brk-extensions"]=x["inspect-brk-extensions"],B.debugId=x.debugId,B.extensionEnvironment=x.extensionEnvironment,B["extensions-dir"]=x["extensions-dir"],B["disable-extensions"]=x["disable-extensions"])}else{const x=this.windowsStateHandler.getNewWindowState(B);(0,d.mark)("code/willCreateCodeWindow");const ne=V=this.instantiationService.createInstance(re.CodeWindow,{state:x,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ne),lt.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,m.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,m.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne)),ne.onDidTriggerSystemContextMenu(({x:te,y:ie})=>this._onDidTriggerSystemContextMenu.fire({window:ne,x:te,y:ie}));const H=(0,v.assertIsDefined)(ne.win?.webContents);H.removeAllListeners("devtools-reload-page"),H.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return B.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(x=>{x||this.doOpenInBrowserWindow(V,B,L)}):this.doOpenInBrowserWindow(V,B,L),V}resolveProfileForBrowserWindow(L){let F;return L.userDataProfileInfo&&(F=this.userDataProfilesMainService.profiles.find(B=>B.name===L.userDataProfileInfo.name),F&&this.userDataProfilesMainService.setProfileForWorkspaceSync(F,L.workspace??"empty-window")),F||(F=this.userDataProfilesMainService.getProfile(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),F}doOpenInBrowserWindow(L,F,B){if(!F.extensionDevelopmentPath)if((0,se.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,se.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority});else{const V=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,F.remoteAuthority)}L.load(F)}onWindowClosed(L){const F=lt.WINDOWS.indexOf(L);lt.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=w.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(F=>(0,p.isEqualAuthority)(F.remoteAuthority,L)))}doGetLastActiveWindow(L){const F=Math.max.apply(Math,L.map(B=>B.lastFocusTime));return L.find(B=>B.lastFocusTime===F)}sendToFocused(L,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...F)}sendToAll(L,F,B){for(const V of this.getWindows())B&&B.indexOf(V.id)>=0||V.sendWhenReady(L,D.CancellationToken.None,F)}getWindows(){return lt.WINDOWS}getWindowCount(){return lt.WINDOWS.length}getWindowById(L){const F=this.getWindows().filter(B=>B.id===L);return(0,R.firstOrDefault)(F)}getWindowByWebContents(L){const F=w.BrowserWindow.fromWebContents(L);if(!!F)return this.getWindowById(F.id)}};z.WINDOWS=[],z=ve([J(2,l.ILogService),J(3,U.IStateMainService),J(4,A.IPolicyService),J(5,i.IEnvironmentMainService),J(6,W.IUserDataProfilesMainService),J(7,a.ILifecycleMainService),J(8,c.IBackupMainService),J(9,s.IConfigurationService),J(10,K.IWorkspacesHistoryMainService),J(11,N.IWorkspacesManagementMainService),J(12,o.IInstantiationService),J(13,r.IDialogMainService),J(14,n.IFileService),J(15,M.IProductService),J(16,T.IProtocolMainService),J(17,_.IThemeMainService)],z),e.WindowsMainService=z}),define(Z[264],ee([0,1,60,33,75,47]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(h,m,I,C){this.workspacesManagementMainService=h,this.windowsMainService=m,this.workspacesHistoryMainService=I,this.backupMainService=C,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,m){const I=this.windowsMainService.getWindowById(h);if(I)return this.workspacesManagementMainService.enterWorkspace(I,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(h,m,I){return this.workspacesManagementMainService.createUntitledWorkspace(m,I)}deleteUntitledWorkspace(h,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(h,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(h,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([J(0,R.IWorkspacesManagementMainService),J(1,t.IWindowsMainService),J(2,k.IWorkspacesHistoryMainService),J(3,w.IBackupMainService)],D),e.WorkspacesMainService=D}),define(Z[265],ee([0,1,15,40,29,30,17,43,18,31,48,42,35,2,13,9,4,12,7,28,81,132,44,146,99,243,149,60,248,19,69,181,84,118,56,102,179,25,59,110,191,211,192,245,103,193,194,14,204,86,68,5,85,257,222,119,22,6,206,262,65,20,63,252,87,41,249,90,111,37,227,229,73,46,234,235,258,236,259,113,238,239,240,241,246,33,263,247,26,91,75,264,47,244,39,210,51,255,218,54,72,89,250]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c,s,r,i,n,o,a,l,P,M,T,O,U,Q,re,le,fe,se,ue,K,N,_,A,W,$,Y,z,j,L,F,B,V,x,ne,H,te,ie,ce,de,ke,Le,Me,Ae,Ve,ge,pe,be,X,oe,he,ye,Ce,Te,Fe,Be,ze,_e,je,G,ae,me,Se,we,Ie,Oe,$e,Ke,xe,Ye,et,ot,at,Ft,Ot,Wt,Rt,_t,Ut,Nt,Lt,Bt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Et=class extends g.Disposable{constructor(Ee,De,Re,Pe,We,Ge,qe,He,Ne,Ue,Qe){super();this.mainProcessNodeIpcServer=Ee,this.userEnv=De,this.mainInstantiationService=Re,this.logService=Pe,this.environmentMainService=We,this.lifecycleMainService=Ge,this.configurationService=qe,this.stateMainService=He,this.fileService=Ne,this.productService=Ue,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const Ee=Ne=>Ne?.startsWith(`${d.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((Ne,Ue,Qe,Je)=>Ee(Je.requestingUrl)?Qe(De.has(Ue)):Qe(!1)),w.session.defaultSession.setPermissionCheckHandler((Ne,Ue,Qe,Je)=>Ee(Je.requestingUrl)?De.has(Ue):!1);const Re=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Pe=Ne=>{for(let Ue=Ne;Ue;Ue=Ue.parent)if(Ue.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},We=Ne=>Ne.resourceType==="xhr"||Pe(Ne.frame),Ge=Ne=>{const Ue=Ne.frame;if(!Ue||!this.windowsMainService)return!1;const Qe=w.BrowserWindow.getAllWindows();for(const Je of Qe)if(Ue.processId===Je.webContents.mainFrame.processId)return!0;return!1},qe=(Ne,Ue)=>{if(Ne.path!=="/index.html")return!0;const Qe=Ue.frame;if(!Qe||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&Qe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};w.session.defaultSession.webRequest.onBeforeRequest((Ne,Ue)=>{const Qe=v.URI.parse(Ne.url);return Qe.scheme===d.Schemas.vscodeWebview&&!qe(Qe,Ne)?(this.logService.error("Blocked vscode-webview request",Ne.url),Ue({cancel:!0})):Qe.scheme===d.Schemas.vscodeFileResource&&!Ge(Ne)?(this.logService.error("Blocked vscode-file request",Ne.url),Ue({cancel:!0})):Qe.path.endsWith(".svg")&&!Re.has(Qe.scheme)?Ue({cancel:!We(Ne)}):Ue({cancel:!1})}),w.session.defaultSession.webRequest.onHeadersReceived((Ne,Ue)=>{const Qe=Ne.responseHeaders,Je=Qe["content-type"]||Qe["Content-Type"];if(Je&&Array.isArray(Je)){const rt=v.URI.parse(Ne.url);if(rt.path.endsWith(".svg")&&Re.has(rt.scheme))return Qe["Content-Type"]=["image/svg+xml"],Ue({cancel:!1,responseHeaders:Qe});if(!rt.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(ut=>ut.toLowerCase().includes("image/svg")))return Ue({cancel:!We(Ne)})}return Ue({cancel:!1})});const He=w.session.defaultSession;typeof He.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&He.setCodeCachePath((0,E.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,h.setUnexpectedErrorHandler)(Re=>this.onUnexpectedError(Re)),process.on("uncaughtException",Re=>(0,h.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,h.onUnexpectedError)(Re)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(Re,Pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Pe)}),w.app.on("activate",(Re,Pe)=>{this.logService.trace("app#activate"),Pe||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(Re,Pe)=>{Pe.on("will-navigate",We=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),We.preventDefault()}),Pe.setWindowOpenHandler(({url:We})=>(this.nativeHostMainService?.openExternal(void 0,We),{action:"deny"}))});let Ee=[],De;w.app.on("open-file",(Re,Pe)=>{this.logService.trace("app#open-file: ",Pe),Re.preventDefault(),Ee.push(this.getWindowOpenableFromPathSync(Pe)),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],De=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Pe=this.windowsMainService?.getWindowByWebContents(Re.sender);let We,Ge;return Pe?.config?(We=Pe.config,Ge={...process.env,...Pe.config.userEnv}):(We=this.environmentMainService.args,Ge=process.env),this.resolveShellEnvironment(We,Ge,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Pe,We)=>{const Ge=this.validateNlsPath([Pe]);if(!Ge||typeof We!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ge,D.VSBuffer.fromString(We))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Pe)=>{const We=this.validateNlsPath(Pe);if(!We)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(We)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}validateNlsPath(Ee){let De;for(const Re of Ee)typeof Re=="string"&&(typeof De!="string"?De=Re:De=(0,E.join)(De,Re));if(!(typeof De!="string"||!(0,E.isAbsolute)(De)||!(0,m.isEqualOrParent)(De,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return v.URI.file(De)}onUnexpectedError(Ee){if(Ee){const De={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.logService.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.logService.error(Ee.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ee=this.productService.win32AppUserModelId;b.isWindows&&Ee&&w.app.setAppUserModelId(Ee);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.logService.error(Ue)}const De=new r.Server;this.lifecycleMainService.onWillShutdown(Ue=>{Ue.reason===2&&De.dispose()}),this.logService.trace("Resolving machine identifier...");const Re=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Pe,sharedProcessReady:We,sharedProcessClient:Ge}=this.setupSharedProcess(Re),qe=await this.initServices(Re,Pe,We);this.setUpHandlers(qe);const He=this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);He&&await He,qe.invokeFunction(Ue=>this.initChannels(Ue,De,Ge));const Ne=qe.invokeFunction(Ue=>this.openFirstWindow(Ue,De));qe.invokeFunction(Ue=>this.afterWindowOpen(Ue,Pe)),this.environmentMainService.args.trace&&qe.invokeFunction(Ue=>this.stopTracingEventually(Ue,Ne))}setUpHandlers(Ee){this._register(Ee.createInstance(n.ProxyAuthHandler)),this._register(Ee.createInstance(_t.DefaultExtensionsProfileInitHandler))}async resolveMachineId(){let Ee=this.stateMainService.getItem(oe.machineIdKey);return(!Ee||b.isMacintosh&&Ee==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(Ee=await(0,u.getMachineId)(),this.stateMainService.setItem(oe.machineIdKey,Ee)),Ee}setupSharedProcess(Ee){const De=this._register(this.mainInstantiationService.createInstance(Ae.SharedProcess,Ee,this.userEnv)),Re=(async()=>{this.logService.trace("Main->SharedProcess#connect");const We=await De.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(We,"main")})(),Pe=(async()=>(await De.whenReady(),Re))();return{sharedProcess:De,sharedProcessReady:Pe,sharedProcessClient:Re}}async initServices(Ee,De,Re){const Pe=new V.ServiceCollection;switch(process.platform){case"win32":Pe.set(Te.IUpdateService,new F.SyncDescriptor(je.Win32UpdateService));break;case"linux":b.isLinuxSnap?Pe.set(Te.IUpdateService,new F.SyncDescriptor(_e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(Te.IUpdateService,new F.SyncDescriptor(ze.LinuxUpdateService));break;case"darwin":Pe.set(Te.IUpdateService,new F.SyncDescriptor(Be.DarwinUpdateService));break}Pe.set(Oe.IWindowsMainService,new F.SyncDescriptor($e.WindowsMainService,[Ee,this.userEnv])),Pe.set(Q.IDialogMainService,new F.SyncDescriptor(Q.DialogMainService)),Pe.set(H.ILaunchMainService,new F.SyncDescriptor(H.LaunchMainService)),Pe.set(U.IDiagnosticsMainService,new F.SyncDescriptor(U.DiagnosticsMainService)),Pe.set(O.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(Re.then(Ge=>Ge.getChannel("diagnostics"))))),Pe.set(x.IIssueMainService,new F.SyncDescriptor(x.IssueMainService,[this.userEnv])),Pe.set(re.IEncryptionMainService,new F.SyncDescriptor(le.EncryptionMainService,[Ee])),Pe.set(ne.IKeyboardLayoutMainService,new F.SyncDescriptor(ne.KeyboardLayoutMainService)),Pe.set(ke.INativeHostMainService,new F.SyncDescriptor(ke.NativeHostMainService,[De])),Pe.set(M.ICredentialsMainService,new F.SyncDescriptor(Ft.CredentialsNativeMainService)),Pe.set(we.IWebviewManagerService,new F.SyncDescriptor(Ie.WebviewMainService)),Pe.set(Ye.IWorkspacesService,new F.SyncDescriptor(ot.WorkspacesMainService)),Pe.set(at.IWorkspacesManagementMainService,new F.SyncDescriptor(at.WorkspacesManagementMainService)),Pe.set(et.IWorkspacesHistoryMainService,new F.SyncDescriptor(et.WorkspacesHistoryMainService)),Pe.set(de.IMenubarMainService,new F.SyncDescriptor(de.MenubarMainService)),Pe.set(K.IExtensionUrlTrustService,new F.SyncDescriptor(N.ExtensionUrlTrustService)),Pe.set(_.IExtensionHostStarter,new F.SyncDescriptor(A.ExtensionHostStarter)),Pe.set(be.IStorageMainService,new F.SyncDescriptor(be.StorageMainService)),Pe.set(be.IApplicationStorageMainService,new F.SyncDescriptor(be.ApplicationStorageMainService)),b.isWindows?Pe.set(W.IExternalTerminalMainService,new F.SyncDescriptor($.WindowsExternalTerminalService)):b.isMacintosh?Pe.set(W.IExternalTerminalMainService,new F.SyncDescriptor($.MacExternalTerminalService)):b.isLinux&&Pe.set(W.IExternalTerminalMainService,new F.SyncDescriptor($.LinuxExternalTerminalService));const We=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Pe.set(a.IBackupMainService,We),Pe.set(G.IURLService,new F.SyncDescriptor(me.NativeURLService)),(0,Ce.supportsTelemetry)(this.productService,this.environmentMainService)){const Ge=(0,Ce.isInternalTelemetry)(this.productService,this.configurationService),qe=(0,s.getDelayedChannel)(Re.then(Je=>Je.getChannel("telemetryAppender"))),He=new he.TelemetryAppenderClient(qe),Ne=(0,X.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,Ee,Ge,this.environmentMainService.installSourcePath),Ue=(0,Ce.getPiiPathsFromEnvironment)(this.environmentMainService),Qe={appenders:[He],commonProperties:Ne,piiPaths:Ue,sendErrorTelemetry:!0};Pe.set(oe.ITelemetryService,new F.SyncDescriptor(ye.TelemetryService,[Qe]))}else Pe.set(oe.ITelemetryService,Ce.NullTelemetryService);return Pe.set(Lt.IExtensionsProfileScannerService,new F.SyncDescriptor(Lt.ExtensionsProfileScannerService)),Pe.set(Bt.IExtensionsScannerService,new F.SyncDescriptor(zt.ExtensionsScannerService)),await We.initialize(),this.mainInstantiationService.createChild(Pe)}initChannels(Ee,De,Re){const Pe=s.ProxyChannel.fromService(Ee.get(H.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Pe);const We=s.ProxyChannel.fromService(Ee.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",We);const Ge=new Wt.PolicyChannel(Ee.get(Ot.IPolicyService));De.registerChannel("policy",Ge),Re.then(tt=>tt.registerChannel("policy",Ge));const qe=this.fileService.getProvider(d.Schemas.file);(0,p.assertType)(qe instanceof L.DiskFileSystemProvider);const He=new j.DiskFileSystemProviderChannel(qe,this.logService,this.environmentMainService);De.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,He),Re.then(tt=>tt.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,He));const Ne=s.ProxyChannel.fromService(Ee.get(Rt.IUserDataProfilesMainService));De.registerChannel("userDataProfiles",Ne),Re.then(tt=>tt.registerChannel("userDataProfiles",Ne));const Ue=new Ut.RequestChannel(Ee.get(Nt.IRequestService));Re.then(tt=>tt.registerChannel("request",Ue));const Qe=new Fe.UpdateChannel(Ee.get(Te.IUpdateService));De.registerChannel("update",Qe);const Je=s.ProxyChannel.fromService(Ee.get(x.IIssueMainService));De.registerChannel("issue",Je);const rt=s.ProxyChannel.fromService(Ee.get(re.IEncryptionMainService));De.registerChannel("encryption",rt);const ut=s.ProxyChannel.fromService(Ee.get(M.ICredentialsMainService));De.registerChannel("credentials",ut);const Ct=s.ProxyChannel.fromService(Ee.get(Ve.ISignService));De.registerChannel("sign",Ct);const Ze=s.ProxyChannel.fromService(Ee.get(ne.IKeyboardLayoutMainService));De.registerChannel("keyboardLayout",Ze),this.nativeHostMainService=Ee.get(ke.INativeHostMainService);const ht=s.ProxyChannel.fromService(this.nativeHostMainService);De.registerChannel("nativeHost",ht),Re.then(tt=>tt.registerChannel("nativeHost",ht));const dt=s.ProxyChannel.fromService(Ee.get(Ye.IWorkspacesService));De.registerChannel("workspaces",dt);const ft=s.ProxyChannel.fromService(Ee.get(de.IMenubarMainService));De.registerChannel("menubar",ft);const pt=s.ProxyChannel.fromService(Ee.get(G.IURLService));De.registerChannel("url",pt);const wt=s.ProxyChannel.fromService(Ee.get(K.IExtensionUrlTrustService));De.registerChannel("extensionUrlTrust",wt);const gt=s.ProxyChannel.fromService(Ee.get(we.IWebviewManagerService));De.registerChannel("webview",gt);const ct=this._register(new pe.StorageDatabaseChannel(this.logService,Ee.get(be.IStorageMainService)));De.registerChannel("storage",ct),Re.then(tt=>tt.registerChannel("storage",ct));const vt=s.ProxyChannel.fromService(Ee.get(W.IExternalTerminalMainService));De.registerChannel("externalTerminal",vt);const Xe=new ce.LogLevelChannel(Ee.get(ie.ILogService));De.registerChannel("logLevel",Xe),Re.then(tt=>tt.registerChannel("logLevel",Xe));const nt=new ce.LoggerChannel(Ee.get(ie.ILoggerService));De.registerChannel("logger",nt),Re.then(tt=>tt.registerChannel("logger",nt));const st=new T.ElectronExtensionHostDebugBroadcastChannel(Ee.get(Oe.IWindowsMainService));De.registerChannel("extensionhostdebugservice",st);const mt=s.ProxyChannel.fromService(Ee.get(_.IExtensionHostStarter));De.registerChannel(_.ipcExtensionHostStarterChannelName,mt)}openFirstWindow(Ee,De){const Re=this.windowsMainService=Ee.get(Oe.IWindowsMainService),Pe=Ee.get(G.IURLService),We=Ee.get(ke.INativeHostMainService);this.lifecycleMainService.phase=2;const Ge=[],qe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Xe=>{try{return{uri:v.URI.parse(Xe),url:Xe}}catch{return}}).filter(Xe=>{if(!Xe||this.shouldBlockURI(Xe.uri))return!1;const nt=this.getWindowOpenableFromProtocolLink(Xe.uri);return nt?(Ge.push(nt),!1):!0}),He=this,Ne=this.environmentMainService,Ue=this.productService,Qe=this.logService;Pe.registerHandler({async handleURL(Xe,nt){if(Qe.trace("app#handleURL: ",Xe.toString(!0),nt),Xe.scheme===Ue.urlProtocol&&Xe.path==="workspace"&&(Xe=Xe.with({authority:"file",path:v.URI.parse(Xe.query).path,query:""})),He.shouldBlockURI(Xe))return!0;let st=!1;const mt=new URLSearchParams(Xe.query);mt.get("windowId")==="_blank"&&(mt.delete("windowId"),Xe=Xe.with({query:mt.toString()}),st=!0),st||(st=b.isMacintosh&&Re.getWindowCount()===0);const tt=He.getWindowOpenableFromProtocolLink(Xe);if(Qe.trace("app#handleURL: windowOpenableFromProtocolLink = ",tt),tt){const[It]=Re.open({context:5,cli:{...Ne.args},urisToOpen:[tt],forceNewWindow:st,gotoLineMode:!0});return It.focus(),!0}if(st){const[It]=Re.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Me.getRemoteAuthority)(Xe)});return await It.ready(),Pe.open(Xe,nt)}return!1}});const Je=this._register(new Ke.ActiveWindowManager({onDidOpenWindow:We.onDidOpenWindow,onDidFocusWindow:We.onDidFocusWindow,getActiveWindowId:()=>We.getActiveWindowId(-1)})),rt=new s.StaticRouter(Xe=>Je.getActiveClientId().then(nt=>Xe===nt)),ut=new ae.URLHandlerRouter(rt),Ct=De.getChannel("urlHandler",ut);Pe.registerHandler(new ae.URLHandlerChannelClient(Ct)),this._register(new Se.ElectronURLListener(qe,Pe,Re,this.environmentMainService,this.productService));const Ze=this.environmentMainService.args,ht=global.macOpenFiles,dt=(0,se.isLaunchedFromCli)(process.env)?0:4,ft=Ze._.length,pt=!!Ze["folder-uri"],wt=!!Ze["file-uri"],gt=Ze["skip-add-to-recently-opened"]===!0,ct=Ze.wait&&Ze.waitMarkerFilePath?v.URI.file(Ze.waitMarkerFilePath):void 0,vt=Ze.remote||void 0;return Ge.length>0?Re.open({context:dt,cli:Ze,urisToOpen:Ge,gotoLineMode:!0,initialStartup:!0}):Ze["new-window"]&&!ft&&!pt&&!wt?Re.open({context:dt,cli:Ze,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:gt,waitMarkerFileURI:ct,initialStartup:!0,remoteAuthority:vt}):ht.length&&!ft&&!pt&&!wt?Re.open({context:1,cli:Ze,urisToOpen:ht.map(Xe=>this.getWindowOpenableFromPathSync(Xe)),noRecentEntry:gt,waitMarkerFileURI:ct,initialStartup:!0}):Re.open({context:dt,cli:Ze,forceNewWindow:Ze["new-window"]||!ft&&Ze["unity-launch"],diffMode:Ze.diff,mergeMode:Ze.merge,noRecentEntry:gt,waitMarkerFileURI:ct,gotoLineMode:Ze.goto,initialStartup:!0,remoteAuthority:vt})}shouldBlockURI(Ee){return!!(Ee.authority===d.Schemas.file&&b.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,S.getPathLabel)(Ee,{os:b.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(Ee){if(!!Ee.path){if(Ee.authority===d.Schemas.file){const De=v.URI.file(Ee.fsPath);return(0,xe.hasWorkspaceFileExtension)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ee.authority===d.Schemas.vscodeRemote){const De=Ee.path.indexOf(E.posix.sep,1);if(De!==-1){const Re=Ee.path.substring(1,De),Pe=Ee.path.substring(De),We=v.URI.from({scheme:d.Schemas.vscodeRemote,authority:Re,path:Pe,query:Ee.query,fragment:Ee.fragment});return(0,xe.hasWorkspaceFileExtension)(Pe)?{workspaceUri:We}:/:[\d]+$/.test(Pe)?{fileUri:We}:{folderUri:We}}}}}getWindowOpenableFromPathSync(Ee){try{if((0,k.statSync)(Ee).isDirectory())return{folderUri:v.URI.file(Ee)};if((0,xe.hasWorkspaceFileExtension)(Ee))return{workspaceUri:v.URI.file(Ee)}}catch{}return{fileUri:v.URI.file(Ee)}}async afterWindowOpen(Ee,De){this.lifecycleMainService.phase=3;let Re=!1;(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>Re=!0);const Pe=Ee.get(oe.ITelemetryService);this._register(De.onDidError(({type:qe,details:He})=>{let Ne;switch(qe){case 1:Ne="SharedProcess: detected unresponsive window";break;case 2:Ne=`SharedProcess: crashed (detail: ${He?.reason??"<unknown>"}, code: ${He?.exitCode??"<unknown>"})`;break;case 3:Ne=`SharedProcess: failed to load (detail: ${He?.reason??"<unknown>"}, code: ${He?.exitCode??"<unknown>"})`;break}(0,h.onUnexpectedError)(new Error(Ne)),Pe.publicLog2("sharedprocesserror",{type:qe,reason:He?.reason,code:He?.exitCode,visible:De.isVisible(),shuttingdown:Re})}));const We=this.productService.win32MutexName;if(b.isWindows&&We)try{const qe=q.__$__nodeRequire("windows-mutex").Mutex,He=new qe(We);(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>He.release())}catch(qe){this.logService.error(qe)}w.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(qe,He)=>{He({url:qe.url.replace(/^vscode-remote-resource:/,"http:"),method:qe.method})});const Ge=Ee.get(Te.IUpdateService);(Ge instanceof je.Win32UpdateService||Ge instanceof ze.LinuxUpdateService||Ge instanceof Be.DarwinUpdateService)&&await Ge.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const He=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,C.stripComments)(He))["enable-crash-reporter"]===void 0){const Qe=(0,Ce.getTelemetryLevel)(this.configurationService)>=1,Je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Qe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.generateUuid)()}"`,"}"],rt=He.substring(0,He.length-2).concat(`,
`,Je.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(rt))}}catch(qe){this.logService.error(qe)}}async resolveShellEnvironment(Ee,De,Re){try{return await(0,ue.getResolvedShellEnv)(this.logService,Ee,De)}catch(Pe){const We=(0,y.toErrorMessage)(Pe);Re?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",We):this.logService.error(We)}return{}}stopTracingEventually(Ee,De){this.logService.info("Tracing: waiting for windows to get ready...");const Re=Ee.get(Q.IDialogMainService);let Pe=!1;const We=async qe=>{if(Pe)return;Pe=!0;const He=await w.contentTracing.stopRecording(`${(0,m.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);qe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${He}`):Re.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,He),buttons:[(0,S.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,p.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},Ge=setTimeout(()=>We(!0),3e4);Promise.all(De.map(qe=>qe.ready())).then(()=>{clearTimeout(Ge),We(!1)})}};Et=ve([J(2,B.IInstantiationService),J(3,ie.ILogService),J(4,fe.IEnvironmentMainService),J(5,te.ILifecycleMainService),J(6,P.IConfigurationService),J(7,ge.IStateMainService),J(8,z.IFileService),J(9,Le.IProductService),J(10,Rt.IUserDataProfilesMainService)],Et),e.CodeApplication=Et}),define(Z[266],ee([0,1,39,8,274,2]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends w.AbstractPolicyService{constructor(h){super();this.productName=h,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(h){await this.throttler.queue(()=>new Promise((m,I)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,h,C=>{for(const S in C){const g=C[S];g===void 0?this.policies.delete(S):this.policies.set(S,g)}this._onDidChange.fire(Object.keys(C)),m()})}catch(C){I(C)}}))}}e.NativePolicyService=D}),define(Z[267],ee([0,1,220,8,17,18,2,12,19,36,110,6,219,275]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends D.Disposable{constructor(b,p,v){super();this.environmentService=p,this.logService=v,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,p){this.logService.trace("RequestService#request (node) - begin",b.url);const{proxyUrl:v,strictSSL:f}=this;let u;try{u=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const c={...process.env,...u},s=b.agent?b.agent:await(0,S.getProxyAgent)(b.url||"",c,{proxyUrl:v,strictSSL:f});b.agent=s,b.strictSSL=f,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(b,p);return this.logService.trace("RequestService#request (node) - success",b.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",b.url,r),r}}async getNodeRequest(b){return((0,w.parse)(b.url).protocol==="https:"?await new Promise((f,u)=>{q(["https"],f,u)}):await new Promise((f,u)=>{q(["http"],f,u)})).request}_request(b,p){return t.Promises.withAsyncBody(async(v,f)=>{const u=(0,w.parse)(b.url),c=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),s={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,y.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(s.auth=b.user+":"+b.password);const r=c(s,i=>{const n=(0,y.isNumber)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...b,url:i.headers.location,followRedirects:n-1},p).then(v,f);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,g.createGunzip)())),v({res:i,stream:(0,k.streamToBufferReadableStream)(o)})}});r.on("error",f),b.timeout&&r.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&r.write(b.data),r.end(),p.onCancellationRequested(()=>{r.abort(),f(new R.CancellationError)})})}async resolveProxy(b){}};d=ve([J(0,h.IConfigurationService),J(1,m.INativeEnvironmentService),J(2,C.ILogService)],d),e.RequestService=d}),define(Z[268],ee([0,1,15,267]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return w.net.request}class R extends t.RequestService{request(y,h){return super.request({...y||{},getRawRequest:k},h)}}e.RequestMainService=R}),define(Z[276],ee([0,1,15,29,7,24,8,43,18,31,48,35,13,9,71,4,34,27,23,44,83,265,10,19,214,226,25,59,184,14,202,86,68,199,85,22,105,6,207,106,53,20,61,251,112,232,54,268,87,221,41,225,73,64,51,39,266,209,2,55,237,38,233]),function(q,e,w,t,k,R,D,y,h,m,I,C,S,g,d,E,b,p,v,f,u,c,s,r,i,n,o,a,l,P,M,T,O,U,Q,re,le,fe,se,ue,K,N,_,A,W,$,Y,z,j,L,F,B,V,x,ne,H,te,ie,ce,de,ke,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Me{main(){try{this.startup()}catch(ge){console.error(ge.message),w.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Te=>console.error(Te));const[ge,pe,be,X,oe,he,ye,Ce]=this.createServices();try{try{await this.initServices(be,Ce,X,oe)}catch(Te){throw this.handleStartupDataDirError(be,ye.nameLong,Te),Te}await ge.invokeFunction(async Te=>{const Fe=Te.get(fe.ILogService),Be=Te.get(re.ILifecycleMainService),ze=Te.get(P.IFileService),_e=await this.claimInstance(Fe,be,Be,ge,ye,!0);return v.Promises.writeFile(be.mainLockfile,String(process.pid)).catch(je=>{Fe.warn(`Error writing main lockfile: ${je.stack}`)}),he.logger=new ue.SpdLogLogger("main",(0,g.join)(be.logsPath,"main.log"),!0,!1,he.getLevel()),(0,I.once)(Be.onWillShutdown)(je=>{ze.dispose(),X.dispose(),je.join(v.Promises.unlink(be.mainLockfile).catch(()=>{}))}),ge.createInstance(c.CodeApplication,_e,pe).startup()})}catch(Te){ge.invokeFunction(this.quit,Te)}}createServices(){const ge=new Q.ServiceCollection,pe=new ce.DisposableStore;process.once("exit",()=>pe.dispose());const be={_serviceBrand:void 0,...K.default};ge.set(N.IProductService,be);const X=new o.EnvironmentMainService(this.resolveArgs(),be),oe=this.patchEnvironment(X);ge.set(o.IEnvironmentMainService,X);const he=new le.BufferLogService,ye=pe.add(new fe.MultiplexLogService([new fe.ConsoleMainLogger((0,fe.getLogLevel)(X)),he]));ge.set(fe.ILogService,ye);const Ce=new M.FileService(ye);ge.set(P.IFileService,Ce);const Te=new T.DiskFileSystemProvider(ye);Ce.registerProvider(S.Schemas.file,Te);const Fe=new ke.UriIdentityService(Ce);ge.set(de.IUriIdentityService,Fe),ge.set(fe.ILoggerService,new se.LoggerService(ye,Ce));const Be=new B.StateMainService(X,ye,Ce);ge.set(F.IStateMainService,Be);const ze=new ne.UserDataProfilesMainService(Be,Fe,X,Ce,ye);ge.set(ne.IUserDataProfilesMainService,ze);const _e=E.isWindows&&be.win32RegValueName?pe.add(new te.NativePolicyService(be.win32RegValueName)):X.policyFile?pe.add(new ie.FilePolicyService(X.policyFile,Ce,ye)):new H.NullPolicyService;ge.set(H.IPolicyService,_e);const je=new i.ConfigurationService(ze.defaultProfile.settingsResource,Ce,_e,ye);return ge.set(r.IConfigurationService,je),ge.set(re.ILifecycleMainService,new O.SyncDescriptor(re.LifecycleMainService)),ge.set(Y.IRequestService,new O.SyncDescriptor(z.RequestMainService)),ge.set(x.IThemeMainService,new O.SyncDescriptor(x.ThemeMainService)),ge.set(j.ISignService,new O.SyncDescriptor(L.SignService)),ge.set(W.ITunnelService,new O.SyncDescriptor($.TunnelService)),ge.set(_.IProtocolMainService,new O.SyncDescriptor(A.ProtocolMainService)),[new U.InstantiationService(ge,!0),oe,X,je,Be,he,be,ze]}patchEnvironment(ge){const pe={VSCODE_IPC_HOOK:ge.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(be=>{const X=process.env[be];typeof X=="string"&&(pe[be]=X)}),Object.assign(process.env,pe),pe}async initServices(ge,pe,be,X){await D.Promises.settled([Promise.all([ge.extensionsPath,ge.codeCachePath,ge.logsPath,pe.defaultProfile.globalStorageHome.fsPath,ge.workspaceStorageHome.fsPath,ge.localHistoryHome.fsPath,ge.backupHome].map(oe=>oe?v.Promises.mkdir(oe,{recursive:!0}):void 0)),X.init(),be.initialize()]),pe.setEnablement(!!be.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ge,pe,be,X,oe,he){let ye;try{(0,d.mark)("code/willStartMainServer"),ye=await(0,u.serve)(pe.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,I.once)(be.onWillShutdown)(()=>ye.dispose())}catch(Ce){if(Ce.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,oe.nameLong,Ce),Ce;let Te;try{Te=await(0,u.connect)(pe.mainIPCHandle,"main")}catch(_e){if(!he||E.isWindows||_e.code!=="ECONNREFUSED")throw _e.code==="EPERM"&&this.showStartupWarningDialog((0,s.localize)(0,null,oe.nameShort),(0,s.localize)(1,null),oe.nameLong),_e;try{(0,t.unlinkSync)(pe.mainIPCHandle)}catch(je){throw ge.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(ge,pe,be,X,oe,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const _e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ge.error(_e),Te.dispose(),new Error(_e)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.showStartupWarningDialog((0,s.localize)(2,null,oe.nameShort),(0,s.localize)(3,null),oe.nameLong)},1e4));const Be=f.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),ze=f.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return X.invokeFunction(async()=>{const _e=new n.DiagnosticsService(V.NullTelemetryService,oe),je=await Be.getMainProcessInfo(),G=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ae=await _e.getDiagnostics(je,G);throw console.log(ae),new h.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow(Be,ge),ge.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),Te.dispose(),Fe&&clearTimeout(Fe),new h.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw ge.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(ge,pe,be){if(be.code==="EACCES"||be.code==="EPERM"){const X=(0,R.coalesce)([ge.userDataPath,ge.extensionsPath,u.XDG_RUNTIME_DIR]).map(oe=>(0,C.getPathLabel)(k.URI.file(oe),{os:E.OS,tildify:ge}));this.showStartupWarningDialog((0,s.localize)(4,null),(0,s.localize)(5,null,(0,y.toErrorMessage)(be),X.join(`
`)),pe)}}showStartupWarningDialog(ge,pe,be){w.dialog.showMessageBoxSync({title:be,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,s.localize)(6,null))],message:ge,detail:pe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ge,pe){if(E.isWindows){const be=await ge.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",be);try{(await new Promise((X,oe)=>{q(["windows-foreground-love"],X,oe)})).allowSetForegroundWindow(be)}catch(X){pe.error(X)}}}quit(ge,pe){const be=ge.get(fe.ILogService),X=ge.get(re.ILifecycleMainService);let oe=0;pe&&(pe.isExpected?pe.message&&be.trace(pe.message):(oe=1,pe.stack?be.error(pe.stack):be.error(`Startup error: ${pe.toString()}`))),X.kill(oe)}resolveArgs(){const ge=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(ge.wait&&!ge.waitMarkerFilePath){const pe=(0,l.createWaitMarkerFile)(ge.verbose);pe&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",pe),ge.waitMarkerFilePath=pe)}return ge}validatePaths(ge){if(ge["open-url"]&&(ge._urls=ge._,ge._=[]),!ge.remote){const pe=this.doValidatePaths(ge._,ge.goto);ge._=pe}return ge}doValidatePaths(ge,pe){const be=(0,b.cwd)(),X=ge.map(ye=>{let Ce=String(ye),Te;pe&&(Te=(0,m.parseLineAndColumnAware)(Ce),Ce=Te.path),Ce&&(Ce=this.preparePath(be,Ce));const Fe=(0,m.sanitizeFilePath)(Ce,be),Be=(0,g.basename)(Fe);return Be&&!(0,m.isValidBasename)(Be)?null:pe&&Te?(Te.path=Fe,this.toPath(Te)):Fe}),oe=E.isWindows||E.isMacintosh,he=(0,R.distinct)(X,ye=>ye&&oe?ye.toLowerCase():ye||"");return(0,R.coalesce)(he)}preparePath(ge,pe){return E.isWindows&&(pe=(0,p.rtrim)(pe,'"')),pe=(0,p.trim)((0,p.trim)(pe," "),"	"),E.isWindows&&(pe=(0,g.resolve)(ge,pe),pe=(0,p.rtrim)(pe,".")),pe}toPath(ge){const pe=[ge.path];return typeof ge.line=="number"&&pe.push(String(ge.line)),typeof ge.column=="number"&&pe.push(String(ge.column)),pe.join(":")}}new Me().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/235a92a3693176fbf9af16ec5b829c458a1d682f/core/vs/code/electron-main/main.js.map
